
			DROP SCHEMA IF EXISTS NCT01928420_All_Data CASCADE;
		
			DROP LANGUAGE IF EXISTS plpgsql;
			CREATE PROCEDURAL LANGUAGE plpgsql;
			CREATE SCHEMA NCT01928420_All_Data;
			CREATE TABLE NCT01928420_All_Data.multiselect_column_name_map (column_name TEXT, item_name TEXT, response_text TEXT, CONSTRAINT pk_multiselect_column_name_map PRIMARY KEY (column_name));

			create or replace function NCT01928420_All_Data.add_table_field (p_table text, p_field text, p_datatype text) 
			returns bool as '
			DECLARE 
			  v_row       record;\
			  v_query     text;\
			BEGIN
			  SELECT 1 into v_row FROM information_schema.columns where table_catalog = current_database() and table_schema= lower(substring(p_table from ''^[^\.]*'')) and table_name= lower(substring(p_table from ''[^\.]*$'')) and column_name = lower(p_field);\
			  if found then
			    raise notice '' column already exists, skipping '';\
			    return ''t'';\
			  else
			    raise notice '' column not present, adding to table '';\
			    v_query := ''alter table '' || p_table || '' add column '' || p_field || '' '' || p_datatype || '';'';\
			    execute v_query; \
			    return ''f'';\
			  end if;\
			END;' language plpgsql;

			CREATE OR REPLACE FUNCTION NCT01928420_All_Data.save_column_name (p_column_name TEXT, p_item_name TEXT, p_response_text TEXT) 
			RETURNS VOID
			AS '
			DECLARE
			  v_existing_name TEXT;\
			BEGIN
				SELECT column_name INTO v_existing_name FROM NCT01928420_All_Data.multiselect_column_name_map WHERE LOWER(column_name) = LOWER($1);\
				IF (v_existing_name IS NULL) THEN
					INSERT INTO NCT01928420_All_Data.multiselect_column_name_map (column_name,item_name,response_text) VALUES (LOWER($1),LOWER($2),LOWER($3));\
				END IF;\
			END; '
			LANGUAGE plpgsql;
				
				create table NCT01928420_All_Data.study_subject_listing (			
				ssoid character varying(40),
				ssid character varying(40),
				subject_status character varying(255),
				subject_unique_id character varying(255),
				secondary_id character varying(255),
				date_of_birth date, 
				sex character(1),
				
		
				site_protocol_name character varying(255),
				site_name character varying(255),
				warehouse_insert_created_timestamp timestamp with time zone);	
				ALTER TABLE NCT01928420_All_Data.study_subject_listing ADD CONSTRAINT Pk_study_subject_listing PRIMARY KEY (ssoid, ssid);	
						
					
					insert into NCT01928420_All_Data.study_subject_listing (
					ssoid, ssid
					, subject_unique_id, secondary_id, site_protocol_name, site_name,
					warehouse_insert_created_timestamp
					) values (	
					'SS_LUM_01',		
					'LUM_01'
					, '', '', ''
					, ''
					
					,'2015-03-19T16:41:35.717Z'
					);
								
					
					insert into NCT01928420_All_Data.study_subject_listing (
					ssoid, ssid
					, subject_unique_id, secondary_id, site_protocol_name, site_name,
					warehouse_insert_created_timestamp
					) values (	
					'SS_LUM_02',		
					'LUM_02'
					, '', '', ''
					, ''
					
					,'2015-03-19T16:41:35.717Z'
					);
								
					
					insert into NCT01928420_All_Data.study_subject_listing (
					ssoid, ssid
					, subject_unique_id, secondary_id, site_protocol_name, site_name,
					warehouse_insert_created_timestamp
					) values (	
					'SS_TEST_01',		
					'Test_01'
					, '', '', ''
					, ''
					
					,'2015-03-19T16:41:35.717Z'
					);
								
					
					insert into NCT01928420_All_Data.study_subject_listing (
					ssoid, ssid
					, subject_unique_id, secondary_id, site_protocol_name, site_name,
					warehouse_insert_created_timestamp
					) values (	
					'SS_TEST_02',		
					'Test_02'
					, '', '', ''
					, ''
					
					,'2015-03-19T16:41:35.717Z'
					);
								
					
					insert into NCT01928420_All_Data.study_subject_listing (
					ssoid, ssid
					, subject_unique_id, secondary_id, site_protocol_name, site_name,
					warehouse_insert_created_timestamp
					) values (	
					'SS_TEST_03',		
					'Test_03'
					, '', '', ''
					, ''
					
					,'2015-03-19T16:41:35.717Z'
					);
								
					
					insert into NCT01928420_All_Data.study_subject_listing (
					ssoid, ssid
					, subject_unique_id, secondary_id, site_protocol_name, site_name,
					warehouse_insert_created_timestamp
					) values (	
					'SS_TEST_04',		
					'Test_04'
					, '', '', ''
					, ''
					
					,'2015-03-19T16:41:35.717Z'
					);
								
					
					insert into NCT01928420_All_Data.study_subject_listing (
					ssoid, ssid
					, subject_unique_id, secondary_id, site_protocol_name, site_name,
					warehouse_insert_created_timestamp
					) values (	
					'SS_TEST_BEN',		
					'Test_Ben'
					, '', '', ''
					, ''
					
					,'2015-03-19T16:41:35.717Z'
					);
								
					
					insert into NCT01928420_All_Data.study_subject_listing (
					ssoid, ssid
					, subject_unique_id, secondary_id, site_protocol_name, site_name,
					warehouse_insert_created_timestamp
					) values (	
					'SS_TS10_101',		
					'TS10_101_10'
					, '', '', '101'
					, 'Site A'
					
					,'2015-03-19T16:41:35.717Z'
					);
								
					
					insert into NCT01928420_All_Data.study_subject_listing (
					ssoid, ssid
					, subject_unique_id, secondary_id, site_protocol_name, site_name,
					warehouse_insert_created_timestamp
					) values (	
					'SS_TS3_101_',		
					'TS3_101_03'
					, '', '', '101'
					, 'Site A'
					
					,'2015-03-19T16:41:35.717Z'
					);
								
					
					insert into NCT01928420_All_Data.study_subject_listing (
					ssoid, ssid
					, subject_unique_id, secondary_id, site_protocol_name, site_name,
					warehouse_insert_created_timestamp
					) values (	
					'SS_TS4_101_',		
					'TS4_101_04'
					, '', '', '101'
					, 'Site A'
					
					,'2015-03-19T16:41:35.717Z'
					);
								
					
					insert into NCT01928420_All_Data.study_subject_listing (
					ssoid, ssid
					, subject_unique_id, secondary_id, site_protocol_name, site_name,
					warehouse_insert_created_timestamp
					) values (	
					'SS_TS6_101_',		
					'TS6_101_06'
					, '', '', '101'
					, 'Site A'
					
					,'2015-03-19T16:41:35.717Z'
					);
								
					
					insert into NCT01928420_All_Data.study_subject_listing (
					ssoid, ssid
					, subject_unique_id, secondary_id, site_protocol_name, site_name,
					warehouse_insert_created_timestamp
					) values (	
					'SS_TS10_102',		
					'TS10_102_10'
					, '', '', '102'
					, 'Site B'
					
					,'2015-03-19T16:41:35.717Z'
					);
								
					
					insert into NCT01928420_All_Data.study_subject_listing (
					ssoid, ssid
					, subject_unique_id, secondary_id, site_protocol_name, site_name,
					warehouse_insert_created_timestamp
					) values (	
					'SS_TS1_102_',		
					'TS1_102_01'
					, '', '', '102'
					, 'Site B'
					
					,'2015-03-19T16:41:35.717Z'
					);
								
					
					insert into NCT01928420_All_Data.study_subject_listing (
					ssoid, ssid
					, subject_unique_id, secondary_id, site_protocol_name, site_name,
					warehouse_insert_created_timestamp
					) values (	
					'SS_TS3_102_',		
					'TS3_102_03'
					, '', '', '102'
					, 'Site B'
					
					,'2015-03-19T16:41:35.717Z'
					);
								
					
					insert into NCT01928420_All_Data.study_subject_listing (
					ssoid, ssid
					, subject_unique_id, secondary_id, site_protocol_name, site_name,
					warehouse_insert_created_timestamp
					) values (	
					'SS_TS4_102_',		
					'TS4_102_04'
					, '', '', '102'
					, 'Site B'
					
					,'2015-03-19T16:41:35.717Z'
					);
								
					
					insert into NCT01928420_All_Data.study_subject_listing (
					ssoid, ssid
					, subject_unique_id, secondary_id, site_protocol_name, site_name,
					warehouse_insert_created_timestamp
					) values (	
					'SS_TS6_102_',		
					'TS6_102_06'
					, '', '', '102'
					, 'Site B'
					
					,'2015-03-19T16:41:35.717Z'
					);
								
					
					insert into NCT01928420_All_Data.study_subject_listing (
					ssoid, ssid
					, subject_unique_id, secondary_id, site_protocol_name, site_name,
					warehouse_insert_created_timestamp
					) values (	
					'SS_TS8_102_',		
					'TS8_102_08'
					, '', '', '102'
					, 'Site B'
					
					,'2015-03-19T16:41:35.717Z'
					);
								
					
					insert into NCT01928420_All_Data.study_subject_listing (
					ssoid, ssid
					, subject_unique_id, secondary_id, site_protocol_name, site_name,
					warehouse_insert_created_timestamp
					) values (	
					'SS_TS10_103',		
					'TS10_103_10'
					, '', '', '103'
					, 'Site C'
					
					,'2015-03-19T16:41:35.717Z'
					);
								
					
					insert into NCT01928420_All_Data.study_subject_listing (
					ssoid, ssid
					, subject_unique_id, secondary_id, site_protocol_name, site_name,
					warehouse_insert_created_timestamp
					) values (	
					'SS_TS1_103_',		
					'TS1_103_01'
					, '', '', '103'
					, 'Site C'
					
					,'2015-03-19T16:41:35.717Z'
					);
								
					
					insert into NCT01928420_All_Data.study_subject_listing (
					ssoid, ssid
					, subject_unique_id, secondary_id, site_protocol_name, site_name,
					warehouse_insert_created_timestamp
					) values (	
					'SS_TS3_103_',		
					'TS3_103_03'
					, '', '', '103'
					, 'Site C'
					
					,'2015-03-19T16:41:35.717Z'
					);
								
					
					insert into NCT01928420_All_Data.study_subject_listing (
					ssoid, ssid
					, subject_unique_id, secondary_id, site_protocol_name, site_name,
					warehouse_insert_created_timestamp
					) values (	
					'SS_TS4_103_',		
					'TS4_103_04'
					, '', '', '103'
					, 'Site C'
					
					,'2015-03-19T16:41:35.717Z'
					);
								
					
					insert into NCT01928420_All_Data.study_subject_listing (
					ssoid, ssid
					, subject_unique_id, secondary_id, site_protocol_name, site_name,
					warehouse_insert_created_timestamp
					) values (	
					'SS_TS6_103_',		
					'TS6_103_06'
					, '', '', '103'
					, 'Site C'
					
					,'2015-03-19T16:41:35.717Z'
					);
								
					
					insert into NCT01928420_All_Data.study_subject_listing (
					ssoid, ssid
					, subject_unique_id, secondary_id, site_protocol_name, site_name,
					warehouse_insert_created_timestamp
					) values (	
					'SS_TS8_103_',		
					'TS8_103_08'
					, '', '', '103'
					, 'Site C'
					
					,'2015-03-19T16:41:35.717Z'
					);
								
					
					insert into NCT01928420_All_Data.study_subject_listing (
					ssoid, ssid
					, subject_unique_id, secondary_id, site_protocol_name, site_name,
					warehouse_insert_created_timestamp
					) values (	
					'SS_TS10_104',		
					'TS10_104_10'
					, '', '', '104'
					, 'Site D'
					
					,'2015-03-19T16:41:35.717Z'
					);
								
					
					insert into NCT01928420_All_Data.study_subject_listing (
					ssoid, ssid
					, subject_unique_id, secondary_id, site_protocol_name, site_name,
					warehouse_insert_created_timestamp
					) values (	
					'SS_TS1_104_',		
					'TS1_104_01'
					, '', '', '104'
					, 'Site D'
					
					,'2015-03-19T16:41:35.717Z'
					);
								
					
					insert into NCT01928420_All_Data.study_subject_listing (
					ssoid, ssid
					, subject_unique_id, secondary_id, site_protocol_name, site_name,
					warehouse_insert_created_timestamp
					) values (	
					'SS_TS11_104',		
					'TS11_104_11'
					, '', '', '104'
					, 'Site D'
					
					,'2015-03-19T16:41:35.717Z'
					);
								
					
					insert into NCT01928420_All_Data.study_subject_listing (
					ssoid, ssid
					, subject_unique_id, secondary_id, site_protocol_name, site_name,
					warehouse_insert_created_timestamp
					) values (	
					'SS_TS3_104_',		
					'TS3_104_03'
					, '', '', '104'
					, 'Site D'
					
					,'2015-03-19T16:41:35.717Z'
					);
								
					
					insert into NCT01928420_All_Data.study_subject_listing (
					ssoid, ssid
					, subject_unique_id, secondary_id, site_protocol_name, site_name,
					warehouse_insert_created_timestamp
					) values (	
					'SS_TS4_104_',		
					'TS4_104_04'
					, '', '', '104'
					, 'Site D'
					
					,'2015-03-19T16:41:35.717Z'
					);
								
					
					insert into NCT01928420_All_Data.study_subject_listing (
					ssoid, ssid
					, subject_unique_id, secondary_id, site_protocol_name, site_name,
					warehouse_insert_created_timestamp
					) values (	
					'SS_TS6_104_',		
					'TS6_104_06'
					, '', '', '104'
					, 'Site D'
					
					,'2015-03-19T16:41:35.717Z'
					);
								
					
					insert into NCT01928420_All_Data.study_subject_listing (
					ssoid, ssid
					, subject_unique_id, secondary_id, site_protocol_name, site_name,
					warehouse_insert_created_timestamp
					) values (	
					'SS_TS8_104_',		
					'TS8_104_08'
					, '', '', '104'
					, 'Site D'
					
					,'2015-03-19T16:41:35.717Z'
					);
								
					
					insert into NCT01928420_All_Data.study_subject_listing (
					ssoid, ssid
					, subject_unique_id, secondary_id, site_protocol_name, site_name,
					warehouse_insert_created_timestamp
					) values (	
					'SS_TS1_105_',		
					'TS1_105_01'
					, '', '', '105'
					, 'Site E'
					
					,'2015-03-19T16:41:35.717Z'
					);
								
					
					insert into NCT01928420_All_Data.study_subject_listing (
					ssoid, ssid
					, subject_unique_id, secondary_id, site_protocol_name, site_name,
					warehouse_insert_created_timestamp
					) values (	
					'SS_TS13_105',		
					'TS13_105_13'
					, '', '', '105'
					, 'Site E'
					
					,'2015-03-19T16:41:35.717Z'
					);
								
					
					insert into NCT01928420_All_Data.study_subject_listing (
					ssoid, ssid
					, subject_unique_id, secondary_id, site_protocol_name, site_name,
					warehouse_insert_created_timestamp
					) values (	
					'SS_TS2_105_',		
					'TS2_105_02'
					, '', '', '105'
					, 'Site E'
					
					,'2015-03-19T16:41:35.717Z'
					);
								
					
					insert into NCT01928420_All_Data.study_subject_listing (
					ssoid, ssid
					, subject_unique_id, secondary_id, site_protocol_name, site_name,
					warehouse_insert_created_timestamp
					) values (	
					'SS_TS5_105_',		
					'TS5_105_05'
					, '', '', '105'
					, 'Site E'
					
					,'2015-03-19T16:41:35.717Z'
					);
								
					
					insert into NCT01928420_All_Data.study_subject_listing (
					ssoid, ssid
					, subject_unique_id, secondary_id, site_protocol_name, site_name,
					warehouse_insert_created_timestamp
					) values (	
					'SS_TS6_105_',		
					'TS6_105_06'
					, '', '', '105'
					, 'Site E'
					
					,'2015-03-19T16:41:35.717Z'
					);
								
					
					insert into NCT01928420_All_Data.study_subject_listing (
					ssoid, ssid
					, subject_unique_id, secondary_id, site_protocol_name, site_name,
					warehouse_insert_created_timestamp
					) values (	
					'SS_TS7_105_',		
					'TS7_105_07'
					, '', '', '105'
					, 'Site E'
					
					,'2015-03-19T16:41:35.717Z'
					);
								
					
					insert into NCT01928420_All_Data.study_subject_listing (
					ssoid, ssid
					, subject_unique_id, secondary_id, site_protocol_name, site_name,
					warehouse_insert_created_timestamp
					) values (	
					'SS_TS9_105_',		
					'TS9_105_09'
					, '', '', '105'
					, 'Site E'
					
					,'2015-03-19T16:41:35.717Z'
					);
							
			create table NCT01928420_All_Data.crf_version (
			crf_version_id serial NOT NULL,
			crf_name character varying(255),
			crf_version_name character varying(255),
			warehouse_insert_created_timestamp timestamp with time zone,
			CONSTRAINT Uk_crf_version_crf_version UNIQUE (crf_name, crf_version_name)
			);
		
		
			
			CREATE TABLE NCT01928420_All_Data.crf_status_summary (
			crf_status_summary_id serial,
			site_name character varying(255),
			ssoid character varying(40),	
			ssid character varying(40),
			study_event_oid character varying(40),
			event_ordinal integer DEFAULT 1,
			crf_name character varying(255),
			crf_version character varying(255),			
			
		
		
						
            crf_status_initial_data_entry  integer,
			crf_status_double_data_entry  integer,
			crf_status_data_entry_complete  integer,
			crf_status_locked  integer,								
			crf_status_initial_data_entry_complete  integer,  
			
		
		
		
			event_status_data_entry_started  integer,							
			event_status_completed  integer,
			event_status_signed  integer,			
			event_status_skipped  integer,
			event_status_stopped  integer,							
			event_status_locked   integer,
			warehouse_insert_created_timestamp timestamp with time zone);
			
			
			ALTER TABLE NCT01928420_All_Data.crf_status_summary ADD CONSTRAINT Fk_ssoid_ssid_crf_status_summary FOREIGN KEY (ssoid, ssid) REFERENCES NCT01928420_All_Data.study_subject_listing;			
	
			  
			
					insert into NCT01928420_All_Data.crf_version (crf_name, crf_version_name, warehouse_insert_created_timestamp) values 
					( 'Verification of Informed Consent', 
					'v2.0',
					'2015-03-19T16:41:35.717Z');
			
			
			
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS10_101',
									
					'TS10_101_10',
					
				'SE_FIRSTVISIT',
				
				'Verification of Informed Consent',
				'v2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS3_101_',
									
					'TS3_101_03',
					
				'SE_FIRSTVISIT',
				
				'Verification of Informed Consent',
				'v2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS4_101_',
									
					'TS4_101_04',
					
				'SE_FIRSTVISIT',
				
				'Verification of Informed Consent',
				'v2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS6_101_',
									
					'TS6_101_06',
					
				'SE_FIRSTVISIT',
				
				'Verification of Informed Consent',
				'v2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS10_102',
									
					'TS10_102_10',
					
				'SE_FIRSTVISIT',
				
				'Verification of Informed Consent',
				'v2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS1_102_',
									
					'TS1_102_01',
					
				'SE_FIRSTVISIT',
				
				'Verification of Informed Consent',
				'v2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS3_102_',
									
					'TS3_102_03',
					
				'SE_FIRSTVISIT',
				
				'Verification of Informed Consent',
				'v2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS4_102_',
									
					'TS4_102_04',
					
				'SE_FIRSTVISIT',
				
				'Verification of Informed Consent',
				'v2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS6_102_',
									
					'TS6_102_06',
					
				'SE_FIRSTVISIT',
				
				'Verification of Informed Consent',
				'v2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS8_102_',
									
					'TS8_102_08',
					
				'SE_FIRSTVISIT',
				
				'Verification of Informed Consent',
				'v2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS10_103',
									
					'TS10_103_10',
					
				'SE_FIRSTVISIT',
				
				'Verification of Informed Consent',
				'v2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS1_103_',
									
					'TS1_103_01',
					
				'SE_FIRSTVISIT',
				
				'Verification of Informed Consent',
				'v2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS3_103_',
									
					'TS3_103_03',
					
				'SE_FIRSTVISIT',
				
				'Verification of Informed Consent',
				'v2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS4_103_',
									
					'TS4_103_04',
					
				'SE_FIRSTVISIT',
				
				'Verification of Informed Consent',
				'v2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS6_103_',
									
					'TS6_103_06',
					
				'SE_FIRSTVISIT',
				
				'Verification of Informed Consent',
				'v2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS8_103_',
									
					'TS8_103_08',
					
				'SE_FIRSTVISIT',
				
				'Verification of Informed Consent',
				'v2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS10_104',
									
					'TS10_104_10',
					
				'SE_FIRSTVISIT',
				
				'Verification of Informed Consent',
				'v2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS1_104_',
									
					'TS1_104_01',
					
				'SE_FIRSTVISIT',
				
				'Verification of Informed Consent',
				'v2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS3_104_',
									
					'TS3_104_03',
					
				'SE_FIRSTVISIT',
				
				'Verification of Informed Consent',
				'v2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS4_104_',
									
					'TS4_104_04',
					
				'SE_FIRSTVISIT',
				
				'Verification of Informed Consent',
				'v2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS6_104_',
									
					'TS6_104_06',
					
				'SE_FIRSTVISIT',
				
				'Verification of Informed Consent',
				'v2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS8_104_',
									
					'TS8_104_08',
					
				'SE_FIRSTVISIT',
				
				'Verification of Informed Consent',
				'v2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS13_105',
									
					'TS13_105_13',
					
				'SE_FIRSTVISIT',
				
				'Verification of Informed Consent',
				'v2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS2_105_',
									
					'TS2_105_02',
					
				'SE_FIRSTVISIT',
				
				'Verification of Informed Consent',
				'v2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS5_105_',
									
					'TS5_105_05',
					
				'SE_FIRSTVISIT',
				
				'Verification of Informed Consent',
				'v2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS6_105_',
									
					'TS6_105_06',
					
				'SE_FIRSTVISIT',
				
				'Verification of Informed Consent',
				'v2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS7_105_',
									
					'TS7_105_07',
					
				'SE_FIRSTVISIT',
				
				'Verification of Informed Consent',
				'v2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS9_105_',
									
					'TS9_105_09',
					
				'SE_FIRSTVISIT',
				
				'Verification of Informed Consent',
				'v2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
				create table NCT01928420_All_Data.Verification_of_Informed_Consent (
				item_data_id serial NOT NULL,
				ssoid character varying(40) NOT NULL,
				ssid character varying(40) NOT NULL,
				study_event_oid character varying(40) NOT NULL,
				event_ordinal integer default 1,
				crf_version character varying(255),
				event_start_date timestamp without time zone,
				event_end_date timestamp without time zone,
				event_status character varying(255),
				event_location character varying(2000),
				subject_age_at_event integer,
				crf_status character varying(255), 
				interviewerName character varying(255),
				interviewDate date,
				warehouse_insert_created_timestamp timestamp with time zone); 			          	 
				
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Verification_of_Informed_Consent', 'ELIGIBILITY_CONF', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Verification_of_Informed_Consent', 'ELIGIBILITY_CONF_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Verification_of_Informed_Consent', 'VERI_INIT', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Verification_of_Informed_Consent', 'VERI_DATE', 'date');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Verification_of_Informed_Consent', 'IFC_PDF', 'text');

	
				
		ALTER TABLE NCT01928420_All_Data.Verification_of_Informed_Consent ADD CONSTRAINT Pk_UNGROUPE PRIMARY KEY (item_data_id);

		
				
		ALTER TABLE NCT01928420_All_Data.Verification_of_Informed_Consent ADD CONSTRAINT 	
		Fk_study_subject_id_UNGROUPE FOREIGN KEY (ssoid, 
		ssid) REFERENCES NCT01928420_All_Data.study_subject_listing;
		
				
									insert into NCT01928420_All_Data.Verification_of_Informed_Consent (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														ELIGIBILITY_CONF
																												
																	,ELIGIBILITY_CONF_label																									
																,
																
														
														VERI_INIT																									
																,
																
														
														VERI_DATE
										)
									values (
									
									
									'SS_TS10_101',
									
									'TS10_101_10', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'v2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,'GW'
															,'2014-06-10'		
									);
										
									insert into NCT01928420_All_Data.Verification_of_Informed_Consent (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														ELIGIBILITY_CONF
																												
																	,ELIGIBILITY_CONF_label																									
																,
																
														
														VERI_INIT																									
																,
																
														
														VERI_DATE
										)
									values (
									
									
									'SS_TS3_101_',
									
									'TS3_101_03', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'v2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,'GW'
															,'2014-06-10'		
									);
										
									insert into NCT01928420_All_Data.Verification_of_Informed_Consent (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														ELIGIBILITY_CONF
																												
																	,ELIGIBILITY_CONF_label																									
																,
																
														
														VERI_INIT																									
																,
																
														
														VERI_DATE
										)
									values (
									
									
									'SS_TS4_101_',
									
									'TS4_101_04', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'v2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,'JM'
															,'2014-06-10'		
									);
										
									insert into NCT01928420_All_Data.Verification_of_Informed_Consent (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														ELIGIBILITY_CONF
																												
																	,ELIGIBILITY_CONF_label																									
																,
																
														
														VERI_INIT																									
																,
																
														
														VERI_DATE
										)
									values (
									
									
									'SS_TS6_101_',
									
									'TS6_101_06', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'v2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,'GW'
															,'2014-06-10'		
									);
										
									insert into NCT01928420_All_Data.Verification_of_Informed_Consent (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														ELIGIBILITY_CONF
																												
																	,ELIGIBILITY_CONF_label																									
																,
																
														
														VERI_INIT																									
																,
																
														
														VERI_DATE
										)
									values (
									
									
									'SS_TS10_102',
									
									'TS10_102_10', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'v2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,'GW'
															,'2014-06-10'		
									);
										
									insert into NCT01928420_All_Data.Verification_of_Informed_Consent (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														ELIGIBILITY_CONF
																												
																	,ELIGIBILITY_CONF_label																									
																,
																
														
														VERI_INIT																									
																,
																
														
														VERI_DATE
										)
									values (
									
									
									'SS_TS1_102_',
									
									'TS1_102_01', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'v2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,'GW'
															,'2014-06-10'		
									);
										
									insert into NCT01928420_All_Data.Verification_of_Informed_Consent (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														ELIGIBILITY_CONF
																												
																	,ELIGIBILITY_CONF_label																									
																,
																
														
														VERI_INIT																									
																,
																
														
														VERI_DATE
										)
									values (
									
									
									'SS_TS3_102_',
									
									'TS3_102_03', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'v2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,'GW'
															,'2014-06-10'		
									);
										
									insert into NCT01928420_All_Data.Verification_of_Informed_Consent (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														ELIGIBILITY_CONF
																												
																	,ELIGIBILITY_CONF_label																									
																,
																
														
														VERI_INIT																									
																,
																
														
														VERI_DATE
										)
									values (
									
									
									'SS_TS4_102_',
									
									'TS4_102_04', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'v2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,'JM'
															,'2014-06-10'		
									);
										
									insert into NCT01928420_All_Data.Verification_of_Informed_Consent (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														ELIGIBILITY_CONF
																												
																	,ELIGIBILITY_CONF_label																									
																,
																
														
														VERI_INIT																									
																,
																
														
														VERI_DATE
										)
									values (
									
									
									'SS_TS6_102_',
									
									'TS6_102_06', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'v2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,'GW'
															,'2014-06-10'		
									);
										
									insert into NCT01928420_All_Data.Verification_of_Informed_Consent (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														ELIGIBILITY_CONF
																												
																	,ELIGIBILITY_CONF_label																									
																,
																
														
														VERI_INIT																									
																,
																
														
														VERI_DATE
										)
									values (
									
									
									'SS_TS8_102_',
									
									'TS8_102_08', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'v2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,'GW'
															,'2014-06-10'		
									);
										
									insert into NCT01928420_All_Data.Verification_of_Informed_Consent (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														ELIGIBILITY_CONF
																												
																	,ELIGIBILITY_CONF_label																									
																,
																
														
														VERI_INIT																									
																,
																
														
														VERI_DATE
										)
									values (
									
									
									'SS_TS10_103',
									
									'TS10_103_10', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'v2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,'GW'
															,'2014-06-10'		
									);
										
									insert into NCT01928420_All_Data.Verification_of_Informed_Consent (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														ELIGIBILITY_CONF
																												
																	,ELIGIBILITY_CONF_label																									
																,
																
														
														VERI_INIT																									
																,
																
														
														VERI_DATE
										)
									values (
									
									
									'SS_TS1_103_',
									
									'TS1_103_01', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'v2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,'GW'
															,'2014-06-10'		
									);
										
									insert into NCT01928420_All_Data.Verification_of_Informed_Consent (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														ELIGIBILITY_CONF
																												
																	,ELIGIBILITY_CONF_label																									
																,
																
														
														VERI_INIT																									
																,
																
														
														VERI_DATE
										)
									values (
									
									
									'SS_TS3_103_',
									
									'TS3_103_03', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'v2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,'GW'
															,'2014-06-10'		
									);
										
									insert into NCT01928420_All_Data.Verification_of_Informed_Consent (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														ELIGIBILITY_CONF
																												
																	,ELIGIBILITY_CONF_label																									
																,
																
														
														VERI_INIT																									
																,
																
														
														VERI_DATE
										)
									values (
									
									
									'SS_TS4_103_',
									
									'TS4_103_04', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'v2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,'JM'
															,'2014-06-10'		
									);
										
									insert into NCT01928420_All_Data.Verification_of_Informed_Consent (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														ELIGIBILITY_CONF
																												
																	,ELIGIBILITY_CONF_label																									
																,
																
														
														VERI_INIT																									
																,
																
														
														VERI_DATE
										)
									values (
									
									
									'SS_TS6_103_',
									
									'TS6_103_06', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'v2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,'GW'
															,'2014-06-10'		
									);
										
									insert into NCT01928420_All_Data.Verification_of_Informed_Consent (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														ELIGIBILITY_CONF
																												
																	,ELIGIBILITY_CONF_label																									
																,
																
														
														VERI_INIT																									
																,
																
														
														VERI_DATE
										)
									values (
									
									
									'SS_TS8_103_',
									
									'TS8_103_08', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'v2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,'GW'
															,'2014-06-10'		
									);
										
									insert into NCT01928420_All_Data.Verification_of_Informed_Consent (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														ELIGIBILITY_CONF
																												
																	,ELIGIBILITY_CONF_label																									
																,
																
														
														VERI_INIT																									
																,
																
														
														VERI_DATE
										)
									values (
									
									
									'SS_TS10_104',
									
									'TS10_104_10', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'v2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,'GW'
															,'2014-06-10'		
									);
										
									insert into NCT01928420_All_Data.Verification_of_Informed_Consent (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														ELIGIBILITY_CONF
																												
																	,ELIGIBILITY_CONF_label																									
																,
																
														
														VERI_INIT																									
																,
																
														
														VERI_DATE
										)
									values (
									
									
									'SS_TS1_104_',
									
									'TS1_104_01', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'v2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,'GW'
															,'2014-06-10'		
									);
										
									insert into NCT01928420_All_Data.Verification_of_Informed_Consent (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														ELIGIBILITY_CONF
																												
																	,ELIGIBILITY_CONF_label																									
																,
																
														
														VERI_INIT																									
																,
																
														
														VERI_DATE
										)
									values (
									
									
									'SS_TS3_104_',
									
									'TS3_104_03', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'v2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,'GW'
															,'2014-06-10'		
									);
										
									insert into NCT01928420_All_Data.Verification_of_Informed_Consent (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														ELIGIBILITY_CONF
																												
																	,ELIGIBILITY_CONF_label																									
																,
																
														
														VERI_INIT																									
																,
																
														
														VERI_DATE
										)
									values (
									
									
									'SS_TS4_104_',
									
									'TS4_104_04', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'v2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,'JM'
															,'2014-06-10'		
									);
										
									insert into NCT01928420_All_Data.Verification_of_Informed_Consent (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														ELIGIBILITY_CONF
																												
																	,ELIGIBILITY_CONF_label																									
																,
																
														
														VERI_INIT																									
																,
																
														
														VERI_DATE
										)
									values (
									
									
									'SS_TS6_104_',
									
									'TS6_104_06', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'v2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,'GW'
															,'2014-06-10'		
									);
										
									insert into NCT01928420_All_Data.Verification_of_Informed_Consent (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														ELIGIBILITY_CONF
																												
																	,ELIGIBILITY_CONF_label																									
																,
																
														
														VERI_INIT																									
																,
																
														
														VERI_DATE
										)
									values (
									
									
									'SS_TS8_104_',
									
									'TS8_104_08', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'v2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,'GW'
															,'2014-06-10'		
									);
										
									insert into NCT01928420_All_Data.Verification_of_Informed_Consent (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														ELIGIBILITY_CONF
																												
																	,ELIGIBILITY_CONF_label																									
																,
																
														
														VERI_INIT																									
																,
																
														
														VERI_DATE
										)
									values (
									
									
									'SS_TS13_105',
									
									'TS13_105_13', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'v2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,'GW'
															,'2014-06-10'		
									);
										
									insert into NCT01928420_All_Data.Verification_of_Informed_Consent (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														ELIGIBILITY_CONF
																												
																	,ELIGIBILITY_CONF_label																									
																,
																
														
														VERI_INIT																									
																,
																
														
														VERI_DATE
										)
									values (
									
									
									'SS_TS2_105_',
									
									'TS2_105_02', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'v2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,'GW'
															,'2014-06-10'		
									);
										
									insert into NCT01928420_All_Data.Verification_of_Informed_Consent (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														ELIGIBILITY_CONF
																												
																	,ELIGIBILITY_CONF_label																									
																,
																
														
														VERI_INIT																									
																,
																
														
														VERI_DATE
										)
									values (
									
									
									'SS_TS5_105_',
									
									'TS5_105_05', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'v2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,'JM'
															,'2014-06-10'		
									);
										
									insert into NCT01928420_All_Data.Verification_of_Informed_Consent (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														ELIGIBILITY_CONF
																												
																	,ELIGIBILITY_CONF_label																									
																,
																
														
														VERI_INIT																									
																,
																
														
														VERI_DATE
										)
									values (
									
									
									'SS_TS6_105_',
									
									'TS6_105_06', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'v2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,'GW'
															,'2014-06-10'		
									);
										
									insert into NCT01928420_All_Data.Verification_of_Informed_Consent (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														ELIGIBILITY_CONF
																												
																	,ELIGIBILITY_CONF_label																									
																,
																
														
														VERI_INIT																									
																,
																
														
														VERI_DATE
										)
									values (
									
									
									'SS_TS7_105_',
									
									'TS7_105_07', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'v2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,'GW'
															,'2014-06-10'		
									);
										
									insert into NCT01928420_All_Data.Verification_of_Informed_Consent (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														ELIGIBILITY_CONF
																												
																	,ELIGIBILITY_CONF_label																									
																,
																
														
														VERI_INIT																									
																,
																
														
														VERI_DATE
										)
									values (
									
									
									'SS_TS9_105_',
									
									'TS9_105_09', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'v2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,'GW'
															,'2014-06-10'		
									);
								
			  
			
					insert into NCT01928420_All_Data.crf_version (crf_name, crf_version_name, warehouse_insert_created_timestamp) values 
					( 'Mini-Mental State Examination', 
					'V1.0',
					'2015-03-19T16:41:35.717Z');
			
			
			
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS10_101',
									
					'TS10_101_10',
					
				'SE_FIRSTVISIT',
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS10_101',
									
					'TS10_101_10',
					
				'SE_1WEEKFU',
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS10_101',
									
					'TS10_101_10',
					
				'SE_2WEEKFU',
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS10_101',
									
					'TS10_101_10',
					
				'SE_MONTHLYFU',
				1,
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS10_101',
									
					'TS10_101_10',
					
				'SE_MONTHLYFU',
				2,
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS3_101_',
									
					'TS3_101_03',
					
				'SE_FIRSTVISIT',
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS3_101_',
									
					'TS3_101_03',
					
				'SE_1WEEKFU',
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS3_101_',
									
					'TS3_101_03',
					
				'SE_2WEEKFU',
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS4_101_',
									
					'TS4_101_04',
					
				'SE_FIRSTVISIT',
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS6_101_',
									
					'TS6_101_06',
					
				'SE_FIRSTVISIT',
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS10_102',
									
					'TS10_102_10',
					
				'SE_FIRSTVISIT',
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS10_102',
									
					'TS10_102_10',
					
				'SE_1WEEKFU',
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS10_102',
									
					'TS10_102_10',
					
				'SE_2WEEKFU',
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS10_102',
									
					'TS10_102_10',
					
				'SE_MONTHLYFU',
				1,
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS10_102',
									
					'TS10_102_10',
					
				'SE_MONTHLYFU',
				2,
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS1_102_',
									
					'TS1_102_01',
					
				'SE_FIRSTVISIT',
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS1_102_',
									
					'TS1_102_01',
					
				'SE_1WEEKFU',
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS1_102_',
									
					'TS1_102_01',
					
				'SE_2WEEKFU',
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS3_102_',
									
					'TS3_102_03',
					
				'SE_FIRSTVISIT',
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS3_102_',
									
					'TS3_102_03',
					
				'SE_1WEEKFU',
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS3_102_',
									
					'TS3_102_03',
					
				'SE_2WEEKFU',
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS4_102_',
									
					'TS4_102_04',
					
				'SE_FIRSTVISIT',
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS6_102_',
									
					'TS6_102_06',
					
				'SE_FIRSTVISIT',
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS6_102_',
									
					'TS6_102_06',
					
				'SE_1WEEKFU',
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS8_102_',
									
					'TS8_102_08',
					
				'SE_FIRSTVISIT',
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS8_102_',
									
					'TS8_102_08',
					
				'SE_1WEEKFU',
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS8_102_',
									
					'TS8_102_08',
					
				'SE_2WEEKFU',
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS8_102_',
									
					'TS8_102_08',
					
				'SE_MONTHLYFU',
				1,
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS8_102_',
									
					'TS8_102_08',
					
				'SE_MONTHLYFU',
				2,
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS10_103',
									
					'TS10_103_10',
					
				'SE_FIRSTVISIT',
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS10_103',
									
					'TS10_103_10',
					
				'SE_1WEEKFU',
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS10_103',
									
					'TS10_103_10',
					
				'SE_2WEEKFU',
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS10_103',
									
					'TS10_103_10',
					
				'SE_MONTHLYFU',
				1,
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS10_103',
									
					'TS10_103_10',
					
				'SE_MONTHLYFU',
				2,
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS1_103_',
									
					'TS1_103_01',
					
				'SE_FIRSTVISIT',
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS1_103_',
									
					'TS1_103_01',
					
				'SE_1WEEKFU',
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS1_103_',
									
					'TS1_103_01',
					
				'SE_2WEEKFU',
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS3_103_',
									
					'TS3_103_03',
					
				'SE_FIRSTVISIT',
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS3_103_',
									
					'TS3_103_03',
					
				'SE_1WEEKFU',
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS3_103_',
									
					'TS3_103_03',
					
				'SE_2WEEKFU',
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS4_103_',
									
					'TS4_103_04',
					
				'SE_FIRSTVISIT',
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS6_103_',
									
					'TS6_103_06',
					
				'SE_FIRSTVISIT',
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS8_103_',
									
					'TS8_103_08',
					
				'SE_FIRSTVISIT',
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS8_103_',
									
					'TS8_103_08',
					
				'SE_1WEEKFU',
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS8_103_',
									
					'TS8_103_08',
					
				'SE_2WEEKFU',
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS8_103_',
									
					'TS8_103_08',
					
				'SE_MONTHLYFU',
				1,
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS8_103_',
									
					'TS8_103_08',
					
				'SE_MONTHLYFU',
				2,
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS10_104',
									
					'TS10_104_10',
					
				'SE_FIRSTVISIT',
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS10_104',
									
					'TS10_104_10',
					
				'SE_1WEEKFU',
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS10_104',
									
					'TS10_104_10',
					
				'SE_2WEEKFU',
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS10_104',
									
					'TS10_104_10',
					
				'SE_MONTHLYFU',
				1,
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS10_104',
									
					'TS10_104_10',
					
				'SE_MONTHLYFU',
				2,
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS1_104_',
									
					'TS1_104_01',
					
				'SE_FIRSTVISIT',
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS1_104_',
									
					'TS1_104_01',
					
				'SE_1WEEKFU',
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS1_104_',
									
					'TS1_104_01',
					
				'SE_2WEEKFU',
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS3_104_',
									
					'TS3_104_03',
					
				'SE_FIRSTVISIT',
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS3_104_',
									
					'TS3_104_03',
					
				'SE_1WEEKFU',
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS3_104_',
									
					'TS3_104_03',
					
				'SE_2WEEKFU',
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS4_104_',
									
					'TS4_104_04',
					
				'SE_FIRSTVISIT',
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS6_104_',
									
					'TS6_104_06',
					
				'SE_FIRSTVISIT',
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS8_104_',
									
					'TS8_104_08',
					
				'SE_FIRSTVISIT',
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS8_104_',
									
					'TS8_104_08',
					
				'SE_1WEEKFU',
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS8_104_',
									
					'TS8_104_08',
					
				'SE_2WEEKFU',
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS8_104_',
									
					'TS8_104_08',
					
				'SE_MONTHLYFU',
				1,
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS8_104_',
									
					'TS8_104_08',
					
				'SE_MONTHLYFU',
				2,
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS13_105',
									
					'TS13_105_13',
					
				'SE_FIRSTVISIT',
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS13_105',
									
					'TS13_105_13',
					
				'SE_1WEEKFU',
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS13_105',
									
					'TS13_105_13',
					
				'SE_2WEEKFU',
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS13_105',
									
					'TS13_105_13',
					
				'SE_MONTHLYFU',
				1,
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS13_105',
									
					'TS13_105_13',
					
				'SE_MONTHLYFU',
				2,
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS2_105_',
									
					'TS2_105_02',
					
				'SE_FIRSTVISIT',
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS2_105_',
									
					'TS2_105_02',
					
				'SE_1WEEKFU',
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS2_105_',
									
					'TS2_105_02',
					
				'SE_2WEEKFU',
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS5_105_',
									
					'TS5_105_05',
					
				'SE_FIRSTVISIT',
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS6_105_',
									
					'TS6_105_06',
					
				'SE_FIRSTVISIT',
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS7_105_',
									
					'TS7_105_07',
					
				'SE_FIRSTVISIT',
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS7_105_',
									
					'TS7_105_07',
					
				'SE_1WEEKFU',
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS7_105_',
									
					'TS7_105_07',
					
				'SE_2WEEKFU',
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS9_105_',
									
					'TS9_105_09',
					
				'SE_FIRSTVISIT',
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS9_105_',
									
					'TS9_105_09',
					
				'SE_1WEEKFU',
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS9_105_',
									
					'TS9_105_09',
					
				'SE_2WEEKFU',
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS9_105_',
									
					'TS9_105_09',
					
				'SE_MONTHLYFU',
				1,
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS9_105_',
									
					'TS9_105_09',
					
				'SE_MONTHLYFU',
				2,
				
				'Mini-Mental State Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
				create table NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
				item_data_id serial NOT NULL,
				ssoid character varying(40) NOT NULL,
				ssid character varying(40) NOT NULL,
				study_event_oid character varying(40) NOT NULL,
				event_ordinal integer default 1,
				crf_version character varying(255),
				event_start_date timestamp without time zone,
				event_end_date timestamp without time zone,
				event_status character varying(255),
				event_location character varying(2000),
				subject_age_at_event integer,
				crf_status character varying(255), 
				interviewerName character varying(255),
				interviewDate date,
				warehouse_insert_created_timestamp timestamp with time zone); 			          	 
				
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE', 'MM_YEAR', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE', 'MM_YEAR_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE', 'MM_SEASN', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE', 'MM_SEASN_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE', 'MM_MONTH', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE', 'MM_MONTH_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE', 'MM_DATE', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE', 'MM_DATE_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE', 'MM_DAYWK', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE', 'MM_DAYWK_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE', 'MM_CNTRY', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE', 'MM_CNTRY_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE', 'MM_STATE', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE', 'MM_STATE_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE', 'MM_CITY', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE', 'MM_CITY_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE', 'MM_BUILD', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE', 'MM_BUILD_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE', 'MM_FLOOR', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE', 'MM_FLOOR_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE', 'MM_OBJ', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE', 'MM_OBJ_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE', 'MM_SPELL', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE', 'MM_SPELL_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE', 'MM_OBJ2', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE', 'MM_OBJ2_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE', 'MM_WATCH', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE', 'MM_WATCH_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE', 'MM_PENCIL', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE', 'MM_PENCIL_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE', 'MM_REPT', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE', 'MM_REPT_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE', 'MM_VDIR', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE', 'MM_VDIR_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE', 'MM_WDIR', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE', 'MM_WDIR_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE', 'MM_CPY', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE', 'MM_CPY_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE', 'MM_SENT', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE', 'MM_SENT_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE', 'MM_SCORE', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE', 'MM_RATE', 'integer');

	
				
		ALTER TABLE NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE ADD CONSTRAINT Pk_MMSE PRIMARY KEY (item_data_id);

		
				
		ALTER TABLE NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE ADD CONSTRAINT 	
		Fk_study_subject_id_MMSE FOREIGN KEY (ssoid, 
		ssid) REFERENCES NCT01928420_All_Data.study_subject_listing;
		
				
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS10_101',
									
									'TS10_101_10', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,5													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,22
															,9		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS10_101',
									
									'TS10_101_10', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,5													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,20
															,8		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS10_101',
									
									'TS10_101_10', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,5													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,20
															,7		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS10_101',
									
									'TS10_101_10', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,1
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,14
															,4		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS10_101',
									
									'TS10_101_10', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,2
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,15
															,4		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS3_101_',
									
									'TS3_101_03', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,14
															,7		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS3_101_',
									
									'TS3_101_03', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,5													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,21
															,7		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS3_101_',
									
									'TS3_101_03', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,15
															,5		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS4_101_',
									
									'TS4_101_04', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,19
															,5		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS6_101_',
									
									'TS6_101_06', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,5													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,18
															,5		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS10_102',
									
									'TS10_102_10', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,5													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,22
															,9		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS10_102',
									
									'TS10_102_10', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,5													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,20
															,8		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS10_102',
									
									'TS10_102_10', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,5													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,20
															,7		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS10_102',
									
									'TS10_102_10', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,1
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,14
															,4		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS10_102',
									
									'TS10_102_10', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,2
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,15
															,4		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS1_102_',
									
									'TS1_102_01', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,14
															,7		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS1_102_',
									
									'TS1_102_01', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,5													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,21
															,7		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS1_102_',
									
									'TS1_102_01', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,15
															,5		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS3_102_',
									
									'TS3_102_03', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,14
															,7		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS3_102_',
									
									'TS3_102_03', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,5													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,21
															,7		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS3_102_',
									
									'TS3_102_03', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,15
															,5		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS4_102_',
									
									'TS4_102_04', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,19
															,5		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS6_102_',
									
									'TS6_102_06', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,5													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,18
															,5		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS6_102_',
									
									'TS6_102_06', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,5													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,18
															,6		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS8_102_',
									
									'TS8_102_08', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,5													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,22
															,9		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS8_102_',
									
									'TS8_102_08', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,5													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,20
															,8		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS8_102_',
									
									'TS8_102_08', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,5													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,20
															,7		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS8_102_',
									
									'TS8_102_08', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,1
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,14
															,4		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS8_102_',
									
									'TS8_102_08', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,2
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,15
															,4		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS10_103',
									
									'TS10_103_10', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,5													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,22
															,9		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS10_103',
									
									'TS10_103_10', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,5													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,20
															,8		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS10_103',
									
									'TS10_103_10', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,5													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,20
															,7		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS10_103',
									
									'TS10_103_10', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,1
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,14
															,4		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS10_103',
									
									'TS10_103_10', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,2
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,15
															,4		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS1_103_',
									
									'TS1_103_01', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,14
															,7		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS1_103_',
									
									'TS1_103_01', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,5													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,21
															,7		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS1_103_',
									
									'TS1_103_01', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,15
															,5		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS3_103_',
									
									'TS3_103_03', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,14
															,7		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS3_103_',
									
									'TS3_103_03', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,5													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,21
															,7		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS3_103_',
									
									'TS3_103_03', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,15
															,5		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS4_103_',
									
									'TS4_103_04', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,19
															,5		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS6_103_',
									
									'TS6_103_06', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,5													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,18
															,5		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS8_103_',
									
									'TS8_103_08', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,5													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,22
															,9		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS8_103_',
									
									'TS8_103_08', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,5													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,20
															,8		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS8_103_',
									
									'TS8_103_08', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,5													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,20
															,7		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS8_103_',
									
									'TS8_103_08', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,1
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,14
															,4		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS8_103_',
									
									'TS8_103_08', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,2
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,15
															,4		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS10_104',
									
									'TS10_104_10', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,5													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,22
															,9		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS10_104',
									
									'TS10_104_10', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,5													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,20
															,8		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS10_104',
									
									'TS10_104_10', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,5													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,20
															,7		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS10_104',
									
									'TS10_104_10', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,1
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,14
															,4		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS10_104',
									
									'TS10_104_10', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,2
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,15
															,4		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS1_104_',
									
									'TS1_104_01', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,14
															,7		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS1_104_',
									
									'TS1_104_01', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,5													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,21
															,7		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS1_104_',
									
									'TS1_104_01', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,15
															,5		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS3_104_',
									
									'TS3_104_03', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,14
															,7		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS3_104_',
									
									'TS3_104_03', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,5													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,21
															,7		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS3_104_',
									
									'TS3_104_03', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,15
															,5		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS4_104_',
									
									'TS4_104_04', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,19
															,5		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS6_104_',
									
									'TS6_104_06', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,5													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,18
															,5		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS8_104_',
									
									'TS8_104_08', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,5													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,22
															,9		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS8_104_',
									
									'TS8_104_08', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,5													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,20
															,8		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS8_104_',
									
									'TS8_104_08', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,5													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,20
															,7		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS8_104_',
									
									'TS8_104_08', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,1
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,14
															,4		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS8_104_',
									
									'TS8_104_08', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,2
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,15
															,4		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS13_105',
									
									'TS13_105_13', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,5													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,22
															,9		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS13_105',
									
									'TS13_105_13', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,5													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,20
															,8		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS13_105',
									
									'TS13_105_13', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,5													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,20
															,7		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS13_105',
									
									'TS13_105_13', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,1
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,14
															,4		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS13_105',
									
									'TS13_105_13', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,2
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,15
															,4		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS2_105_',
									
									'TS2_105_02', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,14
															,7		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS2_105_',
									
									'TS2_105_02', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,5													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,21
															,7		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS2_105_',
									
									'TS2_105_02', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,15
															,5		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS5_105_',
									
									'TS5_105_05', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,19
															,5		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS6_105_',
									
									'TS6_105_06', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,5													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,18
															,5		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS7_105_',
									
									'TS7_105_07', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,14
															,7		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS7_105_',
									
									'TS7_105_07', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,5													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,21
															,7		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS7_105_',
									
									'TS7_105_07', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,15
															,5		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS9_105_',
									
									'TS9_105_09', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,5													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,22
															,9		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS9_105_',
									
									'TS9_105_09', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,5													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,20
															,8		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS9_105_',
									
									'TS9_105_09', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,5													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,20
															,7		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS9_105_',
									
									'TS9_105_09', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,1
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,14
															,4		
									);
										
									insert into NCT01928420_All_Data.Mini_Mental_State_ExaminationMMSE (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MM_YEAR
																												
																	,MM_YEAR_label																									
																,
																
														
														MM_SEASN
																												
																	,MM_SEASN_label																									
																,
																
														
														MM_MONTH
																												
																	,MM_MONTH_label																									
																,
																
														
														MM_DATE
																												
																	,MM_DATE_label																									
																,
																
														
														MM_DAYWK
																												
																	,MM_DAYWK_label																									
																,
																
														
														MM_CNTRY
																												
																	,MM_CNTRY_label																									
																,
																
														
														MM_STATE
																												
																	,MM_STATE_label																									
																,
																
														
														MM_CITY
																												
																	,MM_CITY_label																									
																,
																
														
														MM_BUILD
																												
																	,MM_BUILD_label																									
																,
																
														
														MM_FLOOR
																												
																	,MM_FLOOR_label																									
																,
																
														
														MM_OBJ
																												
																	,MM_OBJ_label																									
																,
																
														
														MM_SPELL
																												
																	,MM_SPELL_label																									
																,
																
														
														MM_OBJ2
																												
																	,MM_OBJ2_label																									
																,
																
														
														MM_WATCH
																												
																	,MM_WATCH_label																									
																,
																
														
														MM_PENCIL
																												
																	,MM_PENCIL_label																									
																,
																
														
														MM_REPT
																												
																	,MM_REPT_label																									
																,
																
														
														MM_VDIR
																												
																	,MM_VDIR_label																									
																,
																
														
														MM_WDIR
																												
																	,MM_WDIR_label																									
																,
																
														
														MM_CPY
																												
																	,MM_CPY_label																									
																,
																
														
														MM_SENT
																												
																	,MM_SENT_label																									
																,
																
														
														MM_SCORE																									
																,
																
														
														MM_RATE
										)
									values (
									
									
									'SS_TS9_105_',
									
									'TS9_105_09', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,2
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,3													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,0													
															,'No'											
														
															,0													
															,'No'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,15
															,4		
									);
								
			  
			
					insert into NCT01928420_All_Data.crf_version (crf_name, crf_version_name, warehouse_insert_created_timestamp) values 
					( 'Inclusion/Exclusion Criteria', 
					'V1.0',
					'2015-03-19T16:41:35.717Z');
			
			
			
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS10_101',
									
					'TS10_101_10',
					
				'SE_FIRSTVISIT',
				
				'Inclusion/Exclusion Criteria',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS3_101_',
									
					'TS3_101_03',
					
				'SE_FIRSTVISIT',
				
				'Inclusion/Exclusion Criteria',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS4_101_',
									
					'TS4_101_04',
					
				'SE_FIRSTVISIT',
				
				'Inclusion/Exclusion Criteria',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS6_101_',
									
					'TS6_101_06',
					
				'SE_FIRSTVISIT',
				
				'Inclusion/Exclusion Criteria',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS10_102',
									
					'TS10_102_10',
					
				'SE_FIRSTVISIT',
				
				'Inclusion/Exclusion Criteria',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS1_102_',
									
					'TS1_102_01',
					
				'SE_FIRSTVISIT',
				
				'Inclusion/Exclusion Criteria',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS3_102_',
									
					'TS3_102_03',
					
				'SE_FIRSTVISIT',
				
				'Inclusion/Exclusion Criteria',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS4_102_',
									
					'TS4_102_04',
					
				'SE_FIRSTVISIT',
				
				'Inclusion/Exclusion Criteria',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS6_102_',
									
					'TS6_102_06',
					
				'SE_FIRSTVISIT',
				
				'Inclusion/Exclusion Criteria',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS8_102_',
									
					'TS8_102_08',
					
				'SE_FIRSTVISIT',
				
				'Inclusion/Exclusion Criteria',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS10_103',
									
					'TS10_103_10',
					
				'SE_FIRSTVISIT',
				
				'Inclusion/Exclusion Criteria',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS1_103_',
									
					'TS1_103_01',
					
				'SE_FIRSTVISIT',
				
				'Inclusion/Exclusion Criteria',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS3_103_',
									
					'TS3_103_03',
					
				'SE_FIRSTVISIT',
				
				'Inclusion/Exclusion Criteria',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS4_103_',
									
					'TS4_103_04',
					
				'SE_FIRSTVISIT',
				
				'Inclusion/Exclusion Criteria',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS6_103_',
									
					'TS6_103_06',
					
				'SE_FIRSTVISIT',
				
				'Inclusion/Exclusion Criteria',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS8_103_',
									
					'TS8_103_08',
					
				'SE_FIRSTVISIT',
				
				'Inclusion/Exclusion Criteria',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS10_104',
									
					'TS10_104_10',
					
				'SE_FIRSTVISIT',
				
				'Inclusion/Exclusion Criteria',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS1_104_',
									
					'TS1_104_01',
					
				'SE_FIRSTVISIT',
				
				'Inclusion/Exclusion Criteria',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS3_104_',
									
					'TS3_104_03',
					
				'SE_FIRSTVISIT',
				
				'Inclusion/Exclusion Criteria',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS4_104_',
									
					'TS4_104_04',
					
				'SE_FIRSTVISIT',
				
				'Inclusion/Exclusion Criteria',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS6_104_',
									
					'TS6_104_06',
					
				'SE_FIRSTVISIT',
				
				'Inclusion/Exclusion Criteria',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS8_104_',
									
					'TS8_104_08',
					
				'SE_FIRSTVISIT',
				
				'Inclusion/Exclusion Criteria',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS13_105',
									
					'TS13_105_13',
					
				'SE_FIRSTVISIT',
				
				'Inclusion/Exclusion Criteria',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS2_105_',
									
					'TS2_105_02',
					
				'SE_FIRSTVISIT',
				
				'Inclusion/Exclusion Criteria',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS5_105_',
									
					'TS5_105_05',
					
				'SE_FIRSTVISIT',
				
				'Inclusion/Exclusion Criteria',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS6_105_',
									
					'TS6_105_06',
					
				'SE_FIRSTVISIT',
				
				'Inclusion/Exclusion Criteria',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS7_105_',
									
					'TS7_105_07',
					
				'SE_FIRSTVISIT',
				
				'Inclusion/Exclusion Criteria',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS9_105_',
									
					'TS9_105_09',
					
				'SE_FIRSTVISIT',
				
				'Inclusion/Exclusion Criteria',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
				create table NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility (
				item_data_id serial NOT NULL,
				ssoid character varying(40) NOT NULL,
				ssid character varying(40) NOT NULL,
				study_event_oid character varying(40) NOT NULL,
				event_ordinal integer default 1,
				crf_version character varying(255),
				event_start_date timestamp without time zone,
				event_end_date timestamp without time zone,
				event_status character varying(255),
				event_location character varying(2000),
				subject_age_at_event integer,
				crf_status character varying(255), 
				interviewerName character varying(255),
				interviewDate date,
				warehouse_insert_created_timestamp timestamp with time zone); 			          	 
				
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility', 'IN_NINCDS', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility', 'IN_NINCDS_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility', 'IN_MMSE', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility', 'IN_MMSE_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility', 'IN_NMDA', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility', 'IN_NMDA_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility', 'IN_HOME', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility', 'IN_HOME_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility', 'IN_CARE', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility', 'IN_CARE_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility', 'IN_ENGSP', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility', 'IN_ENGSP_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility', 'IN_STBL', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility', 'IN_STBL_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility', 'IN_DOSE', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility', 'IN_DOSE_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility', 'IN_HEPIN', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility', 'IN_HEPIN_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility', 'IN_ORAL', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility', 'IN_ORAL_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility', 'IN_IC', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility', 'IN_IC_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility', 'IN_DT_IC', 'date');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility', 'IN_DOC_IC', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility', 'EX_OGTT', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility', 'EX_OGTT_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility', 'EX_HEP', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility', 'EX_HEP_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility', 'EX_CARD', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility', 'EX_CARD_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility', 'EX_RECNT', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility', 'EX_RECNT_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility', 'EX_STRKE', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility', 'EX_STRKE_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility', 'EX_SEIZ', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility', 'EX_SEIZ_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility', 'EX_MENTL', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility', 'EX_MENTL_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility', 'EX_ORAL', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility', 'EX_ORAL_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility', 'EX_INS', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility', 'EX_INS_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility', 'EX_DRUG', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility', 'EX_DRUG_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility', 'INEX_ELIG', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility', 'INEX_ELIG_label', 'character varying(255)');

	
				
		ALTER TABLE NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility ADD CONSTRAINT Pk_ELIGIBIL PRIMARY KEY (item_data_id);

		
				
		ALTER TABLE NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility ADD CONSTRAINT 	
		Fk_study_subject_id_ELIGIBIL FOREIGN KEY (ssoid, 
		ssid) REFERENCES NCT01928420_All_Data.study_subject_listing;
		
				
									insert into NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														IN_NINCDS
																												
																	,IN_NINCDS_label																									
																,
																
														
														IN_MMSE
																												
																	,IN_MMSE_label																									
																,
																
														
														IN_NMDA
																												
																	,IN_NMDA_label																									
																,
																
														
														IN_HOME
																												
																	,IN_HOME_label																									
																,
																
														
														IN_CARE
																												
																	,IN_CARE_label																									
																,
																
														
														IN_ENGSP
																												
																	,IN_ENGSP_label																									
																,
																
														
														IN_STBL
																												
																	,IN_STBL_label																									
																,
																
														
														IN_DOSE
																												
																	,IN_DOSE_label																									
																,
																
														
														IN_HEPIN
																												
																	,IN_HEPIN_label																									
																,
																
														
														IN_ORAL
																												
																	,IN_ORAL_label																									
																,
																
														
														IN_IC
																												
																	,IN_IC_label																									
																,
																
														
														IN_DT_IC																									
																,
																
														
														EX_OGTT
																												
																	,EX_OGTT_label																									
																,
																
														
														EX_HEP
																												
																	,EX_HEP_label																									
																,
																
														
														EX_CARD
																												
																	,EX_CARD_label																									
																,
																
														
														EX_RECNT
																												
																	,EX_RECNT_label																									
																,
																
														
														EX_STRKE
																												
																	,EX_STRKE_label																									
																,
																
														
														EX_SEIZ
																												
																	,EX_SEIZ_label																									
																,
																
														
														EX_MENTL
																												
																	,EX_MENTL_label																									
																,
																
														
														EX_ORAL
																												
																	,EX_ORAL_label																									
																,
																
														
														EX_INS
																												
																	,EX_INS_label																									
																,
																
														
														EX_DRUG
																												
																	,EX_DRUG_label																									
																,
																
														
														INEX_ELIG
																												
																	,INEX_ELIG_label
										)
									values (
									
									
									'SS_TS10_101',
									
									'TS10_101_10', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,'2014-06-10'
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,1													
															,'Eligible'											
																
									);
										
									insert into NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														IN_NINCDS
																												
																	,IN_NINCDS_label																									
																,
																
														
														IN_MMSE
																												
																	,IN_MMSE_label																									
																,
																
														
														IN_NMDA
																												
																	,IN_NMDA_label																									
																,
																
														
														IN_HOME
																												
																	,IN_HOME_label																									
																,
																
														
														IN_CARE
																												
																	,IN_CARE_label																									
																,
																
														
														IN_ENGSP
																												
																	,IN_ENGSP_label																									
																,
																
														
														IN_STBL
																												
																	,IN_STBL_label																									
																,
																
														
														IN_DOSE
																												
																	,IN_DOSE_label																									
																,
																
														
														IN_HEPIN
																												
																	,IN_HEPIN_label																									
																,
																
														
														IN_ORAL
																												
																	,IN_ORAL_label																									
																,
																
														
														IN_IC
																												
																	,IN_IC_label																									
																,
																
														
														IN_DT_IC																									
																,
																
														
														EX_OGTT
																												
																	,EX_OGTT_label																									
																,
																
														
														EX_HEP
																												
																	,EX_HEP_label																									
																,
																
														
														EX_CARD
																												
																	,EX_CARD_label																									
																,
																
														
														EX_RECNT
																												
																	,EX_RECNT_label																									
																,
																
														
														EX_STRKE
																												
																	,EX_STRKE_label																									
																,
																
														
														EX_SEIZ
																												
																	,EX_SEIZ_label																									
																,
																
														
														EX_MENTL
																												
																	,EX_MENTL_label																									
																,
																
														
														EX_ORAL
																												
																	,EX_ORAL_label																									
																,
																
														
														EX_INS
																												
																	,EX_INS_label																									
																,
																
														
														EX_DRUG
																												
																	,EX_DRUG_label																									
																,
																
														
														INEX_ELIG
																												
																	,INEX_ELIG_label
										)
									values (
									
									
									'SS_TS3_101_',
									
									'TS3_101_03', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,'2014-06-10'
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,1													
															,'Eligible'											
																
									);
										
									insert into NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														IN_NINCDS
																												
																	,IN_NINCDS_label																									
																,
																
														
														IN_MMSE
																												
																	,IN_MMSE_label																									
																,
																
														
														IN_NMDA
																												
																	,IN_NMDA_label																									
																,
																
														
														IN_HOME
																												
																	,IN_HOME_label																									
																,
																
														
														IN_CARE
																												
																	,IN_CARE_label																									
																,
																
														
														IN_ENGSP
																												
																	,IN_ENGSP_label																									
																,
																
														
														IN_STBL
																												
																	,IN_STBL_label																									
																,
																
														
														IN_DOSE
																												
																	,IN_DOSE_label																									
																,
																
														
														IN_HEPIN
																												
																	,IN_HEPIN_label																									
																,
																
														
														IN_ORAL
																												
																	,IN_ORAL_label																									
																,
																
														
														IN_IC
																												
																	,IN_IC_label																									
																,
																
														
														IN_DT_IC
										)
									values (
									
									
									'SS_TS4_101_',
									
									'TS4_101_04', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,'2014-06-10'		
									);
										
									insert into NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														IN_NINCDS
																												
																	,IN_NINCDS_label																									
																,
																
														
														IN_MMSE
																												
																	,IN_MMSE_label																									
																,
																
														
														IN_NMDA
																												
																	,IN_NMDA_label																									
																,
																
														
														IN_HOME
																												
																	,IN_HOME_label																									
																,
																
														
														IN_CARE
																												
																	,IN_CARE_label																									
																,
																
														
														IN_ENGSP
																												
																	,IN_ENGSP_label																									
																,
																
														
														IN_STBL
																												
																	,IN_STBL_label																									
																,
																
														
														IN_DOSE
																												
																	,IN_DOSE_label																									
																,
																
														
														IN_HEPIN
																												
																	,IN_HEPIN_label																									
																,
																
														
														IN_ORAL
																												
																	,IN_ORAL_label																									
																,
																
														
														IN_IC
																												
																	,IN_IC_label																									
																,
																
														
														IN_DT_IC																									
																,
																
														
														EX_OGTT
																												
																	,EX_OGTT_label																									
																,
																
														
														EX_HEP
																												
																	,EX_HEP_label																									
																,
																
														
														EX_CARD
																												
																	,EX_CARD_label																									
																,
																
														
														EX_RECNT
																												
																	,EX_RECNT_label																									
																,
																
														
														EX_STRKE
																												
																	,EX_STRKE_label																									
																,
																
														
														EX_SEIZ
																												
																	,EX_SEIZ_label																									
																,
																
														
														EX_MENTL
																												
																	,EX_MENTL_label																									
																,
																
														
														EX_ORAL
																												
																	,EX_ORAL_label																									
																,
																
														
														EX_INS
																												
																	,EX_INS_label																									
																,
																
														
														EX_DRUG
																												
																	,EX_DRUG_label																									
																,
																
														
														INEX_ELIG
																												
																	,INEX_ELIG_label
										)
									values (
									
									
									'SS_TS6_101_',
									
									'TS6_101_06', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,'2014-06-10'
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,1													
															,'Eligible'											
																
									);
										
									insert into NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														IN_NINCDS
																												
																	,IN_NINCDS_label																									
																,
																
														
														IN_MMSE
																												
																	,IN_MMSE_label																									
																,
																
														
														IN_NMDA
																												
																	,IN_NMDA_label																									
																,
																
														
														IN_HOME
																												
																	,IN_HOME_label																									
																,
																
														
														IN_CARE
																												
																	,IN_CARE_label																									
																,
																
														
														IN_ENGSP
																												
																	,IN_ENGSP_label																									
																,
																
														
														IN_STBL
																												
																	,IN_STBL_label																									
																,
																
														
														IN_DOSE
																												
																	,IN_DOSE_label																									
																,
																
														
														IN_HEPIN
																												
																	,IN_HEPIN_label																									
																,
																
														
														IN_ORAL
																												
																	,IN_ORAL_label																									
																,
																
														
														IN_IC
																												
																	,IN_IC_label																									
																,
																
														
														IN_DT_IC																									
																,
																
														
														EX_OGTT
																												
																	,EX_OGTT_label																									
																,
																
														
														EX_HEP
																												
																	,EX_HEP_label																									
																,
																
														
														EX_CARD
																												
																	,EX_CARD_label																									
																,
																
														
														EX_RECNT
																												
																	,EX_RECNT_label																									
																,
																
														
														EX_STRKE
																												
																	,EX_STRKE_label																									
																,
																
														
														EX_SEIZ
																												
																	,EX_SEIZ_label																									
																,
																
														
														EX_MENTL
																												
																	,EX_MENTL_label																									
																,
																
														
														EX_ORAL
																												
																	,EX_ORAL_label																									
																,
																
														
														EX_INS
																												
																	,EX_INS_label																									
																,
																
														
														EX_DRUG
																												
																	,EX_DRUG_label																									
																,
																
														
														INEX_ELIG
																												
																	,INEX_ELIG_label
										)
									values (
									
									
									'SS_TS10_102',
									
									'TS10_102_10', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,'2014-06-10'
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,1													
															,'Eligible'											
																
									);
										
									insert into NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														IN_NINCDS
																												
																	,IN_NINCDS_label																									
																,
																
														
														IN_MMSE
																												
																	,IN_MMSE_label																									
																,
																
														
														IN_NMDA
																												
																	,IN_NMDA_label																									
																,
																
														
														IN_HOME
																												
																	,IN_HOME_label																									
																,
																
														
														IN_CARE
																												
																	,IN_CARE_label																									
																,
																
														
														IN_ENGSP
																												
																	,IN_ENGSP_label																									
																,
																
														
														IN_STBL
																												
																	,IN_STBL_label																									
																,
																
														
														IN_DOSE
																												
																	,IN_DOSE_label																									
																,
																
														
														IN_HEPIN
																												
																	,IN_HEPIN_label																									
																,
																
														
														IN_ORAL
																												
																	,IN_ORAL_label																									
																,
																
														
														IN_IC
																												
																	,IN_IC_label																									
																,
																
														
														IN_DT_IC																									
																,
																
														
														EX_OGTT
																												
																	,EX_OGTT_label																									
																,
																
														
														EX_HEP
																												
																	,EX_HEP_label																									
																,
																
														
														EX_CARD
																												
																	,EX_CARD_label																									
																,
																
														
														EX_RECNT
																												
																	,EX_RECNT_label																									
																,
																
														
														EX_STRKE
																												
																	,EX_STRKE_label																									
																,
																
														
														EX_SEIZ
																												
																	,EX_SEIZ_label																									
																,
																
														
														EX_MENTL
																												
																	,EX_MENTL_label																									
																,
																
														
														EX_ORAL
																												
																	,EX_ORAL_label																									
																,
																
														
														EX_INS
																												
																	,EX_INS_label																									
																,
																
														
														EX_DRUG
																												
																	,EX_DRUG_label																									
																,
																
														
														INEX_ELIG
																												
																	,INEX_ELIG_label
										)
									values (
									
									
									'SS_TS1_102_',
									
									'TS1_102_01', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,'2014-06-10'
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,1													
															,'Eligible'											
																
									);
										
									insert into NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														IN_NINCDS
																												
																	,IN_NINCDS_label																									
																,
																
														
														IN_MMSE
																												
																	,IN_MMSE_label																									
																,
																
														
														IN_NMDA
																												
																	,IN_NMDA_label																									
																,
																
														
														IN_HOME
																												
																	,IN_HOME_label																									
																,
																
														
														IN_CARE
																												
																	,IN_CARE_label																									
																,
																
														
														IN_ENGSP
																												
																	,IN_ENGSP_label																									
																,
																
														
														IN_STBL
																												
																	,IN_STBL_label																									
																,
																
														
														IN_DOSE
																												
																	,IN_DOSE_label																									
																,
																
														
														IN_HEPIN
																												
																	,IN_HEPIN_label																									
																,
																
														
														IN_ORAL
																												
																	,IN_ORAL_label																									
																,
																
														
														IN_IC
																												
																	,IN_IC_label																									
																,
																
														
														IN_DT_IC																									
																,
																
														
														EX_OGTT
																												
																	,EX_OGTT_label																									
																,
																
														
														EX_HEP
																												
																	,EX_HEP_label																									
																,
																
														
														EX_CARD
																												
																	,EX_CARD_label																									
																,
																
														
														EX_RECNT
																												
																	,EX_RECNT_label																									
																,
																
														
														EX_STRKE
																												
																	,EX_STRKE_label																									
																,
																
														
														EX_SEIZ
																												
																	,EX_SEIZ_label																									
																,
																
														
														EX_MENTL
																												
																	,EX_MENTL_label																									
																,
																
														
														EX_ORAL
																												
																	,EX_ORAL_label																									
																,
																
														
														EX_INS
																												
																	,EX_INS_label																									
																,
																
														
														EX_DRUG
																												
																	,EX_DRUG_label																									
																,
																
														
														INEX_ELIG
																												
																	,INEX_ELIG_label
										)
									values (
									
									
									'SS_TS3_102_',
									
									'TS3_102_03', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,'2014-06-10'
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,1													
															,'Eligible'											
																
									);
										
									insert into NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														IN_NINCDS
																												
																	,IN_NINCDS_label																									
																,
																
														
														IN_MMSE
																												
																	,IN_MMSE_label																									
																,
																
														
														IN_NMDA
																												
																	,IN_NMDA_label																									
																,
																
														
														IN_HOME
																												
																	,IN_HOME_label																									
																,
																
														
														IN_CARE
																												
																	,IN_CARE_label																									
																,
																
														
														IN_ENGSP
																												
																	,IN_ENGSP_label																									
																,
																
														
														IN_STBL
																												
																	,IN_STBL_label																									
																,
																
														
														IN_DOSE
																												
																	,IN_DOSE_label																									
																,
																
														
														IN_HEPIN
																												
																	,IN_HEPIN_label																									
																,
																
														
														IN_ORAL
																												
																	,IN_ORAL_label																									
																,
																
														
														IN_IC
																												
																	,IN_IC_label																									
																,
																
														
														IN_DT_IC
										)
									values (
									
									
									'SS_TS4_102_',
									
									'TS4_102_04', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,'2014-06-10'		
									);
										
									insert into NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														IN_NINCDS
																												
																	,IN_NINCDS_label																									
																,
																
														
														IN_MMSE
																												
																	,IN_MMSE_label																									
																,
																
														
														IN_NMDA
																												
																	,IN_NMDA_label																									
																,
																
														
														IN_HOME
																												
																	,IN_HOME_label																									
																,
																
														
														IN_CARE
																												
																	,IN_CARE_label																									
																,
																
														
														IN_ENGSP
																												
																	,IN_ENGSP_label																									
																,
																
														
														IN_STBL
																												
																	,IN_STBL_label																									
																,
																
														
														IN_DOSE
																												
																	,IN_DOSE_label																									
																,
																
														
														IN_HEPIN
																												
																	,IN_HEPIN_label																									
																,
																
														
														IN_ORAL
																												
																	,IN_ORAL_label																									
																,
																
														
														IN_IC
																												
																	,IN_IC_label																									
																,
																
														
														IN_DT_IC																									
																,
																
														
														EX_OGTT
																												
																	,EX_OGTT_label																									
																,
																
														
														EX_HEP
																												
																	,EX_HEP_label																									
																,
																
														
														EX_CARD
																												
																	,EX_CARD_label																									
																,
																
														
														EX_RECNT
																												
																	,EX_RECNT_label																									
																,
																
														
														EX_STRKE
																												
																	,EX_STRKE_label																									
																,
																
														
														EX_SEIZ
																												
																	,EX_SEIZ_label																									
																,
																
														
														EX_MENTL
																												
																	,EX_MENTL_label																									
																,
																
														
														EX_ORAL
																												
																	,EX_ORAL_label																									
																,
																
														
														EX_INS
																												
																	,EX_INS_label																									
																,
																
														
														EX_DRUG
																												
																	,EX_DRUG_label																									
																,
																
														
														INEX_ELIG
																												
																	,INEX_ELIG_label
										)
									values (
									
									
									'SS_TS6_102_',
									
									'TS6_102_06', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,'2014-06-10'
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,1													
															,'Eligible'											
																
									);
										
									insert into NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														IN_NINCDS
																												
																	,IN_NINCDS_label																									
																,
																
														
														IN_MMSE
																												
																	,IN_MMSE_label																									
																,
																
														
														IN_NMDA
																												
																	,IN_NMDA_label																									
																,
																
														
														IN_HOME
																												
																	,IN_HOME_label																									
																,
																
														
														IN_CARE
																												
																	,IN_CARE_label																									
																,
																
														
														IN_ENGSP
																												
																	,IN_ENGSP_label																									
																,
																
														
														IN_STBL
																												
																	,IN_STBL_label																									
																,
																
														
														IN_DOSE
																												
																	,IN_DOSE_label																									
																,
																
														
														IN_HEPIN
																												
																	,IN_HEPIN_label																									
																,
																
														
														IN_ORAL
																												
																	,IN_ORAL_label																									
																,
																
														
														IN_IC
																												
																	,IN_IC_label																									
																,
																
														
														IN_DT_IC																									
																,
																
														
														EX_OGTT
																												
																	,EX_OGTT_label																									
																,
																
														
														EX_HEP
																												
																	,EX_HEP_label																									
																,
																
														
														EX_CARD
																												
																	,EX_CARD_label																									
																,
																
														
														EX_RECNT
																												
																	,EX_RECNT_label																									
																,
																
														
														EX_STRKE
																												
																	,EX_STRKE_label																									
																,
																
														
														EX_SEIZ
																												
																	,EX_SEIZ_label																									
																,
																
														
														EX_MENTL
																												
																	,EX_MENTL_label																									
																,
																
														
														EX_ORAL
																												
																	,EX_ORAL_label																									
																,
																
														
														EX_INS
																												
																	,EX_INS_label																									
																,
																
														
														EX_DRUG
																												
																	,EX_DRUG_label																									
																,
																
														
														INEX_ELIG
																												
																	,INEX_ELIG_label
										)
									values (
									
									
									'SS_TS8_102_',
									
									'TS8_102_08', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,'2014-06-10'
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,1													
															,'Eligible'											
																
									);
										
									insert into NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														IN_NINCDS
																												
																	,IN_NINCDS_label																									
																,
																
														
														IN_MMSE
																												
																	,IN_MMSE_label																									
																,
																
														
														IN_NMDA
																												
																	,IN_NMDA_label																									
																,
																
														
														IN_HOME
																												
																	,IN_HOME_label																									
																,
																
														
														IN_CARE
																												
																	,IN_CARE_label																									
																,
																
														
														IN_ENGSP
																												
																	,IN_ENGSP_label																									
																,
																
														
														IN_STBL
																												
																	,IN_STBL_label																									
																,
																
														
														IN_DOSE
																												
																	,IN_DOSE_label																									
																,
																
														
														IN_HEPIN
																												
																	,IN_HEPIN_label																									
																,
																
														
														IN_ORAL
																												
																	,IN_ORAL_label																									
																,
																
														
														IN_IC
																												
																	,IN_IC_label																									
																,
																
														
														IN_DT_IC																									
																,
																
														
														EX_OGTT
																												
																	,EX_OGTT_label																									
																,
																
														
														EX_HEP
																												
																	,EX_HEP_label																									
																,
																
														
														EX_CARD
																												
																	,EX_CARD_label																									
																,
																
														
														EX_RECNT
																												
																	,EX_RECNT_label																									
																,
																
														
														EX_STRKE
																												
																	,EX_STRKE_label																									
																,
																
														
														EX_SEIZ
																												
																	,EX_SEIZ_label																									
																,
																
														
														EX_MENTL
																												
																	,EX_MENTL_label																									
																,
																
														
														EX_ORAL
																												
																	,EX_ORAL_label																									
																,
																
														
														EX_INS
																												
																	,EX_INS_label																									
																,
																
														
														EX_DRUG
																												
																	,EX_DRUG_label																									
																,
																
														
														INEX_ELIG
																												
																	,INEX_ELIG_label
										)
									values (
									
									
									'SS_TS10_103',
									
									'TS10_103_10', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,'2014-06-10'
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,1													
															,'Eligible'											
																
									);
										
									insert into NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														IN_NINCDS
																												
																	,IN_NINCDS_label																									
																,
																
														
														IN_MMSE
																												
																	,IN_MMSE_label																									
																,
																
														
														IN_NMDA
																												
																	,IN_NMDA_label																									
																,
																
														
														IN_HOME
																												
																	,IN_HOME_label																									
																,
																
														
														IN_CARE
																												
																	,IN_CARE_label																									
																,
																
														
														IN_ENGSP
																												
																	,IN_ENGSP_label																									
																,
																
														
														IN_STBL
																												
																	,IN_STBL_label																									
																,
																
														
														IN_DOSE
																												
																	,IN_DOSE_label																									
																,
																
														
														IN_HEPIN
																												
																	,IN_HEPIN_label																									
																,
																
														
														IN_ORAL
																												
																	,IN_ORAL_label																									
																,
																
														
														IN_IC
																												
																	,IN_IC_label																									
																,
																
														
														IN_DT_IC																									
																,
																
														
														EX_OGTT
																												
																	,EX_OGTT_label																									
																,
																
														
														EX_HEP
																												
																	,EX_HEP_label																									
																,
																
														
														EX_CARD
																												
																	,EX_CARD_label																									
																,
																
														
														EX_RECNT
																												
																	,EX_RECNT_label																									
																,
																
														
														EX_STRKE
																												
																	,EX_STRKE_label																									
																,
																
														
														EX_SEIZ
																												
																	,EX_SEIZ_label																									
																,
																
														
														EX_MENTL
																												
																	,EX_MENTL_label																									
																,
																
														
														EX_ORAL
																												
																	,EX_ORAL_label																									
																,
																
														
														EX_INS
																												
																	,EX_INS_label																									
																,
																
														
														EX_DRUG
																												
																	,EX_DRUG_label																									
																,
																
														
														INEX_ELIG
																												
																	,INEX_ELIG_label
										)
									values (
									
									
									'SS_TS1_103_',
									
									'TS1_103_01', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,'2014-06-10'
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,1													
															,'Eligible'											
																
									);
										
									insert into NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														IN_NINCDS
																												
																	,IN_NINCDS_label																									
																,
																
														
														IN_MMSE
																												
																	,IN_MMSE_label																									
																,
																
														
														IN_NMDA
																												
																	,IN_NMDA_label																									
																,
																
														
														IN_HOME
																												
																	,IN_HOME_label																									
																,
																
														
														IN_CARE
																												
																	,IN_CARE_label																									
																,
																
														
														IN_ENGSP
																												
																	,IN_ENGSP_label																									
																,
																
														
														IN_STBL
																												
																	,IN_STBL_label																									
																,
																
														
														IN_DOSE
																												
																	,IN_DOSE_label																									
																,
																
														
														IN_HEPIN
																												
																	,IN_HEPIN_label																									
																,
																
														
														IN_ORAL
																												
																	,IN_ORAL_label																									
																,
																
														
														IN_IC
																												
																	,IN_IC_label																									
																,
																
														
														IN_DT_IC																									
																,
																
														
														EX_OGTT
																												
																	,EX_OGTT_label																									
																,
																
														
														EX_HEP
																												
																	,EX_HEP_label																									
																,
																
														
														EX_CARD
																												
																	,EX_CARD_label																									
																,
																
														
														EX_RECNT
																												
																	,EX_RECNT_label																									
																,
																
														
														EX_STRKE
																												
																	,EX_STRKE_label																									
																,
																
														
														EX_SEIZ
																												
																	,EX_SEIZ_label																									
																,
																
														
														EX_MENTL
																												
																	,EX_MENTL_label																									
																,
																
														
														EX_ORAL
																												
																	,EX_ORAL_label																									
																,
																
														
														EX_INS
																												
																	,EX_INS_label																									
																,
																
														
														EX_DRUG
																												
																	,EX_DRUG_label																									
																,
																
														
														INEX_ELIG
																												
																	,INEX_ELIG_label
										)
									values (
									
									
									'SS_TS3_103_',
									
									'TS3_103_03', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,'2014-06-10'
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,1													
															,'Eligible'											
																
									);
										
									insert into NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														IN_NINCDS
																												
																	,IN_NINCDS_label																									
																,
																
														
														IN_MMSE
																												
																	,IN_MMSE_label																									
																,
																
														
														IN_NMDA
																												
																	,IN_NMDA_label																									
																,
																
														
														IN_HOME
																												
																	,IN_HOME_label																									
																,
																
														
														IN_CARE
																												
																	,IN_CARE_label																									
																,
																
														
														IN_ENGSP
																												
																	,IN_ENGSP_label																									
																,
																
														
														IN_STBL
																												
																	,IN_STBL_label																									
																,
																
														
														IN_DOSE
																												
																	,IN_DOSE_label																									
																,
																
														
														IN_HEPIN
																												
																	,IN_HEPIN_label																									
																,
																
														
														IN_ORAL
																												
																	,IN_ORAL_label																									
																,
																
														
														IN_IC
																												
																	,IN_IC_label																									
																,
																
														
														IN_DT_IC
										)
									values (
									
									
									'SS_TS4_103_',
									
									'TS4_103_04', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,'2014-06-10'		
									);
										
									insert into NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														IN_NINCDS
																												
																	,IN_NINCDS_label																									
																,
																
														
														IN_MMSE
																												
																	,IN_MMSE_label																									
																,
																
														
														IN_NMDA
																												
																	,IN_NMDA_label																									
																,
																
														
														IN_HOME
																												
																	,IN_HOME_label																									
																,
																
														
														IN_CARE
																												
																	,IN_CARE_label																									
																,
																
														
														IN_ENGSP
																												
																	,IN_ENGSP_label																									
																,
																
														
														IN_STBL
																												
																	,IN_STBL_label																									
																,
																
														
														IN_DOSE
																												
																	,IN_DOSE_label																									
																,
																
														
														IN_HEPIN
																												
																	,IN_HEPIN_label																									
																,
																
														
														IN_ORAL
																												
																	,IN_ORAL_label																									
																,
																
														
														IN_IC
																												
																	,IN_IC_label																									
																,
																
														
														IN_DT_IC																									
																,
																
														
														EX_OGTT
																												
																	,EX_OGTT_label																									
																,
																
														
														EX_HEP
																												
																	,EX_HEP_label																									
																,
																
														
														EX_CARD
																												
																	,EX_CARD_label																									
																,
																
														
														EX_RECNT
																												
																	,EX_RECNT_label																									
																,
																
														
														EX_STRKE
																												
																	,EX_STRKE_label																									
																,
																
														
														EX_SEIZ
																												
																	,EX_SEIZ_label																									
																,
																
														
														EX_MENTL
																												
																	,EX_MENTL_label																									
																,
																
														
														EX_ORAL
																												
																	,EX_ORAL_label																									
																,
																
														
														EX_INS
																												
																	,EX_INS_label																									
																,
																
														
														EX_DRUG
																												
																	,EX_DRUG_label																									
																,
																
														
														INEX_ELIG
																												
																	,INEX_ELIG_label
										)
									values (
									
									
									'SS_TS6_103_',
									
									'TS6_103_06', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,'2014-06-10'
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,1													
															,'Eligible'											
																
									);
										
									insert into NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														IN_NINCDS
																												
																	,IN_NINCDS_label																									
																,
																
														
														IN_MMSE
																												
																	,IN_MMSE_label																									
																,
																
														
														IN_NMDA
																												
																	,IN_NMDA_label																									
																,
																
														
														IN_HOME
																												
																	,IN_HOME_label																									
																,
																
														
														IN_CARE
																												
																	,IN_CARE_label																									
																,
																
														
														IN_ENGSP
																												
																	,IN_ENGSP_label																									
																,
																
														
														IN_STBL
																												
																	,IN_STBL_label																									
																,
																
														
														IN_DOSE
																												
																	,IN_DOSE_label																									
																,
																
														
														IN_HEPIN
																												
																	,IN_HEPIN_label																									
																,
																
														
														IN_ORAL
																												
																	,IN_ORAL_label																									
																,
																
														
														IN_IC
																												
																	,IN_IC_label																									
																,
																
														
														IN_DT_IC																									
																,
																
														
														EX_OGTT
																												
																	,EX_OGTT_label																									
																,
																
														
														EX_HEP
																												
																	,EX_HEP_label																									
																,
																
														
														EX_CARD
																												
																	,EX_CARD_label																									
																,
																
														
														EX_RECNT
																												
																	,EX_RECNT_label																									
																,
																
														
														EX_STRKE
																												
																	,EX_STRKE_label																									
																,
																
														
														EX_SEIZ
																												
																	,EX_SEIZ_label																									
																,
																
														
														EX_MENTL
																												
																	,EX_MENTL_label																									
																,
																
														
														EX_ORAL
																												
																	,EX_ORAL_label																									
																,
																
														
														EX_INS
																												
																	,EX_INS_label																									
																,
																
														
														EX_DRUG
																												
																	,EX_DRUG_label																									
																,
																
														
														INEX_ELIG
																												
																	,INEX_ELIG_label
										)
									values (
									
									
									'SS_TS8_103_',
									
									'TS8_103_08', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,'2014-06-10'
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,1													
															,'Eligible'											
																
									);
										
									insert into NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														IN_NINCDS
																												
																	,IN_NINCDS_label																									
																,
																
														
														IN_MMSE
																												
																	,IN_MMSE_label																									
																,
																
														
														IN_NMDA
																												
																	,IN_NMDA_label																									
																,
																
														
														IN_HOME
																												
																	,IN_HOME_label																									
																,
																
														
														IN_CARE
																												
																	,IN_CARE_label																									
																,
																
														
														IN_ENGSP
																												
																	,IN_ENGSP_label																									
																,
																
														
														IN_STBL
																												
																	,IN_STBL_label																									
																,
																
														
														IN_DOSE
																												
																	,IN_DOSE_label																									
																,
																
														
														IN_HEPIN
																												
																	,IN_HEPIN_label																									
																,
																
														
														IN_ORAL
																												
																	,IN_ORAL_label																									
																,
																
														
														IN_IC
																												
																	,IN_IC_label																									
																,
																
														
														IN_DT_IC																									
																,
																
														
														EX_OGTT
																												
																	,EX_OGTT_label																									
																,
																
														
														EX_HEP
																												
																	,EX_HEP_label																									
																,
																
														
														EX_CARD
																												
																	,EX_CARD_label																									
																,
																
														
														EX_RECNT
																												
																	,EX_RECNT_label																									
																,
																
														
														EX_STRKE
																												
																	,EX_STRKE_label																									
																,
																
														
														EX_SEIZ
																												
																	,EX_SEIZ_label																									
																,
																
														
														EX_MENTL
																												
																	,EX_MENTL_label																									
																,
																
														
														EX_ORAL
																												
																	,EX_ORAL_label																									
																,
																
														
														EX_INS
																												
																	,EX_INS_label																									
																,
																
														
														EX_DRUG
																												
																	,EX_DRUG_label																									
																,
																
														
														INEX_ELIG
																												
																	,INEX_ELIG_label
										)
									values (
									
									
									'SS_TS10_104',
									
									'TS10_104_10', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,'2014-06-10'
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,1													
															,'Eligible'											
																
									);
										
									insert into NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														IN_NINCDS
																												
																	,IN_NINCDS_label																									
																,
																
														
														IN_MMSE
																												
																	,IN_MMSE_label																									
																,
																
														
														IN_NMDA
																												
																	,IN_NMDA_label																									
																,
																
														
														IN_HOME
																												
																	,IN_HOME_label																									
																,
																
														
														IN_CARE
																												
																	,IN_CARE_label																									
																,
																
														
														IN_ENGSP
																												
																	,IN_ENGSP_label																									
																,
																
														
														IN_STBL
																												
																	,IN_STBL_label																									
																,
																
														
														IN_DOSE
																												
																	,IN_DOSE_label																									
																,
																
														
														IN_HEPIN
																												
																	,IN_HEPIN_label																									
																,
																
														
														IN_ORAL
																												
																	,IN_ORAL_label																									
																,
																
														
														IN_IC
																												
																	,IN_IC_label																									
																,
																
														
														IN_DT_IC																									
																,
																
														
														EX_OGTT
																												
																	,EX_OGTT_label																									
																,
																
														
														EX_HEP
																												
																	,EX_HEP_label																									
																,
																
														
														EX_CARD
																												
																	,EX_CARD_label																									
																,
																
														
														EX_RECNT
																												
																	,EX_RECNT_label																									
																,
																
														
														EX_STRKE
																												
																	,EX_STRKE_label																									
																,
																
														
														EX_SEIZ
																												
																	,EX_SEIZ_label																									
																,
																
														
														EX_MENTL
																												
																	,EX_MENTL_label																									
																,
																
														
														EX_ORAL
																												
																	,EX_ORAL_label																									
																,
																
														
														EX_INS
																												
																	,EX_INS_label																									
																,
																
														
														EX_DRUG
																												
																	,EX_DRUG_label																									
																,
																
														
														INEX_ELIG
																												
																	,INEX_ELIG_label
										)
									values (
									
									
									'SS_TS1_104_',
									
									'TS1_104_01', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,'2014-06-10'
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,1													
															,'Eligible'											
																
									);
										
									insert into NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														IN_NINCDS
																												
																	,IN_NINCDS_label																									
																,
																
														
														IN_MMSE
																												
																	,IN_MMSE_label																									
																,
																
														
														IN_NMDA
																												
																	,IN_NMDA_label																									
																,
																
														
														IN_HOME
																												
																	,IN_HOME_label																									
																,
																
														
														IN_CARE
																												
																	,IN_CARE_label																									
																,
																
														
														IN_ENGSP
																												
																	,IN_ENGSP_label																									
																,
																
														
														IN_STBL
																												
																	,IN_STBL_label																									
																,
																
														
														IN_DOSE
																												
																	,IN_DOSE_label																									
																,
																
														
														IN_HEPIN
																												
																	,IN_HEPIN_label																									
																,
																
														
														IN_ORAL
																												
																	,IN_ORAL_label																									
																,
																
														
														IN_IC
																												
																	,IN_IC_label																									
																,
																
														
														IN_DT_IC																									
																,
																
														
														EX_OGTT
																												
																	,EX_OGTT_label																									
																,
																
														
														EX_HEP
																												
																	,EX_HEP_label																									
																,
																
														
														EX_CARD
																												
																	,EX_CARD_label																									
																,
																
														
														EX_RECNT
																												
																	,EX_RECNT_label																									
																,
																
														
														EX_STRKE
																												
																	,EX_STRKE_label																									
																,
																
														
														EX_SEIZ
																												
																	,EX_SEIZ_label																									
																,
																
														
														EX_MENTL
																												
																	,EX_MENTL_label																									
																,
																
														
														EX_ORAL
																												
																	,EX_ORAL_label																									
																,
																
														
														EX_INS
																												
																	,EX_INS_label																									
																,
																
														
														EX_DRUG
																												
																	,EX_DRUG_label																									
																,
																
														
														INEX_ELIG
																												
																	,INEX_ELIG_label
										)
									values (
									
									
									'SS_TS3_104_',
									
									'TS3_104_03', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,'2014-06-10'
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,1													
															,'Eligible'											
																
									);
										
									insert into NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														IN_NINCDS
																												
																	,IN_NINCDS_label																									
																,
																
														
														IN_MMSE
																												
																	,IN_MMSE_label																									
																,
																
														
														IN_NMDA
																												
																	,IN_NMDA_label																									
																,
																
														
														IN_HOME
																												
																	,IN_HOME_label																									
																,
																
														
														IN_CARE
																												
																	,IN_CARE_label																									
																,
																
														
														IN_ENGSP
																												
																	,IN_ENGSP_label																									
																,
																
														
														IN_STBL
																												
																	,IN_STBL_label																									
																,
																
														
														IN_DOSE
																												
																	,IN_DOSE_label																									
																,
																
														
														IN_HEPIN
																												
																	,IN_HEPIN_label																									
																,
																
														
														IN_ORAL
																												
																	,IN_ORAL_label																									
																,
																
														
														IN_IC
																												
																	,IN_IC_label																									
																,
																
														
														IN_DT_IC
										)
									values (
									
									
									'SS_TS4_104_',
									
									'TS4_104_04', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,'2014-06-10'		
									);
										
									insert into NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														IN_NINCDS
																												
																	,IN_NINCDS_label																									
																,
																
														
														IN_MMSE
																												
																	,IN_MMSE_label																									
																,
																
														
														IN_NMDA
																												
																	,IN_NMDA_label																									
																,
																
														
														IN_HOME
																												
																	,IN_HOME_label																									
																,
																
														
														IN_CARE
																												
																	,IN_CARE_label																									
																,
																
														
														IN_ENGSP
																												
																	,IN_ENGSP_label																									
																,
																
														
														IN_STBL
																												
																	,IN_STBL_label																									
																,
																
														
														IN_DOSE
																												
																	,IN_DOSE_label																									
																,
																
														
														IN_HEPIN
																												
																	,IN_HEPIN_label																									
																,
																
														
														IN_ORAL
																												
																	,IN_ORAL_label																									
																,
																
														
														IN_IC
																												
																	,IN_IC_label																									
																,
																
														
														IN_DT_IC																									
																,
																
														
														EX_OGTT
																												
																	,EX_OGTT_label																									
																,
																
														
														EX_HEP
																												
																	,EX_HEP_label																									
																,
																
														
														EX_CARD
																												
																	,EX_CARD_label																									
																,
																
														
														EX_RECNT
																												
																	,EX_RECNT_label																									
																,
																
														
														EX_STRKE
																												
																	,EX_STRKE_label																									
																,
																
														
														EX_SEIZ
																												
																	,EX_SEIZ_label																									
																,
																
														
														EX_MENTL
																												
																	,EX_MENTL_label																									
																,
																
														
														EX_ORAL
																												
																	,EX_ORAL_label																									
																,
																
														
														EX_INS
																												
																	,EX_INS_label																									
																,
																
														
														EX_DRUG
																												
																	,EX_DRUG_label																									
																,
																
														
														INEX_ELIG
																												
																	,INEX_ELIG_label
										)
									values (
									
									
									'SS_TS6_104_',
									
									'TS6_104_06', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,'2014-06-10'
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,1													
															,'Eligible'											
																
									);
										
									insert into NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														IN_NINCDS
																												
																	,IN_NINCDS_label																									
																,
																
														
														IN_MMSE
																												
																	,IN_MMSE_label																									
																,
																
														
														IN_NMDA
																												
																	,IN_NMDA_label																									
																,
																
														
														IN_HOME
																												
																	,IN_HOME_label																									
																,
																
														
														IN_CARE
																												
																	,IN_CARE_label																									
																,
																
														
														IN_ENGSP
																												
																	,IN_ENGSP_label																									
																,
																
														
														IN_STBL
																												
																	,IN_STBL_label																									
																,
																
														
														IN_DOSE
																												
																	,IN_DOSE_label																									
																,
																
														
														IN_HEPIN
																												
																	,IN_HEPIN_label																									
																,
																
														
														IN_ORAL
																												
																	,IN_ORAL_label																									
																,
																
														
														IN_IC
																												
																	,IN_IC_label																									
																,
																
														
														IN_DT_IC																									
																,
																
														
														EX_OGTT
																												
																	,EX_OGTT_label																									
																,
																
														
														EX_HEP
																												
																	,EX_HEP_label																									
																,
																
														
														EX_CARD
																												
																	,EX_CARD_label																									
																,
																
														
														EX_RECNT
																												
																	,EX_RECNT_label																									
																,
																
														
														EX_STRKE
																												
																	,EX_STRKE_label																									
																,
																
														
														EX_SEIZ
																												
																	,EX_SEIZ_label																									
																,
																
														
														EX_MENTL
																												
																	,EX_MENTL_label																									
																,
																
														
														EX_ORAL
																												
																	,EX_ORAL_label																									
																,
																
														
														EX_INS
																												
																	,EX_INS_label																									
																,
																
														
														EX_DRUG
																												
																	,EX_DRUG_label																									
																,
																
														
														INEX_ELIG
																												
																	,INEX_ELIG_label
										)
									values (
									
									
									'SS_TS8_104_',
									
									'TS8_104_08', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,'2014-06-10'
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,1													
															,'Eligible'											
																
									);
										
									insert into NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														IN_NINCDS
																												
																	,IN_NINCDS_label																									
																,
																
														
														IN_MMSE
																												
																	,IN_MMSE_label																									
																,
																
														
														IN_NMDA
																												
																	,IN_NMDA_label																									
																,
																
														
														IN_HOME
																												
																	,IN_HOME_label																									
																,
																
														
														IN_CARE
																												
																	,IN_CARE_label																									
																,
																
														
														IN_ENGSP
																												
																	,IN_ENGSP_label																									
																,
																
														
														IN_STBL
																												
																	,IN_STBL_label																									
																,
																
														
														IN_DOSE
																												
																	,IN_DOSE_label																									
																,
																
														
														IN_HEPIN
																												
																	,IN_HEPIN_label																									
																,
																
														
														IN_ORAL
																												
																	,IN_ORAL_label																									
																,
																
														
														IN_IC
																												
																	,IN_IC_label																									
																,
																
														
														IN_DT_IC																									
																,
																
														
														EX_OGTT
																												
																	,EX_OGTT_label																									
																,
																
														
														EX_HEP
																												
																	,EX_HEP_label																									
																,
																
														
														EX_CARD
																												
																	,EX_CARD_label																									
																,
																
														
														EX_RECNT
																												
																	,EX_RECNT_label																									
																,
																
														
														EX_STRKE
																												
																	,EX_STRKE_label																									
																,
																
														
														EX_SEIZ
																												
																	,EX_SEIZ_label																									
																,
																
														
														EX_MENTL
																												
																	,EX_MENTL_label																									
																,
																
														
														EX_ORAL
																												
																	,EX_ORAL_label																									
																,
																
														
														EX_INS
																												
																	,EX_INS_label																									
																,
																
														
														EX_DRUG
																												
																	,EX_DRUG_label																									
																,
																
														
														INEX_ELIG
																												
																	,INEX_ELIG_label
										)
									values (
									
									
									'SS_TS13_105',
									
									'TS13_105_13', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,'2014-06-10'
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,1													
															,'Eligible'											
																
									);
										
									insert into NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														IN_NINCDS
																												
																	,IN_NINCDS_label																									
																,
																
														
														IN_MMSE
																												
																	,IN_MMSE_label																									
																,
																
														
														IN_NMDA
																												
																	,IN_NMDA_label																									
																,
																
														
														IN_HOME
																												
																	,IN_HOME_label																									
																,
																
														
														IN_CARE
																												
																	,IN_CARE_label																									
																,
																
														
														IN_ENGSP
																												
																	,IN_ENGSP_label																									
																,
																
														
														IN_STBL
																												
																	,IN_STBL_label																									
																,
																
														
														IN_DOSE
																												
																	,IN_DOSE_label																									
																,
																
														
														IN_HEPIN
																												
																	,IN_HEPIN_label																									
																,
																
														
														IN_ORAL
																												
																	,IN_ORAL_label																									
																,
																
														
														IN_IC
																												
																	,IN_IC_label																									
																,
																
														
														IN_DT_IC																									
																,
																
														
														EX_OGTT
																												
																	,EX_OGTT_label																									
																,
																
														
														EX_HEP
																												
																	,EX_HEP_label																									
																,
																
														
														EX_CARD
																												
																	,EX_CARD_label																									
																,
																
														
														EX_RECNT
																												
																	,EX_RECNT_label																									
																,
																
														
														EX_STRKE
																												
																	,EX_STRKE_label																									
																,
																
														
														EX_SEIZ
																												
																	,EX_SEIZ_label																									
																,
																
														
														EX_MENTL
																												
																	,EX_MENTL_label																									
																,
																
														
														EX_ORAL
																												
																	,EX_ORAL_label																									
																,
																
														
														EX_INS
																												
																	,EX_INS_label																									
																,
																
														
														EX_DRUG
																												
																	,EX_DRUG_label																									
																,
																
														
														INEX_ELIG
																												
																	,INEX_ELIG_label
										)
									values (
									
									
									'SS_TS2_105_',
									
									'TS2_105_02', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,'2014-06-10'
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,1													
															,'Eligible'											
																
									);
										
									insert into NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														IN_NINCDS
																												
																	,IN_NINCDS_label																									
																,
																
														
														IN_MMSE
																												
																	,IN_MMSE_label																									
																,
																
														
														IN_NMDA
																												
																	,IN_NMDA_label																									
																,
																
														
														IN_HOME
																												
																	,IN_HOME_label																									
																,
																
														
														IN_CARE
																												
																	,IN_CARE_label																									
																,
																
														
														IN_ENGSP
																												
																	,IN_ENGSP_label																									
																,
																
														
														IN_STBL
																												
																	,IN_STBL_label																									
																,
																
														
														IN_DOSE
																												
																	,IN_DOSE_label																									
																,
																
														
														IN_HEPIN
																												
																	,IN_HEPIN_label																									
																,
																
														
														IN_ORAL
																												
																	,IN_ORAL_label																									
																,
																
														
														IN_IC
																												
																	,IN_IC_label																									
																,
																
														
														IN_DT_IC
										)
									values (
									
									
									'SS_TS5_105_',
									
									'TS5_105_05', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,'2014-06-10'		
									);
										
									insert into NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														IN_NINCDS
																												
																	,IN_NINCDS_label																									
																,
																
														
														IN_MMSE
																												
																	,IN_MMSE_label																									
																,
																
														
														IN_NMDA
																												
																	,IN_NMDA_label																									
																,
																
														
														IN_HOME
																												
																	,IN_HOME_label																									
																,
																
														
														IN_CARE
																												
																	,IN_CARE_label																									
																,
																
														
														IN_ENGSP
																												
																	,IN_ENGSP_label																									
																,
																
														
														IN_STBL
																												
																	,IN_STBL_label																									
																,
																
														
														IN_DOSE
																												
																	,IN_DOSE_label																									
																,
																
														
														IN_HEPIN
																												
																	,IN_HEPIN_label																									
																,
																
														
														IN_ORAL
																												
																	,IN_ORAL_label																									
																,
																
														
														IN_IC
																												
																	,IN_IC_label																									
																,
																
														
														IN_DT_IC																									
																,
																
														
														EX_OGTT
																												
																	,EX_OGTT_label																									
																,
																
														
														EX_HEP
																												
																	,EX_HEP_label																									
																,
																
														
														EX_CARD
																												
																	,EX_CARD_label																									
																,
																
														
														EX_RECNT
																												
																	,EX_RECNT_label																									
																,
																
														
														EX_STRKE
																												
																	,EX_STRKE_label																									
																,
																
														
														EX_SEIZ
																												
																	,EX_SEIZ_label																									
																,
																
														
														EX_MENTL
																												
																	,EX_MENTL_label																									
																,
																
														
														EX_ORAL
																												
																	,EX_ORAL_label																									
																,
																
														
														EX_INS
																												
																	,EX_INS_label																									
																,
																
														
														EX_DRUG
																												
																	,EX_DRUG_label																									
																,
																
														
														INEX_ELIG
																												
																	,INEX_ELIG_label
										)
									values (
									
									
									'SS_TS6_105_',
									
									'TS6_105_06', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,'2014-06-10'
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,1													
															,'Eligible'											
																
									);
										
									insert into NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														IN_NINCDS
																												
																	,IN_NINCDS_label																									
																,
																
														
														IN_MMSE
																												
																	,IN_MMSE_label																									
																,
																
														
														IN_NMDA
																												
																	,IN_NMDA_label																									
																,
																
														
														IN_HOME
																												
																	,IN_HOME_label																									
																,
																
														
														IN_CARE
																												
																	,IN_CARE_label																									
																,
																
														
														IN_ENGSP
																												
																	,IN_ENGSP_label																									
																,
																
														
														IN_STBL
																												
																	,IN_STBL_label																									
																,
																
														
														IN_DOSE
																												
																	,IN_DOSE_label																									
																,
																
														
														IN_HEPIN
																												
																	,IN_HEPIN_label																									
																,
																
														
														IN_ORAL
																												
																	,IN_ORAL_label																									
																,
																
														
														IN_IC
																												
																	,IN_IC_label																									
																,
																
														
														IN_DT_IC																									
																,
																
														
														EX_OGTT
																												
																	,EX_OGTT_label																									
																,
																
														
														EX_HEP
																												
																	,EX_HEP_label																									
																,
																
														
														EX_CARD
																												
																	,EX_CARD_label																									
																,
																
														
														EX_RECNT
																												
																	,EX_RECNT_label																									
																,
																
														
														EX_STRKE
																												
																	,EX_STRKE_label																									
																,
																
														
														EX_SEIZ
																												
																	,EX_SEIZ_label																									
																,
																
														
														EX_MENTL
																												
																	,EX_MENTL_label																									
																,
																
														
														EX_ORAL
																												
																	,EX_ORAL_label																									
																,
																
														
														EX_INS
																												
																	,EX_INS_label																									
																,
																
														
														EX_DRUG
																												
																	,EX_DRUG_label																									
																,
																
														
														INEX_ELIG
																												
																	,INEX_ELIG_label
										)
									values (
									
									
									'SS_TS7_105_',
									
									'TS7_105_07', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,'2014-06-10'
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,1													
															,'Eligible'											
																
									);
										
									insert into NCT01928420_All_Data.Inclusion_Exclusion_CriteriaEligibility (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														IN_NINCDS
																												
																	,IN_NINCDS_label																									
																,
																
														
														IN_MMSE
																												
																	,IN_MMSE_label																									
																,
																
														
														IN_NMDA
																												
																	,IN_NMDA_label																									
																,
																
														
														IN_HOME
																												
																	,IN_HOME_label																									
																,
																
														
														IN_CARE
																												
																	,IN_CARE_label																									
																,
																
														
														IN_ENGSP
																												
																	,IN_ENGSP_label																									
																,
																
														
														IN_STBL
																												
																	,IN_STBL_label																									
																,
																
														
														IN_DOSE
																												
																	,IN_DOSE_label																									
																,
																
														
														IN_HEPIN
																												
																	,IN_HEPIN_label																									
																,
																
														
														IN_ORAL
																												
																	,IN_ORAL_label																									
																,
																
														
														IN_IC
																												
																	,IN_IC_label																									
																,
																
														
														IN_DT_IC																									
																,
																
														
														EX_OGTT
																												
																	,EX_OGTT_label																									
																,
																
														
														EX_HEP
																												
																	,EX_HEP_label																									
																,
																
														
														EX_CARD
																												
																	,EX_CARD_label																									
																,
																
														
														EX_RECNT
																												
																	,EX_RECNT_label																									
																,
																
														
														EX_STRKE
																												
																	,EX_STRKE_label																									
																,
																
														
														EX_SEIZ
																												
																	,EX_SEIZ_label																									
																,
																
														
														EX_MENTL
																												
																	,EX_MENTL_label																									
																,
																
														
														EX_ORAL
																												
																	,EX_ORAL_label																									
																,
																
														
														EX_INS
																												
																	,EX_INS_label																									
																,
																
														
														EX_DRUG
																												
																	,EX_DRUG_label																									
																,
																
														
														INEX_ELIG
																												
																	,INEX_ELIG_label
										)
									values (
									
									
									'SS_TS9_105_',
									
									'TS9_105_09', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,1													
															,'Yes'											
														
															,'2014-06-10'
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,2													
															,'No'											
														
															,1													
															,'Eligible'											
																
									);
								
			  
			
					insert into NCT01928420_All_Data.crf_version (crf_name, crf_version_name, warehouse_insert_created_timestamp) values 
					( 'Demographics', 
					'V1.0',
					'2015-03-19T16:41:35.717Z');
			
			
			
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS10_101',
									
					'TS10_101_10',
					
				'SE_FIRSTVISIT',
				
				'Demographics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS3_101_',
									
					'TS3_101_03',
					
				'SE_FIRSTVISIT',
				
				'Demographics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS6_101_',
									
					'TS6_101_06',
					
				'SE_FIRSTVISIT',
				
				'Demographics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS10_102',
									
					'TS10_102_10',
					
				'SE_FIRSTVISIT',
				
				'Demographics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS1_102_',
									
					'TS1_102_01',
					
				'SE_FIRSTVISIT',
				
				'Demographics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS3_102_',
									
					'TS3_102_03',
					
				'SE_FIRSTVISIT',
				
				'Demographics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS4_102_',
									
					'TS4_102_04',
					
				'SE_FIRSTVISIT',
				
				'Demographics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS6_102_',
									
					'TS6_102_06',
					
				'SE_FIRSTVISIT',
				
				'Demographics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS8_102_',
									
					'TS8_102_08',
					
				'SE_FIRSTVISIT',
				
				'Demographics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS10_103',
									
					'TS10_103_10',
					
				'SE_FIRSTVISIT',
				
				'Demographics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS1_103_',
									
					'TS1_103_01',
					
				'SE_FIRSTVISIT',
				
				'Demographics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS3_103_',
									
					'TS3_103_03',
					
				'SE_FIRSTVISIT',
				
				'Demographics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS6_103_',
									
					'TS6_103_06',
					
				'SE_FIRSTVISIT',
				
				'Demographics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS8_103_',
									
					'TS8_103_08',
					
				'SE_FIRSTVISIT',
				
				'Demographics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS10_104',
									
					'TS10_104_10',
					
				'SE_FIRSTVISIT',
				
				'Demographics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS1_104_',
									
					'TS1_104_01',
					
				'SE_FIRSTVISIT',
				
				'Demographics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS3_104_',
									
					'TS3_104_03',
					
				'SE_FIRSTVISIT',
				
				'Demographics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS6_104_',
									
					'TS6_104_06',
					
				'SE_FIRSTVISIT',
				
				'Demographics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS8_104_',
									
					'TS8_104_08',
					
				'SE_FIRSTVISIT',
				
				'Demographics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS13_105',
									
					'TS13_105_13',
					
				'SE_FIRSTVISIT',
				
				'Demographics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS2_105_',
									
					'TS2_105_02',
					
				'SE_FIRSTVISIT',
				
				'Demographics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS5_105_',
									
					'TS5_105_05',
					
				'SE_FIRSTVISIT',
				
				'Demographics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS6_105_',
									
					'TS6_105_06',
					
				'SE_FIRSTVISIT',
				
				'Demographics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS7_105_',
									
					'TS7_105_07',
					
				'SE_FIRSTVISIT',
				
				'Demographics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS9_105_',
									
					'TS9_105_09',
					
				'SE_FIRSTVISIT',
				
				'Demographics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
				create table NCT01928420_All_Data.DemographicsDemo (
				item_data_id serial NOT NULL,
				ssoid character varying(40) NOT NULL,
				ssid character varying(40) NOT NULL,
				study_event_oid character varying(40) NOT NULL,
				event_ordinal integer default 1,
				crf_version character varying(255),
				event_start_date timestamp without time zone,
				event_end_date timestamp without time zone,
				event_status character varying(255),
				event_location character varying(2000),
				subject_age_at_event integer,
				crf_status character varying(255), 
				interviewerName character varying(255),
				interviewDate date,
				warehouse_insert_created_timestamp timestamp with time zone); 			          	 
				
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.DemographicsDemo', 'DEM_DTIC', 'date');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.DemographicsDemo', 'DEM_DTBR', 'date');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.DemographicsDemo', 'DEM_AGE', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.DemographicsDemo', 'DEM_GEN', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.DemographicsDemo', 'DEM_GEN_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.DemographicsDemo', 'DEM_ETH', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.DemographicsDemo', 'DEM_ETH_label', 'character varying(255)');

	
			
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.DemographicsDemo', 'DEM_RACE_American_Indian',
			'boolean');
			
			
			
			
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.DemographicsDemo', 'DEM_RACE_African_American_or_Black',
			'boolean');
			
			
			
			
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.DemographicsDemo', 'DEM_RACE_Asian',
			'boolean');
			
			
			
			
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.DemographicsDemo', 'DEM_RACE_Caucasian',
			'boolean');
			
			
			
			
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.DemographicsDemo', 'DEM_RACE_Mediterranean',
			'boolean');
			
			
			
			
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.DemographicsDemo', 'DEM_RACE_Middle_Eastern',
			'boolean');
			
			
			
			
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.DemographicsDemo', 'DEM_RACE_Pacific_Islander',
			'boolean');
			
			
			
			
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.DemographicsDemo', 'DEM_RACE_Prefer_not_to_answer',
			'boolean');
			
			
			
			
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.DemographicsDemo', 'DEM_RACE_Unknown',
			'boolean');
			
			
			
			
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.DemographicsDemo', 'DEM_RACE_Other',
			'boolean');
			
			
			
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.DemographicsDemo', 'DEM_OTRACE', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.DemographicsDemo', 'DEM_MAR', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.DemographicsDemo', 'DEM_MAR_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.DemographicsDemo', 'DEM_EDU', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.DemographicsDemo', 'DEM_EDU_label', 'character varying(255)');

	
				
		ALTER TABLE NCT01928420_All_Data.DemographicsDemo ADD CONSTRAINT Pk_DEMO PRIMARY KEY (item_data_id);

		
				
		ALTER TABLE NCT01928420_All_Data.DemographicsDemo ADD CONSTRAINT 	
		Fk_study_subject_id_DEMO FOREIGN KEY (ssoid, 
		ssid) REFERENCES NCT01928420_All_Data.study_subject_listing;
		
				
									insert into NCT01928420_All_Data.DemographicsDemo (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														DEM_DTIC																									
																,
																
														
														DEM_DTBR																									
																,
																
														
														DEM_AGE																									
																,
																
														
														DEM_GEN
																												
																	,DEM_GEN_label																									
																,
																
														
														DEM_ETH
																												
																	,DEM_ETH_label
				,
				DEM_RACE_Mediterranean																									
																,
																
														
														DEM_MAR
																												
																	,DEM_MAR_label																									
																,
																
														
														DEM_EDU
																												
																	,DEM_EDU_label
										)
									values (
									
									
									'SS_TS10_101',
									
									'TS10_101_10', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,'1958-12-24'
															,55
															,1													
															,'Male'											
														
															,2													
															,'Non Hispanic'											
														
					,true
				
															,1													
															,'Single'											
														
															,4													
															,'4 year college'											
																
									);
										
									insert into NCT01928420_All_Data.DemographicsDemo (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														DEM_DTIC																									
																,
																
														
														DEM_DTBR																									
																,
																
														
														DEM_AGE																									
																,
																
														
														DEM_GEN
																												
																	,DEM_GEN_label																									
																,
																
														
														DEM_ETH
																												
																	,DEM_ETH_label
				,
				DEM_RACE_Caucasian																									
																,
																
														
														DEM_MAR
																												
																	,DEM_MAR_label																									
																,
																
														
														DEM_EDU
																												
																	,DEM_EDU_label
										)
									values (
									
									
									'SS_TS3_101_',
									
									'TS3_101_03', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,'1960-05-31'
															,54
															,2													
															,'Female'											
														
															,1													
															,'Hispanic'											
														
					,true
				
															,3													
															,'Divorced/Separated'											
														
															,4													
															,'4 year college'											
																
									);
										
									insert into NCT01928420_All_Data.DemographicsDemo (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														DEM_DTIC																									
																,
																
														
														DEM_DTBR																									
																,
																
														
														DEM_AGE																									
																,
																
														
														DEM_GEN
																												
																	,DEM_GEN_label																									
																,
																
														
														DEM_ETH
																												
																	,DEM_ETH_label
				,
				DEM_RACE_African_American_or_Black																									
																,
																
														
														DEM_MAR
																												
																	,DEM_MAR_label																									
																,
																
														
														DEM_EDU
																												
																	,DEM_EDU_label
										)
									values (
									
									
									'SS_TS6_101_',
									
									'TS6_101_06', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,'1957-09-12'
															,56
															,1													
															,'Male'											
														
															,3													
															,'Unknown'											
														
					,true
				
															,4													
															,'Widowed'											
														
															,5													
															,'Masters'											
																
									);
										
									insert into NCT01928420_All_Data.DemographicsDemo (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														DEM_DTIC																									
																,
																
														
														DEM_DTBR																									
																,
																
														
														DEM_AGE																									
																,
																
														
														DEM_GEN
																												
																	,DEM_GEN_label																									
																,
																
														
														DEM_ETH
																												
																	,DEM_ETH_label
				,
				DEM_RACE_Mediterranean																									
																,
																
														
														DEM_MAR
																												
																	,DEM_MAR_label																									
																,
																
														
														DEM_EDU
																												
																	,DEM_EDU_label
										)
									values (
									
									
									'SS_TS10_102',
									
									'TS10_102_10', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,'1958-12-24'
															,55
															,1													
															,'Male'											
														
															,2													
															,'Non Hispanic'											
														
					,true
				
															,1													
															,'Single'											
														
															,4													
															,'4 year college'											
																
									);
										
									insert into NCT01928420_All_Data.DemographicsDemo (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														DEM_DTIC																									
																,
																
														
														DEM_DTBR																									
																,
																
														
														DEM_AGE																									
																,
																
														
														DEM_GEN
																												
																	,DEM_GEN_label																									
																,
																
														
														DEM_ETH
																												
																	,DEM_ETH_label
				,
				DEM_RACE_Caucasian																									
																,
																
														
														DEM_MAR
																												
																	,DEM_MAR_label																									
																,
																
														
														DEM_EDU
																												
																	,DEM_EDU_label
										)
									values (
									
									
									'SS_TS1_102_',
									
									'TS1_102_01', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,'1960-05-31'
															,54
															,2													
															,'Female'											
														
															,1													
															,'Hispanic'											
														
					,true
				
															,3													
															,'Divorced/Separated'											
														
															,4													
															,'4 year college'											
																
									);
										
									insert into NCT01928420_All_Data.DemographicsDemo (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														DEM_DTIC																									
																,
																
														
														DEM_DTBR																									
																,
																
														
														DEM_AGE																									
																,
																
														
														DEM_GEN
																												
																	,DEM_GEN_label																									
																,
																
														
														DEM_ETH
																												
																	,DEM_ETH_label
				,
				DEM_RACE_Caucasian																									
																,
																
														
														DEM_MAR
																												
																	,DEM_MAR_label																									
																,
																
														
														DEM_EDU
																												
																	,DEM_EDU_label
										)
									values (
									
									
									'SS_TS3_102_',
									
									'TS3_102_03', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,'1960-05-31'
															,54
															,2													
															,'Female'											
														
															,1													
															,'Hispanic'											
														
					,true
				
															,3													
															,'Divorced/Separated'											
														
															,4													
															,'4 year college'											
																
									);
										
									insert into NCT01928420_All_Data.DemographicsDemo (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														DEM_DTIC																									
																,
																
														
														DEM_DTBR																									
																,
																
														
														DEM_AGE																									
																,
																
														
														DEM_GEN
																												
																	,DEM_GEN_label																									
																,
																
														
														DEM_ETH
																												
																	,DEM_ETH_label
				,
				DEM_RACE_Asian
				,
				DEM_RACE_Caucasian																									
																,
																
														
														DEM_MAR
																												
																	,DEM_MAR_label																									
																,
																
														
														DEM_EDU
																												
																	,DEM_EDU_label
										)
									values (
									
									
									'SS_TS4_102_',
									
									'TS4_102_04', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,'1953-12-12'
															,60
															,2													
															,'Female'											
														
															,2													
															,'Non Hispanic'											
														
					,true
					
					,true
				
															,2													
															,'Married'											
														
															,6													
															,'PhD'											
																
									);
										
									insert into NCT01928420_All_Data.DemographicsDemo (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														DEM_DTIC																									
																,
																
														
														DEM_DTBR																									
																,
																
														
														DEM_AGE																									
																,
																
														
														DEM_GEN
																												
																	,DEM_GEN_label																									
																,
																
														
														DEM_ETH
																												
																	,DEM_ETH_label
				,
				DEM_RACE_African_American_or_Black																									
																,
																
														
														DEM_MAR
																												
																	,DEM_MAR_label																									
																,
																
														
														DEM_EDU
																												
																	,DEM_EDU_label
										)
									values (
									
									
									'SS_TS6_102_',
									
									'TS6_102_06', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,'1957-09-12'
															,56
															,1													
															,'Male'											
														
															,3													
															,'Unknown'											
														
					,true
				
															,4													
															,'Widowed'											
														
															,5													
															,'Masters'											
																
									);
										
									insert into NCT01928420_All_Data.DemographicsDemo (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														DEM_DTIC																									
																,
																
														
														DEM_DTBR																									
																,
																
														
														DEM_AGE																									
																,
																
														
														DEM_GEN
																												
																	,DEM_GEN_label																									
																,
																
														
														DEM_ETH
																												
																	,DEM_ETH_label
				,
				DEM_RACE_Mediterranean																									
																,
																
														
														DEM_MAR
																												
																	,DEM_MAR_label																									
																,
																
														
														DEM_EDU
																												
																	,DEM_EDU_label
										)
									values (
									
									
									'SS_TS8_102_',
									
									'TS8_102_08', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,'1958-12-24'
															,55
															,1													
															,'Male'											
														
															,2													
															,'Non Hispanic'											
														
					,true
				
															,1													
															,'Single'											
														
															,4													
															,'4 year college'											
																
									);
										
									insert into NCT01928420_All_Data.DemographicsDemo (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														DEM_DTIC																									
																,
																
														
														DEM_DTBR																									
																,
																
														
														DEM_AGE																									
																,
																
														
														DEM_GEN
																												
																	,DEM_GEN_label																									
																,
																
														
														DEM_ETH
																												
																	,DEM_ETH_label
				,
				DEM_RACE_Mediterranean																									
																,
																
														
														DEM_MAR
																												
																	,DEM_MAR_label																									
																,
																
														
														DEM_EDU
																												
																	,DEM_EDU_label
										)
									values (
									
									
									'SS_TS10_103',
									
									'TS10_103_10', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,'1958-12-24'
															,55
															,1													
															,'Male'											
														
															,2													
															,'Non Hispanic'											
														
					,true
				
															,1													
															,'Single'											
														
															,4													
															,'4 year college'											
																
									);
										
									insert into NCT01928420_All_Data.DemographicsDemo (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														DEM_DTIC																									
																,
																
														
														DEM_DTBR																									
																,
																
														
														DEM_AGE																									
																,
																
														
														DEM_GEN
																												
																	,DEM_GEN_label																									
																,
																
														
														DEM_ETH
																												
																	,DEM_ETH_label
				,
				DEM_RACE_Caucasian																									
																,
																
														
														DEM_MAR
																												
																	,DEM_MAR_label																									
																,
																
														
														DEM_EDU
																												
																	,DEM_EDU_label
										)
									values (
									
									
									'SS_TS1_103_',
									
									'TS1_103_01', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,'1960-05-31'
															,54
															,2													
															,'Female'											
														
															,1													
															,'Hispanic'											
														
					,true
				
															,3													
															,'Divorced/Separated'											
														
															,4													
															,'4 year college'											
																
									);
										
									insert into NCT01928420_All_Data.DemographicsDemo (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														DEM_DTIC																									
																,
																
														
														DEM_DTBR																									
																,
																
														
														DEM_AGE																									
																,
																
														
														DEM_GEN
																												
																	,DEM_GEN_label																									
																,
																
														
														DEM_ETH
																												
																	,DEM_ETH_label
				,
				DEM_RACE_Caucasian																									
																,
																
														
														DEM_MAR
																												
																	,DEM_MAR_label																									
																,
																
														
														DEM_EDU
																												
																	,DEM_EDU_label
										)
									values (
									
									
									'SS_TS3_103_',
									
									'TS3_103_03', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,'1960-05-31'
															,54
															,2													
															,'Female'											
														
															,1													
															,'Hispanic'											
														
					,true
				
															,3													
															,'Divorced/Separated'											
														
															,4													
															,'4 year college'											
																
									);
										
									insert into NCT01928420_All_Data.DemographicsDemo (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														DEM_DTIC																									
																,
																
														
														DEM_DTBR																									
																,
																
														
														DEM_AGE																									
																,
																
														
														DEM_GEN
																												
																	,DEM_GEN_label																									
																,
																
														
														DEM_ETH
																												
																	,DEM_ETH_label
				,
				DEM_RACE_African_American_or_Black																									
																,
																
														
														DEM_MAR
																												
																	,DEM_MAR_label																									
																,
																
														
														DEM_EDU
																												
																	,DEM_EDU_label
										)
									values (
									
									
									'SS_TS6_103_',
									
									'TS6_103_06', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,'1957-09-12'
															,56
															,1													
															,'Male'											
														
															,3													
															,'Unknown'											
														
					,true
				
															,4													
															,'Widowed'											
														
															,5													
															,'Masters'											
																
									);
										
									insert into NCT01928420_All_Data.DemographicsDemo (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														DEM_DTIC																									
																,
																
														
														DEM_DTBR																									
																,
																
														
														DEM_AGE																									
																,
																
														
														DEM_GEN
																												
																	,DEM_GEN_label																									
																,
																
														
														DEM_ETH
																												
																	,DEM_ETH_label
				,
				DEM_RACE_Mediterranean																									
																,
																
														
														DEM_MAR
																												
																	,DEM_MAR_label																									
																,
																
														
														DEM_EDU
																												
																	,DEM_EDU_label
										)
									values (
									
									
									'SS_TS8_103_',
									
									'TS8_103_08', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,'1958-12-24'
															,55
															,1													
															,'Male'											
														
															,2													
															,'Non Hispanic'											
														
					,true
				
															,1													
															,'Single'											
														
															,4													
															,'4 year college'											
																
									);
										
									insert into NCT01928420_All_Data.DemographicsDemo (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														DEM_DTIC																									
																,
																
														
														DEM_DTBR																									
																,
																
														
														DEM_AGE																									
																,
																
														
														DEM_GEN
																												
																	,DEM_GEN_label																									
																,
																
														
														DEM_ETH
																												
																	,DEM_ETH_label
				,
				DEM_RACE_Mediterranean																									
																,
																
														
														DEM_MAR
																												
																	,DEM_MAR_label																									
																,
																
														
														DEM_EDU
																												
																	,DEM_EDU_label
										)
									values (
									
									
									'SS_TS10_104',
									
									'TS10_104_10', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,'1958-12-24'
															,55
															,1													
															,'Male'											
														
															,2													
															,'Non Hispanic'											
														
					,true
				
															,1													
															,'Single'											
														
															,4													
															,'4 year college'											
																
									);
										
									insert into NCT01928420_All_Data.DemographicsDemo (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														DEM_DTIC																									
																,
																
														
														DEM_DTBR																									
																,
																
														
														DEM_AGE																									
																,
																
														
														DEM_GEN
																												
																	,DEM_GEN_label																									
																,
																
														
														DEM_ETH
																												
																	,DEM_ETH_label
				,
				DEM_RACE_Caucasian																									
																,
																
														
														DEM_MAR
																												
																	,DEM_MAR_label																									
																,
																
														
														DEM_EDU
																												
																	,DEM_EDU_label
										)
									values (
									
									
									'SS_TS1_104_',
									
									'TS1_104_01', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,'1960-05-31'
															,54
															,2													
															,'Female'											
														
															,1													
															,'Hispanic'											
														
					,true
				
															,3													
															,'Divorced/Separated'											
														
															,4													
															,'4 year college'											
																
									);
										
									insert into NCT01928420_All_Data.DemographicsDemo (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														DEM_DTIC																									
																,
																
														
														DEM_DTBR																									
																,
																
														
														DEM_AGE																									
																,
																
														
														DEM_GEN
																												
																	,DEM_GEN_label																									
																,
																
														
														DEM_ETH
																												
																	,DEM_ETH_label
				,
				DEM_RACE_Caucasian																									
																,
																
														
														DEM_MAR
																												
																	,DEM_MAR_label																									
																,
																
														
														DEM_EDU
																												
																	,DEM_EDU_label
										)
									values (
									
									
									'SS_TS3_104_',
									
									'TS3_104_03', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,'1960-05-31'
															,54
															,2													
															,'Female'											
														
															,1													
															,'Hispanic'											
														
					,true
				
															,3													
															,'Divorced/Separated'											
														
															,4													
															,'4 year college'											
																
									);
										
									insert into NCT01928420_All_Data.DemographicsDemo (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														DEM_DTIC																									
																,
																
														
														DEM_DTBR																									
																,
																
														
														DEM_AGE																									
																,
																
														
														DEM_GEN
																												
																	,DEM_GEN_label																									
																,
																
														
														DEM_ETH
																												
																	,DEM_ETH_label
				,
				DEM_RACE_African_American_or_Black																									
																,
																
														
														DEM_MAR
																												
																	,DEM_MAR_label																									
																,
																
														
														DEM_EDU
																												
																	,DEM_EDU_label
										)
									values (
									
									
									'SS_TS6_104_',
									
									'TS6_104_06', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,'1957-09-12'
															,56
															,1													
															,'Male'											
														
															,3													
															,'Unknown'											
														
					,true
				
															,4													
															,'Widowed'											
														
															,5													
															,'Masters'											
																
									);
										
									insert into NCT01928420_All_Data.DemographicsDemo (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														DEM_DTIC																									
																,
																
														
														DEM_DTBR																									
																,
																
														
														DEM_AGE																									
																,
																
														
														DEM_GEN
																												
																	,DEM_GEN_label																									
																,
																
														
														DEM_ETH
																												
																	,DEM_ETH_label
				,
				DEM_RACE_Mediterranean																									
																,
																
														
														DEM_MAR
																												
																	,DEM_MAR_label																									
																,
																
														
														DEM_EDU
																												
																	,DEM_EDU_label
										)
									values (
									
									
									'SS_TS8_104_',
									
									'TS8_104_08', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,'1958-12-24'
															,55
															,1													
															,'Male'											
														
															,2													
															,'Non Hispanic'											
														
					,true
				
															,1													
															,'Single'											
														
															,4													
															,'4 year college'											
																
									);
										
									insert into NCT01928420_All_Data.DemographicsDemo (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														DEM_DTIC																									
																,
																
														
														DEM_DTBR																									
																,
																
														
														DEM_AGE																									
																,
																
														
														DEM_GEN
																												
																	,DEM_GEN_label																									
																,
																
														
														DEM_ETH
																												
																	,DEM_ETH_label
				,
				DEM_RACE_Mediterranean																									
																,
																
														
														DEM_MAR
																												
																	,DEM_MAR_label																									
																,
																
														
														DEM_EDU
																												
																	,DEM_EDU_label
										)
									values (
									
									
									'SS_TS13_105',
									
									'TS13_105_13', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,'1958-12-24'
															,55
															,1													
															,'Male'											
														
															,2													
															,'Non Hispanic'											
														
					,true
				
															,1													
															,'Single'											
														
															,4													
															,'4 year college'											
																
									);
										
									insert into NCT01928420_All_Data.DemographicsDemo (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														DEM_DTIC																									
																,
																
														
														DEM_DTBR																									
																,
																
														
														DEM_AGE																									
																,
																
														
														DEM_GEN
																												
																	,DEM_GEN_label																									
																,
																
														
														DEM_ETH
																												
																	,DEM_ETH_label
				,
				DEM_RACE_Caucasian																									
																,
																
														
														DEM_MAR
																												
																	,DEM_MAR_label																									
																,
																
														
														DEM_EDU
																												
																	,DEM_EDU_label
										)
									values (
									
									
									'SS_TS2_105_',
									
									'TS2_105_02', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,'1960-05-31'
															,54
															,2													
															,'Female'											
														
															,1													
															,'Hispanic'											
														
					,true
				
															,3													
															,'Divorced/Separated'											
														
															,4													
															,'4 year college'											
																
									);
										
									insert into NCT01928420_All_Data.DemographicsDemo (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														DEM_DTIC																									
																,
																
														
														DEM_DTBR																									
																,
																
														
														DEM_AGE																									
																,
																
														
														DEM_GEN
																												
																	,DEM_GEN_label																									
																,
																
														
														DEM_ETH
																												
																	,DEM_ETH_label
				,
				DEM_RACE_Asian
				,
				DEM_RACE_Mediterranean																									
																,
																
														
														DEM_MAR
																												
																	,DEM_MAR_label																									
																,
																
														
														DEM_EDU
																												
																	,DEM_EDU_label
										)
									values (
									
									
									'SS_TS5_105_',
									
									'TS5_105_05', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,'1953-12-12'
															,60
															,1													
															,'Male'											
														
															,2													
															,'Non Hispanic'											
														
					,true
					
					,true
				
															,2													
															,'Married'											
														
															,4													
															,'4 year college'											
																
									);
										
									insert into NCT01928420_All_Data.DemographicsDemo (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														DEM_DTIC																									
																,
																
														
														DEM_DTBR																									
																,
																
														
														DEM_AGE																									
																,
																
														
														DEM_GEN
																												
																	,DEM_GEN_label																									
																,
																
														
														DEM_ETH
																												
																	,DEM_ETH_label
				,
				DEM_RACE_African_American_or_Black																									
																,
																
														
														DEM_MAR
																												
																	,DEM_MAR_label																									
																,
																
														
														DEM_EDU
																												
																	,DEM_EDU_label
										)
									values (
									
									
									'SS_TS6_105_',
									
									'TS6_105_06', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,'1957-09-12'
															,56
															,1													
															,'Male'											
														
															,3													
															,'Unknown'											
														
					,true
				
															,4													
															,'Widowed'											
														
															,5													
															,'Masters'											
																
									);
										
									insert into NCT01928420_All_Data.DemographicsDemo (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														DEM_DTIC																									
																,
																
														
														DEM_DTBR																									
																,
																
														
														DEM_AGE																									
																,
																
														
														DEM_GEN
																												
																	,DEM_GEN_label																									
																,
																
														
														DEM_ETH
																												
																	,DEM_ETH_label
				,
				DEM_RACE_Caucasian																									
																,
																
														
														DEM_MAR
																												
																	,DEM_MAR_label																									
																,
																
														
														DEM_EDU
																												
																	,DEM_EDU_label
										)
									values (
									
									
									'SS_TS7_105_',
									
									'TS7_105_07', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,'1960-05-31'
															,54
															,2													
															,'Female'											
														
															,1													
															,'Hispanic'											
														
					,true
				
															,3													
															,'Divorced/Separated'											
														
															,4													
															,'4 year college'											
																
									);
										
									insert into NCT01928420_All_Data.DemographicsDemo (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														DEM_DTIC																									
																,
																
														
														DEM_DTBR																									
																,
																
														
														DEM_AGE																									
																,
																
														
														DEM_GEN
																												
																	,DEM_GEN_label																									
																,
																
														
														DEM_ETH
																												
																	,DEM_ETH_label
				,
				DEM_RACE_Mediterranean																									
																,
																
														
														DEM_MAR
																												
																	,DEM_MAR_label																									
																,
																
														
														DEM_EDU
																												
																	,DEM_EDU_label
										)
									values (
									
									
									'SS_TS9_105_',
									
									'TS9_105_09', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,'1958-12-24'
															,55
															,1													
															,'Male'											
														
															,2													
															,'Non Hispanic'											
														
					,true
				
															,1													
															,'Single'											
														
															,4													
															,'4 year college'											
																
									);
								
			  
			
					insert into NCT01928420_All_Data.crf_version (crf_name, crf_version_name, warehouse_insert_created_timestamp) values 
					( 'Diabetes History', 
					'V1-1.1',
					'2015-03-19T16:41:35.717Z');
			
			
			
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS10_101',
									
					'TS10_101_10',
					
				'SE_FIRSTVISIT',
				
				'Diabetes History',
				'V1-1.1'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS3_101_',
									
					'TS3_101_03',
					
				'SE_FIRSTVISIT',
				
				'Diabetes History',
				'V1-1.1'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS6_101_',
									
					'TS6_101_06',
					
				'SE_FIRSTVISIT',
				
				'Diabetes History',
				'V1-1.1'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS10_102',
									
					'TS10_102_10',
					
				'SE_FIRSTVISIT',
				
				'Diabetes History',
				'V1-1.1'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS1_102_',
									
					'TS1_102_01',
					
				'SE_FIRSTVISIT',
				
				'Diabetes History',
				'V1-1.1'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS3_102_',
									
					'TS3_102_03',
					
				'SE_FIRSTVISIT',
				
				'Diabetes History',
				'V1-1.1'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS6_102_',
									
					'TS6_102_06',
					
				'SE_FIRSTVISIT',
				
				'Diabetes History',
				'V1-1.1'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS8_102_',
									
					'TS8_102_08',
					
				'SE_FIRSTVISIT',
				
				'Diabetes History',
				'V1-1.1'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS10_103',
									
					'TS10_103_10',
					
				'SE_FIRSTVISIT',
				
				'Diabetes History',
				'V1-1.1'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS1_103_',
									
					'TS1_103_01',
					
				'SE_FIRSTVISIT',
				
				'Diabetes History',
				'V1-1.1'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS3_103_',
									
					'TS3_103_03',
					
				'SE_FIRSTVISIT',
				
				'Diabetes History',
				'V1-1.1'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS6_103_',
									
					'TS6_103_06',
					
				'SE_FIRSTVISIT',
				
				'Diabetes History',
				'V1-1.1'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS8_103_',
									
					'TS8_103_08',
					
				'SE_FIRSTVISIT',
				
				'Diabetes History',
				'V1-1.1'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS10_104',
									
					'TS10_104_10',
					
				'SE_FIRSTVISIT',
				
				'Diabetes History',
				'V1-1.1'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS1_104_',
									
					'TS1_104_01',
					
				'SE_FIRSTVISIT',
				
				'Diabetes History',
				'V1-1.1'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS3_104_',
									
					'TS3_104_03',
					
				'SE_FIRSTVISIT',
				
				'Diabetes History',
				'V1-1.1'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS6_104_',
									
					'TS6_104_06',
					
				'SE_FIRSTVISIT',
				
				'Diabetes History',
				'V1-1.1'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS8_104_',
									
					'TS8_104_08',
					
				'SE_FIRSTVISIT',
				
				'Diabetes History',
				'V1-1.1'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS13_105',
									
					'TS13_105_13',
					
				'SE_FIRSTVISIT',
				
				'Diabetes History',
				'V1-1.1'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS2_105_',
									
					'TS2_105_02',
					
				'SE_FIRSTVISIT',
				
				'Diabetes History',
				'V1-1.1'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS5_105_',
									
					'TS5_105_05',
					
				'SE_FIRSTVISIT',
				
				'Diabetes History',
				'V1-1.1'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS6_105_',
									
					'TS6_105_06',
					
				'SE_FIRSTVISIT',
				
				'Diabetes History',
				'V1-1.1'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS7_105_',
									
					'TS7_105_07',
					
				'SE_FIRSTVISIT',
				
				'Diabetes History',
				'V1-1.1'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS9_105_',
									
					'TS9_105_09',
					
				'SE_FIRSTVISIT',
				
				'Diabetes History',
				'V1-1.1'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
				create table NCT01928420_All_Data.Diabetes_HistoryDIABETES (
				item_data_id serial NOT NULL,
				ssoid character varying(40) NOT NULL,
				ssid character varying(40) NOT NULL,
				study_event_oid character varying(40) NOT NULL,
				event_ordinal integer default 1,
				crf_version character varying(255),
				event_start_date timestamp without time zone,
				event_end_date timestamp without time zone,
				event_status character varying(255),
				event_location character varying(2000),
				subject_age_at_event integer,
				crf_status character varying(255), 
				interviewerName character varying(255),
				interviewDate date,
				warehouse_insert_created_timestamp timestamp with time zone); 			          	 
				
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Diabetes_HistoryDIABETES', 'DIABETES_MHSTDAT', 'date');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Diabetes_HistoryDIABETES', 'DIABETES_CMOCCUR', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Diabetes_HistoryDIABETES', 'DIABETES_CMOCCUR_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Diabetes_HistoryDIABETES', 'DIABETES_CMSTDAT', 'date');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Diabetes_HistoryDIABETES', 'INSULIN_CMOCCUR', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Diabetes_HistoryDIABETES', 'INSULIN_CMOCCUR_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Diabetes_HistoryDIABETES', 'INSULIN_CMSTDAT', 'date');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Diabetes_HistoryDIABETES', 'RETINOPATHY_MHOCCUR', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Diabetes_HistoryDIABETES', 'RETINOPATHY_MHOCCUR_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Diabetes_HistoryDIABETES', 'RETINOPATHY_MHSTDAT', 'date');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Diabetes_HistoryDIABETES', 'SGOCCUR', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Diabetes_HistoryDIABETES', 'SGOCCUR_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Diabetes_HistoryDIABETES', 'SGSTDAT', 'date');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Diabetes_HistoryDIABETES', 'AUTONOMIC_NEUROPATHY_MHOCCUR', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Diabetes_HistoryDIABETES', 'AUTONOMIC_NEUROPATHY_MHOCCUR_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Diabetes_HistoryDIABETES', 'AUTONOMIC_NEUROPATHY_MHSTDAT', 'date');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Diabetes_HistoryDIABETES', 'OTHER_DIABETIC_NEUROPATHY_MHOCCUR', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Diabetes_HistoryDIABETES', 'OTHER_DIABETIC_NEUROPATHY_MHOCCUR_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Diabetes_HistoryDIABETES', 'OTHER_DIABETIC_NEUROPATHY_MHSTDAT', 'date');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Diabetes_HistoryDIABETES', 'DIABETIC_NEPHROPATHY_MHOCCUR', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Diabetes_HistoryDIABETES', 'DIABETIC_NEPHROPATHY_MHOCCUR_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Diabetes_HistoryDIABETES', 'DIABETIC_NEPHROPATHY_MHSTDAT', 'date');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Diabetes_HistoryDIABETES', 'SEVERE_HYPOGLYCEMIC_REACTION_MHOCCUR', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Diabetes_HistoryDIABETES', 'SEVERE_HYPOGLYCEMIC_REACTION_MHOCCUR_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Diabetes_HistoryDIABETES', 'SEVERE_HYPOGLYCEMIC_REACTION_MHSTDAT', 'date');

	
				
		ALTER TABLE NCT01928420_All_Data.Diabetes_HistoryDIABETES ADD CONSTRAINT Pk_DIABETES PRIMARY KEY (item_data_id);

		
				
		ALTER TABLE NCT01928420_All_Data.Diabetes_HistoryDIABETES ADD CONSTRAINT 	
		Fk_study_subject_id_DIABETES FOREIGN KEY (ssoid, 
		ssid) REFERENCES NCT01928420_All_Data.study_subject_listing;
		
				
									insert into NCT01928420_All_Data.Diabetes_HistoryDIABETES (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														DIABETES_MHSTDAT																									
																,
																
														
														DIABETES_CMOCCUR
																												
																	,DIABETES_CMOCCUR_label																									
																,
																
														
														DIABETES_CMSTDAT																									
																,
																
														
														INSULIN_CMOCCUR
																												
																	,INSULIN_CMOCCUR_label																									
																,
																
														
														INSULIN_CMSTDAT																									
																,
																
														
														RETINOPATHY_MHOCCUR
																												
																	,RETINOPATHY_MHOCCUR_label																									
																,
																
														
														SGOCCUR
																												
																	,SGOCCUR_label																									
																,
																
														
														OTHER_DIABETIC_NEUROPATHY_MHOCCUR
																												
																	,OTHER_DIABETIC_NEUROPATHY_MHOCCUR_label																									
																,
																
														
														DIABETIC_NEPHROPATHY_MHOCCUR
																												
																	,DIABETIC_NEPHROPATHY_MHOCCUR_label																									
																,
																
														
														SEVERE_HYPOGLYCEMIC_REACTION_MHOCCUR
																												
																	,SEVERE_HYPOGLYCEMIC_REACTION_MHOCCUR_label
										)
									values (
									
									
									'SS_TS10_101',
									
									'TS10_101_10', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1-1.1'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'1988-09-12'
															,'Y'													
															,'Yes'											
														
															,'1989-10-14'
															,'Y'													
															,'Yes'											
														
															,'1989-10-14'
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
																
									);
										
									insert into NCT01928420_All_Data.Diabetes_HistoryDIABETES (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														DIABETES_MHSTDAT																									
																,
																
														
														DIABETES_CMOCCUR
																												
																	,DIABETES_CMOCCUR_label																									
																,
																
														
														DIABETES_CMSTDAT																									
																,
																
														
														INSULIN_CMOCCUR
																												
																	,INSULIN_CMOCCUR_label																									
																,
																
														
														RETINOPATHY_MHOCCUR
																												
																	,RETINOPATHY_MHOCCUR_label																									
																,
																
														
														RETINOPATHY_MHSTDAT																									
																,
																
														
														SGOCCUR
																												
																	,SGOCCUR_label																									
																,
																
														
														AUTONOMIC_NEUROPATHY_MHOCCUR
																												
																	,AUTONOMIC_NEUROPATHY_MHOCCUR_label																									
																,
																
														
														OTHER_DIABETIC_NEUROPATHY_MHOCCUR
																												
																	,OTHER_DIABETIC_NEUROPATHY_MHOCCUR_label																									
																,
																
														
														DIABETIC_NEPHROPATHY_MHOCCUR
																												
																	,DIABETIC_NEPHROPATHY_MHOCCUR_label																									
																,
																
														
														SEVERE_HYPOGLYCEMIC_REACTION_MHOCCUR
																												
																	,SEVERE_HYPOGLYCEMIC_REACTION_MHOCCUR_label
										)
									values (
									
									
									'SS_TS3_101_',
									
									'TS3_101_03', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1-1.1'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'1988-09-12'
															,'Y'													
															,'Yes'											
														
															,'1992-10-10'
															,'N'													
															,'No'											
														
															,'Y'													
															,'Yes'											
														
															,'1992-10-10'
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
																
									);
										
									insert into NCT01928420_All_Data.Diabetes_HistoryDIABETES (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														DIABETES_MHSTDAT																									
																,
																
														
														DIABETES_CMOCCUR
																												
																	,DIABETES_CMOCCUR_label																									
																,
																
														
														INSULIN_CMOCCUR
																												
																	,INSULIN_CMOCCUR_label																									
																,
																
														
														RETINOPATHY_MHOCCUR
																												
																	,RETINOPATHY_MHOCCUR_label																									
																,
																
														
														SGOCCUR
																												
																	,SGOCCUR_label																									
																,
																
														
														AUTONOMIC_NEUROPATHY_MHOCCUR
																												
																	,AUTONOMIC_NEUROPATHY_MHOCCUR_label																									
																,
																
														
														OTHER_DIABETIC_NEUROPATHY_MHOCCUR
																												
																	,OTHER_DIABETIC_NEUROPATHY_MHOCCUR_label																									
																,
																
														
														DIABETIC_NEPHROPATHY_MHOCCUR
																												
																	,DIABETIC_NEPHROPATHY_MHOCCUR_label																									
																,
																
														
														SEVERE_HYPOGLYCEMIC_REACTION_MHOCCUR
																												
																	,SEVERE_HYPOGLYCEMIC_REACTION_MHOCCUR_label
										)
									values (
									
									
									'SS_TS6_101_',
									
									'TS6_101_06', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1-1.1'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'1988-06-11'
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
																
									);
										
									insert into NCT01928420_All_Data.Diabetes_HistoryDIABETES (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														DIABETES_MHSTDAT																									
																,
																
														
														DIABETES_CMOCCUR
																												
																	,DIABETES_CMOCCUR_label																									
																,
																
														
														DIABETES_CMSTDAT																									
																,
																
														
														INSULIN_CMOCCUR
																												
																	,INSULIN_CMOCCUR_label																									
																,
																
														
														INSULIN_CMSTDAT																									
																,
																
														
														RETINOPATHY_MHOCCUR
																												
																	,RETINOPATHY_MHOCCUR_label																									
																,
																
														
														SGOCCUR
																												
																	,SGOCCUR_label																									
																,
																
														
														OTHER_DIABETIC_NEUROPATHY_MHOCCUR
																												
																	,OTHER_DIABETIC_NEUROPATHY_MHOCCUR_label																									
																,
																
														
														DIABETIC_NEPHROPATHY_MHOCCUR
																												
																	,DIABETIC_NEPHROPATHY_MHOCCUR_label																									
																,
																
														
														SEVERE_HYPOGLYCEMIC_REACTION_MHOCCUR
																												
																	,SEVERE_HYPOGLYCEMIC_REACTION_MHOCCUR_label
										)
									values (
									
									
									'SS_TS10_102',
									
									'TS10_102_10', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1-1.1'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'1988-09-12'
															,'Y'													
															,'Yes'											
														
															,'1989-10-14'
															,'Y'													
															,'Yes'											
														
															,'1989-10-14'
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
																
									);
										
									insert into NCT01928420_All_Data.Diabetes_HistoryDIABETES (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														DIABETES_MHSTDAT																									
																,
																
														
														DIABETES_CMOCCUR
																												
																	,DIABETES_CMOCCUR_label																									
																,
																
														
														DIABETES_CMSTDAT																									
																,
																
														
														INSULIN_CMOCCUR
																												
																	,INSULIN_CMOCCUR_label																									
																,
																
														
														RETINOPATHY_MHOCCUR
																												
																	,RETINOPATHY_MHOCCUR_label																									
																,
																
														
														RETINOPATHY_MHSTDAT																									
																,
																
														
														SGOCCUR
																												
																	,SGOCCUR_label																									
																,
																
														
														AUTONOMIC_NEUROPATHY_MHOCCUR
																												
																	,AUTONOMIC_NEUROPATHY_MHOCCUR_label																									
																,
																
														
														OTHER_DIABETIC_NEUROPATHY_MHOCCUR
																												
																	,OTHER_DIABETIC_NEUROPATHY_MHOCCUR_label																									
																,
																
														
														DIABETIC_NEPHROPATHY_MHOCCUR
																												
																	,DIABETIC_NEPHROPATHY_MHOCCUR_label																									
																,
																
														
														SEVERE_HYPOGLYCEMIC_REACTION_MHOCCUR
																												
																	,SEVERE_HYPOGLYCEMIC_REACTION_MHOCCUR_label
										)
									values (
									
									
									'SS_TS1_102_',
									
									'TS1_102_01', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1-1.1'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'1988-09-12'
															,'Y'													
															,'Yes'											
														
															,'1992-10-10'
															,'N'													
															,'No'											
														
															,'Y'													
															,'Yes'											
														
															,'1992-10-10'
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
																
									);
										
									insert into NCT01928420_All_Data.Diabetes_HistoryDIABETES (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														DIABETES_MHSTDAT																									
																,
																
														
														DIABETES_CMOCCUR
																												
																	,DIABETES_CMOCCUR_label																									
																,
																
														
														DIABETES_CMSTDAT																									
																,
																
														
														INSULIN_CMOCCUR
																												
																	,INSULIN_CMOCCUR_label																									
																,
																
														
														RETINOPATHY_MHOCCUR
																												
																	,RETINOPATHY_MHOCCUR_label																									
																,
																
														
														RETINOPATHY_MHSTDAT																									
																,
																
														
														SGOCCUR
																												
																	,SGOCCUR_label																									
																,
																
														
														AUTONOMIC_NEUROPATHY_MHOCCUR
																												
																	,AUTONOMIC_NEUROPATHY_MHOCCUR_label																									
																,
																
														
														OTHER_DIABETIC_NEUROPATHY_MHOCCUR
																												
																	,OTHER_DIABETIC_NEUROPATHY_MHOCCUR_label																									
																,
																
														
														DIABETIC_NEPHROPATHY_MHOCCUR
																												
																	,DIABETIC_NEPHROPATHY_MHOCCUR_label																									
																,
																
														
														SEVERE_HYPOGLYCEMIC_REACTION_MHOCCUR
																												
																	,SEVERE_HYPOGLYCEMIC_REACTION_MHOCCUR_label
										)
									values (
									
									
									'SS_TS3_102_',
									
									'TS3_102_03', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1-1.1'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'1988-09-12'
															,'Y'													
															,'Yes'											
														
															,'1992-10-10'
															,'N'													
															,'No'											
														
															,'Y'													
															,'Yes'											
														
															,'1992-10-10'
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
																
									);
										
									insert into NCT01928420_All_Data.Diabetes_HistoryDIABETES (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														DIABETES_MHSTDAT																									
																,
																
														
														DIABETES_CMOCCUR
																												
																	,DIABETES_CMOCCUR_label																									
																,
																
														
														INSULIN_CMOCCUR
																												
																	,INSULIN_CMOCCUR_label																									
																,
																
														
														RETINOPATHY_MHOCCUR
																												
																	,RETINOPATHY_MHOCCUR_label																									
																,
																
														
														SGOCCUR
																												
																	,SGOCCUR_label																									
																,
																
														
														AUTONOMIC_NEUROPATHY_MHOCCUR
																												
																	,AUTONOMIC_NEUROPATHY_MHOCCUR_label																									
																,
																
														
														OTHER_DIABETIC_NEUROPATHY_MHOCCUR
																												
																	,OTHER_DIABETIC_NEUROPATHY_MHOCCUR_label																									
																,
																
														
														DIABETIC_NEPHROPATHY_MHOCCUR
																												
																	,DIABETIC_NEPHROPATHY_MHOCCUR_label																									
																,
																
														
														SEVERE_HYPOGLYCEMIC_REACTION_MHOCCUR
																												
																	,SEVERE_HYPOGLYCEMIC_REACTION_MHOCCUR_label
										)
									values (
									
									
									'SS_TS6_102_',
									
									'TS6_102_06', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1-1.1'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'1988-06-11'
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
																
									);
										
									insert into NCT01928420_All_Data.Diabetes_HistoryDIABETES (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														DIABETES_MHSTDAT																									
																,
																
														
														DIABETES_CMOCCUR
																												
																	,DIABETES_CMOCCUR_label																									
																,
																
														
														DIABETES_CMSTDAT																									
																,
																
														
														INSULIN_CMOCCUR
																												
																	,INSULIN_CMOCCUR_label																									
																,
																
														
														INSULIN_CMSTDAT																									
																,
																
														
														RETINOPATHY_MHOCCUR
																												
																	,RETINOPATHY_MHOCCUR_label																									
																,
																
														
														SGOCCUR
																												
																	,SGOCCUR_label																									
																,
																
														
														OTHER_DIABETIC_NEUROPATHY_MHOCCUR
																												
																	,OTHER_DIABETIC_NEUROPATHY_MHOCCUR_label																									
																,
																
														
														DIABETIC_NEPHROPATHY_MHOCCUR
																												
																	,DIABETIC_NEPHROPATHY_MHOCCUR_label																									
																,
																
														
														SEVERE_HYPOGLYCEMIC_REACTION_MHOCCUR
																												
																	,SEVERE_HYPOGLYCEMIC_REACTION_MHOCCUR_label
										)
									values (
									
									
									'SS_TS8_102_',
									
									'TS8_102_08', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1-1.1'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'1988-09-12'
															,'Y'													
															,'Yes'											
														
															,'1989-10-14'
															,'Y'													
															,'Yes'											
														
															,'1989-10-14'
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
																
									);
										
									insert into NCT01928420_All_Data.Diabetes_HistoryDIABETES (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														DIABETES_MHSTDAT																									
																,
																
														
														DIABETES_CMOCCUR
																												
																	,DIABETES_CMOCCUR_label																									
																,
																
														
														DIABETES_CMSTDAT																									
																,
																
														
														INSULIN_CMOCCUR
																												
																	,INSULIN_CMOCCUR_label																									
																,
																
														
														INSULIN_CMSTDAT																									
																,
																
														
														RETINOPATHY_MHOCCUR
																												
																	,RETINOPATHY_MHOCCUR_label																									
																,
																
														
														SGOCCUR
																												
																	,SGOCCUR_label																									
																,
																
														
														OTHER_DIABETIC_NEUROPATHY_MHOCCUR
																												
																	,OTHER_DIABETIC_NEUROPATHY_MHOCCUR_label																									
																,
																
														
														DIABETIC_NEPHROPATHY_MHOCCUR
																												
																	,DIABETIC_NEPHROPATHY_MHOCCUR_label																									
																,
																
														
														SEVERE_HYPOGLYCEMIC_REACTION_MHOCCUR
																												
																	,SEVERE_HYPOGLYCEMIC_REACTION_MHOCCUR_label
										)
									values (
									
									
									'SS_TS10_103',
									
									'TS10_103_10', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1-1.1'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'1988-09-12'
															,'Y'													
															,'Yes'											
														
															,'1989-10-14'
															,'Y'													
															,'Yes'											
														
															,'1989-10-14'
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
																
									);
										
									insert into NCT01928420_All_Data.Diabetes_HistoryDIABETES (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														DIABETES_MHSTDAT																									
																,
																
														
														DIABETES_CMOCCUR
																												
																	,DIABETES_CMOCCUR_label																									
																,
																
														
														DIABETES_CMSTDAT																									
																,
																
														
														INSULIN_CMOCCUR
																												
																	,INSULIN_CMOCCUR_label																									
																,
																
														
														RETINOPATHY_MHOCCUR
																												
																	,RETINOPATHY_MHOCCUR_label																									
																,
																
														
														RETINOPATHY_MHSTDAT																									
																,
																
														
														SGOCCUR
																												
																	,SGOCCUR_label																									
																,
																
														
														AUTONOMIC_NEUROPATHY_MHOCCUR
																												
																	,AUTONOMIC_NEUROPATHY_MHOCCUR_label																									
																,
																
														
														OTHER_DIABETIC_NEUROPATHY_MHOCCUR
																												
																	,OTHER_DIABETIC_NEUROPATHY_MHOCCUR_label																									
																,
																
														
														DIABETIC_NEPHROPATHY_MHOCCUR
																												
																	,DIABETIC_NEPHROPATHY_MHOCCUR_label																									
																,
																
														
														SEVERE_HYPOGLYCEMIC_REACTION_MHOCCUR
																												
																	,SEVERE_HYPOGLYCEMIC_REACTION_MHOCCUR_label
										)
									values (
									
									
									'SS_TS1_103_',
									
									'TS1_103_01', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1-1.1'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'1988-09-12'
															,'Y'													
															,'Yes'											
														
															,'1992-10-10'
															,'N'													
															,'No'											
														
															,'Y'													
															,'Yes'											
														
															,'1992-10-10'
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
																
									);
										
									insert into NCT01928420_All_Data.Diabetes_HistoryDIABETES (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														DIABETES_MHSTDAT																									
																,
																
														
														DIABETES_CMOCCUR
																												
																	,DIABETES_CMOCCUR_label																									
																,
																
														
														DIABETES_CMSTDAT																									
																,
																
														
														INSULIN_CMOCCUR
																												
																	,INSULIN_CMOCCUR_label																									
																,
																
														
														RETINOPATHY_MHOCCUR
																												
																	,RETINOPATHY_MHOCCUR_label																									
																,
																
														
														RETINOPATHY_MHSTDAT																									
																,
																
														
														SGOCCUR
																												
																	,SGOCCUR_label																									
																,
																
														
														AUTONOMIC_NEUROPATHY_MHOCCUR
																												
																	,AUTONOMIC_NEUROPATHY_MHOCCUR_label																									
																,
																
														
														OTHER_DIABETIC_NEUROPATHY_MHOCCUR
																												
																	,OTHER_DIABETIC_NEUROPATHY_MHOCCUR_label																									
																,
																
														
														DIABETIC_NEPHROPATHY_MHOCCUR
																												
																	,DIABETIC_NEPHROPATHY_MHOCCUR_label																									
																,
																
														
														SEVERE_HYPOGLYCEMIC_REACTION_MHOCCUR
																												
																	,SEVERE_HYPOGLYCEMIC_REACTION_MHOCCUR_label
										)
									values (
									
									
									'SS_TS3_103_',
									
									'TS3_103_03', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1-1.1'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'1988-09-12'
															,'Y'													
															,'Yes'											
														
															,'1992-10-10'
															,'N'													
															,'No'											
														
															,'Y'													
															,'Yes'											
														
															,'1992-10-10'
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
																
									);
										
									insert into NCT01928420_All_Data.Diabetes_HistoryDIABETES (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														DIABETES_MHSTDAT																									
																,
																
														
														DIABETES_CMOCCUR
																												
																	,DIABETES_CMOCCUR_label																									
																,
																
														
														INSULIN_CMOCCUR
																												
																	,INSULIN_CMOCCUR_label																									
																,
																
														
														RETINOPATHY_MHOCCUR
																												
																	,RETINOPATHY_MHOCCUR_label																									
																,
																
														
														SGOCCUR
																												
																	,SGOCCUR_label																									
																,
																
														
														AUTONOMIC_NEUROPATHY_MHOCCUR
																												
																	,AUTONOMIC_NEUROPATHY_MHOCCUR_label																									
																,
																
														
														OTHER_DIABETIC_NEUROPATHY_MHOCCUR
																												
																	,OTHER_DIABETIC_NEUROPATHY_MHOCCUR_label																									
																,
																
														
														DIABETIC_NEPHROPATHY_MHOCCUR
																												
																	,DIABETIC_NEPHROPATHY_MHOCCUR_label																									
																,
																
														
														SEVERE_HYPOGLYCEMIC_REACTION_MHOCCUR
																												
																	,SEVERE_HYPOGLYCEMIC_REACTION_MHOCCUR_label
										)
									values (
									
									
									'SS_TS6_103_',
									
									'TS6_103_06', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1-1.1'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'1988-06-11'
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
																
									);
										
									insert into NCT01928420_All_Data.Diabetes_HistoryDIABETES (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														DIABETES_MHSTDAT																									
																,
																
														
														DIABETES_CMOCCUR
																												
																	,DIABETES_CMOCCUR_label																									
																,
																
														
														DIABETES_CMSTDAT																									
																,
																
														
														INSULIN_CMOCCUR
																												
																	,INSULIN_CMOCCUR_label																									
																,
																
														
														INSULIN_CMSTDAT																									
																,
																
														
														RETINOPATHY_MHOCCUR
																												
																	,RETINOPATHY_MHOCCUR_label																									
																,
																
														
														SGOCCUR
																												
																	,SGOCCUR_label																									
																,
																
														
														OTHER_DIABETIC_NEUROPATHY_MHOCCUR
																												
																	,OTHER_DIABETIC_NEUROPATHY_MHOCCUR_label																									
																,
																
														
														DIABETIC_NEPHROPATHY_MHOCCUR
																												
																	,DIABETIC_NEPHROPATHY_MHOCCUR_label																									
																,
																
														
														SEVERE_HYPOGLYCEMIC_REACTION_MHOCCUR
																												
																	,SEVERE_HYPOGLYCEMIC_REACTION_MHOCCUR_label
										)
									values (
									
									
									'SS_TS8_103_',
									
									'TS8_103_08', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1-1.1'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'1988-09-12'
															,'Y'													
															,'Yes'											
														
															,'1989-10-14'
															,'Y'													
															,'Yes'											
														
															,'1989-10-14'
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
																
									);
										
									insert into NCT01928420_All_Data.Diabetes_HistoryDIABETES (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														DIABETES_MHSTDAT																									
																,
																
														
														DIABETES_CMOCCUR
																												
																	,DIABETES_CMOCCUR_label																									
																,
																
														
														DIABETES_CMSTDAT																									
																,
																
														
														INSULIN_CMOCCUR
																												
																	,INSULIN_CMOCCUR_label																									
																,
																
														
														INSULIN_CMSTDAT																									
																,
																
														
														RETINOPATHY_MHOCCUR
																												
																	,RETINOPATHY_MHOCCUR_label																									
																,
																
														
														SGOCCUR
																												
																	,SGOCCUR_label																									
																,
																
														
														OTHER_DIABETIC_NEUROPATHY_MHOCCUR
																												
																	,OTHER_DIABETIC_NEUROPATHY_MHOCCUR_label																									
																,
																
														
														DIABETIC_NEPHROPATHY_MHOCCUR
																												
																	,DIABETIC_NEPHROPATHY_MHOCCUR_label																									
																,
																
														
														SEVERE_HYPOGLYCEMIC_REACTION_MHOCCUR
																												
																	,SEVERE_HYPOGLYCEMIC_REACTION_MHOCCUR_label
										)
									values (
									
									
									'SS_TS10_104',
									
									'TS10_104_10', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1-1.1'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'1988-09-12'
															,'Y'													
															,'Yes'											
														
															,'1989-10-14'
															,'Y'													
															,'Yes'											
														
															,'1989-10-14'
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
																
									);
										
									insert into NCT01928420_All_Data.Diabetes_HistoryDIABETES (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														DIABETES_MHSTDAT																									
																,
																
														
														DIABETES_CMOCCUR
																												
																	,DIABETES_CMOCCUR_label																									
																,
																
														
														DIABETES_CMSTDAT																									
																,
																
														
														INSULIN_CMOCCUR
																												
																	,INSULIN_CMOCCUR_label																									
																,
																
														
														RETINOPATHY_MHOCCUR
																												
																	,RETINOPATHY_MHOCCUR_label																									
																,
																
														
														RETINOPATHY_MHSTDAT																									
																,
																
														
														SGOCCUR
																												
																	,SGOCCUR_label																									
																,
																
														
														AUTONOMIC_NEUROPATHY_MHOCCUR
																												
																	,AUTONOMIC_NEUROPATHY_MHOCCUR_label																									
																,
																
														
														OTHER_DIABETIC_NEUROPATHY_MHOCCUR
																												
																	,OTHER_DIABETIC_NEUROPATHY_MHOCCUR_label																									
																,
																
														
														DIABETIC_NEPHROPATHY_MHOCCUR
																												
																	,DIABETIC_NEPHROPATHY_MHOCCUR_label																									
																,
																
														
														SEVERE_HYPOGLYCEMIC_REACTION_MHOCCUR
																												
																	,SEVERE_HYPOGLYCEMIC_REACTION_MHOCCUR_label
										)
									values (
									
									
									'SS_TS1_104_',
									
									'TS1_104_01', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1-1.1'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'1988-09-12'
															,'Y'													
															,'Yes'											
														
															,'1992-10-10'
															,'N'													
															,'No'											
														
															,'Y'													
															,'Yes'											
														
															,'1992-10-10'
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
																
									);
										
									insert into NCT01928420_All_Data.Diabetes_HistoryDIABETES (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														DIABETES_MHSTDAT																									
																,
																
														
														DIABETES_CMOCCUR
																												
																	,DIABETES_CMOCCUR_label																									
																,
																
														
														DIABETES_CMSTDAT																									
																,
																
														
														INSULIN_CMOCCUR
																												
																	,INSULIN_CMOCCUR_label																									
																,
																
														
														RETINOPATHY_MHOCCUR
																												
																	,RETINOPATHY_MHOCCUR_label																									
																,
																
														
														RETINOPATHY_MHSTDAT																									
																,
																
														
														SGOCCUR
																												
																	,SGOCCUR_label																									
																,
																
														
														AUTONOMIC_NEUROPATHY_MHOCCUR
																												
																	,AUTONOMIC_NEUROPATHY_MHOCCUR_label																									
																,
																
														
														OTHER_DIABETIC_NEUROPATHY_MHOCCUR
																												
																	,OTHER_DIABETIC_NEUROPATHY_MHOCCUR_label																									
																,
																
														
														DIABETIC_NEPHROPATHY_MHOCCUR
																												
																	,DIABETIC_NEPHROPATHY_MHOCCUR_label																									
																,
																
														
														SEVERE_HYPOGLYCEMIC_REACTION_MHOCCUR
																												
																	,SEVERE_HYPOGLYCEMIC_REACTION_MHOCCUR_label
										)
									values (
									
									
									'SS_TS3_104_',
									
									'TS3_104_03', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1-1.1'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'1988-09-12'
															,'Y'													
															,'Yes'											
														
															,'1992-10-10'
															,'N'													
															,'No'											
														
															,'Y'													
															,'Yes'											
														
															,'1992-10-10'
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
																
									);
										
									insert into NCT01928420_All_Data.Diabetes_HistoryDIABETES (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														DIABETES_MHSTDAT																									
																,
																
														
														DIABETES_CMOCCUR
																												
																	,DIABETES_CMOCCUR_label																									
																,
																
														
														INSULIN_CMOCCUR
																												
																	,INSULIN_CMOCCUR_label																									
																,
																
														
														RETINOPATHY_MHOCCUR
																												
																	,RETINOPATHY_MHOCCUR_label																									
																,
																
														
														SGOCCUR
																												
																	,SGOCCUR_label																									
																,
																
														
														AUTONOMIC_NEUROPATHY_MHOCCUR
																												
																	,AUTONOMIC_NEUROPATHY_MHOCCUR_label																									
																,
																
														
														OTHER_DIABETIC_NEUROPATHY_MHOCCUR
																												
																	,OTHER_DIABETIC_NEUROPATHY_MHOCCUR_label																									
																,
																
														
														DIABETIC_NEPHROPATHY_MHOCCUR
																												
																	,DIABETIC_NEPHROPATHY_MHOCCUR_label																									
																,
																
														
														SEVERE_HYPOGLYCEMIC_REACTION_MHOCCUR
																												
																	,SEVERE_HYPOGLYCEMIC_REACTION_MHOCCUR_label
										)
									values (
									
									
									'SS_TS6_104_',
									
									'TS6_104_06', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1-1.1'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'1988-06-11'
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
																
									);
										
									insert into NCT01928420_All_Data.Diabetes_HistoryDIABETES (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														DIABETES_MHSTDAT																									
																,
																
														
														DIABETES_CMOCCUR
																												
																	,DIABETES_CMOCCUR_label																									
																,
																
														
														DIABETES_CMSTDAT																									
																,
																
														
														INSULIN_CMOCCUR
																												
																	,INSULIN_CMOCCUR_label																									
																,
																
														
														INSULIN_CMSTDAT																									
																,
																
														
														RETINOPATHY_MHOCCUR
																												
																	,RETINOPATHY_MHOCCUR_label																									
																,
																
														
														SGOCCUR
																												
																	,SGOCCUR_label																									
																,
																
														
														OTHER_DIABETIC_NEUROPATHY_MHOCCUR
																												
																	,OTHER_DIABETIC_NEUROPATHY_MHOCCUR_label																									
																,
																
														
														DIABETIC_NEPHROPATHY_MHOCCUR
																												
																	,DIABETIC_NEPHROPATHY_MHOCCUR_label																									
																,
																
														
														SEVERE_HYPOGLYCEMIC_REACTION_MHOCCUR
																												
																	,SEVERE_HYPOGLYCEMIC_REACTION_MHOCCUR_label
										)
									values (
									
									
									'SS_TS8_104_',
									
									'TS8_104_08', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1-1.1'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'1988-09-12'
															,'Y'													
															,'Yes'											
														
															,'1989-10-14'
															,'Y'													
															,'Yes'											
														
															,'1989-10-14'
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
																
									);
										
									insert into NCT01928420_All_Data.Diabetes_HistoryDIABETES (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														DIABETES_MHSTDAT																									
																,
																
														
														DIABETES_CMOCCUR
																												
																	,DIABETES_CMOCCUR_label																									
																,
																
														
														DIABETES_CMSTDAT																									
																,
																
														
														INSULIN_CMOCCUR
																												
																	,INSULIN_CMOCCUR_label																									
																,
																
														
														INSULIN_CMSTDAT																									
																,
																
														
														RETINOPATHY_MHOCCUR
																												
																	,RETINOPATHY_MHOCCUR_label																									
																,
																
														
														SGOCCUR
																												
																	,SGOCCUR_label																									
																,
																
														
														OTHER_DIABETIC_NEUROPATHY_MHOCCUR
																												
																	,OTHER_DIABETIC_NEUROPATHY_MHOCCUR_label																									
																,
																
														
														DIABETIC_NEPHROPATHY_MHOCCUR
																												
																	,DIABETIC_NEPHROPATHY_MHOCCUR_label																									
																,
																
														
														SEVERE_HYPOGLYCEMIC_REACTION_MHOCCUR
																												
																	,SEVERE_HYPOGLYCEMIC_REACTION_MHOCCUR_label
										)
									values (
									
									
									'SS_TS13_105',
									
									'TS13_105_13', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1-1.1'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'1988-09-12'
															,'Y'													
															,'Yes'											
														
															,'1989-10-14'
															,'Y'													
															,'Yes'											
														
															,'1989-10-14'
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
																
									);
										
									insert into NCT01928420_All_Data.Diabetes_HistoryDIABETES (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														DIABETES_MHSTDAT																									
																,
																
														
														DIABETES_CMOCCUR
																												
																	,DIABETES_CMOCCUR_label																									
																,
																
														
														DIABETES_CMSTDAT																									
																,
																
														
														INSULIN_CMOCCUR
																												
																	,INSULIN_CMOCCUR_label																									
																,
																
														
														RETINOPATHY_MHOCCUR
																												
																	,RETINOPATHY_MHOCCUR_label																									
																,
																
														
														RETINOPATHY_MHSTDAT																									
																,
																
														
														SGOCCUR
																												
																	,SGOCCUR_label																									
																,
																
														
														AUTONOMIC_NEUROPATHY_MHOCCUR
																												
																	,AUTONOMIC_NEUROPATHY_MHOCCUR_label																									
																,
																
														
														OTHER_DIABETIC_NEUROPATHY_MHOCCUR
																												
																	,OTHER_DIABETIC_NEUROPATHY_MHOCCUR_label																									
																,
																
														
														DIABETIC_NEPHROPATHY_MHOCCUR
																												
																	,DIABETIC_NEPHROPATHY_MHOCCUR_label																									
																,
																
														
														SEVERE_HYPOGLYCEMIC_REACTION_MHOCCUR
																												
																	,SEVERE_HYPOGLYCEMIC_REACTION_MHOCCUR_label
										)
									values (
									
									
									'SS_TS2_105_',
									
									'TS2_105_02', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1-1.1'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'1988-09-12'
															,'Y'													
															,'Yes'											
														
															,'1992-10-10'
															,'N'													
															,'No'											
														
															,'Y'													
															,'Yes'											
														
															,'1992-10-10'
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
																
									);
										
									insert into NCT01928420_All_Data.Diabetes_HistoryDIABETES (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														DIABETES_MHSTDAT																									
																,
																
														
														DIABETES_CMOCCUR
																												
																	,DIABETES_CMOCCUR_label																									
																,
																
														
														INSULIN_CMOCCUR
																												
																	,INSULIN_CMOCCUR_label																									
																,
																
														
														RETINOPATHY_MHOCCUR
																												
																	,RETINOPATHY_MHOCCUR_label																									
																,
																
														
														SGOCCUR
																												
																	,SGOCCUR_label																									
																,
																
														
														AUTONOMIC_NEUROPATHY_MHOCCUR
																												
																	,AUTONOMIC_NEUROPATHY_MHOCCUR_label																									
																,
																
														
														OTHER_DIABETIC_NEUROPATHY_MHOCCUR
																												
																	,OTHER_DIABETIC_NEUROPATHY_MHOCCUR_label																									
																,
																
														
														DIABETIC_NEPHROPATHY_MHOCCUR
																												
																	,DIABETIC_NEPHROPATHY_MHOCCUR_label																									
																,
																
														
														SEVERE_HYPOGLYCEMIC_REACTION_MHOCCUR
																												
																	,SEVERE_HYPOGLYCEMIC_REACTION_MHOCCUR_label
										)
									values (
									
									
									'SS_TS5_105_',
									
									'TS5_105_05', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1-1.1'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2000-06-10'
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
																
									);
										
									insert into NCT01928420_All_Data.Diabetes_HistoryDIABETES (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														DIABETES_MHSTDAT																									
																,
																
														
														DIABETES_CMOCCUR
																												
																	,DIABETES_CMOCCUR_label																									
																,
																
														
														INSULIN_CMOCCUR
																												
																	,INSULIN_CMOCCUR_label																									
																,
																
														
														RETINOPATHY_MHOCCUR
																												
																	,RETINOPATHY_MHOCCUR_label																									
																,
																
														
														SGOCCUR
																												
																	,SGOCCUR_label																									
																,
																
														
														AUTONOMIC_NEUROPATHY_MHOCCUR
																												
																	,AUTONOMIC_NEUROPATHY_MHOCCUR_label																									
																,
																
														
														OTHER_DIABETIC_NEUROPATHY_MHOCCUR
																												
																	,OTHER_DIABETIC_NEUROPATHY_MHOCCUR_label																									
																,
																
														
														DIABETIC_NEPHROPATHY_MHOCCUR
																												
																	,DIABETIC_NEPHROPATHY_MHOCCUR_label																									
																,
																
														
														SEVERE_HYPOGLYCEMIC_REACTION_MHOCCUR
																												
																	,SEVERE_HYPOGLYCEMIC_REACTION_MHOCCUR_label
										)
									values (
									
									
									'SS_TS6_105_',
									
									'TS6_105_06', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1-1.1'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'1988-06-11'
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
																
									);
										
									insert into NCT01928420_All_Data.Diabetes_HistoryDIABETES (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														DIABETES_MHSTDAT																									
																,
																
														
														DIABETES_CMOCCUR
																												
																	,DIABETES_CMOCCUR_label																									
																,
																
														
														DIABETES_CMSTDAT																									
																,
																
														
														INSULIN_CMOCCUR
																												
																	,INSULIN_CMOCCUR_label																									
																,
																
														
														RETINOPATHY_MHOCCUR
																												
																	,RETINOPATHY_MHOCCUR_label																									
																,
																
														
														RETINOPATHY_MHSTDAT																									
																,
																
														
														SGOCCUR
																												
																	,SGOCCUR_label																									
																,
																
														
														AUTONOMIC_NEUROPATHY_MHOCCUR
																												
																	,AUTONOMIC_NEUROPATHY_MHOCCUR_label																									
																,
																
														
														OTHER_DIABETIC_NEUROPATHY_MHOCCUR
																												
																	,OTHER_DIABETIC_NEUROPATHY_MHOCCUR_label																									
																,
																
														
														DIABETIC_NEPHROPATHY_MHOCCUR
																												
																	,DIABETIC_NEPHROPATHY_MHOCCUR_label																									
																,
																
														
														SEVERE_HYPOGLYCEMIC_REACTION_MHOCCUR
																												
																	,SEVERE_HYPOGLYCEMIC_REACTION_MHOCCUR_label
										)
									values (
									
									
									'SS_TS7_105_',
									
									'TS7_105_07', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1-1.1'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'1988-09-12'
															,'Y'													
															,'Yes'											
														
															,'1992-10-10'
															,'N'													
															,'No'											
														
															,'Y'													
															,'Yes'											
														
															,'1992-10-10'
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
																
									);
										
									insert into NCT01928420_All_Data.Diabetes_HistoryDIABETES (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														DIABETES_MHSTDAT																									
																,
																
														
														DIABETES_CMOCCUR
																												
																	,DIABETES_CMOCCUR_label																									
																,
																
														
														DIABETES_CMSTDAT																									
																,
																
														
														INSULIN_CMOCCUR
																												
																	,INSULIN_CMOCCUR_label																									
																,
																
														
														INSULIN_CMSTDAT																									
																,
																
														
														RETINOPATHY_MHOCCUR
																												
																	,RETINOPATHY_MHOCCUR_label																									
																,
																
														
														SGOCCUR
																												
																	,SGOCCUR_label																									
																,
																
														
														OTHER_DIABETIC_NEUROPATHY_MHOCCUR
																												
																	,OTHER_DIABETIC_NEUROPATHY_MHOCCUR_label																									
																,
																
														
														DIABETIC_NEPHROPATHY_MHOCCUR
																												
																	,DIABETIC_NEPHROPATHY_MHOCCUR_label																									
																,
																
														
														SEVERE_HYPOGLYCEMIC_REACTION_MHOCCUR
																												
																	,SEVERE_HYPOGLYCEMIC_REACTION_MHOCCUR_label
										)
									values (
									
									
									'SS_TS9_105_',
									
									'TS9_105_09', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1-1.1'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'1988-09-12'
															,'Y'													
															,'Yes'											
														
															,'1989-10-14'
															,'Y'													
															,'Yes'											
														
															,'1989-10-14'
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
														
															,'N'													
															,'No'											
																
									);
								
			  
			
					insert into NCT01928420_All_Data.crf_version (crf_name, crf_version_name, warehouse_insert_created_timestamp) values 
					( 'Local Laboratory Results', 
					'V2.0',
					'2015-03-19T16:41:35.717Z');
			
			
			
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS10_101',
									
					'TS10_101_10',
					
				'SE_1WEEKFU',
				
				'Local Laboratory Results',
				'V2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS10_101',
									
					'TS10_101_10',
					
				'SE_2WEEKFU',
				
				'Local Laboratory Results',
				'V2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS10_101',
									
					'TS10_101_10',
					
				'SE_MONTHLYFU',
				1,
				
				'Local Laboratory Results',
				'V2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS10_101',
									
					'TS10_101_10',
					
				'SE_MONTHLYFU',
				2,
				
				'Local Laboratory Results',
				'V2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS3_101_',
									
					'TS3_101_03',
					
				'SE_1WEEKFU',
				
				'Local Laboratory Results',
				'V2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS10_102',
									
					'TS10_102_10',
					
				'SE_1WEEKFU',
				
				'Local Laboratory Results',
				'V2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS10_102',
									
					'TS10_102_10',
					
				'SE_2WEEKFU',
				
				'Local Laboratory Results',
				'V2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS10_102',
									
					'TS10_102_10',
					
				'SE_MONTHLYFU',
				1,
				
				'Local Laboratory Results',
				'V2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS10_102',
									
					'TS10_102_10',
					
				'SE_MONTHLYFU',
				2,
				
				'Local Laboratory Results',
				'V2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS1_102_',
									
					'TS1_102_01',
					
				'SE_1WEEKFU',
				
				'Local Laboratory Results',
				'V2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS3_102_',
									
					'TS3_102_03',
					
				'SE_1WEEKFU',
				
				'Local Laboratory Results',
				'V2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS6_102_',
									
					'TS6_102_06',
					
				'SE_1WEEKFU',
				
				'Local Laboratory Results',
				'V2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS8_102_',
									
					'TS8_102_08',
					
				'SE_1WEEKFU',
				
				'Local Laboratory Results',
				'V2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS8_102_',
									
					'TS8_102_08',
					
				'SE_2WEEKFU',
				
				'Local Laboratory Results',
				'V2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS8_102_',
									
					'TS8_102_08',
					
				'SE_MONTHLYFU',
				1,
				
				'Local Laboratory Results',
				'V2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS8_102_',
									
					'TS8_102_08',
					
				'SE_MONTHLYFU',
				2,
				
				'Local Laboratory Results',
				'V2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS10_103',
									
					'TS10_103_10',
					
				'SE_1WEEKFU',
				
				'Local Laboratory Results',
				'V2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS10_103',
									
					'TS10_103_10',
					
				'SE_2WEEKFU',
				
				'Local Laboratory Results',
				'V2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS10_103',
									
					'TS10_103_10',
					
				'SE_MONTHLYFU',
				1,
				
				'Local Laboratory Results',
				'V2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS10_103',
									
					'TS10_103_10',
					
				'SE_MONTHLYFU',
				2,
				
				'Local Laboratory Results',
				'V2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS1_103_',
									
					'TS1_103_01',
					
				'SE_1WEEKFU',
				
				'Local Laboratory Results',
				'V2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS3_103_',
									
					'TS3_103_03',
					
				'SE_1WEEKFU',
				
				'Local Laboratory Results',
				'V2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS8_103_',
									
					'TS8_103_08',
					
				'SE_1WEEKFU',
				
				'Local Laboratory Results',
				'V2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS8_103_',
									
					'TS8_103_08',
					
				'SE_2WEEKFU',
				
				'Local Laboratory Results',
				'V2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS8_103_',
									
					'TS8_103_08',
					
				'SE_MONTHLYFU',
				1,
				
				'Local Laboratory Results',
				'V2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS8_103_',
									
					'TS8_103_08',
					
				'SE_MONTHLYFU',
				2,
				
				'Local Laboratory Results',
				'V2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS10_104',
									
					'TS10_104_10',
					
				'SE_1WEEKFU',
				
				'Local Laboratory Results',
				'V2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS10_104',
									
					'TS10_104_10',
					
				'SE_2WEEKFU',
				
				'Local Laboratory Results',
				'V2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS10_104',
									
					'TS10_104_10',
					
				'SE_MONTHLYFU',
				1,
				
				'Local Laboratory Results',
				'V2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS10_104',
									
					'TS10_104_10',
					
				'SE_MONTHLYFU',
				2,
				
				'Local Laboratory Results',
				'V2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS1_104_',
									
					'TS1_104_01',
					
				'SE_1WEEKFU',
				
				'Local Laboratory Results',
				'V2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS3_104_',
									
					'TS3_104_03',
					
				'SE_1WEEKFU',
				
				'Local Laboratory Results',
				'V2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS8_104_',
									
					'TS8_104_08',
					
				'SE_1WEEKFU',
				
				'Local Laboratory Results',
				'V2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS8_104_',
									
					'TS8_104_08',
					
				'SE_2WEEKFU',
				
				'Local Laboratory Results',
				'V2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS8_104_',
									
					'TS8_104_08',
					
				'SE_MONTHLYFU',
				1,
				
				'Local Laboratory Results',
				'V2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS8_104_',
									
					'TS8_104_08',
					
				'SE_MONTHLYFU',
				2,
				
				'Local Laboratory Results',
				'V2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS13_105',
									
					'TS13_105_13',
					
				'SE_1WEEKFU',
				
				'Local Laboratory Results',
				'V2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS13_105',
									
					'TS13_105_13',
					
				'SE_2WEEKFU',
				
				'Local Laboratory Results',
				'V2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS13_105',
									
					'TS13_105_13',
					
				'SE_MONTHLYFU',
				1,
				
				'Local Laboratory Results',
				'V2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS13_105',
									
					'TS13_105_13',
					
				'SE_MONTHLYFU',
				2,
				
				'Local Laboratory Results',
				'V2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS2_105_',
									
					'TS2_105_02',
					
				'SE_1WEEKFU',
				
				'Local Laboratory Results',
				'V2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS7_105_',
									
					'TS7_105_07',
					
				'SE_1WEEKFU',
				
				'Local Laboratory Results',
				'V2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS9_105_',
									
					'TS9_105_09',
					
				'SE_1WEEKFU',
				
				'Local Laboratory Results',
				'V2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS9_105_',
									
					'TS9_105_09',
					
				'SE_2WEEKFU',
				
				'Local Laboratory Results',
				'V2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS9_105_',
									
					'TS9_105_09',
					
				'SE_MONTHLYFU',
				1,
				
				'Local Laboratory Results',
				'V2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS9_105_',
									
					'TS9_105_09',
					
				'SE_MONTHLYFU',
				2,
				
				'Local Laboratory Results',
				'V2.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
				create table NCT01928420_All_Data.Local_Laboratory_ResultsTests (
				item_data_id serial NOT NULL,
				ssoid character varying(40) NOT NULL,
				ssid character varying(40) NOT NULL,
				study_event_oid character varying(40) NOT NULL,
				event_ordinal integer default 1,
				crf_version character varying(255),
				event_start_date timestamp without time zone,
				event_end_date timestamp without time zone,
				event_status character varying(255),
				event_location character varying(2000),
				subject_age_at_event integer,
				crf_status character varying(255), 
				interviewerName character varying(255),
				interviewDate date,
				warehouse_insert_created_timestamp timestamp with time zone); 			          	 
				
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Local_Laboratory_ResultsTests', 'HEM_DT', 'date');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Local_Laboratory_ResultsTests', 'HEM_HEM', 'float');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Local_Laboratory_ResultsTests', 'HEM_RBC', 'float');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Local_Laboratory_ResultsTests', 'HEM_WBC', 'float');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Local_Laboratory_ResultsTests', 'HEM_RHE', 'float');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Local_Laboratory_ResultsTests', 'CH_DT', 'date');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Local_Laboratory_ResultsTests', 'CH_POT', 'float');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Local_Laboratory_ResultsTests', 'CH_CAL', 'float');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Local_Laboratory_ResultsTests', 'CH_ALB', 'float');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Local_Laboratory_ResultsTests', 'UR_DT', 'date');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Local_Laboratory_ResultsTests', 'UR_PRO', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Local_Laboratory_ResultsTests', 'UR_PRO_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Local_Laboratory_ResultsTests', 'UR_LEUK', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Local_Laboratory_ResultsTests', 'UR_LEUK_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Local_Laboratory_ResultsTests', 'UR_NITR', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Local_Laboratory_ResultsTests', 'UR_NITR_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Local_Laboratory_ResultsTests', 'SITE_AB', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Local_Laboratory_ResultsTests', 'SITE_DEC', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Local_Laboratory_ResultsTests', 'HEM_UNITS', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Local_Laboratory_ResultsTests', 'RBC_UNITS', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Local_Laboratory_ResultsTests', 'WBC_UNITS', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Local_Laboratory_ResultsTests', 'RHE_UNITS', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Local_Laboratory_ResultsTests', 'POT_UNITS', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Local_Laboratory_ResultsTests', 'CAL_UNITS', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Local_Laboratory_ResultsTests', 'ALB_UNITS', 'text');

	
				
		ALTER TABLE NCT01928420_All_Data.Local_Laboratory_ResultsTests ADD CONSTRAINT Pk_TESTS PRIMARY KEY (item_data_id);

		
				
		ALTER TABLE NCT01928420_All_Data.Local_Laboratory_ResultsTests ADD CONSTRAINT 	
		Fk_study_subject_id_TESTS FOREIGN KEY (ssoid, 
		ssid) REFERENCES NCT01928420_All_Data.study_subject_listing;
		
				
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label
										)
									values (
									
									
									'SS_TS10_101',
									
									'TS10_101_10', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,13.9
															,5.2
															,4.1
															,4.2
															,'2014-06-10'
															,4
															,9.7
															,3.5
															,'2014-06-10'
															,2													
															,'2+'											
														
															,1													
															,'Positive'											
														
															,0													
															,'Negative'											
																
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label
										)
									values (
									
									
									'SS_TS10_101',
									
									'TS10_101_10', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,14
															,4
															,4
															,4
															,'2014-06-10'
															,4.2
															,9.8
															,3.5
															,'2014-06-10'
															,4													
															,'4+'											
														
															,1													
															,'Positive'											
														
															,0													
															,'Negative'											
																
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label
										)
									values (
									
									
									'SS_TS10_101',
									
									'TS10_101_10', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,1
									 
									,'V2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-11'
															,14
															,4
															,4
															,4
															,'2014-06-11'
															,4
															,9
															,3.5
															,'2014-06-11'
															,0													
															,'Negative'											
														
															,1													
															,'Positive'											
														
															,0													
															,'Negative'											
																
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label
										)
									values (
									
									
									'SS_TS10_101',
									
									'TS10_101_10', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,2
									 
									,'V2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-11'
															,14
															,4
															,4
															,4
															,'2014-06-11'
															,4
															,9
															,3.5
															,'2014-06-11'
															,9													
															,'Trace'											
														
															,0													
															,'Negative'											
														
															,0													
															,'Negative'											
																
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label
										)
									values (
									
									
									'SS_TS3_101_',
									
									'TS3_101_03', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-17'
															,14
															,4
															,4
															,4
															,'2014-06-17'
															,4.4
															,9.8
															,3.5
															,'2014-06-17'
															,2													
															,'2+'											
														
															,0													
															,'Negative'											
														
															,0													
															,'Negative'											
																
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label
										)
									values (
									
									
									'SS_TS10_102',
									
									'TS10_102_10', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,13.9
															,5.2
															,4.1
															,4.2
															,'2014-06-10'
															,4
															,9.7
															,3.5
															,'2014-06-10'
															,2													
															,'2+'											
														
															,1													
															,'Positive'											
														
															,0													
															,'Negative'											
																
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label
										)
									values (
									
									
									'SS_TS10_102',
									
									'TS10_102_10', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,130
															,4
															,3600
															,4
															,'2014-06-10'
															,4.2
															,2.3
															,6.6
															,'2014-06-10'
															,4													
															,'4+'											
														
															,1													
															,'Positive'											
														
															,0													
															,'Negative'											
																
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label
										)
									values (
									
									
									'SS_TS10_102',
									
									'TS10_102_10', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,1
									 
									,'V2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-11'
															,130
															,4
															,9000
															,4
															,'2014-06-11'
															,4
															,2.2
															,3.5
															,'2014-06-11'
															,0													
															,'Negative'											
														
															,1													
															,'Positive'											
														
															,0													
															,'Negative'											
																
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label
										)
									values (
									
									
									'SS_TS10_102',
									
									'TS10_102_10', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,2
									 
									,'V2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-11'
															,130
															,4
															,8000
															,4
															,'2014-06-11'
															,4
															,2.2
															,3.5
															,'2014-06-11'
															,9													
															,'Trace'											
														
															,0													
															,'Negative'											
														
															,0													
															,'Negative'											
																
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label
										)
									values (
									
									
									'SS_TS1_102_',
									
									'TS1_102_01', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-17'
															,14
															,4
															,4
															,4
															,'2014-06-17'
															,4.4
															,9.8
															,3.5
															,'2014-06-17'
															,2													
															,'2+'											
														
															,0													
															,'Negative'											
														
															,0													
															,'Negative'											
																
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label
										)
									values (
									
									
									'SS_TS3_102_',
									
									'TS3_102_03', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-17'
															,14
															,4
															,4
															,4
															,'2014-06-17'
															,4.4
															,9.8
															,3.5
															,'2014-06-17'
															,2													
															,'2+'											
														
															,0													
															,'Negative'											
														
															,0													
															,'Negative'											
																
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE
										)
									values (
									
									
									'SS_TS6_102_',
									
									'TS6_102_06', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,11
															,4
															,4
															,4		
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label
										)
									values (
									
									
									'SS_TS8_102_',
									
									'TS8_102_08', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,13.9
															,5.2
															,4.1
															,4.2
															,'2014-06-10'
															,4
															,9.7
															,3.5
															,'2014-06-10'
															,2													
															,'2+'											
														
															,1													
															,'Positive'											
														
															,0													
															,'Negative'											
																
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label
										)
									values (
									
									
									'SS_TS8_102_',
									
									'TS8_102_08', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,14
															,4
															,4
															,4
															,'2014-06-10'
															,4.2
															,9.8
															,3.5
															,'2014-06-10'
															,4													
															,'4+'											
														
															,1													
															,'Positive'											
														
															,0													
															,'Negative'											
																
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label
										)
									values (
									
									
									'SS_TS8_102_',
									
									'TS8_102_08', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,1
									 
									,'V2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-11'
															,14
															,4
															,4
															,4
															,'2014-06-11'
															,4
															,9
															,3.5
															,'2014-06-11'
															,0													
															,'Negative'											
														
															,1													
															,'Positive'											
														
															,0													
															,'Negative'											
																
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label
										)
									values (
									
									
									'SS_TS8_102_',
									
									'TS8_102_08', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,2
									 
									,'V2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-11'
															,14
															,4
															,4
															,4
															,'2014-06-11'
															,4
															,9
															,3.5
															,'2014-06-11'
															,9													
															,'Trace'											
														
															,0													
															,'Negative'											
														
															,0													
															,'Negative'											
																
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label
										)
									values (
									
									
									'SS_TS10_103',
									
									'TS10_103_10', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,13.9
															,5.2
															,4.1
															,4.2
															,'2014-06-10'
															,4
															,9.7
															,3.5
															,'2014-06-10'
															,2													
															,'2+'											
														
															,1													
															,'Positive'											
														
															,0													
															,'Negative'											
																
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label
										)
									values (
									
									
									'SS_TS10_103',
									
									'TS10_103_10', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,14
															,4
															,4
															,4
															,'2014-06-10'
															,4.2
															,9.8
															,3.5
															,'2014-06-10'
															,4													
															,'4+'											
														
															,1													
															,'Positive'											
														
															,0													
															,'Negative'											
																
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label
										)
									values (
									
									
									'SS_TS10_103',
									
									'TS10_103_10', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,1
									 
									,'V2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-11'
															,14
															,4
															,4
															,4
															,'2014-06-11'
															,4
															,9
															,3.5
															,'2014-06-11'
															,0													
															,'Negative'											
														
															,1													
															,'Positive'											
														
															,0													
															,'Negative'											
																
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label
										)
									values (
									
									
									'SS_TS10_103',
									
									'TS10_103_10', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,2
									 
									,'V2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-11'
															,14
															,4
															,4
															,4
															,'2014-06-11'
															,4
															,9
															,3.5
															,'2014-06-11'
															,9													
															,'Trace'											
														
															,0													
															,'Negative'											
														
															,0													
															,'Negative'											
																
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label
										)
									values (
									
									
									'SS_TS1_103_',
									
									'TS1_103_01', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-17'
															,14
															,4
															,4
															,4
															,'2014-06-17'
															,4.4
															,9.8
															,3.5
															,'2014-06-17'
															,2													
															,'2+'											
														
															,0													
															,'Negative'											
														
															,0													
															,'Negative'											
																
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label
										)
									values (
									
									
									'SS_TS3_103_',
									
									'TS3_103_03', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-17'
															,14
															,4
															,4
															,4
															,'2014-06-17'
															,4.4
															,9.8
															,3.5
															,'2014-06-17'
															,2													
															,'2+'											
														
															,0													
															,'Negative'											
														
															,0													
															,'Negative'											
																
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label
										)
									values (
									
									
									'SS_TS8_103_',
									
									'TS8_103_08', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,13.9
															,5.2
															,4.1
															,4.2
															,'2014-06-10'
															,4
															,9.7
															,3.5
															,'2014-06-10'
															,2													
															,'2+'											
														
															,1													
															,'Positive'											
														
															,0													
															,'Negative'											
																
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label
										)
									values (
									
									
									'SS_TS8_103_',
									
									'TS8_103_08', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,14
															,4
															,4
															,4
															,'2014-06-10'
															,4.2
															,9.8
															,3.5
															,'2014-06-10'
															,4													
															,'4+'											
														
															,1													
															,'Positive'											
														
															,0													
															,'Negative'											
																
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label
										)
									values (
									
									
									'SS_TS8_103_',
									
									'TS8_103_08', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,1
									 
									,'V2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-11'
															,14
															,4
															,4
															,4
															,'2014-06-11'
															,4
															,9
															,3.5
															,'2014-06-11'
															,0													
															,'Negative'											
														
															,1													
															,'Positive'											
														
															,0													
															,'Negative'											
																
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label
										)
									values (
									
									
									'SS_TS8_103_',
									
									'TS8_103_08', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,2
									 
									,'V2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-11'
															,14
															,4
															,4
															,4
															,'2014-06-11'
															,4
															,9
															,3.5
															,'2014-06-11'
															,9													
															,'Trace'											
														
															,0													
															,'Negative'											
														
															,0													
															,'Negative'											
																
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label
										)
									values (
									
									
									'SS_TS10_104',
									
									'TS10_104_10', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,13.9
															,5.2
															,4.1
															,4.2
															,'2014-06-10'
															,4
															,9.7
															,3.5
															,'2014-06-10'
															,2													
															,'2+'											
														
															,1													
															,'Positive'											
														
															,0													
															,'Negative'											
																
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label
										)
									values (
									
									
									'SS_TS10_104',
									
									'TS10_104_10', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,14
															,4
															,4
															,4
															,'2014-06-10'
															,4.2
															,9.8
															,3.5
															,'2014-06-10'
															,4													
															,'4+'											
														
															,1													
															,'Positive'											
														
															,0													
															,'Negative'											
																
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label
										)
									values (
									
									
									'SS_TS10_104',
									
									'TS10_104_10', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,1
									 
									,'V2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-11'
															,14
															,4
															,4
															,4
															,'2014-06-11'
															,4
															,9
															,3.5
															,'2014-06-11'
															,0													
															,'Negative'											
														
															,1													
															,'Positive'											
														
															,0													
															,'Negative'											
																
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label
										)
									values (
									
									
									'SS_TS10_104',
									
									'TS10_104_10', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,2
									 
									,'V2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-11'
															,14
															,4
															,4
															,4
															,'2014-06-11'
															,4
															,9
															,3.5
															,'2014-06-11'
															,9													
															,'Trace'											
														
															,0													
															,'Negative'											
														
															,0													
															,'Negative'											
																
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label
										)
									values (
									
									
									'SS_TS1_104_',
									
									'TS1_104_01', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-17'
															,14
															,4
															,4
															,4
															,'2014-06-17'
															,4.4
															,9.8
															,3.5
															,'2014-06-17'
															,2													
															,'2+'											
														
															,0													
															,'Negative'											
														
															,0													
															,'Negative'											
																
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label
										)
									values (
									
									
									'SS_TS3_104_',
									
									'TS3_104_03', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-17'
															,14
															,4
															,4
															,4
															,'2014-06-17'
															,4.4
															,9.8
															,3.5
															,'2014-06-17'
															,2													
															,'2+'											
														
															,0													
															,'Negative'											
														
															,0													
															,'Negative'											
																
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label
										)
									values (
									
									
									'SS_TS8_104_',
									
									'TS8_104_08', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,13.9
															,5.2
															,4.1
															,4.2
															,'2014-06-10'
															,4
															,9.7
															,3.5
															,'2014-06-10'
															,2													
															,'2+'											
														
															,1													
															,'Positive'											
														
															,0													
															,'Negative'											
																
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label
										)
									values (
									
									
									'SS_TS8_104_',
									
									'TS8_104_08', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,14
															,4
															,4
															,4
															,'2014-06-10'
															,4.2
															,9.8
															,3.5
															,'2014-06-10'
															,4													
															,'4+'											
														
															,1													
															,'Positive'											
														
															,0													
															,'Negative'											
																
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label
										)
									values (
									
									
									'SS_TS8_104_',
									
									'TS8_104_08', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,1
									 
									,'V2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-11'
															,14
															,4
															,4
															,4
															,'2014-06-11'
															,4
															,9
															,3.5
															,'2014-06-11'
															,0													
															,'Negative'											
														
															,1													
															,'Positive'											
														
															,0													
															,'Negative'											
																
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label
										)
									values (
									
									
									'SS_TS8_104_',
									
									'TS8_104_08', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,2
									 
									,'V2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-11'
															,14
															,4
															,4
															,4
															,'2014-06-11'
															,4
															,9
															,3.5
															,'2014-06-11'
															,9													
															,'Trace'											
														
															,0													
															,'Negative'											
														
															,0													
															,'Negative'											
																
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label
										)
									values (
									
									
									'SS_TS13_105',
									
									'TS13_105_13', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-17'
															,13
															,5
															,6
															,10
															,'2014-06-17'
															,4.4
															,9.2
															,5.2
															,'2014-06-17'
															,0													
															,'Negative'											
														
															,0													
															,'Negative'											
														
															,0													
															,'Negative'											
																
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label
										)
									values (
									
									
									'SS_TS13_105',
									
									'TS13_105_13', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-24'
															,12.9
															,4.9
															,6.7
															,20
															,'2014-06-24'
															,4.4
															,8.9
															,3.8
															,'2014-06-24'
															,2													
															,'2+'											
														
															,0													
															,'Negative'											
														
															,1													
															,'Positive'											
																
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label
										)
									values (
									
									
									'SS_TS13_105',
									
									'TS13_105_13', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,1
									 
									,'V2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-07-01'
															,13.3
															,5.3
															,8.7
															,5.3
															,'2014-07-01'
															,4.4
															,9.9
															,3.7
															,'2014-07-01'
															,0													
															,'Negative'											
														
															,1													
															,'Positive'											
														
															,1													
															,'Positive'											
																
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label
										)
									values (
									
									
									'SS_TS13_105',
									
									'TS13_105_13', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,2
									 
									,'V2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-08-01'
															,13
															,5
															,6
															,33
															,'2014-08-01'
															,5
															,10
															,5.4
															,'2014-08-01'
															,3													
															,'3+'											
														
															,1													
															,'Positive'											
														
															,1													
															,'Positive'											
																
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label
										)
									values (
									
									
									'SS_TS2_105_',
									
									'TS2_105_02', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-17'
															,12
															,4
															,5
															,15
															,'2014-06-17'
															,3.6
															,8.9
															,3.6
															,'2014-06-17'
															,2													
															,'2+'											
														
															,0													
															,'Negative'											
														
															,1													
															,'Positive'											
																
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label
										)
									values (
									
									
									'SS_TS7_105_',
									
									'TS7_105_07', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-17'
															,13
															,5.3
															,7
															,2
															,'2014-06-17'
															,4.2
															,9
															,5
															,'2014-06-17'
															,9													
															,'Trace'											
														
															,1													
															,'Positive'											
														
															,1													
															,'Positive'											
																
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label
										)
									values (
									
									
									'SS_TS9_105_',
									
									'TS9_105_09', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-17'
															,14.2
															,5
															,7
															,4.2
															,'2014-06-17'
															,5
															,9.8
															,4
															,'2014-06-17'
															,0													
															,'Negative'											
														
															,0													
															,'Negative'											
														
															,0													
															,'Negative'											
																
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label
										)
									values (
									
									
									'SS_TS9_105_',
									
									'TS9_105_09', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-24'
															,14
															,6
															,5.2
															,4
															,'2014-06-24'
															,4.4
															,10.1
															,4
															,'2014-06-24'
															,9													
															,'Trace'											
														
															,1													
															,'Positive'											
														
															,0													
															,'Negative'											
																
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label
										)
									values (
									
									
									'SS_TS9_105_',
									
									'TS9_105_09', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,1
									 
									,'V2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-07-01'
															,14
															,5.8
															,5.2
															,5.2
															,'2014-07-01'
															,4.4
															,8.9
															,5
															,'2014-07-01'
															,3													
															,'3+'											
														
															,1													
															,'Positive'											
														
															,1													
															,'Positive'											
																
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label
										)
									values (
									
									
									'SS_TS9_105_',
									
									'TS9_105_09', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,2
									 
									,'V2.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-08-01'
															,13
															,4
															,5
															,1
															,'2014-08-01'
															,4
															,8.5
															,4
															,'2014-08-01'
															,1													
															,'1+'											
														
															,0													
															,'Negative'											
														
															,1													
															,'Positive'											
																
									);
								
			  
			
					insert into NCT01928420_All_Data.crf_version (crf_name, crf_version_name, warehouse_insert_created_timestamp) values 
					( 'Local Laboratory Results', 
					'V1.0',
					'2015-03-19T16:41:35.717Z');
			
			
			
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(	
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(		
				'SS_TEST_01',
									
					'Test_01',
					
				'SE_FIRSTVISIT',
				
				'Local Laboratory Results',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(	
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(		
				'SS_TEST_BEN',
									
					'Test_Ben',
					
				'SE_FIRSTVISIT',
				
				'Local Laboratory Results',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS10_101',
									
					'TS10_101_10',
					
				'SE_FIRSTVISIT',
				
				'Local Laboratory Results',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS3_101_',
									
					'TS3_101_03',
					
				'SE_FIRSTVISIT',
				
				'Local Laboratory Results',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS6_101_',
									
					'TS6_101_06',
					
				'SE_FIRSTVISIT',
				
				'Local Laboratory Results',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS10_102',
									
					'TS10_102_10',
					
				'SE_FIRSTVISIT',
				
				'Local Laboratory Results',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS1_102_',
									
					'TS1_102_01',
					
				'SE_FIRSTVISIT',
				
				'Local Laboratory Results',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS3_102_',
									
					'TS3_102_03',
					
				'SE_FIRSTVISIT',
				
				'Local Laboratory Results',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS6_102_',
									
					'TS6_102_06',
					
				'SE_FIRSTVISIT',
				
				'Local Laboratory Results',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS8_102_',
									
					'TS8_102_08',
					
				'SE_FIRSTVISIT',
				
				'Local Laboratory Results',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS10_103',
									
					'TS10_103_10',
					
				'SE_FIRSTVISIT',
				
				'Local Laboratory Results',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS1_103_',
									
					'TS1_103_01',
					
				'SE_FIRSTVISIT',
				
				'Local Laboratory Results',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS3_103_',
									
					'TS3_103_03',
					
				'SE_FIRSTVISIT',
				
				'Local Laboratory Results',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS6_103_',
									
					'TS6_103_06',
					
				'SE_FIRSTVISIT',
				
				'Local Laboratory Results',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS8_103_',
									
					'TS8_103_08',
					
				'SE_FIRSTVISIT',
				
				'Local Laboratory Results',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS10_104',
									
					'TS10_104_10',
					
				'SE_FIRSTVISIT',
				
				'Local Laboratory Results',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS1_104_',
									
					'TS1_104_01',
					
				'SE_FIRSTVISIT',
				
				'Local Laboratory Results',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS11_104',
									
					'TS11_104_11',
					
				'SE_FIRSTVISIT',
				
				'Local Laboratory Results',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS3_104_',
									
					'TS3_104_03',
					
				'SE_FIRSTVISIT',
				
				'Local Laboratory Results',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS6_104_',
									
					'TS6_104_06',
					
				'SE_FIRSTVISIT',
				
				'Local Laboratory Results',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS8_104_',
									
					'TS8_104_08',
					
				'SE_FIRSTVISIT',
				
				'Local Laboratory Results',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS13_105',
									
					'TS13_105_13',
					
				'SE_FIRSTVISIT',
				
				'Local Laboratory Results',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS2_105_',
									
					'TS2_105_02',
					
				'SE_FIRSTVISIT',
				
				'Local Laboratory Results',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS5_105_',
									
					'TS5_105_05',
					
				'SE_FIRSTVISIT',
				
				'Local Laboratory Results',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS6_105_',
									
					'TS6_105_06',
					
				'SE_FIRSTVISIT',
				
				'Local Laboratory Results',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS9_105_',
									
					'TS9_105_09',
					
				'SE_FIRSTVISIT',
				
				'Local Laboratory Results',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Local_Laboratory_ResultsTests', 'HEM_DT', 'date');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Local_Laboratory_ResultsTests', 'HEM_HEM', 'float');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Local_Laboratory_ResultsTests', 'HEM_RBC', 'float');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Local_Laboratory_ResultsTests', 'HEM_WBC', 'float');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Local_Laboratory_ResultsTests', 'HEM_RHE', 'float');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Local_Laboratory_ResultsTests', 'CH_DT', 'date');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Local_Laboratory_ResultsTests', 'CH_POT', 'float');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Local_Laboratory_ResultsTests', 'CH_CAL', 'float');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Local_Laboratory_ResultsTests', 'CH_ALB', 'float');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Local_Laboratory_ResultsTests', 'UR_DT', 'date');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Local_Laboratory_ResultsTests', 'UR_PRO', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Local_Laboratory_ResultsTests', 'UR_PRO_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Local_Laboratory_ResultsTests', 'UR_LEUK', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Local_Laboratory_ResultsTests', 'UR_LEUK_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Local_Laboratory_ResultsTests', 'UR_NITR', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Local_Laboratory_ResultsTests', 'UR_NITR_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Local_Laboratory_ResultsTests', 'SITE_AB', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Local_Laboratory_ResultsTests', 'SITE_DEC', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Local_Laboratory_ResultsTests', 'HEM_UNITS', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Local_Laboratory_ResultsTests', 'RBC_UNITS', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Local_Laboratory_ResultsTests', 'WBC_UNITS', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Local_Laboratory_ResultsTests', 'RHE_UNITS', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Local_Laboratory_ResultsTests', 'POT_UNITS', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Local_Laboratory_ResultsTests', 'CAL_UNITS', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Local_Laboratory_ResultsTests', 'ALB_UNITS', 'text');

			
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														SITE_AB																									
																,
																
														
														SITE_DEC																									
																,
																
														
														HEM_UNITS																									
																,
																
														
														RBC_UNITS																									
																,
																
														
														WBC_UNITS																									
																,
																
														
														RHE_UNITS																									
																,
																
														
														POT_UNITS																									
																,
																
														
														CAL_UNITS																									
																,
																
														
														ALB_UNITS
										)
									values (
									
									
									'SS_TEST_01',
									
									'Test_01', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,102
															,'SiteB'
															,'gm/L'
															,'million cells/mcL'
															,'cells/mcL'
															,'IU/mL'
															,'mmol/L'
															,'mmol/L'
															,'umol/L'		
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														SITE_AB																									
																,
																
														
														SITE_DEC																									
																,
																
														
														HEM_UNITS																									
																,
																
														
														RBC_UNITS																									
																,
																
														
														WBC_UNITS																									
																,
																
														
														RHE_UNITS																									
																,
																
														
														POT_UNITS																									
																,
																
														
														CAL_UNITS																									
																,
																
														
														ALB_UNITS
										)
									values (
									
									
									'SS_TEST_BEN',
									
									'Test_Ben', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,102
															,'SiteB'
															,'gm/L'
															,'million cells/mcL'
															,'cells/mcL'
															,'IU/mL'
															,'mmol/L'
															,'mmol/L'
															,'umol/L'		
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label																									
																,
																
														
														SITE_AB																									
																,
																
														
														SITE_DEC																									
																,
																
														
														HEM_UNITS																									
																,
																
														
														RBC_UNITS																									
																,
																
														
														WBC_UNITS																									
																,
																
														
														RHE_UNITS																									
																,
																
														
														POT_UNITS																									
																,
																
														
														CAL_UNITS																									
																,
																
														
														ALB_UNITS
										)
									values (
									
									
									'SS_TS10_101',
									
									'TS10_101_10', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,14
															,4
															,4
															,4
															,'2014-06-10'
															,4.2
															,9.8
															,3.5
															,'2014-06-10'
															,9													
															,'Trace'											
														
															,1													
															,'Positive'											
														
															,0													
															,'Negative'											
														
															,101
															,'SiteA'
															,'gm/dL'
															,'trillion cells/L'
															,'billion cells/L'
															,'IU/mL'
															,'mEq/L'
															,'mg/dL'
															,'g/dL'		
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label																									
																,
																
														
														SITE_AB																									
																,
																
														
														SITE_DEC																									
																,
																
														
														HEM_UNITS																									
																,
																
														
														RBC_UNITS																									
																,
																
														
														WBC_UNITS																									
																,
																
														
														RHE_UNITS																									
																,
																
														
														POT_UNITS																									
																,
																
														
														CAL_UNITS																									
																,
																
														
														ALB_UNITS
										)
									values (
									
									
									'SS_TS3_101_',
									
									'TS3_101_03', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,14.2
															,4.6
															,5.2
															,5.2
															,'2014-06-10'
															,4.4
															,8.9
															,3.7
															,'2014-06-10'
															,1													
															,'1+'											
														
															,1													
															,'Positive'											
														
															,0													
															,'Negative'											
														
															,101
															,'SiteA'
															,'gm/dL'
															,'trillion cells/L'
															,'billion cells/L'
															,'IU/mL'
															,'mEq/L'
															,'mg/dL'
															,'g/dL'		
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label																									
																,
																
														
														SITE_AB																									
																,
																
														
														SITE_DEC																									
																,
																
														
														HEM_UNITS																									
																,
																
														
														RBC_UNITS																									
																,
																
														
														WBC_UNITS																									
																,
																
														
														RHE_UNITS																									
																,
																
														
														POT_UNITS																									
																,
																
														
														CAL_UNITS																									
																,
																
														
														ALB_UNITS
										)
									values (
									
									
									'SS_TS6_101_',
									
									'TS6_101_06', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,14
															,4
															,4
															,4
															,'2014-06-10'
															,5
															,9
															,4
															,'2014-06-10'
															,2													
															,'2+'											
														
															,1													
															,'Positive'											
														
															,1													
															,'Positive'											
														
															,101
															,'SiteA'
															,'gm/dL'
															,'trillion cells/L'
															,'billion cells/L'
															,'IU/mL'
															,'mEq/L'
															,'mg/dL'
															,'g/dL'		
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label																									
																,
																
														
														SITE_AB																									
																,
																
														
														SITE_DEC																									
																,
																
														
														HEM_UNITS																									
																,
																
														
														RBC_UNITS																									
																,
																
														
														WBC_UNITS																									
																,
																
														
														RHE_UNITS																									
																,
																
														
														POT_UNITS																									
																,
																
														
														CAL_UNITS																									
																,
																
														
														ALB_UNITS
										)
									values (
									
									
									'SS_TS10_102',
									
									'TS10_102_10', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,122
															,4
															,3600
															,4
															,'2014-06-10'
															,4.2
															,9.8
															,3.5
															,'2014-06-10'
															,9													
															,'Trace'											
														
															,1													
															,'Positive'											
														
															,0													
															,'Negative'											
														
															,102
															,'SiteB'
															,'gm/L'
															,'million cells/mcL'
															,'cells/mcL'
															,'IU/mL'
															,'mmol/L'
															,'mmol/L'
															,'umol/L'		
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label																									
																,
																
														
														SITE_AB																									
																,
																
														
														SITE_DEC																									
																,
																
														
														HEM_UNITS																									
																,
																
														
														RBC_UNITS																									
																,
																
														
														WBC_UNITS																									
																,
																
														
														RHE_UNITS																									
																,
																
														
														POT_UNITS																									
																,
																
														
														CAL_UNITS																									
																,
																
														
														ALB_UNITS
										)
									values (
									
									
									'SS_TS1_102_',
									
									'TS1_102_01', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,14.2
															,4.6
															,5.2
															,5.2
															,'2014-06-10'
															,4.4
															,8.9
															,3.7
															,'2014-06-10'
															,1													
															,'1+'											
														
															,1													
															,'Positive'											
														
															,0													
															,'Negative'											
														
															,102
															,'SiteB'
															,'gm/L'
															,'million cells/mcL'
															,'cells/mcL'
															,'IU/mL'
															,'mmol/L'
															,'mmol/L'
															,'umol/L'		
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label																									
																,
																
														
														SITE_AB																									
																,
																
														
														SITE_DEC																									
																,
																
														
														HEM_UNITS																									
																,
																
														
														RBC_UNITS																									
																,
																
														
														WBC_UNITS																									
																,
																
														
														RHE_UNITS																									
																,
																
														
														POT_UNITS																									
																,
																
														
														CAL_UNITS																									
																,
																
														
														ALB_UNITS
										)
									values (
									
									
									'SS_TS3_102_',
									
									'TS3_102_03', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,14.2
															,4.6
															,5.2
															,5.2
															,'2014-06-10'
															,4.4
															,8.9
															,3.7
															,'2014-06-10'
															,1													
															,'1+'											
														
															,1													
															,'Positive'											
														
															,0													
															,'Negative'											
														
															,102
															,'SiteB'
															,'gm/L'
															,'million cells/mcL'
															,'cells/mcL'
															,'IU/mL'
															,'mmol/L'
															,'mmol/L'
															,'umol/L'		
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label																									
																,
																
														
														SITE_AB																									
																,
																
														
														SITE_DEC																									
																,
																
														
														HEM_UNITS																									
																,
																
														
														RBC_UNITS																									
																,
																
														
														WBC_UNITS																									
																,
																
														
														RHE_UNITS																									
																,
																
														
														POT_UNITS																									
																,
																
														
														CAL_UNITS																									
																,
																
														
														ALB_UNITS
										)
									values (
									
									
									'SS_TS6_102_',
									
									'TS6_102_06', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,14
															,4
															,4
															,4
															,'2014-06-10'
															,5
															,9
															,4
															,'2014-06-10'
															,2													
															,'2+'											
														
															,1													
															,'Positive'											
														
															,1													
															,'Positive'											
														
															,102
															,'SiteB'
															,'gm/L'
															,'million cells/mcL'
															,'cells/mcL'
															,'IU/mL'
															,'mmol/L'
															,'mmol/L'
															,'umol/L'		
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label																									
																,
																
														
														SITE_AB																									
																,
																
														
														SITE_DEC																									
																,
																
														
														HEM_UNITS																									
																,
																
														
														RBC_UNITS																									
																,
																
														
														WBC_UNITS																									
																,
																
														
														RHE_UNITS																									
																,
																
														
														POT_UNITS																									
																,
																
														
														CAL_UNITS																									
																,
																
														
														ALB_UNITS
										)
									values (
									
									
									'SS_TS8_102_',
									
									'TS8_102_08', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,14
															,4
															,4
															,4
															,'2014-06-10'
															,4.2
															,9.8
															,3.5
															,'2014-06-10'
															,9													
															,'Trace'											
														
															,1													
															,'Positive'											
														
															,0													
															,'Negative'											
														
															,102
															,'SiteB'
															,'gm/L'
															,'million cells/mcL'
															,'cells/mcL'
															,'IU/mL'
															,'mmol/L'
															,'mmol/L'
															,'umol/L'		
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label																									
																,
																
														
														SITE_AB																									
																,
																
														
														SITE_DEC																									
																,
																
														
														HEM_UNITS																									
																,
																
														
														RBC_UNITS																									
																,
																
														
														WBC_UNITS																									
																,
																
														
														RHE_UNITS																									
																,
																
														
														POT_UNITS																									
																,
																
														
														CAL_UNITS																									
																,
																
														
														ALB_UNITS
										)
									values (
									
									
									'SS_TS10_103',
									
									'TS10_103_10', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,14
															,4
															,4
															,4
															,'2014-06-10'
															,4.2
															,9.8
															,3.5
															,'2014-06-10'
															,9													
															,'Trace'											
														
															,1													
															,'Positive'											
														
															,0													
															,'Negative'											
														
															,101
															,'SiteA'
															,'gm/dL'
															,'trillion cells/L'
															,'billion cells/L'
															,'IU/mL'
															,'mEq/L'
															,'mg/dL'
															,'g/dL'		
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label																									
																,
																
														
														SITE_AB																									
																,
																
														
														SITE_DEC																									
																,
																
														
														HEM_UNITS																									
																,
																
														
														RBC_UNITS																									
																,
																
														
														WBC_UNITS																									
																,
																
														
														RHE_UNITS																									
																,
																
														
														POT_UNITS																									
																,
																
														
														CAL_UNITS																									
																,
																
														
														ALB_UNITS
										)
									values (
									
									
									'SS_TS1_103_',
									
									'TS1_103_01', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,14.2
															,4.6
															,5.2
															,5.2
															,'2014-06-10'
															,4.4
															,8.9
															,3.7
															,'2014-06-10'
															,1													
															,'1+'											
														
															,1													
															,'Positive'											
														
															,0													
															,'Negative'											
														
															,101
															,'SiteA'
															,'gm/dL'
															,'trillion cells/L'
															,'billion cells/L'
															,'IU/mL'
															,'mEq/L'
															,'mg/dL'
															,'g/dL'		
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label																									
																,
																
														
														SITE_AB																									
																,
																
														
														SITE_DEC																									
																,
																
														
														HEM_UNITS																									
																,
																
														
														RBC_UNITS																									
																,
																
														
														WBC_UNITS																									
																,
																
														
														RHE_UNITS																									
																,
																
														
														POT_UNITS																									
																,
																
														
														CAL_UNITS																									
																,
																
														
														ALB_UNITS
										)
									values (
									
									
									'SS_TS3_103_',
									
									'TS3_103_03', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,14.2
															,4.6
															,5.2
															,5.2
															,'2014-06-10'
															,4.4
															,8.9
															,3.7
															,'2014-06-10'
															,1													
															,'1+'											
														
															,1													
															,'Positive'											
														
															,0													
															,'Negative'											
														
															,101
															,'SiteA'
															,'gm/dL'
															,'trillion cells/L'
															,'billion cells/L'
															,'IU/mL'
															,'mEq/L'
															,'mg/dL'
															,'g/dL'		
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label																									
																,
																
														
														SITE_AB																									
																,
																
														
														SITE_DEC																									
																,
																
														
														HEM_UNITS																									
																,
																
														
														RBC_UNITS																									
																,
																
														
														WBC_UNITS																									
																,
																
														
														RHE_UNITS																									
																,
																
														
														POT_UNITS																									
																,
																
														
														CAL_UNITS																									
																,
																
														
														ALB_UNITS
										)
									values (
									
									
									'SS_TS6_103_',
									
									'TS6_103_06', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,14
															,4
															,4
															,4
															,'2014-06-10'
															,5
															,9
															,4
															,'2014-06-10'
															,2													
															,'2+'											
														
															,1													
															,'Positive'											
														
															,1													
															,'Positive'											
														
															,101
															,'SiteA'
															,'gm/dL'
															,'trillion cells/L'
															,'billion cells/L'
															,'IU/mL'
															,'mEq/L'
															,'mg/dL'
															,'g/dL'		
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label																									
																,
																
														
														SITE_AB																									
																,
																
														
														SITE_DEC																									
																,
																
														
														HEM_UNITS																									
																,
																
														
														RBC_UNITS																									
																,
																
														
														WBC_UNITS																									
																,
																
														
														RHE_UNITS																									
																,
																
														
														POT_UNITS																									
																,
																
														
														CAL_UNITS																									
																,
																
														
														ALB_UNITS
										)
									values (
									
									
									'SS_TS8_103_',
									
									'TS8_103_08', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,14
															,4
															,4
															,4
															,'2014-06-10'
															,4.2
															,9.8
															,3.5
															,'2014-06-10'
															,9													
															,'Trace'											
														
															,1													
															,'Positive'											
														
															,0													
															,'Negative'											
														
															,101
															,'SiteA'
															,'gm/dL'
															,'trillion cells/L'
															,'billion cells/L'
															,'IU/mL'
															,'mEq/L'
															,'mg/dL'
															,'g/dL'		
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label																									
																,
																
														
														SITE_AB																									
																,
																
														
														SITE_DEC																									
																,
																
														
														HEM_UNITS																									
																,
																
														
														RBC_UNITS																									
																,
																
														
														WBC_UNITS																									
																,
																
														
														RHE_UNITS																									
																,
																
														
														POT_UNITS																									
																,
																
														
														CAL_UNITS																									
																,
																
														
														ALB_UNITS
										)
									values (
									
									
									'SS_TS10_104',
									
									'TS10_104_10', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,14
															,4
															,4
															,4
															,'2014-06-10'
															,4.2
															,9.8
															,3.5
															,'2014-06-10'
															,9													
															,'Trace'											
														
															,1													
															,'Positive'											
														
															,0													
															,'Negative'											
														
															,101
															,'SiteA'
															,'gm/dL'
															,'trillion cells/L'
															,'billion cells/L'
															,'IU/mL'
															,'mEq/L'
															,'mg/dL'
															,'g/dL'		
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label																									
																,
																
														
														SITE_AB																									
																,
																
														
														SITE_DEC																									
																,
																
														
														HEM_UNITS																									
																,
																
														
														RBC_UNITS																									
																,
																
														
														WBC_UNITS																									
																,
																
														
														RHE_UNITS																									
																,
																
														
														POT_UNITS																									
																,
																
														
														CAL_UNITS																									
																,
																
														
														ALB_UNITS
										)
									values (
									
									
									'SS_TS1_104_',
									
									'TS1_104_01', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,14.2
															,4.6
															,5.2
															,5.2
															,'2014-06-10'
															,4.4
															,8.9
															,3.7
															,'2014-06-10'
															,1													
															,'1+'											
														
															,1													
															,'Positive'											
														
															,0													
															,'Negative'											
														
															,101
															,'SiteA'
															,'gm/dL'
															,'trillion cells/L'
															,'billion cells/L'
															,'IU/mL'
															,'mEq/L'
															,'mg/dL'
															,'g/dL'		
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														SITE_AB																									
																,
																
														
														SITE_DEC																									
																,
																
														
														HEM_UNITS																									
																,
																
														
														RBC_UNITS																									
																,
																
														
														WBC_UNITS																									
																,
																
														
														RHE_UNITS																									
																,
																
														
														POT_UNITS																									
																,
																
														
														CAL_UNITS																									
																,
																
														
														ALB_UNITS
										)
									values (
									
									
									'SS_TS11_104',
									
									'TS11_104_11', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,102
															,'SiteB'
															,'gm/L'
															,'million cells/mcL'
															,'cells/mcL'
															,'IU/mL'
															,'mmol/L'
															,'mmol/L'
															,'umol/L'		
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label																									
																,
																
														
														SITE_AB																									
																,
																
														
														SITE_DEC																									
																,
																
														
														HEM_UNITS																									
																,
																
														
														RBC_UNITS																									
																,
																
														
														WBC_UNITS																									
																,
																
														
														RHE_UNITS																									
																,
																
														
														POT_UNITS																									
																,
																
														
														CAL_UNITS																									
																,
																
														
														ALB_UNITS
										)
									values (
									
									
									'SS_TS3_104_',
									
									'TS3_104_03', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,14.2
															,4.6
															,5.2
															,5.2
															,'2014-06-10'
															,4.4
															,8.9
															,3.7
															,'2014-06-10'
															,1													
															,'1+'											
														
															,1													
															,'Positive'											
														
															,0													
															,'Negative'											
														
															,101
															,'SiteA'
															,'gm/dL'
															,'trillion cells/L'
															,'billion cells/L'
															,'IU/mL'
															,'mEq/L'
															,'mg/dL'
															,'g/dL'		
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label																									
																,
																
														
														SITE_AB																									
																,
																
														
														SITE_DEC																									
																,
																
														
														HEM_UNITS																									
																,
																
														
														RBC_UNITS																									
																,
																
														
														WBC_UNITS																									
																,
																
														
														RHE_UNITS																									
																,
																
														
														POT_UNITS																									
																,
																
														
														CAL_UNITS																									
																,
																
														
														ALB_UNITS
										)
									values (
									
									
									'SS_TS6_104_',
									
									'TS6_104_06', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,14
															,4
															,4
															,4
															,'2014-06-10'
															,5
															,9
															,4
															,'2014-06-10'
															,2													
															,'2+'											
														
															,1													
															,'Positive'											
														
															,1													
															,'Positive'											
														
															,101
															,'SiteA'
															,'gm/dL'
															,'trillion cells/L'
															,'billion cells/L'
															,'IU/mL'
															,'mEq/L'
															,'mg/dL'
															,'g/dL'		
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label																									
																,
																
														
														SITE_AB																									
																,
																
														
														SITE_DEC																									
																,
																
														
														HEM_UNITS																									
																,
																
														
														RBC_UNITS																									
																,
																
														
														WBC_UNITS																									
																,
																
														
														RHE_UNITS																									
																,
																
														
														POT_UNITS																									
																,
																
														
														CAL_UNITS																									
																,
																
														
														ALB_UNITS
										)
									values (
									
									
									'SS_TS8_104_',
									
									'TS8_104_08', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,14
															,4
															,4
															,4
															,'2014-06-10'
															,4.2
															,9.8
															,3.5
															,'2014-06-10'
															,9													
															,'Trace'											
														
															,1													
															,'Positive'											
														
															,0													
															,'Negative'											
														
															,101
															,'SiteA'
															,'gm/dL'
															,'trillion cells/L'
															,'billion cells/L'
															,'IU/mL'
															,'mEq/L'
															,'mg/dL'
															,'g/dL'		
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label																									
																,
																
														
														SITE_AB																									
																,
																
														
														SITE_DEC																									
																,
																
														
														HEM_UNITS																									
																,
																
														
														RBC_UNITS																									
																,
																
														
														WBC_UNITS																									
																,
																
														
														RHE_UNITS																									
																,
																
														
														POT_UNITS																									
																,
																
														
														CAL_UNITS																									
																,
																
														
														ALB_UNITS
										)
									values (
									
									
									'SS_TS13_105',
									
									'TS13_105_13', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,14
															,5
															,10.1
															,1
															,'2014-06-10'
															,4
															,9
															,4
															,'2014-06-10'
															,0													
															,'Negative'											
														
															,1													
															,'Positive'											
														
															,1													
															,'Positive'											
														
															,105
															,'SiteE'
															,'gm/dL'
															,'trillion cells/L'
															,'billion cells/L'
															,'IU/mL'
															,'mEq/L'
															,'mg/dL'
															,'g/dL'		
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label																									
																,
																
														
														SITE_AB																									
																,
																
														
														SITE_DEC																									
																,
																
														
														HEM_UNITS																									
																,
																
														
														RBC_UNITS																									
																,
																
														
														WBC_UNITS																									
																,
																
														
														RHE_UNITS																									
																,
																
														
														POT_UNITS																									
																,
																
														
														CAL_UNITS																									
																,
																
														
														ALB_UNITS
										)
									values (
									
									
									'SS_TS2_105_',
									
									'TS2_105_02', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,13
															,5
															,6
															,23
															,'2014-06-10'
															,4.3
															,10.2
															,5.3
															,'2014-06-10'
															,4													
															,'4+'											
														
															,1													
															,'Positive'											
														
															,1													
															,'Positive'											
														
															,105
															,'SiteE'
															,'gm/dL'
															,'trillion cells/L'
															,'billion cells/L'
															,'IU/mL'
															,'mEq/L'
															,'mg/dL'
															,'g/dL'		
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label																									
																,
																
														
														SITE_AB																									
																,
																
														
														SITE_DEC																									
																,
																
														
														HEM_UNITS																									
																,
																
														
														RBC_UNITS																									
																,
																
														
														WBC_UNITS																									
																,
																
														
														RHE_UNITS																									
																,
																
														
														POT_UNITS																									
																,
																
														
														CAL_UNITS																									
																,
																
														
														ALB_UNITS
										)
									values (
									
									
									'SS_TS5_105_',
									
									'TS5_105_05', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,13.7
															,5.5
															,6.2
															,12
															,'2014-06-10'
															,4
															,9
															,4
															,'2014-06-10'
															,0													
															,'Negative'											
														
															,0													
															,'Negative'											
														
															,0													
															,'Negative'											
														
															,105
															,'SiteE'
															,'gm/dL'
															,'trillion cells/L'
															,'billion cells/L'
															,'IU/mL'
															,'mEq/L'
															,'mg/dL'
															,'g/dL'		
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label																									
																,
																
														
														SITE_AB																									
																,
																
														
														SITE_DEC																									
																,
																
														
														HEM_UNITS																									
																,
																
														
														RBC_UNITS																									
																,
																
														
														WBC_UNITS																									
																,
																
														
														RHE_UNITS																									
																,
																
														
														POT_UNITS																									
																,
																
														
														CAL_UNITS																									
																,
																
														
														ALB_UNITS
										)
									values (
									
									
									'SS_TS6_105_',
									
									'TS6_105_06', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,14
															,4
															,4
															,4
															,'2014-06-10'
															,5
															,9
															,4
															,'2014-06-10'
															,2													
															,'2+'											
														
															,1													
															,'Positive'											
														
															,1													
															,'Positive'											
														
															,101
															,'SiteA'
															,'gm/dL'
															,'trillion cells/L'
															,'billion cells/L'
															,'IU/mL'
															,'mEq/L'
															,'mg/dL'
															,'g/dL'		
									);
										
									insert into NCT01928420_All_Data.Local_Laboratory_ResultsTests (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														HEM_DT																									
																,
																
														
														HEM_HEM																									
																,
																
														
														HEM_RBC																									
																,
																
														
														HEM_WBC																									
																,
																
														
														HEM_RHE																									
																,
																
														
														CH_DT																									
																,
																
														
														CH_POT																									
																,
																
														
														CH_CAL																									
																,
																
														
														CH_ALB																									
																,
																
														
														UR_DT																									
																,
																
														
														UR_PRO
																												
																	,UR_PRO_label																									
																,
																
														
														UR_LEUK
																												
																	,UR_LEUK_label																									
																,
																
														
														UR_NITR
																												
																	,UR_NITR_label																									
																,
																
														
														SITE_AB																									
																,
																
														
														SITE_DEC																									
																,
																
														
														HEM_UNITS																									
																,
																
														
														RBC_UNITS																									
																,
																
														
														WBC_UNITS																									
																,
																
														
														RHE_UNITS																									
																,
																
														
														POT_UNITS																									
																,
																
														
														CAL_UNITS																									
																,
																
														
														ALB_UNITS
										)
									values (
									
									
									'SS_TS9_105_',
									
									'TS9_105_09', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,13
															,4.6
															,7.2
															,33
															,'2014-06-10'
															,4.4
															,8.9
															,3.7
															,'2014-06-10'
															,0													
															,'Negative'											
														
															,1													
															,'Positive'											
														
															,0													
															,'Negative'											
														
															,105
															,'SiteE'
															,'gm/dL'
															,'trillion cells/L'
															,'billion cells/L'
															,'IU/mL'
															,'mEq/L'
															,'mg/dL'
															,'g/dL'		
									);
								
			  
			
					insert into NCT01928420_All_Data.crf_version (crf_name, crf_version_name, warehouse_insert_created_timestamp) values 
					( 'MRI Form', 
					'V1.0',
					'2015-03-19T16:41:35.717Z');
			
			
			
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(	
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(		
				'SS_TEST_01',
									
					'Test_01',
					
				'SE_FIRSTVISIT',
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(	
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(		
				'SS_TEST_01',
									
					'Test_01',
					
				'SE_1WEEKFU',
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS10_101',
									
					'TS10_101_10',
					
				'SE_FIRSTVISIT',
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS10_101',
									
					'TS10_101_10',
					
				'SE_1WEEKFU',
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS10_101',
									
					'TS10_101_10',
					
				'SE_2WEEKFU',
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS10_101',
									
					'TS10_101_10',
					
				'SE_MONTHLYFU',
				1,
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS10_101',
									
					'TS10_101_10',
					
				'SE_MONTHLYFU',
				2,
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS3_101_',
									
					'TS3_101_03',
					
				'SE_FIRSTVISIT',
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS3_101_',
									
					'TS3_101_03',
					
				'SE_1WEEKFU',
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS6_101_',
									
					'TS6_101_06',
					
				'SE_FIRSTVISIT',
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS10_102',
									
					'TS10_102_10',
					
				'SE_FIRSTVISIT',
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS10_102',
									
					'TS10_102_10',
					
				'SE_1WEEKFU',
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS10_102',
									
					'TS10_102_10',
					
				'SE_2WEEKFU',
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS10_102',
									
					'TS10_102_10',
					
				'SE_MONTHLYFU',
				1,
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS10_102',
									
					'TS10_102_10',
					
				'SE_MONTHLYFU',
				2,
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS1_102_',
									
					'TS1_102_01',
					
				'SE_FIRSTVISIT',
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS1_102_',
									
					'TS1_102_01',
					
				'SE_1WEEKFU',
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS3_102_',
									
					'TS3_102_03',
					
				'SE_FIRSTVISIT',
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS3_102_',
									
					'TS3_102_03',
					
				'SE_1WEEKFU',
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS6_102_',
									
					'TS6_102_06',
					
				'SE_FIRSTVISIT',
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS8_102_',
									
					'TS8_102_08',
					
				'SE_FIRSTVISIT',
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS8_102_',
									
					'TS8_102_08',
					
				'SE_1WEEKFU',
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS8_102_',
									
					'TS8_102_08',
					
				'SE_2WEEKFU',
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS8_102_',
									
					'TS8_102_08',
					
				'SE_MONTHLYFU',
				1,
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS8_102_',
									
					'TS8_102_08',
					
				'SE_MONTHLYFU',
				2,
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS10_103',
									
					'TS10_103_10',
					
				'SE_FIRSTVISIT',
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS10_103',
									
					'TS10_103_10',
					
				'SE_1WEEKFU',
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS10_103',
									
					'TS10_103_10',
					
				'SE_2WEEKFU',
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS10_103',
									
					'TS10_103_10',
					
				'SE_MONTHLYFU',
				1,
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS10_103',
									
					'TS10_103_10',
					
				'SE_MONTHLYFU',
				2,
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS1_103_',
									
					'TS1_103_01',
					
				'SE_FIRSTVISIT',
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS1_103_',
									
					'TS1_103_01',
					
				'SE_1WEEKFU',
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS3_103_',
									
					'TS3_103_03',
					
				'SE_FIRSTVISIT',
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS3_103_',
									
					'TS3_103_03',
					
				'SE_1WEEKFU',
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS6_103_',
									
					'TS6_103_06',
					
				'SE_FIRSTVISIT',
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS8_103_',
									
					'TS8_103_08',
					
				'SE_FIRSTVISIT',
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS8_103_',
									
					'TS8_103_08',
					
				'SE_1WEEKFU',
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS8_103_',
									
					'TS8_103_08',
					
				'SE_2WEEKFU',
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS8_103_',
									
					'TS8_103_08',
					
				'SE_MONTHLYFU',
				1,
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS8_103_',
									
					'TS8_103_08',
					
				'SE_MONTHLYFU',
				2,
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS10_104',
									
					'TS10_104_10',
					
				'SE_FIRSTVISIT',
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS10_104',
									
					'TS10_104_10',
					
				'SE_1WEEKFU',
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS10_104',
									
					'TS10_104_10',
					
				'SE_2WEEKFU',
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS10_104',
									
					'TS10_104_10',
					
				'SE_MONTHLYFU',
				1,
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS10_104',
									
					'TS10_104_10',
					
				'SE_MONTHLYFU',
				2,
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS1_104_',
									
					'TS1_104_01',
					
				'SE_FIRSTVISIT',
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS1_104_',
									
					'TS1_104_01',
					
				'SE_1WEEKFU',
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS3_104_',
									
					'TS3_104_03',
					
				'SE_FIRSTVISIT',
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS3_104_',
									
					'TS3_104_03',
					
				'SE_1WEEKFU',
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS6_104_',
									
					'TS6_104_06',
					
				'SE_FIRSTVISIT',
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS8_104_',
									
					'TS8_104_08',
					
				'SE_FIRSTVISIT',
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS8_104_',
									
					'TS8_104_08',
					
				'SE_1WEEKFU',
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS8_104_',
									
					'TS8_104_08',
					
				'SE_2WEEKFU',
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS8_104_',
									
					'TS8_104_08',
					
				'SE_MONTHLYFU',
				1,
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS8_104_',
									
					'TS8_104_08',
					
				'SE_MONTHLYFU',
				2,
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS13_105',
									
					'TS13_105_13',
					
				'SE_FIRSTVISIT',
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS13_105',
									
					'TS13_105_13',
					
				'SE_1WEEKFU',
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS13_105',
									
					'TS13_105_13',
					
				'SE_2WEEKFU',
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS13_105',
									
					'TS13_105_13',
					
				'SE_MONTHLYFU',
				1,
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS13_105',
									
					'TS13_105_13',
					
				'SE_MONTHLYFU',
				2,
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS2_105_',
									
					'TS2_105_02',
					
				'SE_FIRSTVISIT',
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS2_105_',
									
					'TS2_105_02',
					
				'SE_1WEEKFU',
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS5_105_',
									
					'TS5_105_05',
					
				'SE_FIRSTVISIT',
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS6_105_',
									
					'TS6_105_06',
					
				'SE_FIRSTVISIT',
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS7_105_',
									
					'TS7_105_07',
					
				'SE_FIRSTVISIT',
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS7_105_',
									
					'TS7_105_07',
					
				'SE_1WEEKFU',
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS9_105_',
									
					'TS9_105_09',
					
				'SE_FIRSTVISIT',
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS9_105_',
									
					'TS9_105_09',
					
				'SE_1WEEKFU',
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS9_105_',
									
					'TS9_105_09',
					
				'SE_2WEEKFU',
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS9_105_',
									
					'TS9_105_09',
					
				'SE_MONTHLYFU',
				1,
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS9_105_',
									
					'TS9_105_09',
					
				'SE_MONTHLYFU',
				2,
				
				'MRI Form',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
				create table NCT01928420_All_Data.MRI_FormMRI (
				item_data_id serial NOT NULL,
				ssoid character varying(40) NOT NULL,
				ssid character varying(40) NOT NULL,
				study_event_oid character varying(40) NOT NULL,
				event_ordinal integer default 1,
				crf_version character varying(255),
				event_start_date timestamp without time zone,
				event_end_date timestamp without time zone,
				event_status character varying(255),
				event_location character varying(2000),
				subject_age_at_event integer,
				crf_status character varying(255), 
				interviewerName character varying(255),
				interviewDate date,
				warehouse_insert_created_timestamp timestamp with time zone); 			          	 
				
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.MRI_FormMRI', 'MRI_YN', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.MRI_FormMRI', 'MRI_YN_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.MRI_FormMRI', 'MRI_NO', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.MRI_FormMRI', 'MRI_RES', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.MRI_FormMRI', 'MRI_RES_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.MRI_FormMRI', 'MRI_AB', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.MRI_FormMRI', 'MRI_DOC', 'text');

	
				
		ALTER TABLE NCT01928420_All_Data.MRI_FormMRI ADD CONSTRAINT Pk_MRI PRIMARY KEY (item_data_id);

		
				
		ALTER TABLE NCT01928420_All_Data.MRI_FormMRI ADD CONSTRAINT 	
		Fk_study_subject_id_MRI FOREIGN KEY (ssoid, 
		ssid) REFERENCES NCT01928420_All_Data.study_subject_listing;
		
				
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_RES
																												
																	,MRI_RES_label
										)
									values (
									
									
									'SS_TEST_01',
									
									'Test_01', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_NO
										)
									values (
									
									
									'SS_TEST_01',
									
									'Test_01', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,2													
															,'No'											
														
															,'MRI wasn''t needed'		
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_RES
																												
																	,MRI_RES_label
										)
									values (
									
									
									'SS_TS10_101',
									
									'TS10_101_10', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_RES
																												
																	,MRI_RES_label
										)
									values (
									
									
									'SS_TS10_101',
									
									'TS10_101_10', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_RES
																												
																	,MRI_RES_label
										)
									values (
									
									
									'SS_TS10_101',
									
									'TS10_101_10', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_NO
										)
									values (
									
									
									'SS_TS10_101',
									
									'TS10_101_10', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,1
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,2													
															,'No'											
														
															,'Not required'		
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_RES
																												
																	,MRI_RES_label
										)
									values (
									
									
									'SS_TS10_101',
									
									'TS10_101_10', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,2
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_RES
																												
																	,MRI_RES_label
										)
									values (
									
									
									'SS_TS3_101_',
									
									'TS3_101_03', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_RES
																												
																	,MRI_RES_label
										)
									values (
									
									
									'SS_TS3_101_',
									
									'TS3_101_03', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_NO
										)
									values (
									
									
									'SS_TS6_101_',
									
									'TS6_101_06', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,2													
															,'No'											
														
															,'See protocol deviation form.'		
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_RES
																												
																	,MRI_RES_label
										)
									values (
									
									
									'SS_TS10_102',
									
									'TS10_102_10', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_RES
																												
																	,MRI_RES_label
										)
									values (
									
									
									'SS_TS10_102',
									
									'TS10_102_10', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_RES
																												
																	,MRI_RES_label
										)
									values (
									
									
									'SS_TS10_102',
									
									'TS10_102_10', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_NO
										)
									values (
									
									
									'SS_TS10_102',
									
									'TS10_102_10', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,1
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,2													
															,'No'											
														
															,'Not required'		
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_RES
																												
																	,MRI_RES_label
										)
									values (
									
									
									'SS_TS10_102',
									
									'TS10_102_10', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,2
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_RES
																												
																	,MRI_RES_label
										)
									values (
									
									
									'SS_TS1_102_',
									
									'TS1_102_01', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_RES
																												
																	,MRI_RES_label
										)
									values (
									
									
									'SS_TS1_102_',
									
									'TS1_102_01', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_RES
																												
																	,MRI_RES_label
										)
									values (
									
									
									'SS_TS3_102_',
									
									'TS3_102_03', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_RES
																												
																	,MRI_RES_label
										)
									values (
									
									
									'SS_TS3_102_',
									
									'TS3_102_03', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_NO
										)
									values (
									
									
									'SS_TS6_102_',
									
									'TS6_102_06', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,2													
															,'No'											
														
															,'See protocol deviation form.'		
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_RES
																												
																	,MRI_RES_label
										)
									values (
									
									
									'SS_TS8_102_',
									
									'TS8_102_08', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_RES
																												
																	,MRI_RES_label
										)
									values (
									
									
									'SS_TS8_102_',
									
									'TS8_102_08', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_RES
																												
																	,MRI_RES_label
										)
									values (
									
									
									'SS_TS8_102_',
									
									'TS8_102_08', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_NO
										)
									values (
									
									
									'SS_TS8_102_',
									
									'TS8_102_08', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,1
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,2													
															,'No'											
														
															,'Not required'		
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_RES
																												
																	,MRI_RES_label
										)
									values (
									
									
									'SS_TS8_102_',
									
									'TS8_102_08', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,2
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_RES
																												
																	,MRI_RES_label
										)
									values (
									
									
									'SS_TS10_103',
									
									'TS10_103_10', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_RES
																												
																	,MRI_RES_label
										)
									values (
									
									
									'SS_TS10_103',
									
									'TS10_103_10', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_RES
																												
																	,MRI_RES_label
										)
									values (
									
									
									'SS_TS10_103',
									
									'TS10_103_10', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_NO
										)
									values (
									
									
									'SS_TS10_103',
									
									'TS10_103_10', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,1
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,2													
															,'No'											
														
															,'Not required'		
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_RES
																												
																	,MRI_RES_label
										)
									values (
									
									
									'SS_TS10_103',
									
									'TS10_103_10', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,2
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_RES
																												
																	,MRI_RES_label
										)
									values (
									
									
									'SS_TS1_103_',
									
									'TS1_103_01', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_RES
																												
																	,MRI_RES_label
										)
									values (
									
									
									'SS_TS1_103_',
									
									'TS1_103_01', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_RES
																												
																	,MRI_RES_label
										)
									values (
									
									
									'SS_TS3_103_',
									
									'TS3_103_03', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_RES
																												
																	,MRI_RES_label
										)
									values (
									
									
									'SS_TS3_103_',
									
									'TS3_103_03', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_NO
										)
									values (
									
									
									'SS_TS6_103_',
									
									'TS6_103_06', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,2													
															,'No'											
														
															,'See protocol deviation form.'		
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_RES
																												
																	,MRI_RES_label
										)
									values (
									
									
									'SS_TS8_103_',
									
									'TS8_103_08', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_RES
																												
																	,MRI_RES_label
										)
									values (
									
									
									'SS_TS8_103_',
									
									'TS8_103_08', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_RES
																												
																	,MRI_RES_label
										)
									values (
									
									
									'SS_TS8_103_',
									
									'TS8_103_08', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_NO
										)
									values (
									
									
									'SS_TS8_103_',
									
									'TS8_103_08', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,1
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,2													
															,'No'											
														
															,'Not required'		
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_RES
																												
																	,MRI_RES_label
										)
									values (
									
									
									'SS_TS8_103_',
									
									'TS8_103_08', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,2
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_RES
																												
																	,MRI_RES_label
										)
									values (
									
									
									'SS_TS10_104',
									
									'TS10_104_10', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_RES
																												
																	,MRI_RES_label
										)
									values (
									
									
									'SS_TS10_104',
									
									'TS10_104_10', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_RES
																												
																	,MRI_RES_label
										)
									values (
									
									
									'SS_TS10_104',
									
									'TS10_104_10', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_NO
										)
									values (
									
									
									'SS_TS10_104',
									
									'TS10_104_10', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,1
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,2													
															,'No'											
														
															,'Not required'		
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_RES
																												
																	,MRI_RES_label
										)
									values (
									
									
									'SS_TS10_104',
									
									'TS10_104_10', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,2
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_RES
																												
																	,MRI_RES_label
										)
									values (
									
									
									'SS_TS1_104_',
									
									'TS1_104_01', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_RES
																												
																	,MRI_RES_label
										)
									values (
									
									
									'SS_TS1_104_',
									
									'TS1_104_01', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_RES
																												
																	,MRI_RES_label
										)
									values (
									
									
									'SS_TS3_104_',
									
									'TS3_104_03', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_RES
																												
																	,MRI_RES_label
										)
									values (
									
									
									'SS_TS3_104_',
									
									'TS3_104_03', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_NO
										)
									values (
									
									
									'SS_TS6_104_',
									
									'TS6_104_06', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,2													
															,'No'											
														
															,'See protocol deviation form.'		
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_RES
																												
																	,MRI_RES_label
										)
									values (
									
									
									'SS_TS8_104_',
									
									'TS8_104_08', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_RES
																												
																	,MRI_RES_label
										)
									values (
									
									
									'SS_TS8_104_',
									
									'TS8_104_08', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_RES
																												
																	,MRI_RES_label
										)
									values (
									
									
									'SS_TS8_104_',
									
									'TS8_104_08', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_NO
										)
									values (
									
									
									'SS_TS8_104_',
									
									'TS8_104_08', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,1
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,2													
															,'No'											
														
															,'Not required'		
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_RES
																												
																	,MRI_RES_label
										)
									values (
									
									
									'SS_TS8_104_',
									
									'TS8_104_08', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,2
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_RES
																												
																	,MRI_RES_label
										)
									values (
									
									
									'SS_TS13_105',
									
									'TS13_105_13', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_RES
																												
																	,MRI_RES_label
										)
									values (
									
									
									'SS_TS13_105',
									
									'TS13_105_13', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_RES
																												
																	,MRI_RES_label
										)
									values (
									
									
									'SS_TS13_105',
									
									'TS13_105_13', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_NO
										)
									values (
									
									
									'SS_TS13_105',
									
									'TS13_105_13', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,1
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,2													
															,'No'											
														
															,'Not required'		
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_RES
																												
																	,MRI_RES_label
										)
									values (
									
									
									'SS_TS13_105',
									
									'TS13_105_13', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,2
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_RES
																												
																	,MRI_RES_label
										)
									values (
									
									
									'SS_TS2_105_',
									
									'TS2_105_02', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_RES
																												
																	,MRI_RES_label
										)
									values (
									
									
									'SS_TS2_105_',
									
									'TS2_105_02', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_RES
																												
																	,MRI_RES_label
										)
									values (
									
									
									'SS_TS5_105_',
									
									'TS5_105_05', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_NO
										)
									values (
									
									
									'SS_TS6_105_',
									
									'TS6_105_06', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,2													
															,'No'											
														
															,'See protocol deviation form.'		
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_RES
																												
																	,MRI_RES_label
										)
									values (
									
									
									'SS_TS7_105_',
									
									'TS7_105_07', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_RES
																												
																	,MRI_RES_label
										)
									values (
									
									
									'SS_TS7_105_',
									
									'TS7_105_07', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_RES
																												
																	,MRI_RES_label
										)
									values (
									
									
									'SS_TS9_105_',
									
									'TS9_105_09', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_RES
																												
																	,MRI_RES_label
										)
									values (
									
									
									'SS_TS9_105_',
									
									'TS9_105_09', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_RES
																												
																	,MRI_RES_label
										)
									values (
									
									
									'SS_TS9_105_',
									
									'TS9_105_09', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_NO
										)
									values (
									
									
									'SS_TS9_105_',
									
									'TS9_105_09', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,1
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,2													
															,'No'											
														
															,'Not required'		
									);
										
									insert into NCT01928420_All_Data.MRI_FormMRI (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														MRI_YN
																												
																	,MRI_YN_label																									
																,
																
														
														MRI_RES
																												
																	,MRI_RES_label
										)
									values (
									
									
									'SS_TS9_105_',
									
									'TS9_105_09', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,2
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,1													
															,'Normal'											
																
									);
								
			  
			
					insert into NCT01928420_All_Data.crf_version (crf_name, crf_version_name, warehouse_insert_created_timestamp) values 
					( 'Physical Examination', 
					'V1.0',
					'2015-03-19T16:41:35.717Z');
			
			
			
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS10_101',
									
					'TS10_101_10',
					
				'SE_FIRSTVISIT',
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS10_101',
									
					'TS10_101_10',
					
				'SE_1WEEKFU',
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS10_101',
									
					'TS10_101_10',
					
				'SE_2WEEKFU',
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS10_101',
									
					'TS10_101_10',
					
				'SE_MONTHLYFU',
				1,
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS10_101',
									
					'TS10_101_10',
					
				'SE_MONTHLYFU',
				2,
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS3_101_',
									
					'TS3_101_03',
					
				'SE_FIRSTVISIT',
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS3_101_',
									
					'TS3_101_03',
					
				'SE_1WEEKFU',
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS3_101_',
									
					'TS3_101_03',
					
				'SE_2WEEKFU',
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS6_101_',
									
					'TS6_101_06',
					
				'SE_FIRSTVISIT',
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS10_102',
									
					'TS10_102_10',
					
				'SE_FIRSTVISIT',
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS10_102',
									
					'TS10_102_10',
					
				'SE_1WEEKFU',
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS10_102',
									
					'TS10_102_10',
					
				'SE_2WEEKFU',
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS10_102',
									
					'TS10_102_10',
					
				'SE_MONTHLYFU',
				1,
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS10_102',
									
					'TS10_102_10',
					
				'SE_MONTHLYFU',
				2,
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS1_102_',
									
					'TS1_102_01',
					
				'SE_FIRSTVISIT',
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS1_102_',
									
					'TS1_102_01',
					
				'SE_1WEEKFU',
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS1_102_',
									
					'TS1_102_01',
					
				'SE_2WEEKFU',
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS3_102_',
									
					'TS3_102_03',
					
				'SE_FIRSTVISIT',
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS3_102_',
									
					'TS3_102_03',
					
				'SE_1WEEKFU',
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS3_102_',
									
					'TS3_102_03',
					
				'SE_2WEEKFU',
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS6_102_',
									
					'TS6_102_06',
					
				'SE_FIRSTVISIT',
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS8_102_',
									
					'TS8_102_08',
					
				'SE_FIRSTVISIT',
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS8_102_',
									
					'TS8_102_08',
					
				'SE_1WEEKFU',
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS8_102_',
									
					'TS8_102_08',
					
				'SE_2WEEKFU',
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS8_102_',
									
					'TS8_102_08',
					
				'SE_MONTHLYFU',
				1,
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS8_102_',
									
					'TS8_102_08',
					
				'SE_MONTHLYFU',
				2,
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS10_103',
									
					'TS10_103_10',
					
				'SE_FIRSTVISIT',
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS10_103',
									
					'TS10_103_10',
					
				'SE_1WEEKFU',
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS10_103',
									
					'TS10_103_10',
					
				'SE_2WEEKFU',
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS10_103',
									
					'TS10_103_10',
					
				'SE_MONTHLYFU',
				1,
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS10_103',
									
					'TS10_103_10',
					
				'SE_MONTHLYFU',
				2,
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS1_103_',
									
					'TS1_103_01',
					
				'SE_FIRSTVISIT',
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS1_103_',
									
					'TS1_103_01',
					
				'SE_1WEEKFU',
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS1_103_',
									
					'TS1_103_01',
					
				'SE_2WEEKFU',
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS3_103_',
									
					'TS3_103_03',
					
				'SE_FIRSTVISIT',
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS3_103_',
									
					'TS3_103_03',
					
				'SE_1WEEKFU',
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS3_103_',
									
					'TS3_103_03',
					
				'SE_2WEEKFU',
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS6_103_',
									
					'TS6_103_06',
					
				'SE_FIRSTVISIT',
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS8_103_',
									
					'TS8_103_08',
					
				'SE_FIRSTVISIT',
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS8_103_',
									
					'TS8_103_08',
					
				'SE_1WEEKFU',
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS8_103_',
									
					'TS8_103_08',
					
				'SE_2WEEKFU',
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS8_103_',
									
					'TS8_103_08',
					
				'SE_MONTHLYFU',
				1,
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS8_103_',
									
					'TS8_103_08',
					
				'SE_MONTHLYFU',
				2,
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS10_104',
									
					'TS10_104_10',
					
				'SE_FIRSTVISIT',
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS10_104',
									
					'TS10_104_10',
					
				'SE_1WEEKFU',
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS10_104',
									
					'TS10_104_10',
					
				'SE_2WEEKFU',
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS10_104',
									
					'TS10_104_10',
					
				'SE_MONTHLYFU',
				1,
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS10_104',
									
					'TS10_104_10',
					
				'SE_MONTHLYFU',
				2,
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS1_104_',
									
					'TS1_104_01',
					
				'SE_FIRSTVISIT',
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS1_104_',
									
					'TS1_104_01',
					
				'SE_1WEEKFU',
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS1_104_',
									
					'TS1_104_01',
					
				'SE_2WEEKFU',
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS3_104_',
									
					'TS3_104_03',
					
				'SE_FIRSTVISIT',
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS3_104_',
									
					'TS3_104_03',
					
				'SE_1WEEKFU',
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS3_104_',
									
					'TS3_104_03',
					
				'SE_2WEEKFU',
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS6_104_',
									
					'TS6_104_06',
					
				'SE_FIRSTVISIT',
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS8_104_',
									
					'TS8_104_08',
					
				'SE_FIRSTVISIT',
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS8_104_',
									
					'TS8_104_08',
					
				'SE_1WEEKFU',
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS8_104_',
									
					'TS8_104_08',
					
				'SE_2WEEKFU',
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS8_104_',
									
					'TS8_104_08',
					
				'SE_MONTHLYFU',
				1,
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS8_104_',
									
					'TS8_104_08',
					
				'SE_MONTHLYFU',
				2,
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS13_105',
									
					'TS13_105_13',
					
				'SE_FIRSTVISIT',
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS13_105',
									
					'TS13_105_13',
					
				'SE_1WEEKFU',
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS13_105',
									
					'TS13_105_13',
					
				'SE_2WEEKFU',
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS13_105',
									
					'TS13_105_13',
					
				'SE_MONTHLYFU',
				1,
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS13_105',
									
					'TS13_105_13',
					
				'SE_MONTHLYFU',
				2,
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS2_105_',
									
					'TS2_105_02',
					
				'SE_FIRSTVISIT',
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS2_105_',
									
					'TS2_105_02',
					
				'SE_1WEEKFU',
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS2_105_',
									
					'TS2_105_02',
					
				'SE_2WEEKFU',
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS5_105_',
									
					'TS5_105_05',
					
				'SE_FIRSTVISIT',
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS6_105_',
									
					'TS6_105_06',
					
				'SE_FIRSTVISIT',
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS7_105_',
									
					'TS7_105_07',
					
				'SE_FIRSTVISIT',
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS7_105_',
									
					'TS7_105_07',
					
				'SE_1WEEKFU',
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS7_105_',
									
					'TS7_105_07',
					
				'SE_2WEEKFU',
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS9_105_',
									
					'TS9_105_09',
					
				'SE_FIRSTVISIT',
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS9_105_',
									
					'TS9_105_09',
					
				'SE_1WEEKFU',
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS9_105_',
									
					'TS9_105_09',
					
				'SE_2WEEKFU',
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS9_105_',
									
					'TS9_105_09',
					
				'SE_MONTHLYFU',
				1,
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS9_105_',
									
					'TS9_105_09',
					
				'SE_MONTHLYFU',
				2,
				
				'Physical Examination',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
				create table NCT01928420_All_Data.Physical_ExaminationBody_System (
				item_data_id serial NOT NULL,
				ssoid character varying(40) NOT NULL,
				ssid character varying(40) NOT NULL,
				study_event_oid character varying(40) NOT NULL,
				event_ordinal integer default 1,
				crf_version character varying(255),
				event_start_date timestamp without time zone,
				event_end_date timestamp without time zone,
				event_status character varying(255),
				event_location character varying(2000),
				subject_age_at_event integer,
				crf_status character varying(255), 
				interviewerName character varying(255),
				interviewDate date,
				warehouse_insert_created_timestamp timestamp with time zone); 			          	 
				
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Physical_ExaminationBody_System', 'APPEARANCE', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Physical_ExaminationBody_System', 'APPEARANCE_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Physical_ExaminationBody_System', 'APPEARANCE_COMMENTS', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Physical_ExaminationBody_System', 'SKIN', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Physical_ExaminationBody_System', 'SKIN_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Physical_ExaminationBody_System', 'SKIN_COMMENTS', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Physical_ExaminationBody_System', 'HEENT', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Physical_ExaminationBody_System', 'HEENT_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Physical_ExaminationBody_System', 'HEENT_COMMENTS', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Physical_ExaminationBody_System', 'THYROID', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Physical_ExaminationBody_System', 'THYROID_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Physical_ExaminationBody_System', 'THYROID_COMMENTS', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Physical_ExaminationBody_System', 'CHEST', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Physical_ExaminationBody_System', 'CHEST_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Physical_ExaminationBody_System', 'CHEST_COMMENTS', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Physical_ExaminationBody_System', 'LUNGS', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Physical_ExaminationBody_System', 'LUNGS_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Physical_ExaminationBody_System', 'LUNGS_COMMENTS', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Physical_ExaminationBody_System', 'BREAST', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Physical_ExaminationBody_System', 'BREAST_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Physical_ExaminationBody_System', 'BREASTS_COMMENTS', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Physical_ExaminationBody_System', 'HEART', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Physical_ExaminationBody_System', 'HEART_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Physical_ExaminationBody_System', 'HEART_COMMENTS', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Physical_ExaminationBody_System', 'ABDOMEN', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Physical_ExaminationBody_System', 'ABDOMEN_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Physical_ExaminationBody_System', 'ABDOMEN_COMMENTS', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Physical_ExaminationBody_System', 'MUSCULOSKELETAL', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Physical_ExaminationBody_System', 'MUSCULOSKELETAL_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Physical_ExaminationBody_System', 'MUSCULOSKELETAL_COMMENTS', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Physical_ExaminationBody_System', 'GENITALIA', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Physical_ExaminationBody_System', 'GENITALIA_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Physical_ExaminationBody_System', 'GENITALIA_COMMENTS', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Physical_ExaminationBody_System', 'PELVIS', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Physical_ExaminationBody_System', 'PELVIS_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Physical_ExaminationBody_System', 'PELVIS_COMMENTS', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Physical_ExaminationBody_System', 'RECTAL', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Physical_ExaminationBody_System', 'RECTAL_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Physical_ExaminationBody_System', 'RECTAL_COMMENTS', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Physical_ExaminationBody_System', 'PROSTATE', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Physical_ExaminationBody_System', 'PROSTATE_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Physical_ExaminationBody_System', 'PROSTATE_COMMENTS', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Physical_ExaminationBody_System', 'VASCULAR', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Physical_ExaminationBody_System', 'VASCULAR_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Physical_ExaminationBody_System', 'VASCULAR_COMMENTS', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Physical_ExaminationBody_System', 'NEUROLOGICAL', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Physical_ExaminationBody_System', 'NEUROLOGICAL_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Physical_ExaminationBody_System', 'NEUROLOGICAL_COMMENTS', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Physical_ExaminationBody_System', 'LYMPHNODES', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Physical_ExaminationBody_System', 'LYMPHNODES_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Physical_ExaminationBody_System', 'LYMPHNODES_COMMENTS', 'text');

	
				
		ALTER TABLE NCT01928420_All_Data.Physical_ExaminationBody_System ADD CONSTRAINT Pk_BODY_SYS PRIMARY KEY (item_data_id);

		
				
		ALTER TABLE NCT01928420_All_Data.Physical_ExaminationBody_System ADD CONSTRAINT 	
		Fk_study_subject_id_BODY_SYS FOREIGN KEY (ssoid, 
		ssid) REFERENCES NCT01928420_All_Data.study_subject_listing;
		
				
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS10_101',
									
									'TS10_101_10', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														NEUROLOGICAL_COMMENTS																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS10_101',
									
									'TS10_101_10', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,2													
															,'Abnormal'											
														
															,'MMSE Score High'
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														HEART_COMMENTS																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														NEUROLOGICAL_COMMENTS																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS10_101',
									
									'TS10_101_10', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,2													
															,'Abnormal'											
														
															,'Irregular heartbeat'
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,1													
															,'Normal'											
														
															,2													
															,'Abnormal'											
														
															,'MMSE Score High'
															,99													
															,'Not Examined'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS10_101',
									
									'TS10_101_10', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,1
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS10_101',
									
									'TS10_101_10', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,2
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS3_101_',
									
									'TS3_101_03', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														NEUROLOGICAL_COMMENTS																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS3_101_',
									
									'TS3_101_03', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,2													
															,'Abnormal'											
														
															,'MMSE Score High'
															,99													
															,'Not Examined'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS3_101_',
									
									'TS3_101_03', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS6_101_',
									
									'TS6_101_06', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS10_102',
									
									'TS10_102_10', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														NEUROLOGICAL_COMMENTS																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS10_102',
									
									'TS10_102_10', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,2													
															,'Abnormal'											
														
															,'MMSE Score High'
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														HEART_COMMENTS																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														NEUROLOGICAL_COMMENTS																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS10_102',
									
									'TS10_102_10', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,2													
															,'Abnormal'											
														
															,'Irregular heartbeat'
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,1													
															,'Normal'											
														
															,2													
															,'Abnormal'											
														
															,'MMSE Score High'
															,99													
															,'Not Examined'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS10_102',
									
									'TS10_102_10', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,1
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS10_102',
									
									'TS10_102_10', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,2
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS1_102_',
									
									'TS1_102_01', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														NEUROLOGICAL_COMMENTS																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS1_102_',
									
									'TS1_102_01', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,2													
															,'Abnormal'											
														
															,'MMSE Score High'
															,99													
															,'Not Examined'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS1_102_',
									
									'TS1_102_01', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS3_102_',
									
									'TS3_102_03', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														NEUROLOGICAL_COMMENTS																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS3_102_',
									
									'TS3_102_03', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,2													
															,'Abnormal'											
														
															,'MMSE Score High'
															,99													
															,'Not Examined'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS3_102_',
									
									'TS3_102_03', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS6_102_',
									
									'TS6_102_06', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS8_102_',
									
									'TS8_102_08', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														NEUROLOGICAL_COMMENTS																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS8_102_',
									
									'TS8_102_08', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,2													
															,'Abnormal'											
														
															,'MMSE Score High'
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														HEART_COMMENTS																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														NEUROLOGICAL_COMMENTS																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS8_102_',
									
									'TS8_102_08', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,2													
															,'Abnormal'											
														
															,'Irregular heartbeat'
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,1													
															,'Normal'											
														
															,2													
															,'Abnormal'											
														
															,'MMSE Score High'
															,99													
															,'Not Examined'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS8_102_',
									
									'TS8_102_08', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,1
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS8_102_',
									
									'TS8_102_08', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,2
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS10_103',
									
									'TS10_103_10', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														NEUROLOGICAL_COMMENTS																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS10_103',
									
									'TS10_103_10', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,2													
															,'Abnormal'											
														
															,'MMSE Score High'
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														HEART_COMMENTS																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														NEUROLOGICAL_COMMENTS																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS10_103',
									
									'TS10_103_10', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,2													
															,'Abnormal'											
														
															,'Irregular heartbeat'
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,1													
															,'Normal'											
														
															,2													
															,'Abnormal'											
														
															,'MMSE Score High'
															,99													
															,'Not Examined'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS10_103',
									
									'TS10_103_10', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,1
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS10_103',
									
									'TS10_103_10', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,2
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS1_103_',
									
									'TS1_103_01', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														NEUROLOGICAL_COMMENTS																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS1_103_',
									
									'TS1_103_01', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,2													
															,'Abnormal'											
														
															,'MMSE Score High'
															,99													
															,'Not Examined'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS1_103_',
									
									'TS1_103_01', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS3_103_',
									
									'TS3_103_03', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														NEUROLOGICAL_COMMENTS																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS3_103_',
									
									'TS3_103_03', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,2													
															,'Abnormal'											
														
															,'MMSE Score High'
															,99													
															,'Not Examined'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS3_103_',
									
									'TS3_103_03', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS6_103_',
									
									'TS6_103_06', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS8_103_',
									
									'TS8_103_08', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														NEUROLOGICAL_COMMENTS																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS8_103_',
									
									'TS8_103_08', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,2													
															,'Abnormal'											
														
															,'MMSE Score High'
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														HEART_COMMENTS																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														NEUROLOGICAL_COMMENTS																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS8_103_',
									
									'TS8_103_08', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,2													
															,'Abnormal'											
														
															,'Irregular heartbeat'
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,1													
															,'Normal'											
														
															,2													
															,'Abnormal'											
														
															,'MMSE Score High'
															,99													
															,'Not Examined'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS8_103_',
									
									'TS8_103_08', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,1
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS8_103_',
									
									'TS8_103_08', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,2
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS10_104',
									
									'TS10_104_10', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														NEUROLOGICAL_COMMENTS																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS10_104',
									
									'TS10_104_10', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,2													
															,'Abnormal'											
														
															,'MMSE Score High'
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														HEART_COMMENTS																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														NEUROLOGICAL_COMMENTS																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS10_104',
									
									'TS10_104_10', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,2													
															,'Abnormal'											
														
															,'Irregular heartbeat'
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,1													
															,'Normal'											
														
															,2													
															,'Abnormal'											
														
															,'MMSE Score High'
															,99													
															,'Not Examined'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS10_104',
									
									'TS10_104_10', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,1
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS10_104',
									
									'TS10_104_10', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,2
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS1_104_',
									
									'TS1_104_01', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														NEUROLOGICAL_COMMENTS																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS1_104_',
									
									'TS1_104_01', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,2													
															,'Abnormal'											
														
															,'MMSE Score High'
															,99													
															,'Not Examined'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS1_104_',
									
									'TS1_104_01', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS3_104_',
									
									'TS3_104_03', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														NEUROLOGICAL_COMMENTS																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS3_104_',
									
									'TS3_104_03', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,2													
															,'Abnormal'											
														
															,'MMSE Score High'
															,99													
															,'Not Examined'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS3_104_',
									
									'TS3_104_03', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS6_104_',
									
									'TS6_104_06', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS8_104_',
									
									'TS8_104_08', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														NEUROLOGICAL_COMMENTS																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS8_104_',
									
									'TS8_104_08', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,2													
															,'Abnormal'											
														
															,'MMSE Score High'
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														HEART_COMMENTS																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														NEUROLOGICAL_COMMENTS																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS8_104_',
									
									'TS8_104_08', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,2													
															,'Abnormal'											
														
															,'Irregular heartbeat'
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,1													
															,'Normal'											
														
															,2													
															,'Abnormal'											
														
															,'MMSE Score High'
															,99													
															,'Not Examined'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS8_104_',
									
									'TS8_104_08', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,1
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS8_104_',
									
									'TS8_104_08', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,2
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														SKIN_COMMENTS																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS13_105',
									
									'TS13_105_13', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Normal'											
														
															,2													
															,'Abnormal'											
														
															,'Rash'
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														NEUROLOGICAL_COMMENTS																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS13_105',
									
									'TS13_105_13', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,2													
															,'Abnormal'											
														
															,'MMSE Score High'
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														HEART_COMMENTS																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														NEUROLOGICAL_COMMENTS																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS13_105',
									
									'TS13_105_13', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,2													
															,'Abnormal'											
														
															,'Irregular heartbeat'
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,1													
															,'Normal'											
														
															,2													
															,'Abnormal'											
														
															,'MMSE Score High'
															,99													
															,'Not Examined'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS13_105',
									
									'TS13_105_13', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,1
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS13_105',
									
									'TS13_105_13', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,2
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS2_105_',
									
									'TS2_105_02', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														NEUROLOGICAL_COMMENTS																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS2_105_',
									
									'TS2_105_02', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,2													
															,'Abnormal'											
														
															,'MMSE Score High'
															,99													
															,'Not Examined'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS2_105_',
									
									'TS2_105_02', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														LUNGS_COMMENTS																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS5_105_',
									
									'TS5_105_05', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
														
															,1													
															,'Normal'											
														
															,2													
															,'Abnormal'											
														
															,'Cough'
															,99													
															,'Not Examined'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS6_105_',
									
									'TS6_105_06', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS7_105_',
									
									'TS7_105_07', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														NEUROLOGICAL_COMMENTS																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS7_105_',
									
									'TS7_105_07', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,2													
															,'Abnormal'											
														
															,'MMSE Score High'
															,99													
															,'Not Examined'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS7_105_',
									
									'TS7_105_07', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS9_105_',
									
									'TS9_105_09', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														NEUROLOGICAL_COMMENTS																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS9_105_',
									
									'TS9_105_09', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,2													
															,'Abnormal'											
														
															,'MMSE Score High'
															,1													
															,'Normal'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														HEART_COMMENTS																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														NEUROLOGICAL_COMMENTS																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS9_105_',
									
									'TS9_105_09', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,2													
															,'Abnormal'											
														
															,'Irregular heartbeat'
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,1													
															,'Normal'											
														
															,2													
															,'Abnormal'											
														
															,'MMSE Score High'
															,99													
															,'Not Examined'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS9_105_',
									
									'TS9_105_09', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,1
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,1													
															,'Normal'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
																
									);
										
									insert into NCT01928420_All_Data.Physical_ExaminationBody_System (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														APPEARANCE
																												
																	,APPEARANCE_label																									
																,
																
														
														SKIN
																												
																	,SKIN_label																									
																,
																
														
														HEENT
																												
																	,HEENT_label																									
																,
																
														
														THYROID
																												
																	,THYROID_label																									
																,
																
														
														CHEST
																												
																	,CHEST_label																									
																,
																
														
														LUNGS
																												
																	,LUNGS_label																									
																,
																
														
														BREAST
																												
																	,BREAST_label																									
																,
																
														
														HEART
																												
																	,HEART_label																									
																,
																
														
														ABDOMEN
																												
																	,ABDOMEN_label																									
																,
																
														
														MUSCULOSKELETAL
																												
																	,MUSCULOSKELETAL_label																									
																,
																
														
														GENITALIA
																												
																	,GENITALIA_label																									
																,
																
														
														PELVIS
																												
																	,PELVIS_label																									
																,
																
														
														RECTAL
																												
																	,RECTAL_label																									
																,
																
														
														PROSTATE
																												
																	,PROSTATE_label																									
																,
																
														
														VASCULAR
																												
																	,VASCULAR_label																									
																,
																
														
														NEUROLOGICAL
																												
																	,NEUROLOGICAL_label																									
																,
																
														
														LYMPHNODES
																												
																	,LYMPHNODES_label
										)
									values (
									
									
									'SS_TS9_105_',
									
									'TS9_105_09', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,2
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
														
															,99													
															,'Not Examined'											
																
									);
								
			create table NCT01928420_All_Data.Physical_ExaminationOther_Body_System_Site (		
			item_data_id serial NOT NULL,	
			ssoid character varying(40) NOT NULL,			
			ssid character varying(40) NOT NULL,
			study_event_oid character varying(40) NOT NULL,
			event_ordinal integer default 1,	
			crf_version character varying(255),
			event_start_date timestamp without time zone,
			event_end_date timestamp without time zone,
			event_status character varying(255),
			event_location character varying(2000),
			subject_age_at_event integer,
			crf_status character varying(255), 
			interviewerName character varying(255),
			interviewDate date, 
			item_group_repeat_key integer,
			warehouse_insert_created_timestamp timestamp with time zone);
			
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Physical_ExaminationOther_Body_System_Site', 'OTHERBODYSYSTEM', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Physical_ExaminationOther_Body_System_Site', 'OTHERBODYSYSTEM_STATUS', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Physical_ExaminationOther_Body_System_Site', 'OTHERBODYSYSTEM_STATUS_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Physical_ExaminationOther_Body_System_Site', 'OTHERBODYSYSTEM_COMMENTS', 'text');

	
			ALTER TABLE NCT01928420_All_Data.Physical_ExaminationOther_Body_System_Site ADD CONSTRAINT Pk_OTHER_BO PRIMARY KEY (item_data_id);
	
			ALTER TABLE NCT01928420_All_Data.Physical_ExaminationOther_Body_System_Site ADD CONSTRAINT Fk_study_subject_id_OTHER_BO FOREIGN KEY (ssoid, ssid) REFERENCES NCT01928420_All_Data.study_subject_listing;
				
													
									insert into NCT01928420_All_Data.Physical_ExaminationOther_Body_System_Site (
									ssoid, ssid, study_event_oid 
									
										,event_ordinal
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												OTHERBODYSYSTEM																										
														,
												OTHERBODYSYSTEM_STATUS
																																								
														,OTHERBODYSYSTEM_STATUS_label																										
														,
												OTHERBODYSYSTEM_COMMENTS								
									)
									values (		
									'SS_TS10_101',											
									'TS10_101_10', 									
									'SE_MONTHLYFU'									  
							
										,1
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Cognitive delay'
																,2													
																,'Abnormal'											
															
																,'Unable to answer questions'		
									);									
										
													
									insert into NCT01928420_All_Data.Physical_ExaminationOther_Body_System_Site (
									ssoid, ssid, study_event_oid 
									
										,event_ordinal
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												OTHERBODYSYSTEM																										
														,
												OTHERBODYSYSTEM_STATUS
																																								
														,OTHERBODYSYSTEM_STATUS_label																										
														,
												OTHERBODYSYSTEM_COMMENTS								
									)
									values (		
									'SS_TS10_102',											
									'TS10_102_10', 									
									'SE_MONTHLYFU'									  
							
										,1
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Cognitive delay'
																,2													
																,'Abnormal'											
															
																,'Unable to answer questions'		
									);									
										
													
									insert into NCT01928420_All_Data.Physical_ExaminationOther_Body_System_Site (
									ssoid, ssid, study_event_oid 
									
										,event_ordinal
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												OTHERBODYSYSTEM																										
														,
												OTHERBODYSYSTEM_STATUS
																																								
														,OTHERBODYSYSTEM_STATUS_label																										
														,
												OTHERBODYSYSTEM_COMMENTS								
									)
									values (		
									'SS_TS8_102_',											
									'TS8_102_08', 									
									'SE_MONTHLYFU'									  
							
										,1
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Cognitive delay'
																,2													
																,'Abnormal'											
															
																,'Unable to answer questions'		
									);									
										
													
									insert into NCT01928420_All_Data.Physical_ExaminationOther_Body_System_Site (
									ssoid, ssid, study_event_oid 
									
										,event_ordinal
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												OTHERBODYSYSTEM																										
														,
												OTHERBODYSYSTEM_STATUS
																																								
														,OTHERBODYSYSTEM_STATUS_label																										
														,
												OTHERBODYSYSTEM_COMMENTS								
									)
									values (		
									'SS_TS10_103',											
									'TS10_103_10', 									
									'SE_MONTHLYFU'									  
							
										,1
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Cognitive delay'
																,2													
																,'Abnormal'											
															
																,'Unable to answer questions'		
									);									
										
													
									insert into NCT01928420_All_Data.Physical_ExaminationOther_Body_System_Site (
									ssoid, ssid, study_event_oid 
									
										,event_ordinal
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												OTHERBODYSYSTEM																										
														,
												OTHERBODYSYSTEM_STATUS
																																								
														,OTHERBODYSYSTEM_STATUS_label																										
														,
												OTHERBODYSYSTEM_COMMENTS								
									)
									values (		
									'SS_TS8_103_',											
									'TS8_103_08', 									
									'SE_MONTHLYFU'									  
							
										,1
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Cognitive delay'
																,2													
																,'Abnormal'											
															
																,'Unable to answer questions'		
									);									
										
													
									insert into NCT01928420_All_Data.Physical_ExaminationOther_Body_System_Site (
									ssoid, ssid, study_event_oid 
									
										,event_ordinal
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												OTHERBODYSYSTEM																										
														,
												OTHERBODYSYSTEM_STATUS
																																								
														,OTHERBODYSYSTEM_STATUS_label																										
														,
												OTHERBODYSYSTEM_COMMENTS								
									)
									values (		
									'SS_TS10_104',											
									'TS10_104_10', 									
									'SE_MONTHLYFU'									  
							
										,1
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Cognitive delay'
																,2													
																,'Abnormal'											
															
																,'Unable to answer questions'		
									);									
										
													
									insert into NCT01928420_All_Data.Physical_ExaminationOther_Body_System_Site (
									ssoid, ssid, study_event_oid 
									
										,event_ordinal
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												OTHERBODYSYSTEM																										
														,
												OTHERBODYSYSTEM_STATUS
																																								
														,OTHERBODYSYSTEM_STATUS_label																										
														,
												OTHERBODYSYSTEM_COMMENTS								
									)
									values (		
									'SS_TS8_104_',											
									'TS8_104_08', 									
									'SE_MONTHLYFU'									  
							
										,1
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Cognitive delay'
																,2													
																,'Abnormal'											
															
																,'Unable to answer questions'		
									);									
										
													
									insert into NCT01928420_All_Data.Physical_ExaminationOther_Body_System_Site (
									ssoid, ssid, study_event_oid 
									
										,event_ordinal
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												OTHERBODYSYSTEM																										
														,
												OTHERBODYSYSTEM_STATUS
																																								
														,OTHERBODYSYSTEM_STATUS_label																										
														,
												OTHERBODYSYSTEM_COMMENTS								
									)
									values (		
									'SS_TS13_105',											
									'TS13_105_13', 									
									'SE_MONTHLYFU'									  
							
										,1
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Cognitive delay'
																,2													
																,'Abnormal'											
															
																,'Unable to answer questions'		
									);									
										
													
									insert into NCT01928420_All_Data.Physical_ExaminationOther_Body_System_Site (
									ssoid, ssid, study_event_oid 
									
										,event_ordinal
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												OTHERBODYSYSTEM																										
														,
												OTHERBODYSYSTEM_STATUS
																																								
														,OTHERBODYSYSTEM_STATUS_label																										
														,
												OTHERBODYSYSTEM_COMMENTS								
									)
									values (		
									'SS_TS9_105_',											
									'TS9_105_09', 									
									'SE_MONTHLYFU'									  
							
										,1
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Cognitive delay'
																,2													
																,'Abnormal'											
															
																,'Unable to answer questions'		
									);									
							
			  
			
					insert into NCT01928420_All_Data.crf_version (crf_name, crf_version_name, warehouse_insert_created_timestamp) values 
					( 'Vital Signs', 
					'V1.0',
					'2015-03-19T16:41:35.717Z');
			
			
			
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(	
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(		
				'SS_LUM_01',
									
					'LUM_01',
					
				'SE_FIRSTVISIT',
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(	
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(		
				'SS_LUM_02',
									
					'LUM_02',
					
				'SE_FIRSTVISIT',
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(	
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(		
				'SS_TEST_01',
									
					'Test_01',
					
				'SE_FIRSTVISIT',
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(	
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(		
				'SS_TEST_02',
									
					'Test_02',
					
				'SE_FIRSTVISIT',
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(	
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(		
				'SS_TEST_03',
									
					'Test_03',
					
				'SE_FIRSTVISIT',
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(	
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(		
				'SS_TEST_04',
									
					'Test_04',
					
				'SE_FIRSTVISIT',
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(	
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(		
				'SS_TEST_BEN',
									
					'Test_Ben',
					
				'SE_FIRSTVISIT',
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS10_101',
									
					'TS10_101_10',
					
				'SE_FIRSTVISIT',
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS10_101',
									
					'TS10_101_10',
					
				'SE_1WEEKFU',
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS10_101',
									
					'TS10_101_10',
					
				'SE_2WEEKFU',
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS10_101',
									
					'TS10_101_10',
					
				'SE_MONTHLYFU',
				1,
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS10_101',
									
					'TS10_101_10',
					
				'SE_MONTHLYFU',
				2,
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS3_101_',
									
					'TS3_101_03',
					
				'SE_FIRSTVISIT',
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS3_101_',
									
					'TS3_101_03',
					
				'SE_1WEEKFU',
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS6_101_',
									
					'TS6_101_06',
					
				'SE_FIRSTVISIT',
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS10_102',
									
					'TS10_102_10',
					
				'SE_FIRSTVISIT',
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS10_102',
									
					'TS10_102_10',
					
				'SE_1WEEKFU',
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS10_102',
									
					'TS10_102_10',
					
				'SE_2WEEKFU',
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS10_102',
									
					'TS10_102_10',
					
				'SE_MONTHLYFU',
				1,
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS10_102',
									
					'TS10_102_10',
					
				'SE_MONTHLYFU',
				2,
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS1_102_',
									
					'TS1_102_01',
					
				'SE_FIRSTVISIT',
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS1_102_',
									
					'TS1_102_01',
					
				'SE_1WEEKFU',
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS3_102_',
									
					'TS3_102_03',
					
				'SE_FIRSTVISIT',
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS3_102_',
									
					'TS3_102_03',
					
				'SE_1WEEKFU',
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS6_102_',
									
					'TS6_102_06',
					
				'SE_FIRSTVISIT',
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS8_102_',
									
					'TS8_102_08',
					
				'SE_FIRSTVISIT',
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS8_102_',
									
					'TS8_102_08',
					
				'SE_1WEEKFU',
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS8_102_',
									
					'TS8_102_08',
					
				'SE_2WEEKFU',
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS8_102_',
									
					'TS8_102_08',
					
				'SE_MONTHLYFU',
				1,
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS8_102_',
									
					'TS8_102_08',
					
				'SE_MONTHLYFU',
				2,
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS10_103',
									
					'TS10_103_10',
					
				'SE_FIRSTVISIT',
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS10_103',
									
					'TS10_103_10',
					
				'SE_1WEEKFU',
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS10_103',
									
					'TS10_103_10',
					
				'SE_2WEEKFU',
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS10_103',
									
					'TS10_103_10',
					
				'SE_MONTHLYFU',
				1,
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS10_103',
									
					'TS10_103_10',
					
				'SE_MONTHLYFU',
				2,
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS1_103_',
									
					'TS1_103_01',
					
				'SE_FIRSTVISIT',
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS1_103_',
									
					'TS1_103_01',
					
				'SE_1WEEKFU',
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS3_103_',
									
					'TS3_103_03',
					
				'SE_FIRSTVISIT',
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS3_103_',
									
					'TS3_103_03',
					
				'SE_1WEEKFU',
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS6_103_',
									
					'TS6_103_06',
					
				'SE_FIRSTVISIT',
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS8_103_',
									
					'TS8_103_08',
					
				'SE_FIRSTVISIT',
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS8_103_',
									
					'TS8_103_08',
					
				'SE_1WEEKFU',
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS8_103_',
									
					'TS8_103_08',
					
				'SE_2WEEKFU',
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS8_103_',
									
					'TS8_103_08',
					
				'SE_MONTHLYFU',
				1,
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS8_103_',
									
					'TS8_103_08',
					
				'SE_MONTHLYFU',
				2,
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS10_104',
									
					'TS10_104_10',
					
				'SE_FIRSTVISIT',
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS10_104',
									
					'TS10_104_10',
					
				'SE_1WEEKFU',
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS10_104',
									
					'TS10_104_10',
					
				'SE_2WEEKFU',
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS10_104',
									
					'TS10_104_10',
					
				'SE_MONTHLYFU',
				1,
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS10_104',
									
					'TS10_104_10',
					
				'SE_MONTHLYFU',
				2,
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS1_104_',
									
					'TS1_104_01',
					
				'SE_FIRSTVISIT',
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS1_104_',
									
					'TS1_104_01',
					
				'SE_1WEEKFU',
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS3_104_',
									
					'TS3_104_03',
					
				'SE_FIRSTVISIT',
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS3_104_',
									
					'TS3_104_03',
					
				'SE_1WEEKFU',
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS6_104_',
									
					'TS6_104_06',
					
				'SE_FIRSTVISIT',
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS8_104_',
									
					'TS8_104_08',
					
				'SE_FIRSTVISIT',
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS8_104_',
									
					'TS8_104_08',
					
				'SE_1WEEKFU',
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS8_104_',
									
					'TS8_104_08',
					
				'SE_2WEEKFU',
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS8_104_',
									
					'TS8_104_08',
					
				'SE_MONTHLYFU',
				1,
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS8_104_',
									
					'TS8_104_08',
					
				'SE_MONTHLYFU',
				2,
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS1_105_',
									
					'TS1_105_01',
					
				'SE_FIRSTVISIT',
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS13_105',
									
					'TS13_105_13',
					
				'SE_FIRSTVISIT',
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS13_105',
									
					'TS13_105_13',
					
				'SE_1WEEKFU',
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS13_105',
									
					'TS13_105_13',
					
				'SE_2WEEKFU',
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS13_105',
									
					'TS13_105_13',
					
				'SE_MONTHLYFU',
				1,
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS13_105',
									
					'TS13_105_13',
					
				'SE_MONTHLYFU',
				2,
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS2_105_',
									
					'TS2_105_02',
					
				'SE_FIRSTVISIT',
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS2_105_',
									
					'TS2_105_02',
					
				'SE_1WEEKFU',
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS5_105_',
									
					'TS5_105_05',
					
				'SE_FIRSTVISIT',
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS6_105_',
									
					'TS6_105_06',
					
				'SE_FIRSTVISIT',
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS7_105_',
									
					'TS7_105_07',
					
				'SE_FIRSTVISIT',
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS7_105_',
									
					'TS7_105_07',
					
				'SE_1WEEKFU',
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS9_105_',
									
					'TS9_105_09',
					
				'SE_FIRSTVISIT',
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS9_105_',
									
					'TS9_105_09',
					
				'SE_1WEEKFU',
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS9_105_',
									
					'TS9_105_09',
					
				'SE_2WEEKFU',
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS9_105_',
									
					'TS9_105_09',
					
				'SE_MONTHLYFU',
				1,
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS9_105_',
									
					'TS9_105_09',
					
				'SE_MONTHLYFU',
				2,
				
				'Vital Signs',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
				create table NCT01928420_All_Data.Vital_SignsVitals (
				item_data_id serial NOT NULL,
				ssoid character varying(40) NOT NULL,
				ssid character varying(40) NOT NULL,
				study_event_oid character varying(40) NOT NULL,
				event_ordinal integer default 1,
				crf_version character varying(255),
				event_start_date timestamp without time zone,
				event_end_date timestamp without time zone,
				event_status character varying(255),
				event_location character varying(2000),
				subject_age_at_event integer,
				crf_status character varying(255), 
				interviewerName character varying(255),
				interviewDate date,
				warehouse_insert_created_timestamp timestamp with time zone); 			          	 
				
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Vital_SignsVitals', 'VS_TEMP', 'float');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Vital_SignsVitals', 'VS_TUNIT', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Vital_SignsVitals', 'VS_TUNIT_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Vital_SignsVitals', 'VS_HGHT', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Vital_SignsVitals', 'VS_WGHT', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Vital_SignsVitals', 'VS_UNITS', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Vital_SignsVitals', 'VS_UNITS_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Vital_SignsVitals', 'VS_BMI', 'float');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Vital_SignsVitals', 'VS_BPHR', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Vital_SignsVitals', 'VS_BPHR_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Vital_SignsVitals', 'VS_AVSYS', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Vital_SignsVitals', 'VS_AVDIA', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Vital_SignsVitals', 'VS_AVHR', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Vital_SignsVitals', 'VS_COMM', 'text');

	
				
		ALTER TABLE NCT01928420_All_Data.Vital_SignsVitals ADD CONSTRAINT Pk_VITALS PRIMARY KEY (item_data_id);

		
				
		ALTER TABLE NCT01928420_All_Data.Vital_SignsVitals ADD CONSTRAINT 	
		Fk_study_subject_id_VITALS FOREIGN KEY (ssoid, 
		ssid) REFERENCES NCT01928420_All_Data.study_subject_listing;
		
				
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label
										)
									values (
									
									
									'SS_LUM_01',
									
									'LUM_01', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,37
															,2													
															,'Fahrenheit'											
																
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_AVSYS																									
																,
																
														
														VS_AVDIA																									
																,
																
														
														VS_AVHR
										)
									values (
									
									
									'SS_LUM_02',
									
									'LUM_02', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.6
															,2													
															,'Fahrenheit'											
														
															,60
															,120
															,1													
															,'lbs/inches'											
														
															,23.4
															,1													
															,'Yes'											
														
															,120
															,80
															,60		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label
										)
									values (
									
									
									'SS_TEST_01',
									
									'Test_01', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,37
															,1													
															,'Celsius'											
														
															,60
															,120
															,1													
															,'lbs/inches'											
														
															,23.4
															,1													
															,'Yes'											
																
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_AVSYS																									
																,
																
														
														VS_AVDIA																									
																,
																
														
														VS_AVHR
										)
									values (
									
									
									'SS_TEST_02',
									
									'Test_02', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,102
															,2													
															,'Fahrenheit'											
														
															,70
															,180
															,1													
															,'lbs/inches'											
														
															,25.8
															,1													
															,'Yes'											
														
															,120
															,80
															,60		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_AVSYS																									
																,
																
														
														VS_AVDIA																									
																,
																
														
														VS_AVHR
										)
									values (
									
									
									'SS_TEST_03',
									
									'Test_03', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,101
															,2													
															,'Fahrenheit'											
														
															,70
															,200
															,1													
															,'lbs/inches'											
														
															,28.7
															,1													
															,'Yes'											
														
															,120
															,80
															,60		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_AVSYS																									
																,
																
														
														VS_AVDIA																									
																,
																
														
														VS_AVHR
										)
									values (
									
									
									'SS_TEST_04',
									
									'Test_04', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,101
															,2													
															,'Fahrenheit'											
														
															,60
															,120
															,1													
															,'lbs/inches'											
														
															,23.4
															,1													
															,'Yes'											
														
															,120
															,80
															,60		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_AVSYS																									
																,
																
														
														VS_AVDIA																									
																,
																
														
														VS_AVHR
										)
									values (
									
									
									'SS_TEST_BEN',
									
									'Test_Ben', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,101
															,2													
															,'Fahrenheit'											
														
															,60
															,120
															,1													
															,'lbs/inches'											
														
															,23.4
															,1													
															,'Yes'											
														
															,120
															,80
															,60		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_COMM
										)
									values (
									
									
									'SS_TS10_101',
									
									'TS10_101_10', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.6
															,2													
															,'Fahrenheit'											
														
															,63
															,130
															,1													
															,'lbs/inches'											
														
															,23
															,2													
															,'No'											
														
															,'None'		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_COMM
										)
									values (
									
									
									'SS_TS10_101',
									
									'TS10_101_10', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.6
															,2													
															,'Fahrenheit'											
														
															,63
															,130
															,1													
															,'lbs/inches'											
														
															,23
															,2													
															,'No'											
														
															,'None'		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_COMM
										)
									values (
									
									
									'SS_TS10_101',
									
									'TS10_101_10', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.6
															,2													
															,'Fahrenheit'											
														
															,63
															,130
															,1													
															,'lbs/inches'											
														
															,23
															,2													
															,'No'											
														
															,'None.'		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_AVSYS																									
																,
																
														
														VS_AVDIA																									
																,
																
														
														VS_AVHR																									
																,
																
														
														VS_COMM
										)
									values (
									
									
									'SS_TS10_101',
									
									'TS10_101_10', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,1
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.6
															,2													
															,'Fahrenheit'											
														
															,63
															,138
															,1													
															,'lbs/inches'											
														
															,24.4
															,1													
															,'Yes'											
														
															,110
															,90
															,70
															,'None'		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_AVSYS																									
																,
																
														
														VS_AVDIA																									
																,
																
														
														VS_AVHR																									
																,
																
														
														VS_COMM
										)
									values (
									
									
									'SS_TS10_101',
									
									'TS10_101_10', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,2
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.6
															,2													
															,'Fahrenheit'											
														
															,63
															,138
															,1													
															,'lbs/inches'											
														
															,24.4
															,1													
															,'Yes'											
														
															,110
															,90
															,71
															,'None.'		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_AVSYS																									
																,
																
														
														VS_AVDIA																									
																,
																
														
														VS_AVHR																									
																,
																
														
														VS_COMM
										)
									values (
									
									
									'SS_TS3_101_',
									
									'TS3_101_03', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.7
															,2													
															,'Fahrenheit'											
														
															,69
															,140
															,1													
															,'lbs/inches'											
														
															,20.7
															,1													
															,'Yes'											
														
															,114
															,90
															,69
															,'None.'		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_AVSYS																									
																,
																
														
														VS_AVDIA																									
																,
																
														
														VS_AVHR																									
																,
																
														
														VS_COMM
										)
									values (
									
									
									'SS_TS3_101_',
									
									'TS3_101_03', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.6
															,2													
															,'Fahrenheit'											
														
															,69
															,140
															,1													
															,'lbs/inches'											
														
															,20.7
															,1													
															,'Yes'											
														
															,114
															,97
															,71
															,'None.'		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label
										)
									values (
									
									
									'SS_TS6_101_',
									
									'TS6_101_06', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.6
															,2													
															,'Fahrenheit'											
														
															,72
															,150
															,1													
															,'lbs/inches'											
														
															,20.3
															,2													
															,'No'											
																
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_COMM
										)
									values (
									
									
									'SS_TS10_102',
									
									'TS10_102_10', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.6
															,2													
															,'Fahrenheit'											
														
															,63
															,130
															,1													
															,'lbs/inches'											
														
															,23
															,2													
															,'No'											
														
															,'None'		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_COMM
										)
									values (
									
									
									'SS_TS10_102',
									
									'TS10_102_10', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.6
															,2													
															,'Fahrenheit'											
														
															,63
															,130
															,1													
															,'lbs/inches'											
														
															,23
															,2													
															,'No'											
														
															,'None'		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_COMM
										)
									values (
									
									
									'SS_TS10_102',
									
									'TS10_102_10', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.6
															,2													
															,'Fahrenheit'											
														
															,63
															,130
															,1													
															,'lbs/inches'											
														
															,23
															,2													
															,'No'											
														
															,'None.'		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_AVSYS																									
																,
																
														
														VS_AVDIA																									
																,
																
														
														VS_AVHR																									
																,
																
														
														VS_COMM
										)
									values (
									
									
									'SS_TS10_102',
									
									'TS10_102_10', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,1
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.6
															,2													
															,'Fahrenheit'											
														
															,63
															,138
															,1													
															,'lbs/inches'											
														
															,24.4
															,1													
															,'Yes'											
														
															,110
															,90
															,70
															,'None'		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_AVSYS																									
																,
																
														
														VS_AVDIA																									
																,
																
														
														VS_AVHR																									
																,
																
														
														VS_COMM
										)
									values (
									
									
									'SS_TS10_102',
									
									'TS10_102_10', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,2
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.6
															,2													
															,'Fahrenheit'											
														
															,63
															,138
															,1													
															,'lbs/inches'											
														
															,24.4
															,1													
															,'Yes'											
														
															,110
															,90
															,71
															,'None.'		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_AVSYS																									
																,
																
														
														VS_AVDIA																									
																,
																
														
														VS_AVHR																									
																,
																
														
														VS_COMM
										)
									values (
									
									
									'SS_TS1_102_',
									
									'TS1_102_01', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.7
															,2													
															,'Fahrenheit'											
														
															,69
															,140
															,1													
															,'lbs/inches'											
														
															,20.7
															,1													
															,'Yes'											
														
															,114
															,90
															,69
															,'None.'		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_AVSYS																									
																,
																
														
														VS_AVDIA																									
																,
																
														
														VS_AVHR																									
																,
																
														
														VS_COMM
										)
									values (
									
									
									'SS_TS1_102_',
									
									'TS1_102_01', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.6
															,2													
															,'Fahrenheit'											
														
															,69
															,140
															,1													
															,'lbs/inches'											
														
															,20.7
															,1													
															,'Yes'											
														
															,114
															,97
															,71
															,'None.'		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_AVSYS																									
																,
																
														
														VS_AVDIA																									
																,
																
														
														VS_AVHR																									
																,
																
														
														VS_COMM
										)
									values (
									
									
									'SS_TS3_102_',
									
									'TS3_102_03', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.7
															,2													
															,'Fahrenheit'											
														
															,69
															,140
															,1													
															,'lbs/inches'											
														
															,20.7
															,1													
															,'Yes'											
														
															,114
															,90
															,69
															,'None.'		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_AVSYS																									
																,
																
														
														VS_AVDIA																									
																,
																
														
														VS_AVHR																									
																,
																
														
														VS_COMM
										)
									values (
									
									
									'SS_TS3_102_',
									
									'TS3_102_03', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.6
															,2													
															,'Fahrenheit'											
														
															,69
															,140
															,1													
															,'lbs/inches'											
														
															,20.7
															,1													
															,'Yes'											
														
															,114
															,97
															,71
															,'None.'		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label
										)
									values (
									
									
									'SS_TS6_102_',
									
									'TS6_102_06', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.6
															,2													
															,'Fahrenheit'											
														
															,72
															,150
															,1													
															,'lbs/inches'											
														
															,20.3
															,2													
															,'No'											
																
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_COMM
										)
									values (
									
									
									'SS_TS8_102_',
									
									'TS8_102_08', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.6
															,2													
															,'Fahrenheit'											
														
															,63
															,130
															,1													
															,'lbs/inches'											
														
															,23
															,2													
															,'No'											
														
															,'None'		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_COMM
										)
									values (
									
									
									'SS_TS8_102_',
									
									'TS8_102_08', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.6
															,2													
															,'Fahrenheit'											
														
															,63
															,130
															,1													
															,'lbs/inches'											
														
															,23
															,2													
															,'No'											
														
															,'None'		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_COMM
										)
									values (
									
									
									'SS_TS8_102_',
									
									'TS8_102_08', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.6
															,2													
															,'Fahrenheit'											
														
															,63
															,130
															,1													
															,'lbs/inches'											
														
															,23
															,2													
															,'No'											
														
															,'None.'		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_AVSYS																									
																,
																
														
														VS_AVDIA																									
																,
																
														
														VS_AVHR																									
																,
																
														
														VS_COMM
										)
									values (
									
									
									'SS_TS8_102_',
									
									'TS8_102_08', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,1
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.6
															,2													
															,'Fahrenheit'											
														
															,63
															,138
															,1													
															,'lbs/inches'											
														
															,24.4
															,1													
															,'Yes'											
														
															,110
															,90
															,70
															,'None'		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_AVSYS																									
																,
																
														
														VS_AVDIA																									
																,
																
														
														VS_AVHR																									
																,
																
														
														VS_COMM
										)
									values (
									
									
									'SS_TS8_102_',
									
									'TS8_102_08', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,2
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.6
															,2													
															,'Fahrenheit'											
														
															,63
															,138
															,1													
															,'lbs/inches'											
														
															,24.4
															,1													
															,'Yes'											
														
															,110
															,90
															,71
															,'None.'		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_COMM
										)
									values (
									
									
									'SS_TS10_103',
									
									'TS10_103_10', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.6
															,2													
															,'Fahrenheit'											
														
															,63
															,130
															,1													
															,'lbs/inches'											
														
															,23
															,2													
															,'No'											
														
															,'None'		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_COMM
										)
									values (
									
									
									'SS_TS10_103',
									
									'TS10_103_10', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.6
															,2													
															,'Fahrenheit'											
														
															,63
															,130
															,1													
															,'lbs/inches'											
														
															,23
															,2													
															,'No'											
														
															,'None'		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_COMM
										)
									values (
									
									
									'SS_TS10_103',
									
									'TS10_103_10', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.6
															,2													
															,'Fahrenheit'											
														
															,63
															,130
															,1													
															,'lbs/inches'											
														
															,23
															,2													
															,'No'											
														
															,'None.'		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_AVSYS																									
																,
																
														
														VS_AVDIA																									
																,
																
														
														VS_AVHR																									
																,
																
														
														VS_COMM
										)
									values (
									
									
									'SS_TS10_103',
									
									'TS10_103_10', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,1
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.6
															,2													
															,'Fahrenheit'											
														
															,63
															,138
															,1													
															,'lbs/inches'											
														
															,24.4
															,1													
															,'Yes'											
														
															,110
															,90
															,70
															,'None'		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_AVSYS																									
																,
																
														
														VS_AVDIA																									
																,
																
														
														VS_AVHR																									
																,
																
														
														VS_COMM
										)
									values (
									
									
									'SS_TS10_103',
									
									'TS10_103_10', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,2
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.6
															,2													
															,'Fahrenheit'											
														
															,63
															,138
															,1													
															,'lbs/inches'											
														
															,24.4
															,1													
															,'Yes'											
														
															,110
															,90
															,71
															,'None.'		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_AVSYS																									
																,
																
														
														VS_AVDIA																									
																,
																
														
														VS_AVHR																									
																,
																
														
														VS_COMM
										)
									values (
									
									
									'SS_TS1_103_',
									
									'TS1_103_01', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.7
															,2													
															,'Fahrenheit'											
														
															,69
															,140
															,1													
															,'lbs/inches'											
														
															,20.7
															,1													
															,'Yes'											
														
															,114
															,90
															,69
															,'None.'		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_AVSYS																									
																,
																
														
														VS_AVDIA																									
																,
																
														
														VS_AVHR																									
																,
																
														
														VS_COMM
										)
									values (
									
									
									'SS_TS1_103_',
									
									'TS1_103_01', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.6
															,2													
															,'Fahrenheit'											
														
															,69
															,140
															,1													
															,'lbs/inches'											
														
															,20.7
															,1													
															,'Yes'											
														
															,114
															,97
															,71
															,'None.'		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_AVSYS																									
																,
																
														
														VS_AVDIA																									
																,
																
														
														VS_AVHR																									
																,
																
														
														VS_COMM
										)
									values (
									
									
									'SS_TS3_103_',
									
									'TS3_103_03', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.7
															,2													
															,'Fahrenheit'											
														
															,69
															,140
															,1													
															,'lbs/inches'											
														
															,20.7
															,1													
															,'Yes'											
														
															,114
															,90
															,69
															,'None.'		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_AVSYS																									
																,
																
														
														VS_AVDIA																									
																,
																
														
														VS_AVHR																									
																,
																
														
														VS_COMM
										)
									values (
									
									
									'SS_TS3_103_',
									
									'TS3_103_03', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.6
															,2													
															,'Fahrenheit'											
														
															,69
															,140
															,1													
															,'lbs/inches'											
														
															,20.7
															,1													
															,'Yes'											
														
															,114
															,97
															,71
															,'None.'		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label
										)
									values (
									
									
									'SS_TS6_103_',
									
									'TS6_103_06', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.6
															,2													
															,'Fahrenheit'											
														
															,72
															,150
															,1													
															,'lbs/inches'											
														
															,20.3
															,2													
															,'No'											
																
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_COMM
										)
									values (
									
									
									'SS_TS8_103_',
									
									'TS8_103_08', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.6
															,2													
															,'Fahrenheit'											
														
															,63
															,130
															,1													
															,'lbs/inches'											
														
															,23
															,2													
															,'No'											
														
															,'None'		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_COMM
										)
									values (
									
									
									'SS_TS8_103_',
									
									'TS8_103_08', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.6
															,2													
															,'Fahrenheit'											
														
															,63
															,130
															,1													
															,'lbs/inches'											
														
															,23
															,2													
															,'No'											
														
															,'None'		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_COMM
										)
									values (
									
									
									'SS_TS8_103_',
									
									'TS8_103_08', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.6
															,2													
															,'Fahrenheit'											
														
															,63
															,130
															,1													
															,'lbs/inches'											
														
															,23
															,2													
															,'No'											
														
															,'None.'		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_AVSYS																									
																,
																
														
														VS_AVDIA																									
																,
																
														
														VS_AVHR																									
																,
																
														
														VS_COMM
										)
									values (
									
									
									'SS_TS8_103_',
									
									'TS8_103_08', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,1
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.6
															,2													
															,'Fahrenheit'											
														
															,63
															,138
															,1													
															,'lbs/inches'											
														
															,24.4
															,1													
															,'Yes'											
														
															,110
															,90
															,70
															,'None'		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_AVSYS																									
																,
																
														
														VS_AVDIA																									
																,
																
														
														VS_AVHR																									
																,
																
														
														VS_COMM
										)
									values (
									
									
									'SS_TS8_103_',
									
									'TS8_103_08', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,2
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.6
															,2													
															,'Fahrenheit'											
														
															,63
															,138
															,1													
															,'lbs/inches'											
														
															,24.4
															,1													
															,'Yes'											
														
															,110
															,90
															,71
															,'None.'		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_COMM
										)
									values (
									
									
									'SS_TS10_104',
									
									'TS10_104_10', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.6
															,2													
															,'Fahrenheit'											
														
															,63
															,130
															,1													
															,'lbs/inches'											
														
															,23
															,2													
															,'No'											
														
															,'None'		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_COMM
										)
									values (
									
									
									'SS_TS10_104',
									
									'TS10_104_10', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.6
															,2													
															,'Fahrenheit'											
														
															,63
															,130
															,1													
															,'lbs/inches'											
														
															,23
															,2													
															,'No'											
														
															,'None'		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_COMM
										)
									values (
									
									
									'SS_TS10_104',
									
									'TS10_104_10', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.6
															,2													
															,'Fahrenheit'											
														
															,63
															,130
															,1													
															,'lbs/inches'											
														
															,23
															,2													
															,'No'											
														
															,'None.'		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_AVSYS																									
																,
																
														
														VS_AVDIA																									
																,
																
														
														VS_AVHR																									
																,
																
														
														VS_COMM
										)
									values (
									
									
									'SS_TS10_104',
									
									'TS10_104_10', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,1
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.6
															,2													
															,'Fahrenheit'											
														
															,63
															,138
															,1													
															,'lbs/inches'											
														
															,24.4
															,1													
															,'Yes'											
														
															,110
															,90
															,70
															,'None'		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_AVSYS																									
																,
																
														
														VS_AVDIA																									
																,
																
														
														VS_AVHR																									
																,
																
														
														VS_COMM
										)
									values (
									
									
									'SS_TS10_104',
									
									'TS10_104_10', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,2
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.6
															,2													
															,'Fahrenheit'											
														
															,63
															,138
															,1													
															,'lbs/inches'											
														
															,24.4
															,1													
															,'Yes'											
														
															,110
															,90
															,71
															,'None.'		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_AVSYS																									
																,
																
														
														VS_AVDIA																									
																,
																
														
														VS_AVHR																									
																,
																
														
														VS_COMM
										)
									values (
									
									
									'SS_TS1_104_',
									
									'TS1_104_01', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.7
															,2													
															,'Fahrenheit'											
														
															,69
															,140
															,1													
															,'lbs/inches'											
														
															,20.7
															,1													
															,'Yes'											
														
															,114
															,90
															,69
															,'None.'		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_AVSYS																									
																,
																
														
														VS_AVDIA																									
																,
																
														
														VS_AVHR																									
																,
																
														
														VS_COMM
										)
									values (
									
									
									'SS_TS1_104_',
									
									'TS1_104_01', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.6
															,2													
															,'Fahrenheit'											
														
															,69
															,140
															,1													
															,'lbs/inches'											
														
															,20.7
															,1													
															,'Yes'											
														
															,114
															,97
															,71
															,'None.'		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_AVSYS																									
																,
																
														
														VS_AVDIA																									
																,
																
														
														VS_AVHR																									
																,
																
														
														VS_COMM
										)
									values (
									
									
									'SS_TS3_104_',
									
									'TS3_104_03', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.7
															,2													
															,'Fahrenheit'											
														
															,69
															,140
															,1													
															,'lbs/inches'											
														
															,20.7
															,1													
															,'Yes'											
														
															,114
															,90
															,69
															,'None.'		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_AVSYS																									
																,
																
														
														VS_AVDIA																									
																,
																
														
														VS_AVHR																									
																,
																
														
														VS_COMM
										)
									values (
									
									
									'SS_TS3_104_',
									
									'TS3_104_03', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.6
															,2													
															,'Fahrenheit'											
														
															,69
															,140
															,1													
															,'lbs/inches'											
														
															,20.7
															,1													
															,'Yes'											
														
															,114
															,97
															,71
															,'None.'		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label
										)
									values (
									
									
									'SS_TS6_104_',
									
									'TS6_104_06', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.6
															,2													
															,'Fahrenheit'											
														
															,72
															,150
															,1													
															,'lbs/inches'											
														
															,20.3
															,2													
															,'No'											
																
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_COMM
										)
									values (
									
									
									'SS_TS8_104_',
									
									'TS8_104_08', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.6
															,2													
															,'Fahrenheit'											
														
															,63
															,130
															,1													
															,'lbs/inches'											
														
															,23
															,2													
															,'No'											
														
															,'None'		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_COMM
										)
									values (
									
									
									'SS_TS8_104_',
									
									'TS8_104_08', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.6
															,2													
															,'Fahrenheit'											
														
															,63
															,130
															,1													
															,'lbs/inches'											
														
															,23
															,2													
															,'No'											
														
															,'None'		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_COMM
										)
									values (
									
									
									'SS_TS8_104_',
									
									'TS8_104_08', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.6
															,2													
															,'Fahrenheit'											
														
															,63
															,130
															,1													
															,'lbs/inches'											
														
															,23
															,2													
															,'No'											
														
															,'None.'		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_AVSYS																									
																,
																
														
														VS_AVDIA																									
																,
																
														
														VS_AVHR																									
																,
																
														
														VS_COMM
										)
									values (
									
									
									'SS_TS8_104_',
									
									'TS8_104_08', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,1
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.6
															,2													
															,'Fahrenheit'											
														
															,63
															,138
															,1													
															,'lbs/inches'											
														
															,24.4
															,1													
															,'Yes'											
														
															,110
															,90
															,70
															,'None'		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_AVSYS																									
																,
																
														
														VS_AVDIA																									
																,
																
														
														VS_AVHR																									
																,
																
														
														VS_COMM
										)
									values (
									
									
									'SS_TS8_104_',
									
									'TS8_104_08', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,2
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.6
															,2													
															,'Fahrenheit'											
														
															,63
															,138
															,1													
															,'lbs/inches'											
														
															,24.4
															,1													
															,'Yes'											
														
															,110
															,90
															,71
															,'None.'		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT
										)
									values (
									
									
									'SS_TS1_105_',
									
									'TS1_105_01', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,37
															,1													
															,'Celsius'											
														
															,60
															,120		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_COMM
										)
									values (
									
									
									'SS_TS13_105',
									
									'TS13_105_13', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.6
															,2													
															,'Fahrenheit'											
														
															,63
															,130
															,1													
															,'lbs/inches'											
														
															,23
															,2													
															,'No'											
														
															,'None'		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_COMM
										)
									values (
									
									
									'SS_TS13_105',
									
									'TS13_105_13', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.6
															,2													
															,'Fahrenheit'											
														
															,63
															,130
															,1													
															,'lbs/inches'											
														
															,23
															,2													
															,'No'											
														
															,'None'		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_COMM
										)
									values (
									
									
									'SS_TS13_105',
									
									'TS13_105_13', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.6
															,2													
															,'Fahrenheit'											
														
															,63
															,130
															,1													
															,'lbs/inches'											
														
															,23
															,2													
															,'No'											
														
															,'None.'		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_AVSYS																									
																,
																
														
														VS_AVDIA																									
																,
																
														
														VS_AVHR																									
																,
																
														
														VS_COMM
										)
									values (
									
									
									'SS_TS13_105',
									
									'TS13_105_13', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,1
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.6
															,2													
															,'Fahrenheit'											
														
															,63
															,138
															,1													
															,'lbs/inches'											
														
															,24.4
															,1													
															,'Yes'											
														
															,110
															,90
															,70
															,'None'		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_AVSYS																									
																,
																
														
														VS_AVDIA																									
																,
																
														
														VS_AVHR																									
																,
																
														
														VS_COMM
										)
									values (
									
									
									'SS_TS13_105',
									
									'TS13_105_13', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,2
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.6
															,2													
															,'Fahrenheit'											
														
															,63
															,138
															,1													
															,'lbs/inches'											
														
															,24.4
															,1													
															,'Yes'											
														
															,110
															,90
															,71
															,'None.'		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_AVSYS																									
																,
																
														
														VS_AVDIA																									
																,
																
														
														VS_AVHR																									
																,
																
														
														VS_COMM
										)
									values (
									
									
									'SS_TS2_105_',
									
									'TS2_105_02', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.7
															,2													
															,'Fahrenheit'											
														
															,69
															,140
															,1													
															,'lbs/inches'											
														
															,20.7
															,1													
															,'Yes'											
														
															,114
															,90
															,69
															,'None.'		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_AVSYS																									
																,
																
														
														VS_AVDIA																									
																,
																
														
														VS_AVHR																									
																,
																
														
														VS_COMM
										)
									values (
									
									
									'SS_TS2_105_',
									
									'TS2_105_02', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.6
															,2													
															,'Fahrenheit'											
														
															,69
															,140
															,1													
															,'lbs/inches'											
														
															,20.7
															,1													
															,'Yes'											
														
															,114
															,97
															,71
															,'None.'		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label
										)
									values (
									
									
									'SS_TS5_105_',
									
									'TS5_105_05', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,37
															,1													
															,'Celsius'											
														
															,182
															,90
															,2													
															,'cm/kg'											
														
															,27.2
															,2													
															,'No'											
																
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label
										)
									values (
									
									
									'SS_TS6_105_',
									
									'TS6_105_06', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.6
															,2													
															,'Fahrenheit'											
														
															,72
															,150
															,1													
															,'lbs/inches'											
														
															,20.3
															,2													
															,'No'											
																
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_AVSYS																									
																,
																
														
														VS_AVDIA																									
																,
																
														
														VS_AVHR																									
																,
																
														
														VS_COMM
										)
									values (
									
									
									'SS_TS7_105_',
									
									'TS7_105_07', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.7
															,2													
															,'Fahrenheit'											
														
															,69
															,140
															,1													
															,'lbs/inches'											
														
															,20.7
															,1													
															,'Yes'											
														
															,114
															,90
															,69
															,'None.'		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_AVSYS																									
																,
																
														
														VS_AVDIA																									
																,
																
														
														VS_AVHR																									
																,
																
														
														VS_COMM
										)
									values (
									
									
									'SS_TS7_105_',
									
									'TS7_105_07', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.6
															,2													
															,'Fahrenheit'											
														
															,69
															,140
															,1													
															,'lbs/inches'											
														
															,20.7
															,1													
															,'Yes'											
														
															,114
															,97
															,71
															,'None.'		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_COMM
										)
									values (
									
									
									'SS_TS9_105_',
									
									'TS9_105_09', 	 									
									
									'SE_FIRSTVISIT' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.6
															,2													
															,'Fahrenheit'											
														
															,63
															,130
															,1													
															,'lbs/inches'											
														
															,23
															,2													
															,'No'											
														
															,'None'		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_COMM
										)
									values (
									
									
									'SS_TS9_105_',
									
									'TS9_105_09', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.6
															,2													
															,'Fahrenheit'											
														
															,63
															,130
															,1													
															,'lbs/inches'											
														
															,23
															,2													
															,'No'											
														
															,'None'		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_COMM
										)
									values (
									
									
									'SS_TS9_105_',
									
									'TS9_105_09', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.6
															,2													
															,'Fahrenheit'											
														
															,63
															,130
															,1													
															,'lbs/inches'											
														
															,23
															,2													
															,'No'											
														
															,'None.'		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_AVSYS																									
																,
																
														
														VS_AVDIA																									
																,
																
														
														VS_AVHR																									
																,
																
														
														VS_COMM
										)
									values (
									
									
									'SS_TS9_105_',
									
									'TS9_105_09', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,1
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.6
															,2													
															,'Fahrenheit'											
														
															,63
															,138
															,1													
															,'lbs/inches'											
														
															,24.4
															,1													
															,'Yes'											
														
															,110
															,90
															,70
															,'None'		
									);
										
									insert into NCT01928420_All_Data.Vital_SignsVitals (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														VS_TEMP																									
																,
																
														
														VS_TUNIT
																												
																	,VS_TUNIT_label																									
																,
																
														
														VS_HGHT																									
																,
																
														
														VS_WGHT																									
																,
																
														
														VS_UNITS
																												
																	,VS_UNITS_label																									
																,
																
														
														VS_BMI																									
																,
																
														
														VS_BPHR
																												
																	,VS_BPHR_label																									
																,
																
														
														VS_AVSYS																									
																,
																
														
														VS_AVDIA																									
																,
																
														
														VS_AVHR																									
																,
																
														
														VS_COMM
										)
									values (
									
									
									'SS_TS9_105_',
									
									'TS9_105_09', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,2
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,98.6
															,2													
															,'Fahrenheit'											
														
															,63
															,138
															,1													
															,'lbs/inches'											
														
															,24.4
															,1													
															,'Yes'											
														
															,110
															,90
															,71
															,'None.'		
									);
								
			create table NCT01928420_All_Data.Vital_SignsBP_Log (		
			item_data_id serial NOT NULL,	
			ssoid character varying(40) NOT NULL,			
			ssid character varying(40) NOT NULL,
			study_event_oid character varying(40) NOT NULL,
			event_ordinal integer default 1,	
			crf_version character varying(255),
			event_start_date timestamp without time zone,
			event_end_date timestamp without time zone,
			event_status character varying(255),
			event_location character varying(2000),
			subject_age_at_event integer,
			crf_status character varying(255), 
			interviewerName character varying(255),
			interviewDate date, 
			item_group_repeat_key integer,
			warehouse_insert_created_timestamp timestamp with time zone);
			
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Vital_SignsBP_Log', 'VS_TYPE', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Vital_SignsBP_Log', 'VS_SYSBP', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Vital_SignsBP_Log', 'VS_DIABP', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Vital_SignsBP_Log', 'VS_HR', 'integer');

	
			ALTER TABLE NCT01928420_All_Data.Vital_SignsBP_Log ADD CONSTRAINT Pk_BP_LOG PRIMARY KEY (item_data_id);
	
			ALTER TABLE NCT01928420_All_Data.Vital_SignsBP_Log ADD CONSTRAINT Fk_study_subject_id_BP_LOG FOREIGN KEY (ssoid, ssid) REFERENCES NCT01928420_All_Data.study_subject_listing;
				
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_LUM_02',											
									'LUM_02', 									
									'SE_FIRSTVISIT'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Supine'
																,120
																,80
																,60		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_LUM_02',											
									'LUM_02', 									
									'SE_FIRSTVISIT'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Standing'
																,120
																,80
																,60		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE								
									)
									values (		
									'SS_TEST_01',											
									'Test_01', 									
									'SE_FIRSTVISIT'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Supine'		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE								
									)
									values (		
									'SS_TEST_01',											
									'Test_01', 									
									'SE_FIRSTVISIT'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Standing'		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TEST_02',											
									'Test_02', 									
									'SE_FIRSTVISIT'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Supine'
																,120
																,80
																,60		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TEST_02',											
									'Test_02', 									
									'SE_FIRSTVISIT'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Standing'
																,120
																,80
																,60		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TEST_03',											
									'Test_03', 									
									'SE_FIRSTVISIT'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Supine'
																,120
																,80
																,60		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TEST_03',											
									'Test_03', 									
									'SE_FIRSTVISIT'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Standing'
																,120
																,80
																,60		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TEST_04',											
									'Test_04', 									
									'SE_FIRSTVISIT'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Supine'
																,120
																,80
																,60		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TEST_04',											
									'Test_04', 									
									'SE_FIRSTVISIT'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Standing'
																,120
																,80
																,60		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TEST_BEN',											
									'Test_Ben', 									
									'SE_FIRSTVISIT'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Supine'
																,120
																,80
																,60		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TEST_BEN',											
									'Test_Ben', 									
									'SE_FIRSTVISIT'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Standing'
																,120
																,80
																,60		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
										,event_ordinal
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS10_101',											
									'TS10_101_10', 									
									'SE_MONTHLYFU'									  
							
										,1
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Supine'
																,110
																,90
																,70		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
										,event_ordinal
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS10_101',											
									'TS10_101_10', 									
									'SE_MONTHLYFU'									  
							
										,1
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Standing'
																,110
																,90
																,70		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
										,event_ordinal
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS10_101',											
									'TS10_101_10', 									
									'SE_MONTHLYFU'									  
							
										,2
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Supine'
																,110
																,90
																,70		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
										,event_ordinal
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS10_101',											
									'TS10_101_10', 									
									'SE_MONTHLYFU'									  
							
										,2
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Standing'
																,110
																,90
																,72		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS3_101_',											
									'TS3_101_03', 									
									'SE_FIRSTVISIT'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Supine'
																,112
																,88
																,68		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS3_101_',											
									'TS3_101_03', 									
									'SE_FIRSTVISIT'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Standing'
																,115
																,92
																,70		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS3_101_',											
									'TS3_101_03', 									
									'SE_1WEEKFU'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Supine'
																,112
																,95
																,70		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS3_101_',											
									'TS3_101_03', 									
									'SE_1WEEKFU'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Standing'
																,115
																,98
																,72		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
										,event_ordinal
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS10_102',											
									'TS10_102_10', 									
									'SE_MONTHLYFU'									  
							
										,1
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Supine'
																,110
																,90
																,70		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
										,event_ordinal
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS10_102',											
									'TS10_102_10', 									
									'SE_MONTHLYFU'									  
							
										,1
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Standing'
																,110
																,90
																,70		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
										,event_ordinal
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS10_102',											
									'TS10_102_10', 									
									'SE_MONTHLYFU'									  
							
										,2
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Supine'
																,110
																,90
																,70		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
										,event_ordinal
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS10_102',											
									'TS10_102_10', 									
									'SE_MONTHLYFU'									  
							
										,2
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Standing'
																,110
																,90
																,72		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS1_102_',											
									'TS1_102_01', 									
									'SE_FIRSTVISIT'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Supine'
																,112
																,88
																,68		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS1_102_',											
									'TS1_102_01', 									
									'SE_FIRSTVISIT'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Standing'
																,115
																,92
																,70		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS1_102_',											
									'TS1_102_01', 									
									'SE_1WEEKFU'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Supine'
																,112
																,95
																,70		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS1_102_',											
									'TS1_102_01', 									
									'SE_1WEEKFU'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Standing'
																,115
																,98
																,72		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS3_102_',											
									'TS3_102_03', 									
									'SE_FIRSTVISIT'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Supine'
																,112
																,88
																,68		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS3_102_',											
									'TS3_102_03', 									
									'SE_FIRSTVISIT'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Standing'
																,115
																,92
																,70		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS3_102_',											
									'TS3_102_03', 									
									'SE_1WEEKFU'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Supine'
																,112
																,95
																,70		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS3_102_',											
									'TS3_102_03', 									
									'SE_1WEEKFU'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Standing'
																,115
																,98
																,72		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
										,event_ordinal
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS8_102_',											
									'TS8_102_08', 									
									'SE_MONTHLYFU'									  
							
										,1
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Supine'
																,110
																,90
																,70		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
										,event_ordinal
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS8_102_',											
									'TS8_102_08', 									
									'SE_MONTHLYFU'									  
							
										,1
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Standing'
																,110
																,90
																,70		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
										,event_ordinal
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS8_102_',											
									'TS8_102_08', 									
									'SE_MONTHLYFU'									  
							
										,2
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Supine'
																,110
																,90
																,70		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
										,event_ordinal
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS8_102_',											
									'TS8_102_08', 									
									'SE_MONTHLYFU'									  
							
										,2
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Standing'
																,110
																,90
																,72		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
										,event_ordinal
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS10_103',											
									'TS10_103_10', 									
									'SE_MONTHLYFU'									  
							
										,1
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Supine'
																,110
																,90
																,70		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
										,event_ordinal
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS10_103',											
									'TS10_103_10', 									
									'SE_MONTHLYFU'									  
							
										,1
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Standing'
																,110
																,90
																,70		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
										,event_ordinal
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS10_103',											
									'TS10_103_10', 									
									'SE_MONTHLYFU'									  
							
										,2
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Supine'
																,110
																,90
																,70		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
										,event_ordinal
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS10_103',											
									'TS10_103_10', 									
									'SE_MONTHLYFU'									  
							
										,2
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Standing'
																,110
																,90
																,72		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS1_103_',											
									'TS1_103_01', 									
									'SE_FIRSTVISIT'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Supine'
																,112
																,88
																,68		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS1_103_',											
									'TS1_103_01', 									
									'SE_FIRSTVISIT'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Standing'
																,115
																,92
																,70		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS1_103_',											
									'TS1_103_01', 									
									'SE_1WEEKFU'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Supine'
																,112
																,95
																,70		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS1_103_',											
									'TS1_103_01', 									
									'SE_1WEEKFU'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Standing'
																,115
																,98
																,72		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS3_103_',											
									'TS3_103_03', 									
									'SE_FIRSTVISIT'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Supine'
																,112
																,88
																,68		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS3_103_',											
									'TS3_103_03', 									
									'SE_FIRSTVISIT'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Standing'
																,115
																,92
																,70		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS3_103_',											
									'TS3_103_03', 									
									'SE_1WEEKFU'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Supine'
																,112
																,95
																,70		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS3_103_',											
									'TS3_103_03', 									
									'SE_1WEEKFU'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Standing'
																,115
																,98
																,72		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
										,event_ordinal
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS8_103_',											
									'TS8_103_08', 									
									'SE_MONTHLYFU'									  
							
										,1
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Supine'
																,110
																,90
																,70		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
										,event_ordinal
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS8_103_',											
									'TS8_103_08', 									
									'SE_MONTHLYFU'									  
							
										,1
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Standing'
																,110
																,90
																,70		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
										,event_ordinal
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS8_103_',											
									'TS8_103_08', 									
									'SE_MONTHLYFU'									  
							
										,2
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Supine'
																,110
																,90
																,70		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
										,event_ordinal
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS8_103_',											
									'TS8_103_08', 									
									'SE_MONTHLYFU'									  
							
										,2
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Standing'
																,110
																,90
																,72		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
										,event_ordinal
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS10_104',											
									'TS10_104_10', 									
									'SE_MONTHLYFU'									  
							
										,1
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Supine'
																,110
																,90
																,70		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
										,event_ordinal
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS10_104',											
									'TS10_104_10', 									
									'SE_MONTHLYFU'									  
							
										,1
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Standing'
																,110
																,90
																,70		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
										,event_ordinal
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS10_104',											
									'TS10_104_10', 									
									'SE_MONTHLYFU'									  
							
										,2
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Supine'
																,110
																,90
																,70		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
										,event_ordinal
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS10_104',											
									'TS10_104_10', 									
									'SE_MONTHLYFU'									  
							
										,2
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Standing'
																,110
																,90
																,72		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS1_104_',											
									'TS1_104_01', 									
									'SE_FIRSTVISIT'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Supine'
																,112
																,88
																,68		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS1_104_',											
									'TS1_104_01', 									
									'SE_FIRSTVISIT'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Standing'
																,115
																,92
																,70		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS1_104_',											
									'TS1_104_01', 									
									'SE_1WEEKFU'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Supine'
																,112
																,95
																,70		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS1_104_',											
									'TS1_104_01', 									
									'SE_1WEEKFU'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Standing'
																,115
																,98
																,72		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS3_104_',											
									'TS3_104_03', 									
									'SE_FIRSTVISIT'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Supine'
																,112
																,88
																,68		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS3_104_',											
									'TS3_104_03', 									
									'SE_FIRSTVISIT'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Standing'
																,115
																,92
																,70		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS3_104_',											
									'TS3_104_03', 									
									'SE_1WEEKFU'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Supine'
																,112
																,95
																,70		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS3_104_',											
									'TS3_104_03', 									
									'SE_1WEEKFU'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Standing'
																,115
																,98
																,72		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
										,event_ordinal
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS8_104_',											
									'TS8_104_08', 									
									'SE_MONTHLYFU'									  
							
										,1
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Supine'
																,110
																,90
																,70		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
										,event_ordinal
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS8_104_',											
									'TS8_104_08', 									
									'SE_MONTHLYFU'									  
							
										,1
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Standing'
																,110
																,90
																,70		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
										,event_ordinal
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS8_104_',											
									'TS8_104_08', 									
									'SE_MONTHLYFU'									  
							
										,2
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Supine'
																,110
																,90
																,70		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
										,event_ordinal
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS8_104_',											
									'TS8_104_08', 									
									'SE_MONTHLYFU'									  
							
										,2
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Standing'
																,110
																,90
																,72		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
										,event_ordinal
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS13_105',											
									'TS13_105_13', 									
									'SE_MONTHLYFU'									  
							
										,1
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Supine'
																,110
																,90
																,70		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
										,event_ordinal
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS13_105',											
									'TS13_105_13', 									
									'SE_MONTHLYFU'									  
							
										,1
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Standing'
																,110
																,90
																,70		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
										,event_ordinal
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS13_105',											
									'TS13_105_13', 									
									'SE_MONTHLYFU'									  
							
										,2
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Supine'
																,110
																,90
																,70		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
										,event_ordinal
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS13_105',											
									'TS13_105_13', 									
									'SE_MONTHLYFU'									  
							
										,2
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Standing'
																,110
																,90
																,72		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS2_105_',											
									'TS2_105_02', 									
									'SE_FIRSTVISIT'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Supine'
																,112
																,88
																,68		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS2_105_',											
									'TS2_105_02', 									
									'SE_FIRSTVISIT'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Standing'
																,115
																,92
																,70		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS2_105_',											
									'TS2_105_02', 									
									'SE_1WEEKFU'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Supine'
																,112
																,95
																,70		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS2_105_',											
									'TS2_105_02', 									
									'SE_1WEEKFU'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Standing'
																,115
																,98
																,72		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS7_105_',											
									'TS7_105_07', 									
									'SE_FIRSTVISIT'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Supine'
																,112
																,88
																,68		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS7_105_',											
									'TS7_105_07', 									
									'SE_FIRSTVISIT'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Standing'
																,115
																,92
																,70		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS7_105_',											
									'TS7_105_07', 									
									'SE_1WEEKFU'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Supine'
																,112
																,95
																,70		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS7_105_',											
									'TS7_105_07', 									
									'SE_1WEEKFU'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Standing'
																,115
																,98
																,72		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
										,event_ordinal
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS9_105_',											
									'TS9_105_09', 									
									'SE_MONTHLYFU'									  
							
										,1
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Supine'
																,110
																,90
																,70		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
										,event_ordinal
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS9_105_',											
									'TS9_105_09', 									
									'SE_MONTHLYFU'									  
							
										,1
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Standing'
																,110
																,90
																,70		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
										,event_ordinal
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS9_105_',											
									'TS9_105_09', 									
									'SE_MONTHLYFU'									  
							
										,2
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Supine'
																,110
																,90
																,70		
									);									
										
													
									insert into NCT01928420_All_Data.Vital_SignsBP_Log (
									ssoid, ssid, study_event_oid 
									
										,event_ordinal
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												VS_TYPE																										
														,
												VS_SYSBP																										
														,
												VS_DIABP																										
														,
												VS_HR								
									)
									values (		
									'SS_TS9_105_',											
									'TS9_105_09', 									
									'SE_MONTHLYFU'									  
							
										,2
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Standing'
																,110
																,90
																,72		
									);									
							
			  
			
					insert into NCT01928420_All_Data.crf_version (crf_name, crf_version_name, warehouse_insert_created_timestamp) values 
					( 'Parameterized Links Demonstration', 
					'V1.0',
					'2015-03-19T16:41:35.717Z');
			
			
			
				create table NCT01928420_All_Data.Parameterized_Links_DemonstrationMRI (
				item_data_id serial NOT NULL,
				ssoid character varying(40) NOT NULL,
				ssid character varying(40) NOT NULL,
				study_event_oid character varying(40) NOT NULL,
				event_ordinal integer default 1,
				crf_version character varying(255),
				event_start_date timestamp without time zone,
				event_end_date timestamp without time zone,
				event_status character varying(255),
				event_location character varying(2000),
				subject_age_at_event integer,
				crf_status character varying(255), 
				interviewerName character varying(255),
				interviewDate date,
				warehouse_insert_created_timestamp timestamp with time zone); 			          	 
				
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Parameterized_Links_DemonstrationMRI', 'MRI_YN', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Parameterized_Links_DemonstrationMRI', 'MRI_YN_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Parameterized_Links_DemonstrationMRI', 'MRI_NO', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Parameterized_Links_DemonstrationMRI', 'MRI_RES', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Parameterized_Links_DemonstrationMRI', 'MRI_RES_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Parameterized_Links_DemonstrationMRI', 'MRI_AB', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Parameterized_Links_DemonstrationMRI', 'MRI_DOC', 'text');

	
				
		ALTER TABLE NCT01928420_All_Data.Parameterized_Links_DemonstrationMRI ADD CONSTRAINT Pk_MRI001 PRIMARY KEY (item_data_id);

		
				
		ALTER TABLE NCT01928420_All_Data.Parameterized_Links_DemonstrationMRI ADD CONSTRAINT 	
		Fk_study_subject_id_MRI001 FOREIGN KEY (ssoid, 
		ssid) REFERENCES NCT01928420_All_Data.study_subject_listing;
		
		
			  
			
					insert into NCT01928420_All_Data.crf_version (crf_name, crf_version_name, warehouse_insert_created_timestamp) values 
					( 'Pharmacokinetics', 
					'V1.0',
					'2015-03-19T16:41:35.717Z');
			
			
			
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS10_101',
									
					'TS10_101_10',
					
				'SE_1WEEKFU',
				
				'Pharmacokinetics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS10_101',
									
					'TS10_101_10',
					
				'SE_2WEEKFU',
				
				'Pharmacokinetics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS10_101',
									
					'TS10_101_10',
					
				'SE_MONTHLYFU',
				1,
				
				'Pharmacokinetics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS10_101',
									
					'TS10_101_10',
					
				'SE_MONTHLYFU',
				2,
				
				'Pharmacokinetics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS3_101_',
									
					'TS3_101_03',
					
				'SE_1WEEKFU',
				
				'Pharmacokinetics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS10_102',
									
					'TS10_102_10',
					
				'SE_1WEEKFU',
				
				'Pharmacokinetics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS10_102',
									
					'TS10_102_10',
					
				'SE_2WEEKFU',
				
				'Pharmacokinetics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS10_102',
									
					'TS10_102_10',
					
				'SE_MONTHLYFU',
				1,
				
				'Pharmacokinetics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS10_102',
									
					'TS10_102_10',
					
				'SE_MONTHLYFU',
				2,
				
				'Pharmacokinetics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS1_102_',
									
					'TS1_102_01',
					
				'SE_1WEEKFU',
				
				'Pharmacokinetics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS3_102_',
									
					'TS3_102_03',
					
				'SE_1WEEKFU',
				
				'Pharmacokinetics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS8_102_',
									
					'TS8_102_08',
					
				'SE_1WEEKFU',
				
				'Pharmacokinetics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS8_102_',
									
					'TS8_102_08',
					
				'SE_2WEEKFU',
				
				'Pharmacokinetics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS8_102_',
									
					'TS8_102_08',
					
				'SE_MONTHLYFU',
				1,
				
				'Pharmacokinetics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS8_102_',
									
					'TS8_102_08',
					
				'SE_MONTHLYFU',
				2,
				
				'Pharmacokinetics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS10_103',
									
					'TS10_103_10',
					
				'SE_1WEEKFU',
				
				'Pharmacokinetics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS10_103',
									
					'TS10_103_10',
					
				'SE_2WEEKFU',
				
				'Pharmacokinetics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS10_103',
									
					'TS10_103_10',
					
				'SE_MONTHLYFU',
				1,
				
				'Pharmacokinetics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS10_103',
									
					'TS10_103_10',
					
				'SE_MONTHLYFU',
				2,
				
				'Pharmacokinetics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS1_103_',
									
					'TS1_103_01',
					
				'SE_1WEEKFU',
				
				'Pharmacokinetics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS3_103_',
									
					'TS3_103_03',
					
				'SE_1WEEKFU',
				
				'Pharmacokinetics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS8_103_',
									
					'TS8_103_08',
					
				'SE_1WEEKFU',
				
				'Pharmacokinetics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS8_103_',
									
					'TS8_103_08',
					
				'SE_2WEEKFU',
				
				'Pharmacokinetics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS8_103_',
									
					'TS8_103_08',
					
				'SE_MONTHLYFU',
				1,
				
				'Pharmacokinetics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS8_103_',
									
					'TS8_103_08',
					
				'SE_MONTHLYFU',
				2,
				
				'Pharmacokinetics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS10_104',
									
					'TS10_104_10',
					
				'SE_1WEEKFU',
				
				'Pharmacokinetics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS10_104',
									
					'TS10_104_10',
					
				'SE_2WEEKFU',
				
				'Pharmacokinetics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS10_104',
									
					'TS10_104_10',
					
				'SE_MONTHLYFU',
				1,
				
				'Pharmacokinetics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS10_104',
									
					'TS10_104_10',
					
				'SE_MONTHLYFU',
				2,
				
				'Pharmacokinetics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS1_104_',
									
					'TS1_104_01',
					
				'SE_1WEEKFU',
				
				'Pharmacokinetics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS3_104_',
									
					'TS3_104_03',
					
				'SE_1WEEKFU',
				
				'Pharmacokinetics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS8_104_',
									
					'TS8_104_08',
					
				'SE_1WEEKFU',
				
				'Pharmacokinetics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS8_104_',
									
					'TS8_104_08',
					
				'SE_2WEEKFU',
				
				'Pharmacokinetics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS8_104_',
									
					'TS8_104_08',
					
				'SE_MONTHLYFU',
				1,
				
				'Pharmacokinetics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS8_104_',
									
					'TS8_104_08',
					
				'SE_MONTHLYFU',
				2,
				
				'Pharmacokinetics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS13_105',
									
					'TS13_105_13',
					
				'SE_1WEEKFU',
				
				'Pharmacokinetics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS13_105',
									
					'TS13_105_13',
					
				'SE_2WEEKFU',
				
				'Pharmacokinetics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS13_105',
									
					'TS13_105_13',
					
				'SE_MONTHLYFU',
				1,
				
				'Pharmacokinetics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS13_105',
									
					'TS13_105_13',
					
				'SE_MONTHLYFU',
				2,
				
				'Pharmacokinetics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS2_105_',
									
					'TS2_105_02',
					
				'SE_1WEEKFU',
				
				'Pharmacokinetics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS7_105_',
									
					'TS7_105_07',
					
				'SE_1WEEKFU',
				
				'Pharmacokinetics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS9_105_',
									
					'TS9_105_09',
					
				'SE_1WEEKFU',
				
				'Pharmacokinetics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS9_105_',
									
					'TS9_105_09',
					
				'SE_2WEEKFU',
				
				'Pharmacokinetics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS9_105_',
									
					'TS9_105_09',
					
				'SE_MONTHLYFU',
				1,
				
				'Pharmacokinetics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
			
				event_ordinal,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS9_105_',
									
					'TS9_105_09',
					
				'SE_MONTHLYFU',
				2,
				
				'Pharmacokinetics',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
				create table NCT01928420_All_Data.PharmacokineticsResults (
				item_data_id serial NOT NULL,
				ssoid character varying(40) NOT NULL,
				ssid character varying(40) NOT NULL,
				study_event_oid character varying(40) NOT NULL,
				event_ordinal integer default 1,
				crf_version character varying(255),
				event_start_date timestamp without time zone,
				event_end_date timestamp without time zone,
				event_status character varying(255),
				event_location character varying(2000),
				subject_age_at_event integer,
				crf_status character varying(255), 
				interviewerName character varying(255),
				interviewDate date,
				warehouse_insert_created_timestamp timestamp with time zone); 			          	 
				
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.PharmacokineticsResults', 'PH_DT', 'date');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.PharmacokineticsResults', 'PH_S1ST', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.PharmacokineticsResults', 'PH_S1AT', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.PharmacokineticsResults', 'PH_S1RS', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.PharmacokineticsResults', 'PH_S2ST', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.PharmacokineticsResults', 'PH_S2AT', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.PharmacokineticsResults', 'PH_S2RS', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.PharmacokineticsResults', 'PH_S3ST', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.PharmacokineticsResults', 'PH_S3AT', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.PharmacokineticsResults', 'PH_S3RS', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.PharmacokineticsResults', 'PH_S4ST', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.PharmacokineticsResults', 'PH_S4AT', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.PharmacokineticsResults', 'PH_S4RS', 'text');

	
				
		ALTER TABLE NCT01928420_All_Data.PharmacokineticsResults ADD CONSTRAINT Pk_RESULTS PRIMARY KEY (item_data_id);

		
				
		ALTER TABLE NCT01928420_All_Data.PharmacokineticsResults ADD CONSTRAINT 	
		Fk_study_subject_id_RESULTS FOREIGN KEY (ssoid, 
		ssid) REFERENCES NCT01928420_All_Data.study_subject_listing;
		
				
									insert into NCT01928420_All_Data.PharmacokineticsResults (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														PH_DT																									
																,
																
														
														PH_S1ST																									
																,
																
														
														PH_S1AT																									
																,
																
														
														PH_S1RS																									
																,
																
														
														PH_S2ST																									
																,
																
														
														PH_S2AT																									
																,
																
														
														PH_S2RS																									
																,
																
														
														PH_S3ST																									
																,
																
														
														PH_S3AT																									
																,
																
														
														PH_S3RS																									
																,
																
														
														PH_S4ST																									
																,
																
														
														PH_S4AT																									
																,
																
														
														PH_S4RS
										)
									values (
									
									
									'SS_TS10_101',
									
									'TS10_101_10', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,'10:12'
															,'10:12'
															,'5'
															,'12:12'
															,'12:12'
															,'4'
															,'13:12'
															,'13:12'
															,'3'
															,'14:12'
															,'14:12'
															,'2'		
									);
										
									insert into NCT01928420_All_Data.PharmacokineticsResults (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														PH_DT																									
																,
																
														
														PH_S1ST																									
																,
																
														
														PH_S1AT																									
																,
																
														
														PH_S1RS																									
																,
																
														
														PH_S2ST																									
																,
																
														
														PH_S2AT																									
																,
																
														
														PH_S2RS																									
																,
																
														
														PH_S3ST																									
																,
																
														
														PH_S3AT																									
																,
																
														
														PH_S3RS																									
																,
																
														
														PH_S4ST																									
																,
																
														
														PH_S4AT																									
																,
																
														
														PH_S4RS
										)
									values (
									
									
									'SS_TS10_101',
									
									'TS10_101_10', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,'10:10'
															,'10:10'
															,'5'
															,'12:10'
															,'12:10'
															,'4'
															,'13:10'
															,'13:10'
															,'3'
															,'14:10'
															,'14:10'
															,'2'		
									);
										
									insert into NCT01928420_All_Data.PharmacokineticsResults (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														PH_DT																									
																,
																
														
														PH_S1ST																									
																,
																
														
														PH_S1AT																									
																,
																
														
														PH_S1RS																									
																,
																
														
														PH_S2ST																									
																,
																
														
														PH_S2AT																									
																,
																
														
														PH_S2RS																									
																,
																
														
														PH_S3ST																									
																,
																
														
														PH_S3AT																									
																,
																
														
														PH_S3RS																									
																,
																
														
														PH_S4ST																									
																,
																
														
														PH_S4AT																									
																,
																
														
														PH_S4RS
										)
									values (
									
									
									'SS_TS10_101',
									
									'TS10_101_10', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,1
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-11'
															,'12:32'
															,'12:32'
															,'5'
															,'14:32'
															,'14:32'
															,'4'
															,'15:32'
															,'15:32'
															,'3'
															,'16:32'
															,'16:32'
															,'2'		
									);
										
									insert into NCT01928420_All_Data.PharmacokineticsResults (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														PH_DT																									
																,
																
														
														PH_S1ST																									
																,
																
														
														PH_S1AT																									
																,
																
														
														PH_S1RS																									
																,
																
														
														PH_S2ST																									
																,
																
														
														PH_S2AT																									
																,
																
														
														PH_S2RS																									
																,
																
														
														PH_S3ST																									
																,
																
														
														PH_S3AT																									
																,
																
														
														PH_S3RS																									
																,
																
														
														PH_S4ST																									
																,
																
														
														PH_S4AT																									
																,
																
														
														PH_S4RS
										)
									values (
									
									
									'SS_TS10_101',
									
									'TS10_101_10', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,2
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,'12:32'
															,'12:32'
															,'4'
															,'14:32'
															,'14:32'
															,'3'
															,'15:32'
															,'15:32'
															,'2'
															,'16:32'
															,'16:32'
															,'1'		
									);
										
									insert into NCT01928420_All_Data.PharmacokineticsResults (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														PH_DT																									
																,
																
														
														PH_S1ST																									
																,
																
														
														PH_S1AT																									
																,
																
														
														PH_S1RS																									
																,
																
														
														PH_S2ST																									
																,
																
														
														PH_S2AT																									
																,
																
														
														PH_S2RS																									
																,
																
														
														PH_S3ST																									
																,
																
														
														PH_S3AT																									
																,
																
														
														PH_S3RS																									
																,
																
														
														PH_S4ST																									
																,
																
														
														PH_S4AT																									
																,
																
														
														PH_S4RS
										)
									values (
									
									
									'SS_TS3_101_',
									
									'TS3_101_03', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-17'
															,'11:23'
															,'11:23'
															,'6'
															,'13:23'
															,'13:23'
															,'5'
															,'14:23'
															,'14:23'
															,'4.5'
															,'15:23'
															,'15:23'
															,'3'		
									);
										
									insert into NCT01928420_All_Data.PharmacokineticsResults (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														PH_DT																									
																,
																
														
														PH_S1ST																									
																,
																
														
														PH_S1AT																									
																,
																
														
														PH_S1RS																									
																,
																
														
														PH_S2ST																									
																,
																
														
														PH_S2AT																									
																,
																
														
														PH_S2RS																									
																,
																
														
														PH_S3ST																									
																,
																
														
														PH_S3AT																									
																,
																
														
														PH_S3RS																									
																,
																
														
														PH_S4ST																									
																,
																
														
														PH_S4AT																									
																,
																
														
														PH_S4RS
										)
									values (
									
									
									'SS_TS10_102',
									
									'TS10_102_10', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,'10:12'
															,'10:12'
															,'5'
															,'12:12'
															,'12:12'
															,'4'
															,'13:12'
															,'13:12'
															,'3'
															,'14:12'
															,'14:12'
															,'2'		
									);
										
									insert into NCT01928420_All_Data.PharmacokineticsResults (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														PH_DT																									
																,
																
														
														PH_S1ST																									
																,
																
														
														PH_S1AT																									
																,
																
														
														PH_S1RS																									
																,
																
														
														PH_S2ST																									
																,
																
														
														PH_S2AT																									
																,
																
														
														PH_S2RS																									
																,
																
														
														PH_S3ST																									
																,
																
														
														PH_S3AT																									
																,
																
														
														PH_S3RS																									
																,
																
														
														PH_S4ST																									
																,
																
														
														PH_S4AT																									
																,
																
														
														PH_S4RS
										)
									values (
									
									
									'SS_TS10_102',
									
									'TS10_102_10', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,'10:10'
															,'10:10'
															,'5'
															,'12:10'
															,'12:10'
															,'4'
															,'13:10'
															,'13:10'
															,'3'
															,'14:10'
															,'14:10'
															,'2'		
									);
										
									insert into NCT01928420_All_Data.PharmacokineticsResults (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														PH_DT																									
																,
																
														
														PH_S1ST																									
																,
																
														
														PH_S1AT																									
																,
																
														
														PH_S1RS																									
																,
																
														
														PH_S2ST																									
																,
																
														
														PH_S2AT																									
																,
																
														
														PH_S2RS																									
																,
																
														
														PH_S3ST																									
																,
																
														
														PH_S3AT																									
																,
																
														
														PH_S3RS																									
																,
																
														
														PH_S4ST																									
																,
																
														
														PH_S4AT																									
																,
																
														
														PH_S4RS
										)
									values (
									
									
									'SS_TS10_102',
									
									'TS10_102_10', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,1
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-11'
															,'12:32'
															,'12:32'
															,'5'
															,'14:32'
															,'14:32'
															,'4'
															,'15:32'
															,'15:32'
															,'3'
															,'16:32'
															,'16:32'
															,'2'		
									);
										
									insert into NCT01928420_All_Data.PharmacokineticsResults (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														PH_DT																									
																,
																
														
														PH_S1ST																									
																,
																
														
														PH_S1AT																									
																,
																
														
														PH_S1RS																									
																,
																
														
														PH_S2ST																									
																,
																
														
														PH_S2AT																									
																,
																
														
														PH_S2RS																									
																,
																
														
														PH_S3ST																									
																,
																
														
														PH_S3AT																									
																,
																
														
														PH_S3RS																									
																,
																
														
														PH_S4ST																									
																,
																
														
														PH_S4AT																									
																,
																
														
														PH_S4RS
										)
									values (
									
									
									'SS_TS10_102',
									
									'TS10_102_10', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,2
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,'12:32'
															,'12:32'
															,'4'
															,'14:32'
															,'14:32'
															,'3'
															,'15:32'
															,'15:32'
															,'2'
															,'16:32'
															,'16:32'
															,'1'		
									);
										
									insert into NCT01928420_All_Data.PharmacokineticsResults (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														PH_DT																									
																,
																
														
														PH_S1ST																									
																,
																
														
														PH_S1AT																									
																,
																
														
														PH_S1RS																									
																,
																
														
														PH_S2ST																									
																,
																
														
														PH_S2AT																									
																,
																
														
														PH_S2RS																									
																,
																
														
														PH_S3ST																									
																,
																
														
														PH_S3AT																									
																,
																
														
														PH_S3RS																									
																,
																
														
														PH_S4ST																									
																,
																
														
														PH_S4AT																									
																,
																
														
														PH_S4RS
										)
									values (
									
									
									'SS_TS1_102_',
									
									'TS1_102_01', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-17'
															,'11:23'
															,'11:23'
															,'6'
															,'13:23'
															,'13:23'
															,'5'
															,'14:23'
															,'14:23'
															,'4.5'
															,'15:23'
															,'15:23'
															,'3'		
									);
										
									insert into NCT01928420_All_Data.PharmacokineticsResults (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														PH_DT																									
																,
																
														
														PH_S1ST																									
																,
																
														
														PH_S1AT																									
																,
																
														
														PH_S1RS																									
																,
																
														
														PH_S2ST																									
																,
																
														
														PH_S2AT																									
																,
																
														
														PH_S2RS																									
																,
																
														
														PH_S3ST																									
																,
																
														
														PH_S3AT																									
																,
																
														
														PH_S3RS																									
																,
																
														
														PH_S4ST																									
																,
																
														
														PH_S4AT																									
																,
																
														
														PH_S4RS
										)
									values (
									
									
									'SS_TS3_102_',
									
									'TS3_102_03', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-17'
															,'11:23'
															,'11:23'
															,'6'
															,'13:23'
															,'13:23'
															,'5'
															,'14:23'
															,'14:23'
															,'4.5'
															,'15:23'
															,'15:23'
															,'3'		
									);
										
									insert into NCT01928420_All_Data.PharmacokineticsResults (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														PH_DT																									
																,
																
														
														PH_S1ST																									
																,
																
														
														PH_S1AT																									
																,
																
														
														PH_S1RS																									
																,
																
														
														PH_S2ST																									
																,
																
														
														PH_S2AT																									
																,
																
														
														PH_S2RS																									
																,
																
														
														PH_S3ST																									
																,
																
														
														PH_S3AT																									
																,
																
														
														PH_S3RS																									
																,
																
														
														PH_S4ST																									
																,
																
														
														PH_S4AT																									
																,
																
														
														PH_S4RS
										)
									values (
									
									
									'SS_TS8_102_',
									
									'TS8_102_08', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,'10:12'
															,'10:12'
															,'5'
															,'12:12'
															,'12:12'
															,'4'
															,'13:12'
															,'13:12'
															,'3'
															,'14:12'
															,'14:12'
															,'2'		
									);
										
									insert into NCT01928420_All_Data.PharmacokineticsResults (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														PH_DT																									
																,
																
														
														PH_S1ST																									
																,
																
														
														PH_S1AT																									
																,
																
														
														PH_S1RS																									
																,
																
														
														PH_S2ST																									
																,
																
														
														PH_S2AT																									
																,
																
														
														PH_S2RS																									
																,
																
														
														PH_S3ST																									
																,
																
														
														PH_S3AT																									
																,
																
														
														PH_S3RS																									
																,
																
														
														PH_S4ST																									
																,
																
														
														PH_S4AT																									
																,
																
														
														PH_S4RS
										)
									values (
									
									
									'SS_TS8_102_',
									
									'TS8_102_08', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,'10:10'
															,'10:10'
															,'5'
															,'12:10'
															,'12:10'
															,'4'
															,'13:10'
															,'13:10'
															,'3'
															,'14:10'
															,'14:10'
															,'2'		
									);
										
									insert into NCT01928420_All_Data.PharmacokineticsResults (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														PH_DT																									
																,
																
														
														PH_S1ST																									
																,
																
														
														PH_S1AT																									
																,
																
														
														PH_S1RS																									
																,
																
														
														PH_S2ST																									
																,
																
														
														PH_S2AT																									
																,
																
														
														PH_S2RS																									
																,
																
														
														PH_S3ST																									
																,
																
														
														PH_S3AT																									
																,
																
														
														PH_S3RS																									
																,
																
														
														PH_S4ST																									
																,
																
														
														PH_S4AT																									
																,
																
														
														PH_S4RS
										)
									values (
									
									
									'SS_TS8_102_',
									
									'TS8_102_08', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,1
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-11'
															,'12:32'
															,'12:32'
															,'5'
															,'14:32'
															,'14:32'
															,'4'
															,'15:32'
															,'15:32'
															,'3'
															,'16:32'
															,'16:32'
															,'2'		
									);
										
									insert into NCT01928420_All_Data.PharmacokineticsResults (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														PH_DT																									
																,
																
														
														PH_S1ST																									
																,
																
														
														PH_S1AT																									
																,
																
														
														PH_S1RS																									
																,
																
														
														PH_S2ST																									
																,
																
														
														PH_S2AT																									
																,
																
														
														PH_S2RS																									
																,
																
														
														PH_S3ST																									
																,
																
														
														PH_S3AT																									
																,
																
														
														PH_S3RS																									
																,
																
														
														PH_S4ST																									
																,
																
														
														PH_S4AT																									
																,
																
														
														PH_S4RS
										)
									values (
									
									
									'SS_TS8_102_',
									
									'TS8_102_08', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,2
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,'12:32'
															,'12:32'
															,'4'
															,'14:32'
															,'14:32'
															,'3'
															,'15:32'
															,'15:32'
															,'2'
															,'16:32'
															,'16:32'
															,'1'		
									);
										
									insert into NCT01928420_All_Data.PharmacokineticsResults (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														PH_DT																									
																,
																
														
														PH_S1ST																									
																,
																
														
														PH_S1AT																									
																,
																
														
														PH_S1RS																									
																,
																
														
														PH_S2ST																									
																,
																
														
														PH_S2AT																									
																,
																
														
														PH_S2RS																									
																,
																
														
														PH_S3ST																									
																,
																
														
														PH_S3AT																									
																,
																
														
														PH_S3RS																									
																,
																
														
														PH_S4ST																									
																,
																
														
														PH_S4AT																									
																,
																
														
														PH_S4RS
										)
									values (
									
									
									'SS_TS10_103',
									
									'TS10_103_10', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,'10:12'
															,'10:12'
															,'5'
															,'12:12'
															,'12:12'
															,'4'
															,'13:12'
															,'13:12'
															,'3'
															,'14:12'
															,'14:12'
															,'2'		
									);
										
									insert into NCT01928420_All_Data.PharmacokineticsResults (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														PH_DT																									
																,
																
														
														PH_S1ST																									
																,
																
														
														PH_S1AT																									
																,
																
														
														PH_S1RS																									
																,
																
														
														PH_S2ST																									
																,
																
														
														PH_S2AT																									
																,
																
														
														PH_S2RS																									
																,
																
														
														PH_S3ST																									
																,
																
														
														PH_S3AT																									
																,
																
														
														PH_S3RS																									
																,
																
														
														PH_S4ST																									
																,
																
														
														PH_S4AT																									
																,
																
														
														PH_S4RS
										)
									values (
									
									
									'SS_TS10_103',
									
									'TS10_103_10', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,'10:10'
															,'10:10'
															,'5'
															,'12:10'
															,'12:10'
															,'4'
															,'13:10'
															,'13:10'
															,'3'
															,'14:10'
															,'14:10'
															,'2'		
									);
										
									insert into NCT01928420_All_Data.PharmacokineticsResults (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														PH_DT																									
																,
																
														
														PH_S1ST																									
																,
																
														
														PH_S1AT																									
																,
																
														
														PH_S1RS																									
																,
																
														
														PH_S2ST																									
																,
																
														
														PH_S2AT																									
																,
																
														
														PH_S2RS																									
																,
																
														
														PH_S3ST																									
																,
																
														
														PH_S3AT																									
																,
																
														
														PH_S3RS																									
																,
																
														
														PH_S4ST																									
																,
																
														
														PH_S4AT																									
																,
																
														
														PH_S4RS
										)
									values (
									
									
									'SS_TS10_103',
									
									'TS10_103_10', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,1
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-11'
															,'12:32'
															,'12:32'
															,'5'
															,'14:32'
															,'14:32'
															,'4'
															,'15:32'
															,'15:32'
															,'3'
															,'16:32'
															,'16:32'
															,'2'		
									);
										
									insert into NCT01928420_All_Data.PharmacokineticsResults (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														PH_DT																									
																,
																
														
														PH_S1ST																									
																,
																
														
														PH_S1AT																									
																,
																
														
														PH_S1RS																									
																,
																
														
														PH_S2ST																									
																,
																
														
														PH_S2AT																									
																,
																
														
														PH_S2RS																									
																,
																
														
														PH_S3ST																									
																,
																
														
														PH_S3AT																									
																,
																
														
														PH_S3RS																									
																,
																
														
														PH_S4ST																									
																,
																
														
														PH_S4AT																									
																,
																
														
														PH_S4RS
										)
									values (
									
									
									'SS_TS10_103',
									
									'TS10_103_10', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,2
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,'12:32'
															,'12:32'
															,'4'
															,'14:32'
															,'14:32'
															,'3'
															,'15:32'
															,'15:32'
															,'2'
															,'16:32'
															,'16:32'
															,'1'		
									);
										
									insert into NCT01928420_All_Data.PharmacokineticsResults (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														PH_DT																									
																,
																
														
														PH_S1ST																									
																,
																
														
														PH_S1AT																									
																,
																
														
														PH_S1RS																									
																,
																
														
														PH_S2ST																									
																,
																
														
														PH_S2AT																									
																,
																
														
														PH_S2RS																									
																,
																
														
														PH_S3ST																									
																,
																
														
														PH_S3AT																									
																,
																
														
														PH_S3RS																									
																,
																
														
														PH_S4ST																									
																,
																
														
														PH_S4AT																									
																,
																
														
														PH_S4RS
										)
									values (
									
									
									'SS_TS1_103_',
									
									'TS1_103_01', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-17'
															,'11:23'
															,'11:23'
															,'6'
															,'13:23'
															,'13:23'
															,'5'
															,'14:23'
															,'14:23'
															,'4.5'
															,'15:23'
															,'15:23'
															,'3'		
									);
										
									insert into NCT01928420_All_Data.PharmacokineticsResults (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														PH_DT																									
																,
																
														
														PH_S1ST																									
																,
																
														
														PH_S1AT																									
																,
																
														
														PH_S1RS																									
																,
																
														
														PH_S2ST																									
																,
																
														
														PH_S2AT																									
																,
																
														
														PH_S2RS																									
																,
																
														
														PH_S3ST																									
																,
																
														
														PH_S3AT																									
																,
																
														
														PH_S3RS																									
																,
																
														
														PH_S4ST																									
																,
																
														
														PH_S4AT																									
																,
																
														
														PH_S4RS
										)
									values (
									
									
									'SS_TS3_103_',
									
									'TS3_103_03', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-17'
															,'11:23'
															,'11:23'
															,'6'
															,'13:23'
															,'13:23'
															,'5'
															,'14:23'
															,'14:23'
															,'4.5'
															,'15:23'
															,'15:23'
															,'3'		
									);
										
									insert into NCT01928420_All_Data.PharmacokineticsResults (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														PH_DT																									
																,
																
														
														PH_S1ST																									
																,
																
														
														PH_S1AT																									
																,
																
														
														PH_S1RS																									
																,
																
														
														PH_S2ST																									
																,
																
														
														PH_S2AT																									
																,
																
														
														PH_S2RS																									
																,
																
														
														PH_S3ST																									
																,
																
														
														PH_S3AT																									
																,
																
														
														PH_S3RS																									
																,
																
														
														PH_S4ST																									
																,
																
														
														PH_S4AT																									
																,
																
														
														PH_S4RS
										)
									values (
									
									
									'SS_TS8_103_',
									
									'TS8_103_08', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,'10:12'
															,'10:12'
															,'5'
															,'12:12'
															,'12:12'
															,'4'
															,'13:12'
															,'13:12'
															,'3'
															,'14:12'
															,'14:12'
															,'2'		
									);
										
									insert into NCT01928420_All_Data.PharmacokineticsResults (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														PH_DT																									
																,
																
														
														PH_S1ST																									
																,
																
														
														PH_S1AT																									
																,
																
														
														PH_S1RS																									
																,
																
														
														PH_S2ST																									
																,
																
														
														PH_S2AT																									
																,
																
														
														PH_S2RS																									
																,
																
														
														PH_S3ST																									
																,
																
														
														PH_S3AT																									
																,
																
														
														PH_S3RS																									
																,
																
														
														PH_S4ST																									
																,
																
														
														PH_S4AT																									
																,
																
														
														PH_S4RS
										)
									values (
									
									
									'SS_TS8_103_',
									
									'TS8_103_08', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,'10:10'
															,'10:10'
															,'5'
															,'12:10'
															,'12:10'
															,'4'
															,'13:10'
															,'13:10'
															,'3'
															,'14:10'
															,'14:10'
															,'2'		
									);
										
									insert into NCT01928420_All_Data.PharmacokineticsResults (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														PH_DT																									
																,
																
														
														PH_S1ST																									
																,
																
														
														PH_S1AT																									
																,
																
														
														PH_S1RS																									
																,
																
														
														PH_S2ST																									
																,
																
														
														PH_S2AT																									
																,
																
														
														PH_S2RS																									
																,
																
														
														PH_S3ST																									
																,
																
														
														PH_S3AT																									
																,
																
														
														PH_S3RS																									
																,
																
														
														PH_S4ST																									
																,
																
														
														PH_S4AT																									
																,
																
														
														PH_S4RS
										)
									values (
									
									
									'SS_TS8_103_',
									
									'TS8_103_08', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,1
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-11'
															,'12:32'
															,'12:32'
															,'5'
															,'14:32'
															,'14:32'
															,'4'
															,'15:32'
															,'15:32'
															,'3'
															,'16:32'
															,'16:32'
															,'2'		
									);
										
									insert into NCT01928420_All_Data.PharmacokineticsResults (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														PH_DT																									
																,
																
														
														PH_S1ST																									
																,
																
														
														PH_S1AT																									
																,
																
														
														PH_S1RS																									
																,
																
														
														PH_S2ST																									
																,
																
														
														PH_S2AT																									
																,
																
														
														PH_S2RS																									
																,
																
														
														PH_S3ST																									
																,
																
														
														PH_S3AT																									
																,
																
														
														PH_S3RS																									
																,
																
														
														PH_S4ST																									
																,
																
														
														PH_S4AT																									
																,
																
														
														PH_S4RS
										)
									values (
									
									
									'SS_TS8_103_',
									
									'TS8_103_08', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,2
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,'12:32'
															,'12:32'
															,'4'
															,'14:32'
															,'14:32'
															,'3'
															,'15:32'
															,'15:32'
															,'2'
															,'16:32'
															,'16:32'
															,'1'		
									);
										
									insert into NCT01928420_All_Data.PharmacokineticsResults (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														PH_DT																									
																,
																
														
														PH_S1ST																									
																,
																
														
														PH_S1AT																									
																,
																
														
														PH_S1RS																									
																,
																
														
														PH_S2ST																									
																,
																
														
														PH_S2AT																									
																,
																
														
														PH_S2RS																									
																,
																
														
														PH_S3ST																									
																,
																
														
														PH_S3AT																									
																,
																
														
														PH_S3RS																									
																,
																
														
														PH_S4ST																									
																,
																
														
														PH_S4AT																									
																,
																
														
														PH_S4RS
										)
									values (
									
									
									'SS_TS10_104',
									
									'TS10_104_10', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,'10:12'
															,'10:12'
															,'5'
															,'12:12'
															,'12:12'
															,'4'
															,'13:12'
															,'13:12'
															,'3'
															,'14:12'
															,'14:12'
															,'2'		
									);
										
									insert into NCT01928420_All_Data.PharmacokineticsResults (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														PH_DT																									
																,
																
														
														PH_S1ST																									
																,
																
														
														PH_S1AT																									
																,
																
														
														PH_S1RS																									
																,
																
														
														PH_S2ST																									
																,
																
														
														PH_S2AT																									
																,
																
														
														PH_S2RS																									
																,
																
														
														PH_S3ST																									
																,
																
														
														PH_S3AT																									
																,
																
														
														PH_S3RS																									
																,
																
														
														PH_S4ST																									
																,
																
														
														PH_S4AT																									
																,
																
														
														PH_S4RS
										)
									values (
									
									
									'SS_TS10_104',
									
									'TS10_104_10', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,'10:10'
															,'10:10'
															,'5'
															,'12:10'
															,'12:10'
															,'4'
															,'13:10'
															,'13:10'
															,'3'
															,'14:10'
															,'14:10'
															,'2'		
									);
										
									insert into NCT01928420_All_Data.PharmacokineticsResults (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														PH_DT																									
																,
																
														
														PH_S1ST																									
																,
																
														
														PH_S1AT																									
																,
																
														
														PH_S1RS																									
																,
																
														
														PH_S2ST																									
																,
																
														
														PH_S2AT																									
																,
																
														
														PH_S2RS																									
																,
																
														
														PH_S3ST																									
																,
																
														
														PH_S3AT																									
																,
																
														
														PH_S3RS																									
																,
																
														
														PH_S4ST																									
																,
																
														
														PH_S4AT																									
																,
																
														
														PH_S4RS
										)
									values (
									
									
									'SS_TS10_104',
									
									'TS10_104_10', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,1
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-11'
															,'12:32'
															,'12:32'
															,'5'
															,'14:32'
															,'14:32'
															,'4'
															,'15:32'
															,'15:32'
															,'3'
															,'16:32'
															,'16:32'
															,'2'		
									);
										
									insert into NCT01928420_All_Data.PharmacokineticsResults (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														PH_DT																									
																,
																
														
														PH_S1ST																									
																,
																
														
														PH_S1AT																									
																,
																
														
														PH_S1RS																									
																,
																
														
														PH_S2ST																									
																,
																
														
														PH_S2AT																									
																,
																
														
														PH_S2RS																									
																,
																
														
														PH_S3ST																									
																,
																
														
														PH_S3AT																									
																,
																
														
														PH_S3RS																									
																,
																
														
														PH_S4ST																									
																,
																
														
														PH_S4AT																									
																,
																
														
														PH_S4RS
										)
									values (
									
									
									'SS_TS10_104',
									
									'TS10_104_10', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,2
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,'12:32'
															,'12:32'
															,'4'
															,'14:32'
															,'14:32'
															,'3'
															,'15:32'
															,'15:32'
															,'2'
															,'16:32'
															,'16:32'
															,'1'		
									);
										
									insert into NCT01928420_All_Data.PharmacokineticsResults (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														PH_DT																									
																,
																
														
														PH_S1ST																									
																,
																
														
														PH_S1AT																									
																,
																
														
														PH_S1RS																									
																,
																
														
														PH_S2ST																									
																,
																
														
														PH_S2AT																									
																,
																
														
														PH_S2RS																									
																,
																
														
														PH_S3ST																									
																,
																
														
														PH_S3AT																									
																,
																
														
														PH_S3RS																									
																,
																
														
														PH_S4ST																									
																,
																
														
														PH_S4AT																									
																,
																
														
														PH_S4RS
										)
									values (
									
									
									'SS_TS1_104_',
									
									'TS1_104_01', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-17'
															,'11:23'
															,'11:23'
															,'6'
															,'13:23'
															,'13:23'
															,'5'
															,'14:23'
															,'14:23'
															,'4.5'
															,'15:23'
															,'15:23'
															,'3'		
									);
										
									insert into NCT01928420_All_Data.PharmacokineticsResults (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														PH_DT																									
																,
																
														
														PH_S1ST																									
																,
																
														
														PH_S1AT																									
																,
																
														
														PH_S1RS																									
																,
																
														
														PH_S2ST																									
																,
																
														
														PH_S2AT																									
																,
																
														
														PH_S2RS																									
																,
																
														
														PH_S3ST																									
																,
																
														
														PH_S3AT																									
																,
																
														
														PH_S3RS																									
																,
																
														
														PH_S4ST																									
																,
																
														
														PH_S4AT																									
																,
																
														
														PH_S4RS
										)
									values (
									
									
									'SS_TS3_104_',
									
									'TS3_104_03', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-17'
															,'11:23'
															,'11:23'
															,'6'
															,'13:23'
															,'13:23'
															,'5'
															,'14:23'
															,'14:23'
															,'4.5'
															,'15:23'
															,'15:23'
															,'3'		
									);
										
									insert into NCT01928420_All_Data.PharmacokineticsResults (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														PH_DT																									
																,
																
														
														PH_S1ST																									
																,
																
														
														PH_S1AT																									
																,
																
														
														PH_S1RS																									
																,
																
														
														PH_S2ST																									
																,
																
														
														PH_S2AT																									
																,
																
														
														PH_S2RS																									
																,
																
														
														PH_S3ST																									
																,
																
														
														PH_S3AT																									
																,
																
														
														PH_S3RS																									
																,
																
														
														PH_S4ST																									
																,
																
														
														PH_S4AT																									
																,
																
														
														PH_S4RS
										)
									values (
									
									
									'SS_TS8_104_',
									
									'TS8_104_08', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,'10:12'
															,'10:12'
															,'5'
															,'12:12'
															,'12:12'
															,'4'
															,'13:12'
															,'13:12'
															,'3'
															,'14:12'
															,'14:12'
															,'2'		
									);
										
									insert into NCT01928420_All_Data.PharmacokineticsResults (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														PH_DT																									
																,
																
														
														PH_S1ST																									
																,
																
														
														PH_S1AT																									
																,
																
														
														PH_S1RS																									
																,
																
														
														PH_S2ST																									
																,
																
														
														PH_S2AT																									
																,
																
														
														PH_S2RS																									
																,
																
														
														PH_S3ST																									
																,
																
														
														PH_S3AT																									
																,
																
														
														PH_S3RS																									
																,
																
														
														PH_S4ST																									
																,
																
														
														PH_S4AT																									
																,
																
														
														PH_S4RS
										)
									values (
									
									
									'SS_TS8_104_',
									
									'TS8_104_08', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,'10:10'
															,'10:10'
															,'5'
															,'12:10'
															,'12:10'
															,'4'
															,'13:10'
															,'13:10'
															,'3'
															,'14:10'
															,'14:10'
															,'2'		
									);
										
									insert into NCT01928420_All_Data.PharmacokineticsResults (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														PH_DT																									
																,
																
														
														PH_S1ST																									
																,
																
														
														PH_S1AT																									
																,
																
														
														PH_S1RS																									
																,
																
														
														PH_S2ST																									
																,
																
														
														PH_S2AT																									
																,
																
														
														PH_S2RS																									
																,
																
														
														PH_S3ST																									
																,
																
														
														PH_S3AT																									
																,
																
														
														PH_S3RS																									
																,
																
														
														PH_S4ST																									
																,
																
														
														PH_S4AT																									
																,
																
														
														PH_S4RS
										)
									values (
									
									
									'SS_TS8_104_',
									
									'TS8_104_08', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,1
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-11'
															,'12:32'
															,'12:32'
															,'5'
															,'14:32'
															,'14:32'
															,'4'
															,'15:32'
															,'15:32'
															,'3'
															,'16:32'
															,'16:32'
															,'2'		
									);
										
									insert into NCT01928420_All_Data.PharmacokineticsResults (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														PH_DT																									
																,
																
														
														PH_S1ST																									
																,
																
														
														PH_S1AT																									
																,
																
														
														PH_S1RS																									
																,
																
														
														PH_S2ST																									
																,
																
														
														PH_S2AT																									
																,
																
														
														PH_S2RS																									
																,
																
														
														PH_S3ST																									
																,
																
														
														PH_S3AT																									
																,
																
														
														PH_S3RS																									
																,
																
														
														PH_S4ST																									
																,
																
														
														PH_S4AT																									
																,
																
														
														PH_S4RS
										)
									values (
									
									
									'SS_TS8_104_',
									
									'TS8_104_08', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,2
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,'12:32'
															,'12:32'
															,'4'
															,'14:32'
															,'14:32'
															,'3'
															,'15:32'
															,'15:32'
															,'2'
															,'16:32'
															,'16:32'
															,'1'		
									);
										
									insert into NCT01928420_All_Data.PharmacokineticsResults (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														PH_DT																									
																,
																
														
														PH_S1ST																									
																,
																
														
														PH_S1AT																									
																,
																
														
														PH_S1RS																									
																,
																
														
														PH_S2ST																									
																,
																
														
														PH_S2AT																									
																,
																
														
														PH_S2RS																									
																,
																
														
														PH_S3ST																									
																,
																
														
														PH_S3AT																									
																,
																
														
														PH_S3RS																									
																,
																
														
														PH_S4ST																									
																,
																
														
														PH_S4AT																									
																,
																
														
														PH_S4RS
										)
									values (
									
									
									'SS_TS13_105',
									
									'TS13_105_13', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,'10:12'
															,'10:12'
															,'5'
															,'12:12'
															,'12:12'
															,'4'
															,'13:12'
															,'13:12'
															,'3'
															,'14:12'
															,'14:12'
															,'2'		
									);
										
									insert into NCT01928420_All_Data.PharmacokineticsResults (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														PH_DT																									
																,
																
														
														PH_S1ST																									
																,
																
														
														PH_S1AT																									
																,
																
														
														PH_S1RS																									
																,
																
														
														PH_S2ST																									
																,
																
														
														PH_S2AT																									
																,
																
														
														PH_S2RS																									
																,
																
														
														PH_S3ST																									
																,
																
														
														PH_S3AT																									
																,
																
														
														PH_S3RS																									
																,
																
														
														PH_S4ST																									
																,
																
														
														PH_S4AT																									
																,
																
														
														PH_S4RS
										)
									values (
									
									
									'SS_TS13_105',
									
									'TS13_105_13', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,'10:10'
															,'10:10'
															,'5'
															,'12:10'
															,'12:10'
															,'4'
															,'13:10'
															,'13:10'
															,'3'
															,'14:10'
															,'14:10'
															,'2'		
									);
										
									insert into NCT01928420_All_Data.PharmacokineticsResults (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														PH_DT																									
																,
																
														
														PH_S1ST																									
																,
																
														
														PH_S1AT																									
																,
																
														
														PH_S1RS																									
																,
																
														
														PH_S2ST																									
																,
																
														
														PH_S2AT																									
																,
																
														
														PH_S2RS																									
																,
																
														
														PH_S3ST																									
																,
																
														
														PH_S3AT																									
																,
																
														
														PH_S3RS																									
																,
																
														
														PH_S4ST																									
																,
																
														
														PH_S4AT																									
																,
																
														
														PH_S4RS
										)
									values (
									
									
									'SS_TS13_105',
									
									'TS13_105_13', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,1
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-11'
															,'12:32'
															,'12:32'
															,'5'
															,'14:32'
															,'14:32'
															,'4'
															,'15:32'
															,'15:32'
															,'3'
															,'16:32'
															,'16:32'
															,'2'		
									);
										
									insert into NCT01928420_All_Data.PharmacokineticsResults (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														PH_DT																									
																,
																
														
														PH_S1ST																									
																,
																
														
														PH_S1AT																									
																,
																
														
														PH_S1RS																									
																,
																
														
														PH_S2ST																									
																,
																
														
														PH_S2AT																									
																,
																
														
														PH_S2RS																									
																,
																
														
														PH_S3ST																									
																,
																
														
														PH_S3AT																									
																,
																
														
														PH_S3RS																									
																,
																
														
														PH_S4ST																									
																,
																
														
														PH_S4AT																									
																,
																
														
														PH_S4RS
										)
									values (
									
									
									'SS_TS13_105',
									
									'TS13_105_13', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,2
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,'12:32'
															,'12:32'
															,'4'
															,'14:32'
															,'14:32'
															,'3'
															,'15:32'
															,'15:32'
															,'2'
															,'16:32'
															,'16:32'
															,'1'		
									);
										
									insert into NCT01928420_All_Data.PharmacokineticsResults (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														PH_DT																									
																,
																
														
														PH_S1ST																									
																,
																
														
														PH_S1AT																									
																,
																
														
														PH_S1RS																									
																,
																
														
														PH_S2ST																									
																,
																
														
														PH_S2AT																									
																,
																
														
														PH_S2RS																									
																,
																
														
														PH_S3ST																									
																,
																
														
														PH_S3AT																									
																,
																
														
														PH_S3RS																									
																,
																
														
														PH_S4ST																									
																,
																
														
														PH_S4AT																									
																,
																
														
														PH_S4RS
										)
									values (
									
									
									'SS_TS2_105_',
									
									'TS2_105_02', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-17'
															,'11:23'
															,'11:23'
															,'6'
															,'13:23'
															,'13:23'
															,'5'
															,'14:23'
															,'14:23'
															,'4.5'
															,'15:23'
															,'15:23'
															,'3'		
									);
										
									insert into NCT01928420_All_Data.PharmacokineticsResults (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														PH_DT																									
																,
																
														
														PH_S1ST																									
																,
																
														
														PH_S1AT																									
																,
																
														
														PH_S1RS																									
																,
																
														
														PH_S2ST																									
																,
																
														
														PH_S2AT																									
																,
																
														
														PH_S2RS																									
																,
																
														
														PH_S3ST																									
																,
																
														
														PH_S3AT																									
																,
																
														
														PH_S3RS																									
																,
																
														
														PH_S4ST																									
																,
																
														
														PH_S4AT																									
																,
																
														
														PH_S4RS
										)
									values (
									
									
									'SS_TS7_105_',
									
									'TS7_105_07', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-17'
															,'11:23'
															,'11:23'
															,'6'
															,'13:23'
															,'13:23'
															,'5'
															,'14:23'
															,'14:23'
															,'4.5'
															,'15:23'
															,'15:23'
															,'3'		
									);
										
									insert into NCT01928420_All_Data.PharmacokineticsResults (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														PH_DT																									
																,
																
														
														PH_S1ST																									
																,
																
														
														PH_S1AT																									
																,
																
														
														PH_S1RS																									
																,
																
														
														PH_S2ST																									
																,
																
														
														PH_S2AT																									
																,
																
														
														PH_S2RS																									
																,
																
														
														PH_S3ST																									
																,
																
														
														PH_S3AT																									
																,
																
														
														PH_S3RS																									
																,
																
														
														PH_S4ST																									
																,
																
														
														PH_S4AT																									
																,
																
														
														PH_S4RS
										)
									values (
									
									
									'SS_TS9_105_',
									
									'TS9_105_09', 	 									
									
									'SE_1WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,'10:12'
															,'10:12'
															,'5'
															,'12:12'
															,'12:12'
															,'4'
															,'13:12'
															,'13:12'
															,'3'
															,'14:12'
															,'14:12'
															,'2'		
									);
										
									insert into NCT01928420_All_Data.PharmacokineticsResults (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														PH_DT																									
																,
																
														
														PH_S1ST																									
																,
																
														
														PH_S1AT																									
																,
																
														
														PH_S1RS																									
																,
																
														
														PH_S2ST																									
																,
																
														
														PH_S2AT																									
																,
																
														
														PH_S2RS																									
																,
																
														
														PH_S3ST																									
																,
																
														
														PH_S3AT																									
																,
																
														
														PH_S3RS																									
																,
																
														
														PH_S4ST																									
																,
																
														
														PH_S4AT																									
																,
																
														
														PH_S4RS
										)
									values (
									
									
									'SS_TS9_105_',
									
									'TS9_105_09', 	 									
									
									'SE_2WEEKFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,'10:10'
															,'10:10'
															,'5'
															,'12:10'
															,'12:10'
															,'4'
															,'13:10'
															,'13:10'
															,'3'
															,'14:10'
															,'14:10'
															,'2'		
									);
										
									insert into NCT01928420_All_Data.PharmacokineticsResults (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														PH_DT																									
																,
																
														
														PH_S1ST																									
																,
																
														
														PH_S1AT																									
																,
																
														
														PH_S1RS																									
																,
																
														
														PH_S2ST																									
																,
																
														
														PH_S2AT																									
																,
																
														
														PH_S2RS																									
																,
																
														
														PH_S3ST																									
																,
																
														
														PH_S3AT																									
																,
																
														
														PH_S3RS																									
																,
																
														
														PH_S4ST																									
																,
																
														
														PH_S4AT																									
																,
																
														
														PH_S4RS
										)
									values (
									
									
									'SS_TS9_105_',
									
									'TS9_105_09', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,1
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-11'
															,'12:32'
															,'12:32'
															,'5'
															,'14:32'
															,'14:32'
															,'4'
															,'15:32'
															,'15:32'
															,'3'
															,'16:32'
															,'16:32'
															,'2'		
									);
										
									insert into NCT01928420_All_Data.PharmacokineticsResults (
									ssoid, ssid, study_event_oid
									 
										,event_ordinal
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														PH_DT																									
																,
																
														
														PH_S1ST																									
																,
																
														
														PH_S1AT																									
																,
																
														
														PH_S1RS																									
																,
																
														
														PH_S2ST																									
																,
																
														
														PH_S2AT																									
																,
																
														
														PH_S2RS																									
																,
																
														
														PH_S3ST																									
																,
																
														
														PH_S3AT																									
																,
																
														
														PH_S3RS																									
																,
																
														
														PH_S4ST																									
																,
																
														
														PH_S4AT																									
																,
																
														
														PH_S4RS
										)
									values (
									
									
									'SS_TS9_105_',
									
									'TS9_105_09', 	 									
									
									'SE_MONTHLYFU' 									  
									
									
										,2
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,'2014-06-10'
															,'12:32'
															,'12:32'
															,'4'
															,'14:32'
															,'14:32'
															,'3'
															,'15:32'
															,'15:32'
															,'2'
															,'16:32'
															,'16:32'
															,'1'		
									);
								
			  
			
					insert into NCT01928420_All_Data.crf_version (crf_name, crf_version_name, warehouse_insert_created_timestamp) values 
					( 'Completion/Discontinuation', 
					'V1.0',
					'2015-03-19T16:41:35.717Z');
			
			
			
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS10_101',
									
					'TS10_101_10',
					
				'SE_EOSORLFU',
				
				'Completion/Discontinuation',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS10_102',
									
					'TS10_102_10',
					
				'SE_EOSORLFU',
				
				'Completion/Discontinuation',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS8_102_',
									
					'TS8_102_08',
					
				'SE_EOSORLFU',
				
				'Completion/Discontinuation',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS10_103',
									
					'TS10_103_10',
					
				'SE_EOSORLFU',
				
				'Completion/Discontinuation',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS8_103_',
									
					'TS8_103_08',
					
				'SE_EOSORLFU',
				
				'Completion/Discontinuation',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS10_104',
									
					'TS10_104_10',
					
				'SE_EOSORLFU',
				
				'Completion/Discontinuation',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS8_104_',
									
					'TS8_104_08',
					
				'SE_EOSORLFU',
				
				'Completion/Discontinuation',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS13_105',
									
					'TS13_105_13',
					
				'SE_EOSORLFU',
				
				'Completion/Discontinuation',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS9_105_',
									
					'TS9_105_09',
					
				'SE_EOSORLFU',
				
				'Completion/Discontinuation',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
				create table NCT01928420_All_Data.Completion_DiscontinuationCD (
				item_data_id serial NOT NULL,
				ssoid character varying(40) NOT NULL,
				ssid character varying(40) NOT NULL,
				study_event_oid character varying(40) NOT NULL,
				event_ordinal integer default 1,
				crf_version character varying(255),
				event_start_date timestamp without time zone,
				event_end_date timestamp without time zone,
				event_status character varying(255),
				event_location character varying(2000),
				subject_age_at_event integer,
				crf_status character varying(255), 
				interviewerName character varying(255),
				interviewDate date,
				warehouse_insert_created_timestamp timestamp with time zone); 			          	 
				
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Completion_DiscontinuationCD', 'CD_YN', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Completion_DiscontinuationCD', 'CD_YN_label', 'character varying(255)');

	
			
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Completion_DiscontinuationCD', 'CD_WTHDR_Patient_voluntarily_withdre0001',
			'boolean');
			
			
			
				SELECT NCT01928420_All_Data.save_column_name('CD_WTHDR_Patient_voluntarily_withdre0001','CD_WTHDR','Patient_voluntarily_withdrew_from_study');
			
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Completion_DiscontinuationCD', 'WTHDR_SP', 'text');

	
			
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Completion_DiscontinuationCD', 'CD_MISS_Patient_missed_appointment',
			'boolean');
			
			
			
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Completion_DiscontinuationCD', 'MISS_EV', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Completion_DiscontinuationCD', 'MISS_EV_label', 'character varying(255)');

	
			
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Completion_DiscontinuationCD', 'CD_AE_Adverse_event_occurred',
			'boolean');
			
			
			
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Completion_DiscontinuationCD', 'AE_SP', 'text');

	
			
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Completion_DiscontinuationCD', 'CD_DTH_Patient_expired',
			'boolean');
			
			
			
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Completion_DiscontinuationCD', 'DTH_CAUSE', 'text');

	
			
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Completion_DiscontinuationCD', 'CD_OTH_Other_reason',
			'boolean');
			
			
			
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Completion_DiscontinuationCD', 'OTH_SP', 'text');

	
				
		ALTER TABLE NCT01928420_All_Data.Completion_DiscontinuationCD ADD CONSTRAINT Pk_CD PRIMARY KEY (item_data_id);

		
				
		ALTER TABLE NCT01928420_All_Data.Completion_DiscontinuationCD ADD CONSTRAINT 	
		Fk_study_subject_id_CD FOREIGN KEY (ssoid, 
		ssid) REFERENCES NCT01928420_All_Data.study_subject_listing;
		
				
									insert into NCT01928420_All_Data.Completion_DiscontinuationCD (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														CD_YN
																												
																	,CD_YN_label
										)
									values (
									
									
									'SS_TS10_101',
									
									'TS10_101_10', 	 									
									
									'SE_EOSORLFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
																
									);
										
									insert into NCT01928420_All_Data.Completion_DiscontinuationCD (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														CD_YN
																												
																	,CD_YN_label
										)
									values (
									
									
									'SS_TS10_102',
									
									'TS10_102_10', 	 									
									
									'SE_EOSORLFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
																
									);
										
									insert into NCT01928420_All_Data.Completion_DiscontinuationCD (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														CD_YN
																												
																	,CD_YN_label
										)
									values (
									
									
									'SS_TS8_102_',
									
									'TS8_102_08', 	 									
									
									'SE_EOSORLFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
																
									);
										
									insert into NCT01928420_All_Data.Completion_DiscontinuationCD (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														CD_YN
																												
																	,CD_YN_label
										)
									values (
									
									
									'SS_TS10_103',
									
									'TS10_103_10', 	 									
									
									'SE_EOSORLFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
																
									);
										
									insert into NCT01928420_All_Data.Completion_DiscontinuationCD (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														CD_YN
																												
																	,CD_YN_label
										)
									values (
									
									
									'SS_TS8_103_',
									
									'TS8_103_08', 	 									
									
									'SE_EOSORLFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
																
									);
										
									insert into NCT01928420_All_Data.Completion_DiscontinuationCD (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														CD_YN
																												
																	,CD_YN_label
										)
									values (
									
									
									'SS_TS10_104',
									
									'TS10_104_10', 	 									
									
									'SE_EOSORLFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
																
									);
										
									insert into NCT01928420_All_Data.Completion_DiscontinuationCD (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														CD_YN
																												
																	,CD_YN_label
										)
									values (
									
									
									'SS_TS8_104_',
									
									'TS8_104_08', 	 									
									
									'SE_EOSORLFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
																
									);
										
									insert into NCT01928420_All_Data.Completion_DiscontinuationCD (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														CD_YN
																												
																	,CD_YN_label
										)
									values (
									
									
									'SS_TS13_105',
									
									'TS13_105_13', 	 									
									
									'SE_EOSORLFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
																
									);
										
									insert into NCT01928420_All_Data.Completion_DiscontinuationCD (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														CD_YN
																												
																	,CD_YN_label
										)
									values (
									
									
									'SS_TS9_105_',
									
									'TS9_105_09', 	 									
									
									'SE_EOSORLFU' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
																
									);
								
			  
			
					insert into NCT01928420_All_Data.crf_version (crf_name, crf_version_name, warehouse_insert_created_timestamp) values 
					( 'Medical History', 
					'V1.0',
					'2015-03-19T16:41:35.717Z');
			
			
			
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS10_101',
									
					'TS10_101_10',
					
				'SE_LOGS',
				
				'Medical History',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS3_101_',
									
					'TS3_101_03',
					
				'SE_LOGS',
				
				'Medical History',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS6_101_',
									
					'TS6_101_06',
					
				'SE_LOGS',
				
				'Medical History',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS10_102',
									
					'TS10_102_10',
					
				'SE_LOGS',
				
				'Medical History',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS1_102_',
									
					'TS1_102_01',
					
				'SE_LOGS',
				
				'Medical History',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS3_102_',
									
					'TS3_102_03',
					
				'SE_LOGS',
				
				'Medical History',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS6_102_',
									
					'TS6_102_06',
					
				'SE_LOGS',
				
				'Medical History',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS8_102_',
									
					'TS8_102_08',
					
				'SE_LOGS',
				
				'Medical History',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS10_103',
									
					'TS10_103_10',
					
				'SE_LOGS',
				
				'Medical History',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS1_103_',
									
					'TS1_103_01',
					
				'SE_LOGS',
				
				'Medical History',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS3_103_',
									
					'TS3_103_03',
					
				'SE_LOGS',
				
				'Medical History',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS6_103_',
									
					'TS6_103_06',
					
				'SE_LOGS',
				
				'Medical History',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS8_103_',
									
					'TS8_103_08',
					
				'SE_LOGS',
				
				'Medical History',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS10_104',
									
					'TS10_104_10',
					
				'SE_LOGS',
				
				'Medical History',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS1_104_',
									
					'TS1_104_01',
					
				'SE_LOGS',
				
				'Medical History',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS3_104_',
									
					'TS3_104_03',
					
				'SE_LOGS',
				
				'Medical History',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS6_104_',
									
					'TS6_104_06',
					
				'SE_LOGS',
				
				'Medical History',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS8_104_',
									
					'TS8_104_08',
					
				'SE_LOGS',
				
				'Medical History',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS13_105',
									
					'TS13_105_13',
					
				'SE_LOGS',
				
				'Medical History',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS2_105_',
									
					'TS2_105_02',
					
				'SE_LOGS',
				
				'Medical History',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS6_105_',
									
					'TS6_105_06',
					
				'SE_LOGS',
				
				'Medical History',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS7_105_',
									
					'TS7_105_07',
					
				'SE_LOGS',
				
				'Medical History',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS9_105_',
									
					'TS9_105_09',
					
				'SE_LOGS',
				
				'Medical History',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
			create table NCT01928420_All_Data.Medical_HistoryG1 (		
			item_data_id serial NOT NULL,	
			ssoid character varying(40) NOT NULL,			
			ssid character varying(40) NOT NULL,
			study_event_oid character varying(40) NOT NULL,
			event_ordinal integer default 1,	
			crf_version character varying(255),
			event_start_date timestamp without time zone,
			event_end_date timestamp without time zone,
			event_status character varying(255),
			event_location character varying(2000),
			subject_age_at_event integer,
			crf_status character varying(255), 
			interviewerName character varying(255),
			interviewDate date, 
			item_group_repeat_key integer,
			warehouse_insert_created_timestamp timestamp with time zone);
			
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Medical_HistoryG1', 'PER_DIAG', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Medical_HistoryG1', 'PER_DATE_min', 'date');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Medical_HistoryG1', 'PER_DATE_max', 'date');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Medical_HistoryG1', 'PER_COMM', 'text');

	
			ALTER TABLE NCT01928420_All_Data.Medical_HistoryG1 ADD CONSTRAINT Pk_G1 PRIMARY KEY (item_data_id);
	
			ALTER TABLE NCT01928420_All_Data.Medical_HistoryG1 ADD CONSTRAINT Fk_study_subject_id_G1 FOREIGN KEY (ssoid, ssid) REFERENCES NCT01928420_All_Data.study_subject_listing;
				
													
									insert into NCT01928420_All_Data.Medical_HistoryG1 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PER_DIAG														
														,PER_DATE_min
																
														,PER_DATE_max
										
									)
									values (		
									'SS_TS10_101',											
									'TS10_101_10', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'AD'
																,
													
							'2012-09-12'
						,												
																		
													
							'2012-09-12'
								
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG1 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PER_DIAG																										
														,
												PER_COMM								
									)
									values (		
									'SS_TS10_101',											
									'TS10_101_10', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Diabetes'
																,'Type II'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG1 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PER_DIAG																										
														,
												PER_COMM								
									)
									values (		
									'SS_TS3_101_',											
									'TS3_101_03', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'AD'
																,'Unknown Date'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG1 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PER_DIAG																										
														,
												PER_COMM								
									)
									values (		
									'SS_TS3_101_',											
									'TS3_101_03', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Migraines'
																,'Unknown Date'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG1 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PER_DIAG																										
														,
												PER_COMM								
									)
									values (		
									'SS_TS3_101_',											
									'TS3_101_03', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,3
									, '2015-03-19T16:41:35.717Z'										
							
																,'Diabetes'
																,'Unknown Date'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG1 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PER_DIAG																										
														,
												PER_COMM								
									)
									values (		
									'SS_TS6_101_',											
									'TS6_101_06', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'AD'
																,'Date Unknown'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG1 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PER_DIAG														
														,PER_DATE_min
																
														,PER_DATE_max
																												
														,
												PER_COMM								
									)
									values (		
									'SS_TS6_101_',											
									'TS6_101_06', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Diabetes'
																,
													
							'1988-09-12'
						,												
																		
													
							'1988-09-12'
						
																,'Type II'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG1 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PER_DIAG								
									)
									values (		
									'SS_TS10_102',											
									'TS10_102_10', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'AD'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG1 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PER_DIAG																										
														,
												PER_COMM								
									)
									values (		
									'SS_TS10_102',											
									'TS10_102_10', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Diabetes'
																,'Type II'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG1 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PER_DIAG																										
														,
												PER_COMM								
									)
									values (		
									'SS_TS1_102_',											
									'TS1_102_01', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'AD'
																,'Unknown Date'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG1 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PER_DIAG																										
														,
												PER_COMM								
									)
									values (		
									'SS_TS1_102_',											
									'TS1_102_01', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Migraines'
																,'Unknown Date'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG1 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PER_DIAG																										
														,
												PER_COMM								
									)
									values (		
									'SS_TS1_102_',											
									'TS1_102_01', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,3
									, '2015-03-19T16:41:35.717Z'										
							
																,'Diabetes'
																,'Unknown Date'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG1 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PER_DIAG																										
														,
												PER_COMM								
									)
									values (		
									'SS_TS3_102_',											
									'TS3_102_03', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'AD'
																,'Unknown Date'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG1 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PER_DIAG																										
														,
												PER_COMM								
									)
									values (		
									'SS_TS3_102_',											
									'TS3_102_03', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Migraines'
																,'Unknown Date'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG1 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PER_DIAG																										
														,
												PER_COMM								
									)
									values (		
									'SS_TS3_102_',											
									'TS3_102_03', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,3
									, '2015-03-19T16:41:35.717Z'										
							
																,'Diabetes'
																,'Unknown Date'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG1 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PER_DIAG																										
														,
												PER_COMM								
									)
									values (		
									'SS_TS6_102_',											
									'TS6_102_06', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'AD'
																,'Date Unknown'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG1 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PER_DIAG																										
														,
												PER_COMM								
									)
									values (		
									'SS_TS6_102_',											
									'TS6_102_06', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Diabetes'
																,'Type II'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG1 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PER_DIAG								
									)
									values (		
									'SS_TS8_102_',											
									'TS8_102_08', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'AD'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG1 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PER_DIAG																										
														,
												PER_COMM								
									)
									values (		
									'SS_TS8_102_',											
									'TS8_102_08', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Diabetes'
																,'Type II'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG1 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PER_DIAG								
									)
									values (		
									'SS_TS10_103',											
									'TS10_103_10', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'AD'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG1 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PER_DIAG																										
														,
												PER_COMM								
									)
									values (		
									'SS_TS10_103',											
									'TS10_103_10', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Diabetes'
																,'Type II'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG1 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PER_DIAG																										
														,
												PER_COMM								
									)
									values (		
									'SS_TS1_103_',											
									'TS1_103_01', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'AD'
																,'Unknown Date'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG1 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PER_DIAG																										
														,
												PER_COMM								
									)
									values (		
									'SS_TS1_103_',											
									'TS1_103_01', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Migraines'
																,'Unknown Date'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG1 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PER_DIAG																										
														,
												PER_COMM								
									)
									values (		
									'SS_TS1_103_',											
									'TS1_103_01', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,3
									, '2015-03-19T16:41:35.717Z'										
							
																,'Diabetes'
																,'Unknown Date'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG1 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PER_DIAG																										
														,
												PER_COMM								
									)
									values (		
									'SS_TS3_103_',											
									'TS3_103_03', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'AD'
																,'Unknown Date'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG1 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PER_DIAG																										
														,
												PER_COMM								
									)
									values (		
									'SS_TS3_103_',											
									'TS3_103_03', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Migraines'
																,'Unknown Date'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG1 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PER_DIAG																										
														,
												PER_COMM								
									)
									values (		
									'SS_TS3_103_',											
									'TS3_103_03', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,3
									, '2015-03-19T16:41:35.717Z'										
							
																,'Diabetes'
																,'Unknown Date'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG1 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PER_DIAG																										
														,
												PER_COMM								
									)
									values (		
									'SS_TS6_103_',											
									'TS6_103_06', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'AD'
																,'Date Unknown'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG1 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PER_DIAG																										
														,
												PER_COMM								
									)
									values (		
									'SS_TS6_103_',											
									'TS6_103_06', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Diabetes'
																,'Type II'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG1 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PER_DIAG								
									)
									values (		
									'SS_TS8_103_',											
									'TS8_103_08', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'AD'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG1 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PER_DIAG																										
														,
												PER_COMM								
									)
									values (		
									'SS_TS8_103_',											
									'TS8_103_08', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Diabetes'
																,'Type II'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG1 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PER_DIAG								
									)
									values (		
									'SS_TS10_104',											
									'TS10_104_10', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'AD'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG1 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PER_DIAG																										
														,
												PER_COMM								
									)
									values (		
									'SS_TS10_104',											
									'TS10_104_10', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Diabetes'
																,'Type II'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG1 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PER_DIAG																										
														,
												PER_COMM								
									)
									values (		
									'SS_TS1_104_',											
									'TS1_104_01', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'AD'
																,'Unknown Date'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG1 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PER_DIAG																										
														,
												PER_COMM								
									)
									values (		
									'SS_TS1_104_',											
									'TS1_104_01', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Migraines'
																,'Unknown Date'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG1 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PER_DIAG																										
														,
												PER_COMM								
									)
									values (		
									'SS_TS1_104_',											
									'TS1_104_01', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,3
									, '2015-03-19T16:41:35.717Z'										
							
																,'Diabetes'
																,'Unknown Date'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG1 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PER_DIAG																										
														,
												PER_COMM								
									)
									values (		
									'SS_TS3_104_',											
									'TS3_104_03', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'AD'
																,'Unknown Date'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG1 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PER_DIAG																										
														,
												PER_COMM								
									)
									values (		
									'SS_TS3_104_',											
									'TS3_104_03', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Migraines'
																,'Unknown Date'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG1 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PER_DIAG																										
														,
												PER_COMM								
									)
									values (		
									'SS_TS3_104_',											
									'TS3_104_03', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,3
									, '2015-03-19T16:41:35.717Z'										
							
																,'Diabetes'
																,'Unknown Date'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG1 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PER_DIAG																										
														,
												PER_COMM								
									)
									values (		
									'SS_TS6_104_',											
									'TS6_104_06', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'AD'
																,'Date Unknown'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG1 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PER_DIAG																										
														,
												PER_COMM								
									)
									values (		
									'SS_TS6_104_',											
									'TS6_104_06', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Diabetes'
																,'Type II'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG1 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PER_DIAG								
									)
									values (		
									'SS_TS8_104_',											
									'TS8_104_08', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'AD'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG1 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PER_DIAG																										
														,
												PER_COMM								
									)
									values (		
									'SS_TS8_104_',											
									'TS8_104_08', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Diabetes'
																,'Type II'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG1 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PER_DIAG								
									)
									values (		
									'SS_TS13_105',											
									'TS13_105_13', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'AD'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG1 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PER_DIAG																										
														,
												PER_COMM								
									)
									values (		
									'SS_TS13_105',											
									'TS13_105_13', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Diabetes'
																,'Type II'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG1 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PER_DIAG																										
														,
												PER_COMM								
									)
									values (		
									'SS_TS2_105_',											
									'TS2_105_02', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'AD'
																,'Unknown Date'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG1 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PER_DIAG																										
														,
												PER_COMM								
									)
									values (		
									'SS_TS2_105_',											
									'TS2_105_02', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Migraines'
																,'Unknown Date'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG1 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PER_DIAG																										
														,
												PER_COMM								
									)
									values (		
									'SS_TS2_105_',											
									'TS2_105_02', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,3
									, '2015-03-19T16:41:35.717Z'										
							
																,'Diabetes'
																,'Unknown Date'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG1 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PER_DIAG																										
														,
												PER_COMM								
									)
									values (		
									'SS_TS6_105_',											
									'TS6_105_06', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'AD'
																,'Date Unknown'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG1 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PER_DIAG																										
														,
												PER_COMM								
									)
									values (		
									'SS_TS6_105_',											
									'TS6_105_06', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Diabetes'
																,'Type II'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG1 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PER_DIAG																										
														,
												PER_COMM								
									)
									values (		
									'SS_TS7_105_',											
									'TS7_105_07', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'AD'
																,'Unknown Date'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG1 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PER_DIAG																										
														,
												PER_COMM								
									)
									values (		
									'SS_TS7_105_',											
									'TS7_105_07', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Migraines'
																,'Unknown Date'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG1 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PER_DIAG																										
														,
												PER_COMM								
									)
									values (		
									'SS_TS7_105_',											
									'TS7_105_07', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,3
									, '2015-03-19T16:41:35.717Z'										
							
																,'Diabetes'
																,'Unknown Date'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG1 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PER_DIAG								
									)
									values (		
									'SS_TS9_105_',											
									'TS9_105_09', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'AD'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG1 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PER_DIAG																										
														,
												PER_COMM								
									)
									values (		
									'SS_TS9_105_',											
									'TS9_105_09', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Diabetes'
																,'Type II'		
									);									
							
			create table NCT01928420_All_Data.Medical_HistoryG2 (		
			item_data_id serial NOT NULL,	
			ssoid character varying(40) NOT NULL,			
			ssid character varying(40) NOT NULL,
			study_event_oid character varying(40) NOT NULL,
			event_ordinal integer default 1,	
			crf_version character varying(255),
			event_start_date timestamp without time zone,
			event_end_date timestamp without time zone,
			event_status character varying(255),
			event_location character varying(2000),
			subject_age_at_event integer,
			crf_status character varying(255), 
			interviewerName character varying(255),
			interviewDate date, 
			item_group_repeat_key integer,
			warehouse_insert_created_timestamp timestamp with time zone);
			
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Medical_HistoryG2', 'FAM_ID', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Medical_HistoryG2', 'FAM_ID_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Medical_HistoryG2', 'FAM_DIAG', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Medical_HistoryG2', 'FAM_DATE_min', 'date');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Medical_HistoryG2', 'FAM_DATE_max', 'date');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Medical_HistoryG2', 'FAM_COMM', 'text');

	
			ALTER TABLE NCT01928420_All_Data.Medical_HistoryG2 ADD CONSTRAINT Pk_G2 PRIMARY KEY (item_data_id);
	
			ALTER TABLE NCT01928420_All_Data.Medical_HistoryG2 ADD CONSTRAINT Fk_study_subject_id_G2 FOREIGN KEY (ssoid, ssid) REFERENCES NCT01928420_All_Data.study_subject_listing;
				
													
									insert into NCT01928420_All_Data.Medical_HistoryG2 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												FAM_ID
																																								
														,FAM_ID_label																										
														,
												FAM_DIAG																										
														,
												FAM_COMM								
									)
									values (		
									'SS_TS10_101',											
									'TS10_101_10', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,1													
																,'Mother'											
															
																,'Breast cancer'
																,'Deceased'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG2 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												FAM_ID
																																								
														,FAM_ID_label																										
														,
												FAM_DIAG														
														,FAM_DATE_min
																
														,FAM_DATE_max
																												
														,
												FAM_COMM								
									)
									values (		
									'SS_TS3_101_',											
									'TS3_101_03', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,2													
																,'Father'											
															
																,'Colon cancer'
																,
													
							'1980-01-01'
						,												
																		
													
							'1980-01-01'
						
																,'Deceased'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG2 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												FAM_ID
																																								
														,FAM_ID_label																										
														,
												FAM_DIAG														
														,FAM_DATE_min
																
														,FAM_DATE_max
																												
														,
												FAM_COMM								
									)
									values (		
									'SS_TS3_101_',											
									'TS3_101_03', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,6													
																,'Maternal Grandmother'											
															
																,'Melanoma'
																,
													
							'1970-01-01'
						,												
																		
													
							'1970-01-01'
						
																,'Deceased'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG2 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												FAM_ID
																																								
														,FAM_ID_label																										
														,
												FAM_DIAG																										
														,
												FAM_COMM								
									)
									values (		
									'SS_TS3_101_',											
									'TS3_101_03', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,3
									, '2015-03-19T16:41:35.717Z'										
							
																,4													
																,'Sister'											
															
																,'Diabetes'
																,'Date Unknown'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG2 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												FAM_ID
																																								
														,FAM_ID_label																										
														,
												FAM_DIAG																										
														,
												FAM_COMM								
									)
									values (		
									'SS_TS10_102',											
									'TS10_102_10', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,1													
																,'Mother'											
															
																,'Breast cancer'
																,'Deceased'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG2 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												FAM_ID
																																								
														,FAM_ID_label																										
														,
												FAM_DIAG																										
														,
												FAM_COMM								
									)
									values (		
									'SS_TS1_102_',											
									'TS1_102_01', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,2													
																,'Father'											
															
																,'Colon cancer'
																,'Deceased'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG2 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												FAM_ID
																																								
														,FAM_ID_label																										
														,
												FAM_DIAG																										
														,
												FAM_COMM								
									)
									values (		
									'SS_TS1_102_',											
									'TS1_102_01', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,6													
																,'Maternal Grandmother'											
															
																,'Melanoma'
																,'Deceased'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG2 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												FAM_ID
																																								
														,FAM_ID_label																										
														,
												FAM_DIAG																										
														,
												FAM_COMM								
									)
									values (		
									'SS_TS1_102_',											
									'TS1_102_01', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,3
									, '2015-03-19T16:41:35.717Z'										
							
																,4													
																,'Sister'											
															
																,'Diabetes'
																,'Date Unknown'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG2 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												FAM_ID
																																								
														,FAM_ID_label																										
														,
												FAM_DIAG																										
														,
												FAM_COMM								
									)
									values (		
									'SS_TS3_102_',											
									'TS3_102_03', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,2													
																,'Father'											
															
																,'Colon cancer'
																,'Deceased'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG2 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												FAM_ID
																																								
														,FAM_ID_label																										
														,
												FAM_DIAG																										
														,
												FAM_COMM								
									)
									values (		
									'SS_TS3_102_',											
									'TS3_102_03', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,6													
																,'Maternal Grandmother'											
															
																,'Melanoma'
																,'Deceased'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG2 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												FAM_ID
																																								
														,FAM_ID_label																										
														,
												FAM_DIAG																										
														,
												FAM_COMM								
									)
									values (		
									'SS_TS3_102_',											
									'TS3_102_03', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,3
									, '2015-03-19T16:41:35.717Z'										
							
																,4													
																,'Sister'											
															
																,'Diabetes'
																,'Date Unknown'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG2 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												FAM_ID
																																								
														,FAM_ID_label																										
														,
												FAM_DIAG																										
														,
												FAM_COMM								
									)
									values (		
									'SS_TS8_102_',											
									'TS8_102_08', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,1													
																,'Mother'											
															
																,'Breast cancer'
																,'Deceased'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG2 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												FAM_ID
																																								
														,FAM_ID_label																										
														,
												FAM_DIAG																										
														,
												FAM_COMM								
									)
									values (		
									'SS_TS10_103',											
									'TS10_103_10', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,1													
																,'Mother'											
															
																,'Breast cancer'
																,'Deceased'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG2 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												FAM_ID
																																								
														,FAM_ID_label																										
														,
												FAM_DIAG																										
														,
												FAM_COMM								
									)
									values (		
									'SS_TS1_103_',											
									'TS1_103_01', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,2													
																,'Father'											
															
																,'Colon cancer'
																,'Deceased'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG2 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												FAM_ID
																																								
														,FAM_ID_label																										
														,
												FAM_DIAG																										
														,
												FAM_COMM								
									)
									values (		
									'SS_TS1_103_',											
									'TS1_103_01', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,6													
																,'Maternal Grandmother'											
															
																,'Melanoma'
																,'Deceased'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG2 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												FAM_ID
																																								
														,FAM_ID_label																										
														,
												FAM_DIAG																										
														,
												FAM_COMM								
									)
									values (		
									'SS_TS1_103_',											
									'TS1_103_01', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,3
									, '2015-03-19T16:41:35.717Z'										
							
																,4													
																,'Sister'											
															
																,'Diabetes'
																,'Date Unknown'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG2 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												FAM_ID
																																								
														,FAM_ID_label																										
														,
												FAM_DIAG																										
														,
												FAM_COMM								
									)
									values (		
									'SS_TS3_103_',											
									'TS3_103_03', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,2													
																,'Father'											
															
																,'Colon cancer'
																,'Deceased'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG2 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												FAM_ID
																																								
														,FAM_ID_label																										
														,
												FAM_DIAG																										
														,
												FAM_COMM								
									)
									values (		
									'SS_TS3_103_',											
									'TS3_103_03', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,6													
																,'Maternal Grandmother'											
															
																,'Melanoma'
																,'Deceased'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG2 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												FAM_ID
																																								
														,FAM_ID_label																										
														,
												FAM_DIAG																										
														,
												FAM_COMM								
									)
									values (		
									'SS_TS3_103_',											
									'TS3_103_03', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,3
									, '2015-03-19T16:41:35.717Z'										
							
																,4													
																,'Sister'											
															
																,'Diabetes'
																,'Date Unknown'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG2 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												FAM_ID
																																								
														,FAM_ID_label																										
														,
												FAM_DIAG																										
														,
												FAM_COMM								
									)
									values (		
									'SS_TS8_103_',											
									'TS8_103_08', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,1													
																,'Mother'											
															
																,'Breast cancer'
																,'Deceased'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG2 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												FAM_ID
																																								
														,FAM_ID_label																										
														,
												FAM_DIAG																										
														,
												FAM_COMM								
									)
									values (		
									'SS_TS10_104',											
									'TS10_104_10', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,1													
																,'Mother'											
															
																,'Breast cancer'
																,'Deceased'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG2 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												FAM_ID
																																								
														,FAM_ID_label																										
														,
												FAM_DIAG																										
														,
												FAM_COMM								
									)
									values (		
									'SS_TS1_104_',											
									'TS1_104_01', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,2													
																,'Father'											
															
																,'Colon cancer'
																,'Deceased'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG2 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												FAM_ID
																																								
														,FAM_ID_label																										
														,
												FAM_DIAG																										
														,
												FAM_COMM								
									)
									values (		
									'SS_TS1_104_',											
									'TS1_104_01', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,6													
																,'Maternal Grandmother'											
															
																,'Melanoma'
																,'Deceased'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG2 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												FAM_ID
																																								
														,FAM_ID_label																										
														,
												FAM_DIAG																										
														,
												FAM_COMM								
									)
									values (		
									'SS_TS1_104_',											
									'TS1_104_01', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,3
									, '2015-03-19T16:41:35.717Z'										
							
																,4													
																,'Sister'											
															
																,'Diabetes'
																,'Date Unknown'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG2 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												FAM_ID
																																								
														,FAM_ID_label																										
														,
												FAM_DIAG																										
														,
												FAM_COMM								
									)
									values (		
									'SS_TS3_104_',											
									'TS3_104_03', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,2													
																,'Father'											
															
																,'Colon cancer'
																,'Deceased'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG2 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												FAM_ID
																																								
														,FAM_ID_label																										
														,
												FAM_DIAG																										
														,
												FAM_COMM								
									)
									values (		
									'SS_TS3_104_',											
									'TS3_104_03', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,6													
																,'Maternal Grandmother'											
															
																,'Melanoma'
																,'Deceased'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG2 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												FAM_ID
																																								
														,FAM_ID_label																										
														,
												FAM_DIAG																										
														,
												FAM_COMM								
									)
									values (		
									'SS_TS3_104_',											
									'TS3_104_03', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,3
									, '2015-03-19T16:41:35.717Z'										
							
																,4													
																,'Sister'											
															
																,'Diabetes'
																,'Date Unknown'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG2 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												FAM_ID
																																								
														,FAM_ID_label																										
														,
												FAM_DIAG																										
														,
												FAM_COMM								
									)
									values (		
									'SS_TS8_104_',											
									'TS8_104_08', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,1													
																,'Mother'											
															
																,'Breast cancer'
																,'Deceased'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG2 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												FAM_ID
																																								
														,FAM_ID_label																										
														,
												FAM_DIAG																										
														,
												FAM_COMM								
									)
									values (		
									'SS_TS13_105',											
									'TS13_105_13', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,1													
																,'Mother'											
															
																,'Breast cancer'
																,'Deceased'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG2 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												FAM_ID
																																								
														,FAM_ID_label																										
														,
												FAM_DIAG																										
														,
												FAM_COMM								
									)
									values (		
									'SS_TS2_105_',											
									'TS2_105_02', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,2													
																,'Father'											
															
																,'Colon cancer'
																,'Deceased'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG2 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												FAM_ID
																																								
														,FAM_ID_label																										
														,
												FAM_DIAG																										
														,
												FAM_COMM								
									)
									values (		
									'SS_TS2_105_',											
									'TS2_105_02', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,6													
																,'Maternal Grandmother'											
															
																,'Melanoma'
																,'Deceased'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG2 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												FAM_ID
																																								
														,FAM_ID_label																										
														,
												FAM_DIAG																										
														,
												FAM_COMM								
									)
									values (		
									'SS_TS2_105_',											
									'TS2_105_02', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,3
									, '2015-03-19T16:41:35.717Z'										
							
																,4													
																,'Sister'											
															
																,'Diabetes'
																,'Date Unknown'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG2 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												FAM_ID
																																								
														,FAM_ID_label																										
														,
												FAM_DIAG																										
														,
												FAM_COMM								
									)
									values (		
									'SS_TS7_105_',											
									'TS7_105_07', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,2													
																,'Father'											
															
																,'Colon cancer'
																,'Deceased'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG2 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												FAM_ID
																																								
														,FAM_ID_label																										
														,
												FAM_DIAG																										
														,
												FAM_COMM								
									)
									values (		
									'SS_TS7_105_',											
									'TS7_105_07', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,6													
																,'Maternal Grandmother'											
															
																,'Melanoma'
																,'Deceased'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG2 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												FAM_ID
																																								
														,FAM_ID_label																										
														,
												FAM_DIAG																										
														,
												FAM_COMM								
									)
									values (		
									'SS_TS7_105_',											
									'TS7_105_07', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,3
									, '2015-03-19T16:41:35.717Z'										
							
																,4													
																,'Sister'											
															
																,'Diabetes'
																,'Date Unknown'		
									);									
										
													
									insert into NCT01928420_All_Data.Medical_HistoryG2 (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												FAM_ID
																																								
														,FAM_ID_label																										
														,
												FAM_DIAG																										
														,
												FAM_COMM								
									)
									values (		
									'SS_TS9_105_',											
									'TS9_105_09', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,1													
																,'Mother'											
															
																,'Breast cancer'
																,'Deceased'		
									);									
							
			  
			
					insert into NCT01928420_All_Data.crf_version (crf_name, crf_version_name, warehouse_insert_created_timestamp) values 
					( 'Protocol Deviation Log', 
					'V1.1',
					'2015-03-19T16:41:35.717Z');
			
			
			
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS10_101',
									
					'TS10_101_10',
					
				'SE_LOGS',
				
				'Protocol Deviation Log',
				'V1.1'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS6_101_',
									
					'TS6_101_06',
					
				'SE_LOGS',
				
				'Protocol Deviation Log',
				'V1.1'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS10_102',
									
					'TS10_102_10',
					
				'SE_LOGS',
				
				'Protocol Deviation Log',
				'V1.1'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS4_102_',
									
					'TS4_102_04',
					
				'SE_LOGS',
				
				'Protocol Deviation Log',
				'V1.1'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS6_102_',
									
					'TS6_102_06',
					
				'SE_LOGS',
				
				'Protocol Deviation Log',
				'V1.1'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS8_102_',
									
					'TS8_102_08',
					
				'SE_LOGS',
				
				'Protocol Deviation Log',
				'V1.1'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS10_103',
									
					'TS10_103_10',
					
				'SE_LOGS',
				
				'Protocol Deviation Log',
				'V1.1'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS6_103_',
									
					'TS6_103_06',
					
				'SE_LOGS',
				
				'Protocol Deviation Log',
				'V1.1'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS8_103_',
									
					'TS8_103_08',
					
				'SE_LOGS',
				
				'Protocol Deviation Log',
				'V1.1'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS10_104',
									
					'TS10_104_10',
					
				'SE_LOGS',
				
				'Protocol Deviation Log',
				'V1.1'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS6_104_',
									
					'TS6_104_06',
					
				'SE_LOGS',
				
				'Protocol Deviation Log',
				'V1.1'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS8_104_',
									
					'TS8_104_08',
					
				'SE_LOGS',
				
				'Protocol Deviation Log',
				'V1.1'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS13_105',
									
					'TS13_105_13',
					
				'SE_LOGS',
				
				'Protocol Deviation Log',
				'V1.1'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS6_105_',
									
					'TS6_105_06',
					
				'SE_LOGS',
				
				'Protocol Deviation Log',
				'V1.1'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS9_105_',
									
					'TS9_105_09',
					
				'SE_LOGS',
				
				'Protocol Deviation Log',
				'V1.1'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
			create table NCT01928420_All_Data.Protocol_Deviation_LogProtocol_Deviation_Log (		
			item_data_id serial NOT NULL,	
			ssoid character varying(40) NOT NULL,			
			ssid character varying(40) NOT NULL,
			study_event_oid character varying(40) NOT NULL,
			event_ordinal integer default 1,	
			crf_version character varying(255),
			event_start_date timestamp without time zone,
			event_end_date timestamp without time zone,
			event_status character varying(255),
			event_location character varying(2000),
			subject_age_at_event integer,
			crf_status character varying(255), 
			interviewerName character varying(255),
			interviewDate date, 
			item_group_repeat_key integer,
			warehouse_insert_created_timestamp timestamp with time zone);
			
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Protocol_Deviation_LogProtocol_Deviation_Log', 'PD_EVENT', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Protocol_Deviation_LogProtocol_Deviation_Log', 'PD_EVENT_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Protocol_Deviation_LogProtocol_Deviation_Log', 'PD_PRODEV', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Protocol_Deviation_LogProtocol_Deviation_Log', 'PD_PRODEV_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Protocol_Deviation_LogProtocol_Deviation_Log', 'PD_DEV', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Protocol_Deviation_LogProtocol_Deviation_Log', 'PD_REA', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Protocol_Deviation_LogProtocol_Deviation_Log', 'PD_COMM', 'text');

	
			ALTER TABLE NCT01928420_All_Data.Protocol_Deviation_LogProtocol_Deviation_Log ADD CONSTRAINT Pk_PROTOCOL PRIMARY KEY (item_data_id);
	
			ALTER TABLE NCT01928420_All_Data.Protocol_Deviation_LogProtocol_Deviation_Log ADD CONSTRAINT Fk_study_subject_id_PROTOCOL FOREIGN KEY (ssoid, ssid) REFERENCES NCT01928420_All_Data.study_subject_listing;
				
													
									insert into NCT01928420_All_Data.Protocol_Deviation_LogProtocol_Deviation_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PD_EVENT
																																								
														,PD_EVENT_label																										
														,
												PD_PRODEV
																																								
														,PD_PRODEV_label																										
														,
												PD_DEV																										
														,
												PD_REA																										
														,
												PD_COMM								
									)
									values (		
									'SS_TS10_101',											
									'TS10_101_10', 									
									'SE_LOGS'									  
							
									,'V1.1'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,1													
																,'First Visit'											
															
																,5													
																,'Vital Signs'											
															
																,'BP & HR not taken'
																,'Time constraints'
																,'None'		
									);									
										
													
									insert into NCT01928420_All_Data.Protocol_Deviation_LogProtocol_Deviation_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PD_EVENT
																																								
														,PD_EVENT_label																										
														,
												PD_PRODEV
																																								
														,PD_PRODEV_label																										
														,
												PD_DEV																										
														,
												PD_REA																										
														,
												PD_COMM								
									)
									values (		
									'SS_TS10_101',											
									'TS10_101_10', 									
									'SE_LOGS'									  
							
									,'V1.1'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,2													
																,'1-week Follow Up'											
															
																,5													
																,'Vital Signs'											
															
																,'BP & HR not taken'
																,'Subject non-compliant'
																,'None'		
									);									
										
													
									insert into NCT01928420_All_Data.Protocol_Deviation_LogProtocol_Deviation_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PD_EVENT
																																								
														,PD_EVENT_label																										
														,
												PD_PRODEV
																																								
														,PD_PRODEV_label																										
														,
												PD_DEV																										
														,
												PD_REA																										
														,
												PD_COMM								
									)
									values (		
									'SS_TS10_101',											
									'TS10_101_10', 									
									'SE_LOGS'									  
							
									,'V1.1'
							,'' ,''
									,3
									, '2015-03-19T16:41:35.717Z'										
							
																,3													
																,'2-week Follow Up'											
															
																,5													
																,'Vital Signs'											
															
																,'BP & HR not taken'
																,'Time constraints'
																,'None'		
									);									
										
													
									insert into NCT01928420_All_Data.Protocol_Deviation_LogProtocol_Deviation_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PD_EVENT
																																								
														,PD_EVENT_label																										
														,
												PD_PRODEV
																																								
														,PD_PRODEV_label																										
														,
												PD_DEV																										
														,
												PD_REA								
									)
									values (		
									'SS_TS6_101_',											
									'TS6_101_06', 									
									'SE_LOGS'									  
							
									,'V1.1'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,1													
																,'First Visit'											
															
																,7													
																,'Physical Exam'											
															
																,'Not performed'
																,'Subject did not complete visit'		
									);									
										
													
									insert into NCT01928420_All_Data.Protocol_Deviation_LogProtocol_Deviation_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PD_EVENT
																																								
														,PD_EVENT_label																										
														,
												PD_PRODEV
																																								
														,PD_PRODEV_label																										
														,
												PD_DEV																										
														,
												PD_REA								
									)
									values (		
									'SS_TS6_101_',											
									'TS6_101_06', 									
									'SE_LOGS'									  
							
									,'V1.1'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,1													
																,'First Visit'											
															
																,5													
																,'Vital Signs'											
															
																,'BP & HR not taken'
																,'Subject did not complete visit'		
									);									
										
													
									insert into NCT01928420_All_Data.Protocol_Deviation_LogProtocol_Deviation_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PD_EVENT
																																								
														,PD_EVENT_label																										
														,
												PD_PRODEV
																																								
														,PD_PRODEV_label																										
														,
												PD_DEV																										
														,
												PD_REA								
									)
									values (		
									'SS_TS6_101_',											
									'TS6_101_06', 									
									'SE_LOGS'									  
							
									,'V1.1'
							,'' ,''
									,3
									, '2015-03-19T16:41:35.717Z'										
							
																,1													
																,'First Visit'											
															
																,3													
																,'MRI'											
															
																,'Not performed'
																,'Subject did not complete visit'		
									);									
										
													
									insert into NCT01928420_All_Data.Protocol_Deviation_LogProtocol_Deviation_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PD_EVENT
																																								
														,PD_EVENT_label																										
														,
												PD_PRODEV
																																								
														,PD_PRODEV_label																										
														,
												PD_DEV																										
														,
												PD_REA																										
														,
												PD_COMM								
									)
									values (		
									'SS_TS10_102',											
									'TS10_102_10', 									
									'SE_LOGS'									  
							
									,'V1.1'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,1													
																,'First Visit'											
															
																,5													
																,'Vital Signs'											
															
																,'BP & HR not taken'
																,'Time constraints'
																,'None'		
									);									
										
													
									insert into NCT01928420_All_Data.Protocol_Deviation_LogProtocol_Deviation_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PD_EVENT
																																								
														,PD_EVENT_label																										
														,
												PD_PRODEV
																																								
														,PD_PRODEV_label																										
														,
												PD_DEV																										
														,
												PD_REA																										
														,
												PD_COMM								
									)
									values (		
									'SS_TS10_102',											
									'TS10_102_10', 									
									'SE_LOGS'									  
							
									,'V1.1'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,2													
																,'1-week Follow Up'											
															
																,5													
																,'Vital Signs'											
															
																,'BP & HR not taken'
																,'Subject non-compliant'
																,'None'		
									);									
										
													
									insert into NCT01928420_All_Data.Protocol_Deviation_LogProtocol_Deviation_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PD_EVENT
																																								
														,PD_EVENT_label																										
														,
												PD_PRODEV
																																								
														,PD_PRODEV_label																										
														,
												PD_DEV																										
														,
												PD_REA																										
														,
												PD_COMM								
									)
									values (		
									'SS_TS10_102',											
									'TS10_102_10', 									
									'SE_LOGS'									  
							
									,'V1.1'
							,'' ,''
									,3
									, '2015-03-19T16:41:35.717Z'										
							
																,3													
																,'2-week Follow Up'											
															
																,5													
																,'Vital Signs'											
															
																,'BP & HR not taken'
																,'Time constraints'
																,'None'		
									);									
										
													
									insert into NCT01928420_All_Data.Protocol_Deviation_LogProtocol_Deviation_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PD_EVENT
																																								
														,PD_EVENT_label																										
														,
												PD_DEV																										
														,
												PD_REA																										
														,
												PD_COMM								
									)
									values (		
									'SS_TS4_102_',											
									'TS4_102_04', 									
									'SE_LOGS'									  
							
									,'V1.1'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,2													
																,'1-week Follow Up'											
															
																,'Skipped Visit'
																,'Subject did not appear on scheduled date'
																,'Visit marked as skipped'		
									);									
										
													
									insert into NCT01928420_All_Data.Protocol_Deviation_LogProtocol_Deviation_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PD_EVENT
																																								
														,PD_EVENT_label																										
														,
												PD_PRODEV
																																								
														,PD_PRODEV_label																										
														,
												PD_DEV																										
														,
												PD_REA								
									)
									values (		
									'SS_TS6_102_',											
									'TS6_102_06', 									
									'SE_LOGS'									  
							
									,'V1.1'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,1													
																,'First Visit'											
															
																,7													
																,'Physical Exam'											
															
																,'Not performed'
																,'Subject did not complete visit'		
									);									
										
													
									insert into NCT01928420_All_Data.Protocol_Deviation_LogProtocol_Deviation_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PD_EVENT
																																								
														,PD_EVENT_label																										
														,
												PD_PRODEV
																																								
														,PD_PRODEV_label																										
														,
												PD_DEV																										
														,
												PD_REA								
									)
									values (		
									'SS_TS6_102_',											
									'TS6_102_06', 									
									'SE_LOGS'									  
							
									,'V1.1'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,1													
																,'First Visit'											
															
																,5													
																,'Vital Signs'											
															
																,'BP & HR not taken'
																,'Subject did not complete visit'		
									);									
										
													
									insert into NCT01928420_All_Data.Protocol_Deviation_LogProtocol_Deviation_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PD_EVENT
																																								
														,PD_EVENT_label																										
														,
												PD_PRODEV
																																								
														,PD_PRODEV_label																										
														,
												PD_DEV																										
														,
												PD_REA								
									)
									values (		
									'SS_TS6_102_',											
									'TS6_102_06', 									
									'SE_LOGS'									  
							
									,'V1.1'
							,'' ,''
									,3
									, '2015-03-19T16:41:35.717Z'										
							
																,1													
																,'First Visit'											
															
																,3													
																,'MRI'											
															
																,'Not performed'
																,'Subject did not complete visit'		
									);									
										
													
									insert into NCT01928420_All_Data.Protocol_Deviation_LogProtocol_Deviation_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PD_EVENT
																																								
														,PD_EVENT_label																										
														,
												PD_PRODEV
																																								
														,PD_PRODEV_label																										
														,
												PD_DEV																										
														,
												PD_REA																										
														,
												PD_COMM								
									)
									values (		
									'SS_TS8_102_',											
									'TS8_102_08', 									
									'SE_LOGS'									  
							
									,'V1.1'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,1													
																,'First Visit'											
															
																,5													
																,'Vital Signs'											
															
																,'BP & HR not taken'
																,'Time constraints'
																,'None'		
									);									
										
													
									insert into NCT01928420_All_Data.Protocol_Deviation_LogProtocol_Deviation_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PD_EVENT
																																								
														,PD_EVENT_label																										
														,
												PD_PRODEV
																																								
														,PD_PRODEV_label																										
														,
												PD_DEV																										
														,
												PD_REA																										
														,
												PD_COMM								
									)
									values (		
									'SS_TS8_102_',											
									'TS8_102_08', 									
									'SE_LOGS'									  
							
									,'V1.1'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,2													
																,'1-week Follow Up'											
															
																,5													
																,'Vital Signs'											
															
																,'BP & HR not taken'
																,'Subject non-compliant'
																,'None'		
									);									
										
													
									insert into NCT01928420_All_Data.Protocol_Deviation_LogProtocol_Deviation_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PD_EVENT
																																								
														,PD_EVENT_label																										
														,
												PD_PRODEV
																																								
														,PD_PRODEV_label																										
														,
												PD_DEV																										
														,
												PD_REA																										
														,
												PD_COMM								
									)
									values (		
									'SS_TS8_102_',											
									'TS8_102_08', 									
									'SE_LOGS'									  
							
									,'V1.1'
							,'' ,''
									,3
									, '2015-03-19T16:41:35.717Z'										
							
																,3													
																,'2-week Follow Up'											
															
																,5													
																,'Vital Signs'											
															
																,'BP & HR not taken'
																,'Time constraints'
																,'None'		
									);									
										
													
									insert into NCT01928420_All_Data.Protocol_Deviation_LogProtocol_Deviation_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PD_EVENT
																																								
														,PD_EVENT_label																										
														,
												PD_PRODEV
																																								
														,PD_PRODEV_label																										
														,
												PD_DEV																										
														,
												PD_REA																										
														,
												PD_COMM								
									)
									values (		
									'SS_TS10_103',											
									'TS10_103_10', 									
									'SE_LOGS'									  
							
									,'V1.1'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,1													
																,'First Visit'											
															
																,5													
																,'Vital Signs'											
															
																,'BP & HR not taken'
																,'Time constraints'
																,'None'		
									);									
										
													
									insert into NCT01928420_All_Data.Protocol_Deviation_LogProtocol_Deviation_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PD_EVENT
																																								
														,PD_EVENT_label																										
														,
												PD_PRODEV
																																								
														,PD_PRODEV_label																										
														,
												PD_DEV																										
														,
												PD_REA																										
														,
												PD_COMM								
									)
									values (		
									'SS_TS10_103',											
									'TS10_103_10', 									
									'SE_LOGS'									  
							
									,'V1.1'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,2													
																,'1-week Follow Up'											
															
																,5													
																,'Vital Signs'											
															
																,'BP & HR not taken'
																,'Subject non-compliant'
																,'None'		
									);									
										
													
									insert into NCT01928420_All_Data.Protocol_Deviation_LogProtocol_Deviation_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PD_EVENT
																																								
														,PD_EVENT_label																										
														,
												PD_PRODEV
																																								
														,PD_PRODEV_label																										
														,
												PD_DEV																										
														,
												PD_REA																										
														,
												PD_COMM								
									)
									values (		
									'SS_TS10_103',											
									'TS10_103_10', 									
									'SE_LOGS'									  
							
									,'V1.1'
							,'' ,''
									,3
									, '2015-03-19T16:41:35.717Z'										
							
																,3													
																,'2-week Follow Up'											
															
																,5													
																,'Vital Signs'											
															
																,'BP & HR not taken'
																,'Time constraints'
																,'None'		
									);									
										
													
									insert into NCT01928420_All_Data.Protocol_Deviation_LogProtocol_Deviation_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PD_EVENT
																																								
														,PD_EVENT_label																										
														,
												PD_PRODEV
																																								
														,PD_PRODEV_label																										
														,
												PD_DEV																										
														,
												PD_REA								
									)
									values (		
									'SS_TS6_103_',											
									'TS6_103_06', 									
									'SE_LOGS'									  
							
									,'V1.1'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,1													
																,'First Visit'											
															
																,7													
																,'Physical Exam'											
															
																,'Not performed'
																,'Subject did not complete visit'		
									);									
										
													
									insert into NCT01928420_All_Data.Protocol_Deviation_LogProtocol_Deviation_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PD_EVENT
																																								
														,PD_EVENT_label																										
														,
												PD_PRODEV
																																								
														,PD_PRODEV_label																										
														,
												PD_DEV																										
														,
												PD_REA								
									)
									values (		
									'SS_TS6_103_',											
									'TS6_103_06', 									
									'SE_LOGS'									  
							
									,'V1.1'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,1													
																,'First Visit'											
															
																,5													
																,'Vital Signs'											
															
																,'BP & HR not taken'
																,'Subject did not complete visit'		
									);									
										
													
									insert into NCT01928420_All_Data.Protocol_Deviation_LogProtocol_Deviation_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PD_EVENT
																																								
														,PD_EVENT_label																										
														,
												PD_PRODEV
																																								
														,PD_PRODEV_label																										
														,
												PD_DEV																										
														,
												PD_REA								
									)
									values (		
									'SS_TS6_103_',											
									'TS6_103_06', 									
									'SE_LOGS'									  
							
									,'V1.1'
							,'' ,''
									,3
									, '2015-03-19T16:41:35.717Z'										
							
																,1													
																,'First Visit'											
															
																,3													
																,'MRI'											
															
																,'Not performed'
																,'Subject did not complete visit'		
									);									
										
													
									insert into NCT01928420_All_Data.Protocol_Deviation_LogProtocol_Deviation_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PD_EVENT
																																								
														,PD_EVENT_label																										
														,
												PD_PRODEV
																																								
														,PD_PRODEV_label																										
														,
												PD_DEV																										
														,
												PD_REA																										
														,
												PD_COMM								
									)
									values (		
									'SS_TS8_103_',											
									'TS8_103_08', 									
									'SE_LOGS'									  
							
									,'V1.1'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,1													
																,'First Visit'											
															
																,5													
																,'Vital Signs'											
															
																,'BP & HR not taken'
																,'Time constraints'
																,'None'		
									);									
										
													
									insert into NCT01928420_All_Data.Protocol_Deviation_LogProtocol_Deviation_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PD_EVENT
																																								
														,PD_EVENT_label																										
														,
												PD_PRODEV
																																								
														,PD_PRODEV_label																										
														,
												PD_DEV																										
														,
												PD_REA																										
														,
												PD_COMM								
									)
									values (		
									'SS_TS8_103_',											
									'TS8_103_08', 									
									'SE_LOGS'									  
							
									,'V1.1'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,2													
																,'1-week Follow Up'											
															
																,5													
																,'Vital Signs'											
															
																,'BP & HR not taken'
																,'Subject non-compliant'
																,'None'		
									);									
										
													
									insert into NCT01928420_All_Data.Protocol_Deviation_LogProtocol_Deviation_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PD_EVENT
																																								
														,PD_EVENT_label																										
														,
												PD_PRODEV
																																								
														,PD_PRODEV_label																										
														,
												PD_DEV																										
														,
												PD_REA																										
														,
												PD_COMM								
									)
									values (		
									'SS_TS8_103_',											
									'TS8_103_08', 									
									'SE_LOGS'									  
							
									,'V1.1'
							,'' ,''
									,3
									, '2015-03-19T16:41:35.717Z'										
							
																,3													
																,'2-week Follow Up'											
															
																,5													
																,'Vital Signs'											
															
																,'BP & HR not taken'
																,'Time constraints'
																,'None'		
									);									
										
													
									insert into NCT01928420_All_Data.Protocol_Deviation_LogProtocol_Deviation_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PD_EVENT
																																								
														,PD_EVENT_label																										
														,
												PD_PRODEV
																																								
														,PD_PRODEV_label																										
														,
												PD_DEV																										
														,
												PD_REA																										
														,
												PD_COMM								
									)
									values (		
									'SS_TS10_104',											
									'TS10_104_10', 									
									'SE_LOGS'									  
							
									,'V1.1'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,1													
																,'First Visit'											
															
																,5													
																,'Vital Signs'											
															
																,'BP & HR not taken'
																,'Time constraints'
																,'None'		
									);									
										
													
									insert into NCT01928420_All_Data.Protocol_Deviation_LogProtocol_Deviation_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PD_EVENT
																																								
														,PD_EVENT_label																										
														,
												PD_PRODEV
																																								
														,PD_PRODEV_label																										
														,
												PD_DEV																										
														,
												PD_REA																										
														,
												PD_COMM								
									)
									values (		
									'SS_TS10_104',											
									'TS10_104_10', 									
									'SE_LOGS'									  
							
									,'V1.1'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,2													
																,'1-week Follow Up'											
															
																,5													
																,'Vital Signs'											
															
																,'BP & HR not taken'
																,'Subject non-compliant'
																,'None'		
									);									
										
													
									insert into NCT01928420_All_Data.Protocol_Deviation_LogProtocol_Deviation_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PD_EVENT
																																								
														,PD_EVENT_label																										
														,
												PD_PRODEV
																																								
														,PD_PRODEV_label																										
														,
												PD_DEV																										
														,
												PD_REA																										
														,
												PD_COMM								
									)
									values (		
									'SS_TS10_104',											
									'TS10_104_10', 									
									'SE_LOGS'									  
							
									,'V1.1'
							,'' ,''
									,3
									, '2015-03-19T16:41:35.717Z'										
							
																,3													
																,'2-week Follow Up'											
															
																,5													
																,'Vital Signs'											
															
																,'BP & HR not taken'
																,'Time constraints'
																,'None'		
									);									
										
													
									insert into NCT01928420_All_Data.Protocol_Deviation_LogProtocol_Deviation_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PD_EVENT
																																								
														,PD_EVENT_label																										
														,
												PD_PRODEV
																																								
														,PD_PRODEV_label																										
														,
												PD_DEV																										
														,
												PD_REA								
									)
									values (		
									'SS_TS6_104_',											
									'TS6_104_06', 									
									'SE_LOGS'									  
							
									,'V1.1'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,1													
																,'First Visit'											
															
																,7													
																,'Physical Exam'											
															
																,'Not performed'
																,'Subject did not complete visit'		
									);									
										
													
									insert into NCT01928420_All_Data.Protocol_Deviation_LogProtocol_Deviation_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PD_EVENT
																																								
														,PD_EVENT_label																										
														,
												PD_PRODEV
																																								
														,PD_PRODEV_label																										
														,
												PD_DEV																										
														,
												PD_REA								
									)
									values (		
									'SS_TS6_104_',											
									'TS6_104_06', 									
									'SE_LOGS'									  
							
									,'V1.1'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,1													
																,'First Visit'											
															
																,5													
																,'Vital Signs'											
															
																,'BP & HR not taken'
																,'Subject did not complete visit'		
									);									
										
													
									insert into NCT01928420_All_Data.Protocol_Deviation_LogProtocol_Deviation_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PD_EVENT
																																								
														,PD_EVENT_label																										
														,
												PD_PRODEV
																																								
														,PD_PRODEV_label																										
														,
												PD_DEV																										
														,
												PD_REA								
									)
									values (		
									'SS_TS6_104_',											
									'TS6_104_06', 									
									'SE_LOGS'									  
							
									,'V1.1'
							,'' ,''
									,3
									, '2015-03-19T16:41:35.717Z'										
							
																,1													
																,'First Visit'											
															
																,3													
																,'MRI'											
															
																,'Not performed'
																,'Subject did not complete visit'		
									);									
										
													
									insert into NCT01928420_All_Data.Protocol_Deviation_LogProtocol_Deviation_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PD_EVENT
																																								
														,PD_EVENT_label																										
														,
												PD_PRODEV
																																								
														,PD_PRODEV_label																										
														,
												PD_DEV																										
														,
												PD_REA																										
														,
												PD_COMM								
									)
									values (		
									'SS_TS8_104_',											
									'TS8_104_08', 									
									'SE_LOGS'									  
							
									,'V1.1'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,1													
																,'First Visit'											
															
																,5													
																,'Vital Signs'											
															
																,'BP & HR not taken'
																,'Time constraints'
																,'None'		
									);									
										
													
									insert into NCT01928420_All_Data.Protocol_Deviation_LogProtocol_Deviation_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PD_EVENT
																																								
														,PD_EVENT_label																										
														,
												PD_PRODEV
																																								
														,PD_PRODEV_label																										
														,
												PD_DEV																										
														,
												PD_REA																										
														,
												PD_COMM								
									)
									values (		
									'SS_TS8_104_',											
									'TS8_104_08', 									
									'SE_LOGS'									  
							
									,'V1.1'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,2													
																,'1-week Follow Up'											
															
																,5													
																,'Vital Signs'											
															
																,'BP & HR not taken'
																,'Subject non-compliant'
																,'None'		
									);									
										
													
									insert into NCT01928420_All_Data.Protocol_Deviation_LogProtocol_Deviation_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PD_EVENT
																																								
														,PD_EVENT_label																										
														,
												PD_PRODEV
																																								
														,PD_PRODEV_label																										
														,
												PD_DEV																										
														,
												PD_REA																										
														,
												PD_COMM								
									)
									values (		
									'SS_TS8_104_',											
									'TS8_104_08', 									
									'SE_LOGS'									  
							
									,'V1.1'
							,'' ,''
									,3
									, '2015-03-19T16:41:35.717Z'										
							
																,3													
																,'2-week Follow Up'											
															
																,5													
																,'Vital Signs'											
															
																,'BP & HR not taken'
																,'Time constraints'
																,'None'		
									);									
										
													
									insert into NCT01928420_All_Data.Protocol_Deviation_LogProtocol_Deviation_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PD_EVENT
																																								
														,PD_EVENT_label																										
														,
												PD_PRODEV
																																								
														,PD_PRODEV_label																										
														,
												PD_DEV																										
														,
												PD_REA																										
														,
												PD_COMM								
									)
									values (		
									'SS_TS13_105',											
									'TS13_105_13', 									
									'SE_LOGS'									  
							
									,'V1.1'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,1													
																,'First Visit'											
															
																,5													
																,'Vital Signs'											
															
																,'BP & HR not taken'
																,'Time constraints'
																,'None'		
									);									
										
													
									insert into NCT01928420_All_Data.Protocol_Deviation_LogProtocol_Deviation_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PD_EVENT
																																								
														,PD_EVENT_label																										
														,
												PD_PRODEV
																																								
														,PD_PRODEV_label																										
														,
												PD_DEV																										
														,
												PD_REA																										
														,
												PD_COMM								
									)
									values (		
									'SS_TS13_105',											
									'TS13_105_13', 									
									'SE_LOGS'									  
							
									,'V1.1'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,2													
																,'1-week Follow Up'											
															
																,5													
																,'Vital Signs'											
															
																,'BP & HR not taken'
																,'Subject non-compliant'
																,'None'		
									);									
										
													
									insert into NCT01928420_All_Data.Protocol_Deviation_LogProtocol_Deviation_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PD_EVENT
																																								
														,PD_EVENT_label																										
														,
												PD_PRODEV
																																								
														,PD_PRODEV_label																										
														,
												PD_DEV																										
														,
												PD_REA																										
														,
												PD_COMM								
									)
									values (		
									'SS_TS13_105',											
									'TS13_105_13', 									
									'SE_LOGS'									  
							
									,'V1.1'
							,'' ,''
									,3
									, '2015-03-19T16:41:35.717Z'										
							
																,3													
																,'2-week Follow Up'											
															
																,5													
																,'Vital Signs'											
															
																,'BP & HR not taken'
																,'Time constraints'
																,'None'		
									);									
										
													
									insert into NCT01928420_All_Data.Protocol_Deviation_LogProtocol_Deviation_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PD_EVENT
																																								
														,PD_EVENT_label																										
														,
												PD_PRODEV
																																								
														,PD_PRODEV_label																										
														,
												PD_DEV																										
														,
												PD_REA								
									)
									values (		
									'SS_TS6_105_',											
									'TS6_105_06', 									
									'SE_LOGS'									  
							
									,'V1.1'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,1													
																,'First Visit'											
															
																,7													
																,'Physical Exam'											
															
																,'Not performed'
																,'Subject did not complete visit'		
									);									
										
													
									insert into NCT01928420_All_Data.Protocol_Deviation_LogProtocol_Deviation_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PD_EVENT
																																								
														,PD_EVENT_label																										
														,
												PD_PRODEV
																																								
														,PD_PRODEV_label																										
														,
												PD_DEV																										
														,
												PD_REA								
									)
									values (		
									'SS_TS6_105_',											
									'TS6_105_06', 									
									'SE_LOGS'									  
							
									,'V1.1'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,1													
																,'First Visit'											
															
																,5													
																,'Vital Signs'											
															
																,'BP & HR not taken'
																,'Subject did not complete visit'		
									);									
										
													
									insert into NCT01928420_All_Data.Protocol_Deviation_LogProtocol_Deviation_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PD_EVENT
																																								
														,PD_EVENT_label																										
														,
												PD_PRODEV
																																								
														,PD_PRODEV_label																										
														,
												PD_DEV																										
														,
												PD_REA								
									)
									values (		
									'SS_TS6_105_',											
									'TS6_105_06', 									
									'SE_LOGS'									  
							
									,'V1.1'
							,'' ,''
									,3
									, '2015-03-19T16:41:35.717Z'										
							
																,1													
																,'First Visit'											
															
																,3													
																,'MRI'											
															
																,'Not performed'
																,'Subject did not complete visit'		
									);									
										
													
									insert into NCT01928420_All_Data.Protocol_Deviation_LogProtocol_Deviation_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PD_EVENT
																																								
														,PD_EVENT_label																										
														,
												PD_PRODEV
																																								
														,PD_PRODEV_label																										
														,
												PD_DEV																										
														,
												PD_REA																										
														,
												PD_COMM								
									)
									values (		
									'SS_TS9_105_',											
									'TS9_105_09', 									
									'SE_LOGS'									  
							
									,'V1.1'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,1													
																,'First Visit'											
															
																,5													
																,'Vital Signs'											
															
																,'BP & HR not taken'
																,'Time constraints'
																,'None'		
									);									
										
													
									insert into NCT01928420_All_Data.Protocol_Deviation_LogProtocol_Deviation_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PD_EVENT
																																								
														,PD_EVENT_label																										
														,
												PD_PRODEV
																																								
														,PD_PRODEV_label																										
														,
												PD_DEV																										
														,
												PD_REA																										
														,
												PD_COMM								
									)
									values (		
									'SS_TS9_105_',											
									'TS9_105_09', 									
									'SE_LOGS'									  
							
									,'V1.1'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,2													
																,'1-week Follow Up'											
															
																,5													
																,'Vital Signs'											
															
																,'BP & HR not taken'
																,'Subject non-compliant'
																,'None'		
									);									
										
													
									insert into NCT01928420_All_Data.Protocol_Deviation_LogProtocol_Deviation_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												PD_EVENT
																																								
														,PD_EVENT_label																										
														,
												PD_PRODEV
																																								
														,PD_PRODEV_label																										
														,
												PD_DEV																										
														,
												PD_REA																										
														,
												PD_COMM								
									)
									values (		
									'SS_TS9_105_',											
									'TS9_105_09', 									
									'SE_LOGS'									  
							
									,'V1.1'
							,'' ,''
									,3
									, '2015-03-19T16:41:35.717Z'										
							
																,3													
																,'2-week Follow Up'											
															
																,5													
																,'Vital Signs'											
															
																,'BP & HR not taken'
																,'Time constraints'
																,'None'		
									);									
							
			  
			
					insert into NCT01928420_All_Data.crf_version (crf_name, crf_version_name, warehouse_insert_created_timestamp) values 
					( 'Concomitant Medication Log', 
					'V1.0',
					'2015-03-19T16:41:35.717Z');
			
			
			
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS10_101',
									
					'TS10_101_10',
					
				'SE_LOGS',
				
				'Concomitant Medication Log',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS6_101_',
									
					'TS6_101_06',
					
				'SE_LOGS',
				
				'Concomitant Medication Log',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS10_102',
									
					'TS10_102_10',
					
				'SE_LOGS',
				
				'Concomitant Medication Log',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS6_102_',
									
					'TS6_102_06',
					
				'SE_LOGS',
				
				'Concomitant Medication Log',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS8_102_',
									
					'TS8_102_08',
					
				'SE_LOGS',
				
				'Concomitant Medication Log',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS10_103',
									
					'TS10_103_10',
					
				'SE_LOGS',
				
				'Concomitant Medication Log',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS6_103_',
									
					'TS6_103_06',
					
				'SE_LOGS',
				
				'Concomitant Medication Log',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS8_103_',
									
					'TS8_103_08',
					
				'SE_LOGS',
				
				'Concomitant Medication Log',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS10_104',
									
					'TS10_104_10',
					
				'SE_LOGS',
				
				'Concomitant Medication Log',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS6_104_',
									
					'TS6_104_06',
					
				'SE_LOGS',
				
				'Concomitant Medication Log',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS8_104_',
									
					'TS8_104_08',
					
				'SE_LOGS',
				
				'Concomitant Medication Log',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS13_105',
									
					'TS13_105_13',
					
				'SE_LOGS',
				
				'Concomitant Medication Log',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS6_105_',
									
					'TS6_105_06',
					
				'SE_LOGS',
				
				'Concomitant Medication Log',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS9_105_',
									
					'TS9_105_09',
					
				'SE_LOGS',
				
				'Concomitant Medication Log',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
				create table NCT01928420_All_Data.Concomitant_Medication_LogConMeds (
				item_data_id serial NOT NULL,
				ssoid character varying(40) NOT NULL,
				ssid character varying(40) NOT NULL,
				study_event_oid character varying(40) NOT NULL,
				event_ordinal integer default 1,
				crf_version character varying(255),
				event_start_date timestamp without time zone,
				event_end_date timestamp without time zone,
				event_status character varying(255),
				event_location character varying(2000),
				subject_age_at_event integer,
				crf_status character varying(255), 
				interviewerName character varying(255),
				interviewDate date,
				warehouse_insert_created_timestamp timestamp with time zone); 			          	 
				
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Concomitant_Medication_LogConMeds', 'CM_YN', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Concomitant_Medication_LogConMeds', 'CM_YN_label', 'character varying(255)');

	
				
		ALTER TABLE NCT01928420_All_Data.Concomitant_Medication_LogConMeds ADD CONSTRAINT Pk_CONMEDS PRIMARY KEY (item_data_id);

		
				
		ALTER TABLE NCT01928420_All_Data.Concomitant_Medication_LogConMeds ADD CONSTRAINT 	
		Fk_study_subject_id_CONMEDS FOREIGN KEY (ssoid, 
		ssid) REFERENCES NCT01928420_All_Data.study_subject_listing;
		
				
									insert into NCT01928420_All_Data.Concomitant_Medication_LogConMeds (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														CM_YN
																												
																	,CM_YN_label
										)
									values (
									
									
									'SS_TS10_101',
									
									'TS10_101_10', 	 									
									
									'SE_LOGS' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
																
									);
										
									insert into NCT01928420_All_Data.Concomitant_Medication_LogConMeds (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														CM_YN
																												
																	,CM_YN_label
										)
									values (
									
									
									'SS_TS6_101_',
									
									'TS6_101_06', 	 									
									
									'SE_LOGS' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
																
									);
										
									insert into NCT01928420_All_Data.Concomitant_Medication_LogConMeds (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														CM_YN
																												
																	,CM_YN_label
										)
									values (
									
									
									'SS_TS10_102',
									
									'TS10_102_10', 	 									
									
									'SE_LOGS' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
																
									);
										
									insert into NCT01928420_All_Data.Concomitant_Medication_LogConMeds (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														CM_YN
																												
																	,CM_YN_label
										)
									values (
									
									
									'SS_TS6_102_',
									
									'TS6_102_06', 	 									
									
									'SE_LOGS' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
																
									);
										
									insert into NCT01928420_All_Data.Concomitant_Medication_LogConMeds (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														CM_YN
																												
																	,CM_YN_label
										)
									values (
									
									
									'SS_TS8_102_',
									
									'TS8_102_08', 	 									
									
									'SE_LOGS' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
																
									);
										
									insert into NCT01928420_All_Data.Concomitant_Medication_LogConMeds (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														CM_YN
																												
																	,CM_YN_label
										)
									values (
									
									
									'SS_TS10_103',
									
									'TS10_103_10', 	 									
									
									'SE_LOGS' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
																
									);
										
									insert into NCT01928420_All_Data.Concomitant_Medication_LogConMeds (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														CM_YN
																												
																	,CM_YN_label
										)
									values (
									
									
									'SS_TS6_103_',
									
									'TS6_103_06', 	 									
									
									'SE_LOGS' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
																
									);
										
									insert into NCT01928420_All_Data.Concomitant_Medication_LogConMeds (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														CM_YN
																												
																	,CM_YN_label
										)
									values (
									
									
									'SS_TS8_103_',
									
									'TS8_103_08', 	 									
									
									'SE_LOGS' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
																
									);
										
									insert into NCT01928420_All_Data.Concomitant_Medication_LogConMeds (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														CM_YN
																												
																	,CM_YN_label
										)
									values (
									
									
									'SS_TS10_104',
									
									'TS10_104_10', 	 									
									
									'SE_LOGS' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
																
									);
										
									insert into NCT01928420_All_Data.Concomitant_Medication_LogConMeds (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														CM_YN
																												
																	,CM_YN_label
										)
									values (
									
									
									'SS_TS6_104_',
									
									'TS6_104_06', 	 									
									
									'SE_LOGS' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
																
									);
										
									insert into NCT01928420_All_Data.Concomitant_Medication_LogConMeds (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														CM_YN
																												
																	,CM_YN_label
										)
									values (
									
									
									'SS_TS8_104_',
									
									'TS8_104_08', 	 									
									
									'SE_LOGS' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
																
									);
										
									insert into NCT01928420_All_Data.Concomitant_Medication_LogConMeds (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														CM_YN
																												
																	,CM_YN_label
										)
									values (
									
									
									'SS_TS13_105',
									
									'TS13_105_13', 	 									
									
									'SE_LOGS' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
																
									);
										
									insert into NCT01928420_All_Data.Concomitant_Medication_LogConMeds (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														CM_YN
																												
																	,CM_YN_label
										)
									values (
									
									
									'SS_TS6_105_',
									
									'TS6_105_06', 	 									
									
									'SE_LOGS' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
																
									);
										
									insert into NCT01928420_All_Data.Concomitant_Medication_LogConMeds (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														CM_YN
																												
																	,CM_YN_label
										)
									values (
									
									
									'SS_TS9_105_',
									
									'TS9_105_09', 	 									
									
									'SE_LOGS' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
																
									);
								
			create table NCT01928420_All_Data.Concomitant_Medication_LogConMed_Log (		
			item_data_id serial NOT NULL,	
			ssoid character varying(40) NOT NULL,			
			ssid character varying(40) NOT NULL,
			study_event_oid character varying(40) NOT NULL,
			event_ordinal integer default 1,	
			crf_version character varying(255),
			event_start_date timestamp without time zone,
			event_end_date timestamp without time zone,
			event_status character varying(255),
			event_location character varying(2000),
			subject_age_at_event integer,
			crf_status character varying(255), 
			interviewerName character varying(255),
			interviewDate date, 
			item_group_repeat_key integer,
			warehouse_insert_created_timestamp timestamp with time zone);
			
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Concomitant_Medication_LogConMed_Log', 'CM_MED', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Concomitant_Medication_LogConMed_Log', 'CM_DOSE', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Concomitant_Medication_LogConMed_Log', 'CM_FREQ', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Concomitant_Medication_LogConMed_Log', 'CM_FREQ_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Concomitant_Medication_LogConMed_Log', 'CM_IND', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Concomitant_Medication_LogConMed_Log', 'CM_STDT_min', 'date');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Concomitant_Medication_LogConMed_Log', 'CM_STDT_max', 'date');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Concomitant_Medication_LogConMed_Log', 'CM_ONGNG', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Concomitant_Medication_LogConMed_Log', 'CM_ONGNG_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Concomitant_Medication_LogConMed_Log', 'CM_SPDT_min', 'date');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Concomitant_Medication_LogConMed_Log', 'CM_SPDT_max', 'date');

	
			ALTER TABLE NCT01928420_All_Data.Concomitant_Medication_LogConMed_Log ADD CONSTRAINT Pk_CONMED_L PRIMARY KEY (item_data_id);
	
			ALTER TABLE NCT01928420_All_Data.Concomitant_Medication_LogConMed_Log ADD CONSTRAINT Fk_study_subject_id_CONMED_L FOREIGN KEY (ssoid, ssid) REFERENCES NCT01928420_All_Data.study_subject_listing;
				
													
									insert into NCT01928420_All_Data.Concomitant_Medication_LogConMed_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												CM_MED																										
														,
												CM_DOSE																										
														,
												CM_FREQ
																																								
														,CM_FREQ_label																										
														,
												CM_IND														
														,CM_STDT_min
																
														,CM_STDT_max
																												
														,
												CM_ONGNG
																																								
														,CM_ONGNG_label								
									)
									values (		
									'SS_TS10_101',											
									'TS10_101_10', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Aricept'
																,'1'
																,2													
																,'Daily'											
															
																,'AD'
																,
													
							'2013-01-01'
						,												
																		
													
							'2013-01-01'
						
																,1													
																,'Yes'											
																	
									);									
										
													
									insert into NCT01928420_All_Data.Concomitant_Medication_LogConMed_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												CM_MED																										
														,
												CM_DOSE																										
														,
												CM_FREQ
																																								
														,CM_FREQ_label																										
														,
												CM_IND														
														,CM_STDT_min
																
														,CM_STDT_max
																												
														,
												CM_ONGNG
																																								
														,CM_ONGNG_label								
									)
									values (		
									'SS_TS10_101',											
									'TS10_101_10', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Glucophage'
																,'2'
																,3													
																,'2x per day'											
															
																,'Diabetes'
																,
													
							'1988-01-01'
						,												
																		
													
							'1988-01-01'
						
																,1													
																,'Yes'											
																	
									);									
										
													
									insert into NCT01928420_All_Data.Concomitant_Medication_LogConMed_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												CM_MED																										
														,
												CM_DOSE																										
														,
												CM_FREQ
																																								
														,CM_FREQ_label																										
														,
												CM_IND														
														,CM_STDT_min
																
														,CM_STDT_max
																												
														,
												CM_ONGNG
																																								
														,CM_ONGNG_label								
									)
									values (		
									'SS_TS6_101_',											
									'TS6_101_06', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Exelon'
																,'2 tablets'
																,2													
																,'Daily'											
															
																,'AD'
																,
													
							'1989-06-10'
						,												
																		
													
							'1989-06-10'
						
																,1													
																,'Yes'											
																	
									);									
										
													
									insert into NCT01928420_All_Data.Concomitant_Medication_LogConMed_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												CM_MED																										
														,
												CM_DOSE																										
														,
												CM_FREQ
																																								
														,CM_FREQ_label																										
														,
												CM_IND														
														,CM_STDT_min
																
														,CM_STDT_max
																												
														,
												CM_ONGNG
																																								
														,CM_ONGNG_label														
														,CM_SPDT_min
																
														,CM_SPDT_max
										
									)
									values (		
									'SS_TS6_101_',											
									'TS6_101_06', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Epilim'
																,'1 injection'
																,6													
																,'Monthly'											
															
																,'Seizures'
																,
													
							'1999-09-12'
						,												
																		
													
							'1999-09-12'
						
																,2													
																,'No'											
															
																,
													
							'1999-10-12'
						,												
																		
													
							'1999-10-12'
								
									);									
										
													
									insert into NCT01928420_All_Data.Concomitant_Medication_LogConMed_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												CM_MED																										
														,
												CM_DOSE																										
														,
												CM_FREQ
																																								
														,CM_FREQ_label																										
														,
												CM_IND																										
														,
												CM_ONGNG
																																								
														,CM_ONGNG_label								
									)
									values (		
									'SS_TS10_102',											
									'TS10_102_10', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Aricept'
																,'1'
																,2													
																,'Daily'											
															
																,'AD'
																,1													
																,'Yes'											
																	
									);									
										
													
									insert into NCT01928420_All_Data.Concomitant_Medication_LogConMed_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												CM_MED																										
														,
												CM_DOSE																										
														,
												CM_FREQ
																																								
														,CM_FREQ_label																										
														,
												CM_IND																										
														,
												CM_ONGNG
																																								
														,CM_ONGNG_label								
									)
									values (		
									'SS_TS10_102',											
									'TS10_102_10', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Glucophage'
																,'2'
																,3													
																,'2x per day'											
															
																,'Diabetes'
																,1													
																,'Yes'											
																	
									);									
										
													
									insert into NCT01928420_All_Data.Concomitant_Medication_LogConMed_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												CM_MED																										
														,
												CM_DOSE																										
														,
												CM_FREQ
																																								
														,CM_FREQ_label																										
														,
												CM_IND																										
														,
												CM_ONGNG
																																								
														,CM_ONGNG_label								
									)
									values (		
									'SS_TS6_102_',											
									'TS6_102_06', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Exelon'
																,'2 tablets'
																,2													
																,'Daily'											
															
																,'AD'
																,1													
																,'Yes'											
																	
									);									
										
													
									insert into NCT01928420_All_Data.Concomitant_Medication_LogConMed_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												CM_MED																										
														,
												CM_DOSE																										
														,
												CM_FREQ
																																								
														,CM_FREQ_label																										
														,
												CM_IND																										
														,
												CM_ONGNG
																																								
														,CM_ONGNG_label								
									)
									values (		
									'SS_TS6_102_',											
									'TS6_102_06', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Epilim'
																,'1 injection'
																,6													
																,'Monthly'											
															
																,'Seizures'
																,2													
																,'No'											
																	
									);									
										
													
									insert into NCT01928420_All_Data.Concomitant_Medication_LogConMed_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												CM_MED																										
														,
												CM_DOSE																										
														,
												CM_FREQ
																																								
														,CM_FREQ_label																										
														,
												CM_IND																										
														,
												CM_ONGNG
																																								
														,CM_ONGNG_label								
									)
									values (		
									'SS_TS8_102_',											
									'TS8_102_08', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Aricept'
																,'1'
																,2													
																,'Daily'											
															
																,'AD'
																,1													
																,'Yes'											
																	
									);									
										
													
									insert into NCT01928420_All_Data.Concomitant_Medication_LogConMed_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												CM_MED																										
														,
												CM_DOSE																										
														,
												CM_FREQ
																																								
														,CM_FREQ_label																										
														,
												CM_IND																										
														,
												CM_ONGNG
																																								
														,CM_ONGNG_label								
									)
									values (		
									'SS_TS8_102_',											
									'TS8_102_08', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Glucophage'
																,'2'
																,3													
																,'2x per day'											
															
																,'Diabetes'
																,1													
																,'Yes'											
																	
									);									
										
													
									insert into NCT01928420_All_Data.Concomitant_Medication_LogConMed_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												CM_MED																										
														,
												CM_DOSE																										
														,
												CM_FREQ
																																								
														,CM_FREQ_label																										
														,
												CM_IND																										
														,
												CM_ONGNG
																																								
														,CM_ONGNG_label								
									)
									values (		
									'SS_TS10_103',											
									'TS10_103_10', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Aricept'
																,'1'
																,2													
																,'Daily'											
															
																,'AD'
																,1													
																,'Yes'											
																	
									);									
										
													
									insert into NCT01928420_All_Data.Concomitant_Medication_LogConMed_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												CM_MED																										
														,
												CM_DOSE																										
														,
												CM_FREQ
																																								
														,CM_FREQ_label																										
														,
												CM_IND																										
														,
												CM_ONGNG
																																								
														,CM_ONGNG_label								
									)
									values (		
									'SS_TS10_103',											
									'TS10_103_10', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Glucophage'
																,'2'
																,3													
																,'2x per day'											
															
																,'Diabetes'
																,1													
																,'Yes'											
																	
									);									
										
													
									insert into NCT01928420_All_Data.Concomitant_Medication_LogConMed_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												CM_MED																										
														,
												CM_DOSE																										
														,
												CM_FREQ
																																								
														,CM_FREQ_label																										
														,
												CM_IND																										
														,
												CM_ONGNG
																																								
														,CM_ONGNG_label								
									)
									values (		
									'SS_TS6_103_',											
									'TS6_103_06', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Exelon'
																,'2 tablets'
																,2													
																,'Daily'											
															
																,'AD'
																,1													
																,'Yes'											
																	
									);									
										
													
									insert into NCT01928420_All_Data.Concomitant_Medication_LogConMed_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												CM_MED																										
														,
												CM_DOSE																										
														,
												CM_FREQ
																																								
														,CM_FREQ_label																										
														,
												CM_IND																										
														,
												CM_ONGNG
																																								
														,CM_ONGNG_label								
									)
									values (		
									'SS_TS6_103_',											
									'TS6_103_06', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Epilim'
																,'1 injection'
																,6													
																,'Monthly'											
															
																,'Seizures'
																,2													
																,'No'											
																	
									);									
										
													
									insert into NCT01928420_All_Data.Concomitant_Medication_LogConMed_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												CM_MED																										
														,
												CM_DOSE																										
														,
												CM_FREQ
																																								
														,CM_FREQ_label																										
														,
												CM_IND																										
														,
												CM_ONGNG
																																								
														,CM_ONGNG_label								
									)
									values (		
									'SS_TS8_103_',											
									'TS8_103_08', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Aricept'
																,'1'
																,2													
																,'Daily'											
															
																,'AD'
																,1													
																,'Yes'											
																	
									);									
										
													
									insert into NCT01928420_All_Data.Concomitant_Medication_LogConMed_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												CM_MED																										
														,
												CM_DOSE																										
														,
												CM_FREQ
																																								
														,CM_FREQ_label																										
														,
												CM_IND																										
														,
												CM_ONGNG
																																								
														,CM_ONGNG_label								
									)
									values (		
									'SS_TS8_103_',											
									'TS8_103_08', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Glucophage'
																,'2'
																,3													
																,'2x per day'											
															
																,'Diabetes'
																,1													
																,'Yes'											
																	
									);									
										
													
									insert into NCT01928420_All_Data.Concomitant_Medication_LogConMed_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												CM_MED																										
														,
												CM_DOSE																										
														,
												CM_FREQ
																																								
														,CM_FREQ_label																										
														,
												CM_IND																										
														,
												CM_ONGNG
																																								
														,CM_ONGNG_label								
									)
									values (		
									'SS_TS10_104',											
									'TS10_104_10', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Aricept'
																,'1'
																,2													
																,'Daily'											
															
																,'AD'
																,1													
																,'Yes'											
																	
									);									
										
													
									insert into NCT01928420_All_Data.Concomitant_Medication_LogConMed_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												CM_MED																										
														,
												CM_DOSE																										
														,
												CM_FREQ
																																								
														,CM_FREQ_label																										
														,
												CM_IND																										
														,
												CM_ONGNG
																																								
														,CM_ONGNG_label								
									)
									values (		
									'SS_TS10_104',											
									'TS10_104_10', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Glucophage'
																,'2'
																,3													
																,'2x per day'											
															
																,'Diabetes'
																,1													
																,'Yes'											
																	
									);									
										
													
									insert into NCT01928420_All_Data.Concomitant_Medication_LogConMed_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												CM_MED																										
														,
												CM_DOSE																										
														,
												CM_FREQ
																																								
														,CM_FREQ_label																										
														,
												CM_IND																										
														,
												CM_ONGNG
																																								
														,CM_ONGNG_label								
									)
									values (		
									'SS_TS6_104_',											
									'TS6_104_06', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Exelon'
																,'2 tablets'
																,2													
																,'Daily'											
															
																,'AD'
																,1													
																,'Yes'											
																	
									);									
										
													
									insert into NCT01928420_All_Data.Concomitant_Medication_LogConMed_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												CM_MED																										
														,
												CM_DOSE																										
														,
												CM_FREQ
																																								
														,CM_FREQ_label																										
														,
												CM_IND																										
														,
												CM_ONGNG
																																								
														,CM_ONGNG_label								
									)
									values (		
									'SS_TS6_104_',											
									'TS6_104_06', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Epilim'
																,'1 injection'
																,6													
																,'Monthly'											
															
																,'Seizures'
																,2													
																,'No'											
																	
									);									
										
													
									insert into NCT01928420_All_Data.Concomitant_Medication_LogConMed_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												CM_MED																										
														,
												CM_DOSE																										
														,
												CM_FREQ
																																								
														,CM_FREQ_label																										
														,
												CM_IND																										
														,
												CM_ONGNG
																																								
														,CM_ONGNG_label								
									)
									values (		
									'SS_TS8_104_',											
									'TS8_104_08', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Aricept'
																,'1'
																,2													
																,'Daily'											
															
																,'AD'
																,1													
																,'Yes'											
																	
									);									
										
													
									insert into NCT01928420_All_Data.Concomitant_Medication_LogConMed_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												CM_MED																										
														,
												CM_DOSE																										
														,
												CM_FREQ
																																								
														,CM_FREQ_label																										
														,
												CM_IND																										
														,
												CM_ONGNG
																																								
														,CM_ONGNG_label								
									)
									values (		
									'SS_TS8_104_',											
									'TS8_104_08', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Glucophage'
																,'2'
																,3													
																,'2x per day'											
															
																,'Diabetes'
																,1													
																,'Yes'											
																	
									);									
										
													
									insert into NCT01928420_All_Data.Concomitant_Medication_LogConMed_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												CM_MED																										
														,
												CM_DOSE																										
														,
												CM_FREQ
																																								
														,CM_FREQ_label																										
														,
												CM_IND																										
														,
												CM_ONGNG
																																								
														,CM_ONGNG_label								
									)
									values (		
									'SS_TS13_105',											
									'TS13_105_13', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Aricept'
																,'1'
																,2													
																,'Daily'											
															
																,'AD'
																,1													
																,'Yes'											
																	
									);									
										
													
									insert into NCT01928420_All_Data.Concomitant_Medication_LogConMed_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												CM_MED																										
														,
												CM_DOSE																										
														,
												CM_FREQ
																																								
														,CM_FREQ_label																										
														,
												CM_IND																										
														,
												CM_ONGNG
																																								
														,CM_ONGNG_label								
									)
									values (		
									'SS_TS13_105',											
									'TS13_105_13', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Glucophage'
																,'2'
																,3													
																,'2x per day'											
															
																,'Diabetes'
																,1													
																,'Yes'											
																	
									);									
										
													
									insert into NCT01928420_All_Data.Concomitant_Medication_LogConMed_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												CM_MED																										
														,
												CM_DOSE																										
														,
												CM_FREQ
																																								
														,CM_FREQ_label																										
														,
												CM_IND																										
														,
												CM_ONGNG
																																								
														,CM_ONGNG_label								
									)
									values (		
									'SS_TS6_105_',											
									'TS6_105_06', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Exelon'
																,'2 tablets'
																,2													
																,'Daily'											
															
																,'AD'
																,1													
																,'Yes'											
																	
									);									
										
													
									insert into NCT01928420_All_Data.Concomitant_Medication_LogConMed_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												CM_MED																										
														,
												CM_DOSE																										
														,
												CM_FREQ
																																								
														,CM_FREQ_label																										
														,
												CM_IND																										
														,
												CM_ONGNG
																																								
														,CM_ONGNG_label								
									)
									values (		
									'SS_TS6_105_',											
									'TS6_105_06', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Epilim'
																,'1 injection'
																,6													
																,'Monthly'											
															
																,'Seizures'
																,2													
																,'No'											
																	
									);									
										
													
									insert into NCT01928420_All_Data.Concomitant_Medication_LogConMed_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												CM_MED																										
														,
												CM_DOSE																										
														,
												CM_FREQ
																																								
														,CM_FREQ_label																										
														,
												CM_IND																										
														,
												CM_ONGNG
																																								
														,CM_ONGNG_label								
									)
									values (		
									'SS_TS9_105_',											
									'TS9_105_09', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Aricept'
																,'1'
																,2													
																,'Daily'											
															
																,'AD'
																,1													
																,'Yes'											
																	
									);									
										
													
									insert into NCT01928420_All_Data.Concomitant_Medication_LogConMed_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												CM_MED																										
														,
												CM_DOSE																										
														,
												CM_FREQ
																																								
														,CM_FREQ_label																										
														,
												CM_IND																										
														,
												CM_ONGNG
																																								
														,CM_ONGNG_label								
									)
									values (		
									'SS_TS9_105_',											
									'TS9_105_09', 									
									'SE_LOGS'									  
							
									,'V1.0'
							,'' ,''
									,2
									, '2015-03-19T16:41:35.717Z'										
							
																,'Glucophage'
																,'2'
																,3													
																,'2x per day'											
															
																,'Diabetes'
																,1													
																,'Yes'											
																	
									);									
							
			  
			
					insert into NCT01928420_All_Data.crf_version (crf_name, crf_version_name, warehouse_insert_created_timestamp) values 
					( 'Serious Adverse Events', 
					'V1.0',
					'2015-03-19T16:41:35.717Z');
			
			
			
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS10_101',
									
					'TS10_101_10',
					
				'SE_AE',
				
				'Serious Adverse Events',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS6_101_',
									
					'TS6_101_06',
					
				'SE_AE',
				
				'Serious Adverse Events',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS10_102',
									
					'TS10_102_10',
					
				'SE_AE',
				
				'Serious Adverse Events',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS6_102_',
									
					'TS6_102_06',
					
				'SE_AE',
				
				'Serious Adverse Events',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS8_102_',
									
					'TS8_102_08',
					
				'SE_AE',
				
				'Serious Adverse Events',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS10_103',
									
					'TS10_103_10',
					
				'SE_AE',
				
				'Serious Adverse Events',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS6_103_',
									
					'TS6_103_06',
					
				'SE_AE',
				
				'Serious Adverse Events',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS8_103_',
									
					'TS8_103_08',
					
				'SE_AE',
				
				'Serious Adverse Events',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS10_104',
									
					'TS10_104_10',
					
				'SE_AE',
				
				'Serious Adverse Events',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS6_104_',
									
					'TS6_104_06',
					
				'SE_AE',
				
				'Serious Adverse Events',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS8_104_',
									
					'TS8_104_08',
					
				'SE_AE',
				
				'Serious Adverse Events',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS13_105',
									
					'TS13_105_13',
					
				'SE_AE',
				
				'Serious Adverse Events',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS6_105_',
									
					'TS6_105_06',
					
				'SE_AE',
				
				'Serious Adverse Events',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS9_105_',
									
					'TS9_105_09',
					
				'SE_AE',
				
				'Serious Adverse Events',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
				create table NCT01928420_All_Data.Serious_Adverse_EventsSAE1 (
				item_data_id serial NOT NULL,
				ssoid character varying(40) NOT NULL,
				ssid character varying(40) NOT NULL,
				study_event_oid character varying(40) NOT NULL,
				event_ordinal integer default 1,
				crf_version character varying(255),
				event_start_date timestamp without time zone,
				event_end_date timestamp without time zone,
				event_status character varying(255),
				event_location character varying(2000),
				subject_age_at_event integer,
				crf_status character varying(255), 
				interviewerName character varying(255),
				interviewDate date,
				warehouse_insert_created_timestamp timestamp with time zone); 			          	 
				
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Serious_Adverse_EventsSAE1', 'SAE1_YN', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Serious_Adverse_EventsSAE1', 'SAE1_YN_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Serious_Adverse_EventsSAE1', 'SAE1_CAT', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Serious_Adverse_EventsSAE1', 'SAE1_CAT_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Serious_Adverse_EventsSAE1', 'SAE1_OT', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Serious_Adverse_EventsSAE1', 'SAE1_DES', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Serious_Adverse_EventsSAE1', 'SAE1_DTST', 'date');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Serious_Adverse_EventsSAE1', 'SAE1_CON', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Serious_Adverse_EventsSAE1', 'SAE1_CON_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Serious_Adverse_EventsSAE1', 'SAE1_DTED', 'date');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Serious_Adverse_EventsSAE1', 'SAE1_STAT', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Serious_Adverse_EventsSAE1', 'SAE1_STAT_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Serious_Adverse_EventsSAE1', 'SAE2_YN', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Serious_Adverse_EventsSAE1', 'SAE2_YN_label', 'character varying(255)');

	
				
		ALTER TABLE NCT01928420_All_Data.Serious_Adverse_EventsSAE1 ADD CONSTRAINT Pk_SAE1 PRIMARY KEY (item_data_id);

		
				
		ALTER TABLE NCT01928420_All_Data.Serious_Adverse_EventsSAE1 ADD CONSTRAINT 	
		Fk_study_subject_id_SAE1 FOREIGN KEY (ssoid, 
		ssid) REFERENCES NCT01928420_All_Data.study_subject_listing;
		
				
									insert into NCT01928420_All_Data.Serious_Adverse_EventsSAE1 (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														SAE1_YN
																												
																	,SAE1_YN_label
										)
									values (
									
									
									'SS_TS10_101',
									
									'TS10_101_10', 	 									
									
									'SE_AE' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,2													
															,'No'											
																
									);
										
									insert into NCT01928420_All_Data.Serious_Adverse_EventsSAE1 (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														SAE1_YN
																												
																	,SAE1_YN_label																									
																,
																
														
														SAE1_CAT
																												
																	,SAE1_CAT_label																									
																,
																
														
														SAE1_DES																									
																,
																
														
														SAE1_DTST																									
																,
																
														
														SAE1_CON
																												
																	,SAE1_CON_label																									
																,
																
														
														SAE1_DTED																									
																,
																
														
														SAE1_STAT
																												
																	,SAE1_STAT_label																									
																,
																
														
														SAE2_YN
																												
																	,SAE2_YN_label
										)
									values (
									
									
									'SS_TS6_101_',
									
									'TS6_101_06', 	 									
									
									'SE_AE' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,3													
															,'Prolonged hospitalization'											
														
															,'Irregular heartbeat'
															,'2014-06-11'
															,2													
															,'No'											
														
															,'2014-06-18'
															,1													
															,'Yes'											
														
															,2													
															,'No'											
																
									);
										
									insert into NCT01928420_All_Data.Serious_Adverse_EventsSAE1 (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														SAE1_YN
																												
																	,SAE1_YN_label
										)
									values (
									
									
									'SS_TS10_102',
									
									'TS10_102_10', 	 									
									
									'SE_AE' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,2													
															,'No'											
																
									);
										
									insert into NCT01928420_All_Data.Serious_Adverse_EventsSAE1 (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														SAE1_YN
																												
																	,SAE1_YN_label																									
																,
																
														
														SAE1_CAT
																												
																	,SAE1_CAT_label																									
																,
																
														
														SAE1_DES																									
																,
																
														
														SAE1_DTST																									
																,
																
														
														SAE1_CON
																												
																	,SAE1_CON_label																									
																,
																
														
														SAE1_DTED																									
																,
																
														
														SAE1_STAT
																												
																	,SAE1_STAT_label																									
																,
																
														
														SAE2_YN
																												
																	,SAE2_YN_label
										)
									values (
									
									
									'SS_TS6_102_',
									
									'TS6_102_06', 	 									
									
									'SE_AE' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,3													
															,'Prolonged hospitalization'											
														
															,'Irregular heartbeat'
															,'2014-06-11'
															,2													
															,'No'											
														
															,'2014-06-18'
															,1													
															,'Yes'											
														
															,2													
															,'No'											
																
									);
										
									insert into NCT01928420_All_Data.Serious_Adverse_EventsSAE1 (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														SAE1_YN
																												
																	,SAE1_YN_label
										)
									values (
									
									
									'SS_TS8_102_',
									
									'TS8_102_08', 	 									
									
									'SE_AE' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,2													
															,'No'											
																
									);
										
									insert into NCT01928420_All_Data.Serious_Adverse_EventsSAE1 (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														SAE1_YN
																												
																	,SAE1_YN_label
										)
									values (
									
									
									'SS_TS10_103',
									
									'TS10_103_10', 	 									
									
									'SE_AE' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,2													
															,'No'											
																
									);
										
									insert into NCT01928420_All_Data.Serious_Adverse_EventsSAE1 (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														SAE1_YN
																												
																	,SAE1_YN_label																									
																,
																
														
														SAE1_CAT
																												
																	,SAE1_CAT_label																									
																,
																
														
														SAE1_DES																									
																,
																
														
														SAE1_DTST																									
																,
																
														
														SAE1_CON
																												
																	,SAE1_CON_label																									
																,
																
														
														SAE1_DTED																									
																,
																
														
														SAE1_STAT
																												
																	,SAE1_STAT_label																									
																,
																
														
														SAE2_YN
																												
																	,SAE2_YN_label
										)
									values (
									
									
									'SS_TS6_103_',
									
									'TS6_103_06', 	 									
									
									'SE_AE' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,3													
															,'Prolonged hospitalization'											
														
															,'Irregular heartbeat'
															,'2014-06-11'
															,2													
															,'No'											
														
															,'2014-06-18'
															,1													
															,'Yes'											
														
															,2													
															,'No'											
																
									);
										
									insert into NCT01928420_All_Data.Serious_Adverse_EventsSAE1 (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														SAE1_YN
																												
																	,SAE1_YN_label
										)
									values (
									
									
									'SS_TS8_103_',
									
									'TS8_103_08', 	 									
									
									'SE_AE' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,2													
															,'No'											
																
									);
										
									insert into NCT01928420_All_Data.Serious_Adverse_EventsSAE1 (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														SAE1_YN
																												
																	,SAE1_YN_label
										)
									values (
									
									
									'SS_TS10_104',
									
									'TS10_104_10', 	 									
									
									'SE_AE' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,2													
															,'No'											
																
									);
										
									insert into NCT01928420_All_Data.Serious_Adverse_EventsSAE1 (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														SAE1_YN
																												
																	,SAE1_YN_label																									
																,
																
														
														SAE1_CAT
																												
																	,SAE1_CAT_label																									
																,
																
														
														SAE1_DES																									
																,
																
														
														SAE1_DTST																									
																,
																
														
														SAE1_CON
																												
																	,SAE1_CON_label																									
																,
																
														
														SAE1_DTED																									
																,
																
														
														SAE1_STAT
																												
																	,SAE1_STAT_label																									
																,
																
														
														SAE2_YN
																												
																	,SAE2_YN_label
										)
									values (
									
									
									'SS_TS6_104_',
									
									'TS6_104_06', 	 									
									
									'SE_AE' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,3													
															,'Prolonged hospitalization'											
														
															,'Irregular heartbeat'
															,'2014-06-11'
															,2													
															,'No'											
														
															,'2014-06-18'
															,1													
															,'Yes'											
														
															,2													
															,'No'											
																
									);
										
									insert into NCT01928420_All_Data.Serious_Adverse_EventsSAE1 (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														SAE1_YN
																												
																	,SAE1_YN_label
										)
									values (
									
									
									'SS_TS8_104_',
									
									'TS8_104_08', 	 									
									
									'SE_AE' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,2													
															,'No'											
																
									);
										
									insert into NCT01928420_All_Data.Serious_Adverse_EventsSAE1 (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														SAE1_YN
																												
																	,SAE1_YN_label
										)
									values (
									
									
									'SS_TS13_105',
									
									'TS13_105_13', 	 									
									
									'SE_AE' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,2													
															,'No'											
																
									);
										
									insert into NCT01928420_All_Data.Serious_Adverse_EventsSAE1 (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														SAE1_YN
																												
																	,SAE1_YN_label																									
																,
																
														
														SAE1_CAT
																												
																	,SAE1_CAT_label																									
																,
																
														
														SAE1_DES																									
																,
																
														
														SAE1_DTST																									
																,
																
														
														SAE1_CON
																												
																	,SAE1_CON_label																									
																,
																
														
														SAE1_DTED																									
																,
																
														
														SAE1_STAT
																												
																	,SAE1_STAT_label																									
																,
																
														
														SAE2_YN
																												
																	,SAE2_YN_label
										)
									values (
									
									
									'SS_TS6_105_',
									
									'TS6_105_06', 	 									
									
									'SE_AE' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,1													
															,'Yes'											
														
															,3													
															,'Prolonged hospitalization'											
														
															,'Irregular heartbeat'
															,'2014-06-11'
															,2													
															,'No'											
														
															,'2014-06-18'
															,1													
															,'Yes'											
														
															,2													
															,'No'											
																
									);
										
									insert into NCT01928420_All_Data.Serious_Adverse_EventsSAE1 (
									ssoid, ssid, study_event_oid
										
									,crf_version
									, event_location, interviewerName
										, warehouse_insert_created_timestamp
																																			
																,
																
														
														SAE1_YN
																												
																	,SAE1_YN_label
										)
									values (
									
									
									'SS_TS9_105_',
									
									'TS9_105_09', 	 									
									
									'SE_AE' 									  
									
									
									 
									,'V1.0'																				  
									
									,'' ,''
									
										, '2015-03-19T16:41:35.717Z'
										
									
															,2													
															,'No'											
																
									);
								
				create table NCT01928420_All_Data.Serious_Adverse_EventsSAE2 (
				item_data_id serial NOT NULL,
				ssoid character varying(40) NOT NULL,
				ssid character varying(40) NOT NULL,
				study_event_oid character varying(40) NOT NULL,
				event_ordinal integer default 1,
				crf_version character varying(255),
				event_start_date timestamp without time zone,
				event_end_date timestamp without time zone,
				event_status character varying(255),
				event_location character varying(2000),
				subject_age_at_event integer,
				crf_status character varying(255), 
				interviewerName character varying(255),
				interviewDate date,
				warehouse_insert_created_timestamp timestamp with time zone); 			          	 
				
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Serious_Adverse_EventsSAE2', 'SAE2_CAT', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Serious_Adverse_EventsSAE2', 'SAE2_CAT_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Serious_Adverse_EventsSAE2', 'SAE2_OT', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Serious_Adverse_EventsSAE2', 'SAE2_DES', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Serious_Adverse_EventsSAE2', 'SAE2_DTST', 'date');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Serious_Adverse_EventsSAE2', 'SAE2_CON', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Serious_Adverse_EventsSAE2', 'SAE2_CON_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Serious_Adverse_EventsSAE2', 'SAE2_DTED', 'date');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Serious_Adverse_EventsSAE2', 'SAE2_STAT', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Serious_Adverse_EventsSAE2', 'SAE2_STAT_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Serious_Adverse_EventsSAE2', 'SAE3_YN', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Serious_Adverse_EventsSAE2', 'SAE3_YN_label', 'character varying(255)');

	
				
		ALTER TABLE NCT01928420_All_Data.Serious_Adverse_EventsSAE2 ADD CONSTRAINT Pk_SAE2 PRIMARY KEY (item_data_id);

		
				
		ALTER TABLE NCT01928420_All_Data.Serious_Adverse_EventsSAE2 ADD CONSTRAINT 	
		Fk_study_subject_id_SAE2 FOREIGN KEY (ssoid, 
		ssid) REFERENCES NCT01928420_All_Data.study_subject_listing;
		
		
				create table NCT01928420_All_Data.Serious_Adverse_EventsSAE3 (
				item_data_id serial NOT NULL,
				ssoid character varying(40) NOT NULL,
				ssid character varying(40) NOT NULL,
				study_event_oid character varying(40) NOT NULL,
				event_ordinal integer default 1,
				crf_version character varying(255),
				event_start_date timestamp without time zone,
				event_end_date timestamp without time zone,
				event_status character varying(255),
				event_location character varying(2000),
				subject_age_at_event integer,
				crf_status character varying(255), 
				interviewerName character varying(255),
				interviewDate date,
				warehouse_insert_created_timestamp timestamp with time zone); 			          	 
				
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Serious_Adverse_EventsSAE3', 'SAE3_CAT', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Serious_Adverse_EventsSAE3', 'SAE3_CAT_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Serious_Adverse_EventsSAE3', 'SAE3_OT', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Serious_Adverse_EventsSAE3', 'SAE3_DES', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Serious_Adverse_EventsSAE3', 'SAE3_DTST', 'date');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Serious_Adverse_EventsSAE3', 'SAE3_CON', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Serious_Adverse_EventsSAE3', 'SAE3_CON_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Serious_Adverse_EventsSAE3', 'SAE3_DTED', 'date');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Serious_Adverse_EventsSAE3', 'SAE3_STAT', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Serious_Adverse_EventsSAE3', 'SAE3_STAT_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Serious_Adverse_EventsSAE3', 'SAE4_YN', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Serious_Adverse_EventsSAE3', 'SAE4_YN_label', 'character varying(255)');

	
				
		ALTER TABLE NCT01928420_All_Data.Serious_Adverse_EventsSAE3 ADD CONSTRAINT Pk_SAE3 PRIMARY KEY (item_data_id);

		
				
		ALTER TABLE NCT01928420_All_Data.Serious_Adverse_EventsSAE3 ADD CONSTRAINT 	
		Fk_study_subject_id_SAE3 FOREIGN KEY (ssoid, 
		ssid) REFERENCES NCT01928420_All_Data.study_subject_listing;
		
		
				create table NCT01928420_All_Data.Serious_Adverse_EventsSAE4 (
				item_data_id serial NOT NULL,
				ssoid character varying(40) NOT NULL,
				ssid character varying(40) NOT NULL,
				study_event_oid character varying(40) NOT NULL,
				event_ordinal integer default 1,
				crf_version character varying(255),
				event_start_date timestamp without time zone,
				event_end_date timestamp without time zone,
				event_status character varying(255),
				event_location character varying(2000),
				subject_age_at_event integer,
				crf_status character varying(255), 
				interviewerName character varying(255),
				interviewDate date,
				warehouse_insert_created_timestamp timestamp with time zone); 			          	 
				
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Serious_Adverse_EventsSAE4', 'SAE4_CAT', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Serious_Adverse_EventsSAE4', 'SAE4_CAT_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Serious_Adverse_EventsSAE4', 'SAE4_OT', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Serious_Adverse_EventsSAE4', 'SAE4_DES', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Serious_Adverse_EventsSAE4', 'SAE4_DTST', 'date');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Serious_Adverse_EventsSAE4', 'SAE4_CON', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Serious_Adverse_EventsSAE4', 'SAE4_CON_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Serious_Adverse_EventsSAE4', 'SAE4_DTED', 'date');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Serious_Adverse_EventsSAE4', 'SAE4_STAT', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Serious_Adverse_EventsSAE4', 'SAE4_STAT_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Serious_Adverse_EventsSAE4', 'SAE5_YN', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Serious_Adverse_EventsSAE4', 'SAE5_YN_label', 'character varying(255)');

	
				
		ALTER TABLE NCT01928420_All_Data.Serious_Adverse_EventsSAE4 ADD CONSTRAINT Pk_SAE4 PRIMARY KEY (item_data_id);

		
				
		ALTER TABLE NCT01928420_All_Data.Serious_Adverse_EventsSAE4 ADD CONSTRAINT 	
		Fk_study_subject_id_SAE4 FOREIGN KEY (ssoid, 
		ssid) REFERENCES NCT01928420_All_Data.study_subject_listing;
		
		
				create table NCT01928420_All_Data.Serious_Adverse_EventsSAE5 (
				item_data_id serial NOT NULL,
				ssoid character varying(40) NOT NULL,
				ssid character varying(40) NOT NULL,
				study_event_oid character varying(40) NOT NULL,
				event_ordinal integer default 1,
				crf_version character varying(255),
				event_start_date timestamp without time zone,
				event_end_date timestamp without time zone,
				event_status character varying(255),
				event_location character varying(2000),
				subject_age_at_event integer,
				crf_status character varying(255), 
				interviewerName character varying(255),
				interviewDate date,
				warehouse_insert_created_timestamp timestamp with time zone); 			          	 
				
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Serious_Adverse_EventsSAE5', 'SAE5_CAT', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Serious_Adverse_EventsSAE5', 'SAE5_CAT_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Serious_Adverse_EventsSAE5', 'SAE5_OT', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Serious_Adverse_EventsSAE5', 'SAE5_DES', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Serious_Adverse_EventsSAE5', 'SAE5_DTST', 'date');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Serious_Adverse_EventsSAE5', 'SAE5_CON', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Serious_Adverse_EventsSAE5', 'SAE5_CON_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Serious_Adverse_EventsSAE5', 'SAE5_DTED', 'date');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Serious_Adverse_EventsSAE5', 'SAE5_STAT', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Serious_Adverse_EventsSAE5', 'SAE5_STAT_label', 'character varying(255)');

	
				
		ALTER TABLE NCT01928420_All_Data.Serious_Adverse_EventsSAE5 ADD CONSTRAINT Pk_SAE5 PRIMARY KEY (item_data_id);

		
				
		ALTER TABLE NCT01928420_All_Data.Serious_Adverse_EventsSAE5 ADD CONSTRAINT 	
		Fk_study_subject_id_SAE5 FOREIGN KEY (ssoid, 
		ssid) REFERENCES NCT01928420_All_Data.study_subject_listing;
		
		
			  
			
					insert into NCT01928420_All_Data.crf_version (crf_name, crf_version_name, warehouse_insert_created_timestamp) values 
					( 'Adverse Events Log', 
					'V1.0',
					'2015-03-19T16:41:35.717Z');
			
			
			
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS10_101',
									
					'TS10_101_10',
					
				'SE_AE',
				
				'Adverse Events Log',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site A',				
					
				'SS_TS6_101_',
									
					'TS6_101_06',
					
				'SE_AE',
				
				'Adverse Events Log',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS10_102',
									
					'TS10_102_10',
					
				'SE_AE',
				
				'Adverse Events Log',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS6_102_',
									
					'TS6_102_06',
					
				'SE_AE',
				
				'Adverse Events Log',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site B',				
					
				'SS_TS8_102_',
									
					'TS8_102_08',
					
				'SE_AE',
				
				'Adverse Events Log',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS10_103',
									
					'TS10_103_10',
					
				'SE_AE',
				
				'Adverse Events Log',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS6_103_',
									
					'TS6_103_06',
					
				'SE_AE',
				
				'Adverse Events Log',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site C',				
					
				'SS_TS8_103_',
									
					'TS8_103_08',
					
				'SE_AE',
				
				'Adverse Events Log',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS10_104',
									
					'TS10_104_10',
					
				'SE_AE',
				
				'Adverse Events Log',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS6_104_',
									
					'TS6_104_06',
					
				'SE_AE',
				
				'Adverse Events Log',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site D',				
					
				'SS_TS8_104_',
									
					'TS8_104_08',
					
				'SE_AE',
				
				'Adverse Events Log',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS13_105',
									
					'TS13_105_13',
					
				'SE_AE',
				
				'Adverse Events Log',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS6_105_',
									
					'TS6_105_06',
					
				'SE_AE',
				
				'Adverse Events Log',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
						
			INSERT INTO NCT01928420_All_Data.crf_status_summary 
			(
				site_name,
				
			ssoid,
			
				ssid,
			
			study_event_oid,
				
			crf_name,
			crf_version
				
							
				,warehouse_insert_created_timestamp				
				
																																											
			)
			VALUES
			(	
					'Site E',				
					
				'SS_TS9_105_',
									
					'TS9_105_09',
					
				'SE_AE',
				
				'Adverse Events Log',
				'V1.0'
				
		
				,'2015-03-19T16:41:35.717Z'
			);
		
			create table NCT01928420_All_Data.Adverse_Events_LogAE_Log (		
			item_data_id serial NOT NULL,	
			ssoid character varying(40) NOT NULL,			
			ssid character varying(40) NOT NULL,
			study_event_oid character varying(40) NOT NULL,
			event_ordinal integer default 1,	
			crf_version character varying(255),
			event_start_date timestamp without time zone,
			event_end_date timestamp without time zone,
			event_status character varying(255),
			event_location character varying(2000),
			subject_age_at_event integer,
			crf_status character varying(255), 
			interviewerName character varying(255),
			interviewDate date, 
			item_group_repeat_key integer,
			warehouse_insert_created_timestamp timestamp with time zone);
			
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Adverse_Events_LogAE_Log', 'AE_DESC', 'text');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Adverse_Events_LogAE_Log', 'AE_DTON', 'date');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Adverse_Events_LogAE_Log', 'AE_DTRE', 'date');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Adverse_Events_LogAE_Log', 'AE_SEV', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Adverse_Events_LogAE_Log', 'AE_SEV_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Adverse_Events_LogAE_Log', 'AE_ACT', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Adverse_Events_LogAE_Log', 'AE_ACT_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Adverse_Events_LogAE_Log', 'AE_OUT', 'integer');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Adverse_Events_LogAE_Log', 'AE_OUT_label', 'character varying(255)');

	
		
			SELECT NCT01928420_All_Data.add_table_field('NCT01928420_All_Data.Adverse_Events_LogAE_Log', 'AE_OTOUT', 'text');

	
			ALTER TABLE NCT01928420_All_Data.Adverse_Events_LogAE_Log ADD CONSTRAINT Pk_AE_LOG PRIMARY KEY (item_data_id);
	
			ALTER TABLE NCT01928420_All_Data.Adverse_Events_LogAE_Log ADD CONSTRAINT Fk_study_subject_id_AE_LOG FOREIGN KEY (ssoid, ssid) REFERENCES NCT01928420_All_Data.study_subject_listing;
				
													
									insert into NCT01928420_All_Data.Adverse_Events_LogAE_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												AE_DESC																										
														,
												AE_DTON																										
														,
												AE_DTRE																										
														,
												AE_SEV
																																								
														,AE_SEV_label																										
														,
												AE_ACT
																																								
														,AE_ACT_label																										
														,
												AE_OUT
																																								
														,AE_OUT_label								
									)
									values (		
									'SS_TS10_101',											
									'TS10_101_10', 									
									'SE_AE'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Rash'
																,'2014-06-10'
																,'2014-06-10'
																,1													
																,'I'											
															
																,1													
																,'None'											
															
																,1													
																,'Recovered without sequelae'											
																	
									);									
										
													
									insert into NCT01928420_All_Data.Adverse_Events_LogAE_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												AE_DESC																										
														,
												AE_DTON																										
														,
												AE_DTRE																										
														,
												AE_SEV
																																								
														,AE_SEV_label																										
														,
												AE_ACT
																																								
														,AE_ACT_label																										
														,
												AE_OUT
																																								
														,AE_OUT_label								
									)
									values (		
									'SS_TS6_101_',											
									'TS6_101_06', 									
									'SE_AE'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Hospitalization'
																,'2014-06-11'
																,'2014-06-17'
																,4													
																,'IV'											
															
																,2													
																,'Dose Interrupted'											
															
																,1													
																,'Recovered without sequelae'											
																	
									);									
										
													
									insert into NCT01928420_All_Data.Adverse_Events_LogAE_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												AE_DESC																										
														,
												AE_DTON																										
														,
												AE_DTRE																										
														,
												AE_SEV
																																								
														,AE_SEV_label																										
														,
												AE_ACT
																																								
														,AE_ACT_label																										
														,
												AE_OUT
																																								
														,AE_OUT_label								
									)
									values (		
									'SS_TS10_102',											
									'TS10_102_10', 									
									'SE_AE'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Rash'
																,'2014-06-10'
																,'2014-06-10'
																,1													
																,'I'											
															
																,1													
																,'None'											
															
																,1													
																,'Recovered without sequelae'											
																	
									);									
										
													
									insert into NCT01928420_All_Data.Adverse_Events_LogAE_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												AE_DESC																										
														,
												AE_DTON																										
														,
												AE_DTRE																										
														,
												AE_SEV
																																								
														,AE_SEV_label																										
														,
												AE_ACT
																																								
														,AE_ACT_label																										
														,
												AE_OUT
																																								
														,AE_OUT_label								
									)
									values (		
									'SS_TS6_102_',											
									'TS6_102_06', 									
									'SE_AE'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Hospitalization'
																,'2014-06-11'
																,'2014-06-17'
																,4													
																,'IV'											
															
																,2													
																,'Dose Interrupted'											
															
																,1													
																,'Recovered without sequelae'											
																	
									);									
										
													
									insert into NCT01928420_All_Data.Adverse_Events_LogAE_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												AE_DESC																										
														,
												AE_DTON																										
														,
												AE_DTRE																										
														,
												AE_SEV
																																								
														,AE_SEV_label																										
														,
												AE_ACT
																																								
														,AE_ACT_label																										
														,
												AE_OUT
																																								
														,AE_OUT_label								
									)
									values (		
									'SS_TS8_102_',											
									'TS8_102_08', 									
									'SE_AE'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Rash'
																,'2014-06-10'
																,'2014-06-10'
																,1													
																,'I'											
															
																,1													
																,'None'											
															
																,1													
																,'Recovered without sequelae'											
																	
									);									
										
													
									insert into NCT01928420_All_Data.Adverse_Events_LogAE_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												AE_DESC																										
														,
												AE_DTON																										
														,
												AE_DTRE																										
														,
												AE_SEV
																																								
														,AE_SEV_label																										
														,
												AE_ACT
																																								
														,AE_ACT_label																										
														,
												AE_OUT
																																								
														,AE_OUT_label								
									)
									values (		
									'SS_TS10_103',											
									'TS10_103_10', 									
									'SE_AE'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Rash'
																,'2014-06-10'
																,'2014-06-10'
																,1													
																,'I'											
															
																,1													
																,'None'											
															
																,1													
																,'Recovered without sequelae'											
																	
									);									
										
													
									insert into NCT01928420_All_Data.Adverse_Events_LogAE_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												AE_DESC																										
														,
												AE_DTON																										
														,
												AE_DTRE																										
														,
												AE_SEV
																																								
														,AE_SEV_label																										
														,
												AE_ACT
																																								
														,AE_ACT_label																										
														,
												AE_OUT
																																								
														,AE_OUT_label								
									)
									values (		
									'SS_TS6_103_',											
									'TS6_103_06', 									
									'SE_AE'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Hospitalization'
																,'2014-06-11'
																,'2014-06-17'
																,4													
																,'IV'											
															
																,2													
																,'Dose Interrupted'											
															
																,1													
																,'Recovered without sequelae'											
																	
									);									
										
													
									insert into NCT01928420_All_Data.Adverse_Events_LogAE_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												AE_DESC																										
														,
												AE_DTON																										
														,
												AE_DTRE																										
														,
												AE_SEV
																																								
														,AE_SEV_label																										
														,
												AE_ACT
																																								
														,AE_ACT_label																										
														,
												AE_OUT
																																								
														,AE_OUT_label								
									)
									values (		
									'SS_TS8_103_',											
									'TS8_103_08', 									
									'SE_AE'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Rash'
																,'2014-06-10'
																,'2014-06-10'
																,1													
																,'I'											
															
																,1													
																,'None'											
															
																,1													
																,'Recovered without sequelae'											
																	
									);									
										
													
									insert into NCT01928420_All_Data.Adverse_Events_LogAE_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												AE_DESC																										
														,
												AE_DTON																										
														,
												AE_DTRE																										
														,
												AE_SEV
																																								
														,AE_SEV_label																										
														,
												AE_ACT
																																								
														,AE_ACT_label																										
														,
												AE_OUT
																																								
														,AE_OUT_label								
									)
									values (		
									'SS_TS10_104',											
									'TS10_104_10', 									
									'SE_AE'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Rash'
																,'2014-06-10'
																,'2014-06-10'
																,1													
																,'I'											
															
																,1													
																,'None'											
															
																,1													
																,'Recovered without sequelae'											
																	
									);									
										
													
									insert into NCT01928420_All_Data.Adverse_Events_LogAE_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												AE_DESC																										
														,
												AE_DTON																										
														,
												AE_DTRE																										
														,
												AE_SEV
																																								
														,AE_SEV_label																										
														,
												AE_ACT
																																								
														,AE_ACT_label																										
														,
												AE_OUT
																																								
														,AE_OUT_label								
									)
									values (		
									'SS_TS6_104_',											
									'TS6_104_06', 									
									'SE_AE'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Hospitalization'
																,'2014-06-11'
																,'2014-06-17'
																,4													
																,'IV'											
															
																,2													
																,'Dose Interrupted'											
															
																,1													
																,'Recovered without sequelae'											
																	
									);									
										
													
									insert into NCT01928420_All_Data.Adverse_Events_LogAE_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												AE_DESC																										
														,
												AE_DTON																										
														,
												AE_DTRE																										
														,
												AE_SEV
																																								
														,AE_SEV_label																										
														,
												AE_ACT
																																								
														,AE_ACT_label																										
														,
												AE_OUT
																																								
														,AE_OUT_label								
									)
									values (		
									'SS_TS8_104_',											
									'TS8_104_08', 									
									'SE_AE'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Rash'
																,'2014-06-10'
																,'2014-06-10'
																,1													
																,'I'											
															
																,1													
																,'None'											
															
																,1													
																,'Recovered without sequelae'											
																	
									);									
										
													
									insert into NCT01928420_All_Data.Adverse_Events_LogAE_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												AE_DESC																										
														,
												AE_DTON																										
														,
												AE_DTRE																										
														,
												AE_SEV
																																								
														,AE_SEV_label																										
														,
												AE_ACT
																																								
														,AE_ACT_label																										
														,
												AE_OUT
																																								
														,AE_OUT_label								
									)
									values (		
									'SS_TS13_105',											
									'TS13_105_13', 									
									'SE_AE'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Rash'
																,'2014-06-10'
																,'2014-06-10'
																,1													
																,'I'											
															
																,1													
																,'None'											
															
																,1													
																,'Recovered without sequelae'											
																	
									);									
										
													
									insert into NCT01928420_All_Data.Adverse_Events_LogAE_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												AE_DESC																										
														,
												AE_DTON																										
														,
												AE_DTRE																										
														,
												AE_SEV
																																								
														,AE_SEV_label																										
														,
												AE_ACT
																																								
														,AE_ACT_label																										
														,
												AE_OUT
																																								
														,AE_OUT_label								
									)
									values (		
									'SS_TS6_105_',											
									'TS6_105_06', 									
									'SE_AE'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Hospitalization'
																,'2014-06-11'
																,'2014-06-17'
																,4													
																,'IV'											
															
																,2													
																,'Dose Interrupted'											
															
																,1													
																,'Recovered without sequelae'											
																	
									);									
										
													
									insert into NCT01928420_All_Data.Adverse_Events_LogAE_Log (
									ssoid, ssid, study_event_oid 
									
									,crf_version
									, event_location, interviewerName		
									, item_group_repeat_key
									, warehouse_insert_created_timestamp
																																	
														,
												AE_DESC																										
														,
												AE_DTON																										
														,
												AE_DTRE																										
														,
												AE_SEV
																																								
														,AE_SEV_label																										
														,
												AE_ACT
																																								
														,AE_ACT_label																										
														,
												AE_OUT
																																								
														,AE_OUT_label								
									)
									values (		
									'SS_TS9_105_',											
									'TS9_105_09', 									
									'SE_AE'									  
							
									,'V1.0'
							,'' ,''
									,1
									, '2015-03-19T16:41:35.717Z'										
							
																,'Rash'
																,'2014-06-10'
																,'2014-06-10'
																,1													
																,'I'											
															
																,1													
																,'None'											
															
																,1													
																,'Recovered without sequelae'											
																	
									);									
							